# 142 commands:
use utf8;
[
### UBX-ACK-ACK Message acknowledged ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Class ID of the Acknowledged Message',
                'group' => '',
                'ln_arg' => 2855,
                'name' => 'clsID',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Message ID of the Acknowledged Message',
                'group' => '',
                'ln_arg' => 2866,
                'name' => 'msgID',
                'offset' => '1',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x05',
  'code' => 'UBX-ACK-ACK',
  'comment' => 'Output upon processing of an input message. A UBX-ACK-ACK is sent as soon as possible but at least within one second.',
  'id' => '0x01',
  'length' => '2',
  'ln_classid' => 2852,
  'ln_comment' => 2848,
  'ln_msg' => 2845,
  'ln_name' => 2846,
  'ln_type' => 2847,
  'name' => 'Message acknowledged',
  'type' => 'Output'
}
, ### UBX-ACK-NAK Message not acknowledged ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Class ID of the Not-Acknowledged Message',
                'group' => '',
                'ln_arg' => 2882,
                'name' => 'clsID',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Message ID of the Not-Acknowledged Message',
                'group' => '',
                'ln_arg' => 2883,
                'name' => 'msgID',
                'offset' => '1',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x05',
  'code' => 'UBX-ACK-NAK',
  'comment' => 'Output upon processing of an input message. A UBX-ACK-NAK is sent as soon as possible but at least within one second.',
  'id' => '0x00',
  'length' => '2',
  'ln_classid' => 2879,
  'ln_comment' => 2875,
  'ln_msg' => 2872,
  'ln_name' => 2873,
  'ln_type' => 2874,
  'name' => 'Message not acknowledged',
  'type' => 'Output'
}
, ### UBX-CFG-ANT Antenna control settings ###
{
  'args' => [
              {
                'bitfield' => [
                                {
                                  'bit' => '0',
                                  'bitfrom' => undef,
                                  'descr' => 'Enable antenna supply voltage control signal',
                                  'name' => 'svcs',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '1',
                                  'bitfrom' => undef,
                                  'descr' => 'Enable short circuit detection',
                                  'name' => 'scd',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '2',
                                  'bitfrom' => undef,
                                  'descr' => 'Enable open circuit detection',
                                  'name' => 'ocd',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '3',
                                  'bitfrom' => undef,
                                  'descr' => 'Power down antenna supply if short circuit is detected. (only in combination with bit 1)',
                                  'name' => 'pdwnOnSCD',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '4',
                                  'bitfrom' => undef,
                                  'descr' => 'Enable automatic recovery from short state',
                                  'name' => 'recovery',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'Antenna ﬂag mask',
                'group' => '',
                'ln_arg' => 2915,
                'name' => 'flags',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X2',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '4',
                                  'bitfrom' => '0',
                                  'descr' => 'PIO-pin used for switching antenna supply',
                                  'name' => 'pinSwitch',
                                  'numbits' => '5'
                                },
                                {
                                  'bit' => '9',
                                  'bitfrom' => '5',
                                  'descr' => 'PIO-pin used for detecting a short in the antenna supply',
                                  'name' => 'pinSCD',
                                  'numbits' => '5'
                                },
                                {
                                  'bit' => '14',
                                  'bitfrom' => '10',
                                  'descr' => 'PIO-pin used for detecting open/not connected antenna',
                                  'name' => 'pinOCD',
                                  'numbits' => '5'
                                },
                                {
                                  'bit' => '15',
                                  'bitfrom' => undef,
                                  'descr' => 'if set to one, and this command is sent to the receiver, the receiver will reconﬁgure the pins as speciﬁed.',
                                  'name' => 'reconfig',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'Antenna pin conﬁguration',
                'group' => '',
                'ln_arg' => 2934,
                'name' => 'pins',
                'offset' => '2',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X2',
                'unit' => '-'
              }
            ],
  'class' => '0x06',
  'code' => 'UBX-CFG-ANT',
  'comment' => 'This message is deprecated in protocol versions greater than 23.01. Use UBX-CFG-VALSET, UBX-CFG-VALGET, UBX-CFG-VALDEL instead. See the Legacy UBX Message Fields Reference for the corresponding conﬁguration item. This message allows the user to conﬁgure the antenna supervisor. The antenna supervisor can be used to detect the status of an active antenna and control it. It can be used to turn oﬀ the supply to the antenna in the event of a short cirquit (for example) or to manage power consumption in power save mode. Refer to antenna supervisor conﬁguration in the Integration manual for more information regarding the behavior of the antenna supervisor. Refer to UBX-MON-HW for a description of the ﬁelds in the message used to obtain the status of the antenna. Note that not all pins can be used for antenna supervisor operation, it is recommended that you use the default pins, consult the Integration manual if you need to use other pins.',
  'id' => '0x13',
  'length' => '4',
  'ln_bitfield' => 2942,
  'ln_classid' => 2912,
  'ln_comment' => 2898,
  'ln_msg' => 2895,
  'ln_name' => 2896,
  'ln_type' => 2897,
  'name' => 'Antenna control settings',
  'type' => 'Get/set'
}
, ### UBX-CFG-CFG Clear, save and load conﬁgurations ###
{
  'args' => [
              {
                'bitfield' => [
                                {
                                  'bit' => '31',
                                  'bitfrom' => '0',
                                  'descr' => 'Clear all saved conﬁguration from the selected non- volatile memory if any bit is set',
                                  'name' => 'clearAll',
                                  'numbits' => '32'
                                }
                              ],
                'descr' => 'Mask for conﬁguration to clear',
                'group' => '',
                'ln_arg' => 2970,
                'name' => 'clearMask',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X4',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '31',
                                  'bitfrom' => '0',
                                  'descr' => 'Save all current conﬁguration to the selected non- volatile memory if any bit is set',
                                  'name' => 'saveAll',
                                  'numbits' => '32'
                                }
                              ],
                'descr' => 'Mask for conﬁguration to save',
                'group' => '',
                'ln_arg' => 2974,
                'name' => 'saveMask',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X4',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '31',
                                  'bitfrom' => '0',
                                  'descr' => 'Discard current conﬁguration and rebuilt it from lower non-volatile memory layers if any bit is set',
                                  'name' => 'loadAll',
                                  'numbits' => '32'
                                }
                              ],
                'descr' => 'Mask for conﬁguration to load',
                'group' => '',
                'ln_arg' => 2978,
                'name' => 'loadMask',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X4',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '0',
                                  'bitfrom' => undef,
                                  'descr' => 'Battery-backed RAM',
                                  'name' => 'devBBR',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '1',
                                  'bitfrom' => undef,
                                  'descr' => 'Flash',
                                  'name' => 'devFlash',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '2',
                                  'bitfrom' => undef,
                                  'descr' => 'EEPROM (only supported for protocol versions less than 14.00)',
                                  'name' => 'devEEPROM',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '4',
                                  'bitfrom' => undef,
                                  'descr' => 'SPI Flash (only supported for protocol versions less than 14.00)',
                                  'name' => 'devSpiFlash',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'Mask which selects the memory devices for saving and/or clearing operation Note that if a deviceMask is not provided, the receiver defaults the operation requested to battery-backed RAM (BBR) and Flash (if available)',
                'group' => 'optional',
                'ln_arg' => 2993,
                'name' => 'deviceMask',
                'offset' => '12',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X1',
                'unit' => '-'
              }
            ],
  'class' => '0x06',
  'code' => 'UBX-CFG-CFG',
  'comment' => 'See Receiver conﬁguration for a detailed description on how receiver conﬁguration should be used. The behavior of this message has changed for protocol versions greater than 23.01. Use UBX-CFG-VALSET and UBX-CFG-VALDEL with the appropriate layers instead. These new messages support selective saving and clearing to retain the behavior removed from this message. The three masks which were used to clear, save and load a subsection of conﬁguration have lost their meaning. It is no longer possible to save or clear a subsection of the conﬁguration using this message. The behavior of the masks is now:
•     if any bit is set in the clearMask: all conﬁguration in the selected non-volatile memory is deleted
•     if any bit is set in the saveMask: all current conﬁguration is stored (copied) to the selected layers
•     if any bit is set in the loadMask: The curerent conﬁguration is discarded and rebuilt from all the lower layers Note that commands can be combined. The sequence of execution is clear, save, then load. ☞ This message is deprecated in protocol versions greater than 23.01. Use UBX-CFG-VALSET, UBX-CFG-VALGET, UBX-CFG-VALDEL instead.',
  'hasgroup' => 'optional',
  'id' => '0x09',
  'length' => '12 + [0,1]',
  'ln_bitfield' => 3005,
  'ln_classid' => 2967,
  'ln_comment' => 2952,
  'ln_msg' => 2949,
  'ln_name' => 2950,
  'ln_type' => 2951,
  'name' => 'Clear, save and load conﬁgurations',
  'type' => 'Command'
}
, ### UBX-CFG-DAT Set user-deﬁned datum ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Semi-major axis ( accepted range = 6,300,000.0 to 6,500,000.0 meters ).',
                'group' => '',
                'ln_arg' => 3024,
                'name' => 'majA',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'R8',
                'unit' => 'm'
              },
              {
                'bitfield' => [],
                'descr' => '1.0 / ﬂattening ( accepted range is 0.0 to 500.0 ).',
                'group' => '',
                'ln_arg' => 3026,
                'name' => 'flat',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'R8',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'X axis shift at the origin ( accepted range is +/- 5000.0 meters ).',
                'group' => '',
                'ln_arg' => 3027,
                'name' => 'dX',
                'offset' => '16',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'R4',
                'unit' => 'm'
              },
              {
                'bitfield' => [],
                'descr' => 'Y axis shift at the origin ( accepted range is +/- 5000.0 meters ).',
                'group' => '',
                'ln_arg' => 3029,
                'name' => 'dY',
                'offset' => '20',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'R4',
                'unit' => 'm'
              },
              {
                'bitfield' => [],
                'descr' => 'Z axis shift at the origin ( accepted range is +/- 5000.0 meters ).',
                'group' => '',
                'ln_arg' => 3031,
                'name' => 'dZ',
                'offset' => '24',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'R4',
                'unit' => 'm'
              },
              {
                'bitfield' => [],
                'descr' => 'Rotation about the X axis ( accepted range is +/- 20.0 milli-arc seconds ).',
                'group' => '',
                'ln_arg' => 3033,
                'name' => 'rotX',
                'offset' => '28',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'R4',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'Rotation about the Y axis ( accepted range is +/- 20.0 milli-arc seconds ).',
                'group' => '',
                'ln_arg' => 3035,
                'name' => 'rotY',
                'offset' => '32',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'R4',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'Rotation about the Z axis ( accepted range is +/- 20.0 milli-arc seconds ).',
                'group' => '',
                'ln_arg' => 3037,
                'name' => 'rotZ',
                'offset' => '36',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'R4',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'Scale change ( accepted range is 0.0 to 50.0 parts per million ).',
                'group' => '',
                'ln_arg' => 3039,
                'name' => 'scale',
                'offset' => '40',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'R4',
                'unit' => 'ppm'
              }
            ],
  'class' => '0x06',
  'code' => 'UBX-CFG-DAT',
  'comment' => 'This message is deprecated in protocol versions greater than 23.01. Use UBX-CFG-VALSET, UBX-CFG-VALGET, UBX-CFG-VALDEL instead. See the Legacy UBX Message Fields Reference for the corresponding conﬁguration item.',
  'id' => '0x06',
  'length' => '44',
  'ln_classid' => 3021,
  'ln_comment' => 3016,
  'ln_msg' => 3013,
  'ln_name' => 3014,
  'ln_type' => 3015,
  'name' => 'Set user-deﬁned datum',
  'type' => 'Set'
}
, ### UBX-CFG-DAT Get currently deﬁned datum ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Datum number: 0 = WGS84, 0xFFFF = user-deﬁned (extra values are deﬁned for protocol versions less than 13.00)',
                'group' => '',
                'ln_arg' => 3067,
                'name' => 'datumNum',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'ASCII string: WGS84 or USER (extra values are deﬁned for protocol versions less than 13.00)',
                'group' => '',
                'ln_arg' => 3070,
                'name' => 'datumName',
                'offset' => '2',
                'repeat' => '6',
                'scale' => '-',
                'type' => 'CH',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Semi-major axis ( accepted range = 6,300,000.0 to 6,500,000.0 meters ).',
                'group' => '',
                'ln_arg' => 3072,
                'name' => 'majA',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'R8',
                'unit' => 'm'
              },
              {
                'bitfield' => [],
                'descr' => '1.0 / ﬂattening ( accepted range is 0.0 to 500.0 ).',
                'group' => '',
                'ln_arg' => 3074,
                'name' => 'flat',
                'offset' => '16',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'R8',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'X axis shift at the origin ( accepted range is +/- 5000.0 meters ).',
                'group' => '',
                'ln_arg' => 3075,
                'name' => 'dX',
                'offset' => '24',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'R4',
                'unit' => 'm'
              },
              {
                'bitfield' => [],
                'descr' => 'Y axis shift at the origin ( accepted range is +/- 5000.0 meters ).',
                'group' => '',
                'ln_arg' => 3077,
                'name' => 'dY',
                'offset' => '28',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'R4',
                'unit' => 'm'
              },
              {
                'bitfield' => [],
                'descr' => 'Z axis shift at the origin ( accepted range is +/- 5000.0 meters ).',
                'group' => '',
                'ln_arg' => 3079,
                'name' => 'dZ',
                'offset' => '32',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'R4',
                'unit' => 'm'
              },
              {
                'bitfield' => [],
                'descr' => 'Rotation about the X axis ( accepted range is +/- 20.0 milli-arc seconds ).',
                'group' => '',
                'ln_arg' => 3081,
                'name' => 'rotX',
                'offset' => '36',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'R4',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'Rotation about the Y axis ( accepted range is +/- 20.0 milli-arc seconds ).',
                'group' => '',
                'ln_arg' => 3083,
                'name' => 'rotY',
                'offset' => '40',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'R4',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'Rotation about the Z axis ( accepted range is +/- 20.0 milli-arc seconds ).',
                'group' => '',
                'ln_arg' => 3085,
                'name' => 'rotZ',
                'offset' => '44',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'R4',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'Scale change ( accepted range is 0.0 to 50.0 parts per million ).',
                'group' => '',
                'ln_arg' => 3087,
                'name' => 'scale',
                'offset' => '48',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'R4',
                'unit' => 'ppm'
              }
            ],
  'class' => '0x06',
  'code' => 'UBX-CFG-DAT',
  'comment' => 'This message is deprecated in protocol versions greater than 23.01. Use UBX-CFG-VALSET, UBX-CFG-VALGET, UBX-CFG-VALDEL instead. See the Legacy UBX Message Fields Reference for the corresponding conﬁguration item. Returns the parameters of the currently deﬁned datum. If no user-deﬁned datum has been set, this will default to WGS84.',
  'id' => '0x06',
  'length' => '52',
  'ln_classid' => 3064,
  'ln_comment' => 3057,
  'ln_msg' => 3044,
  'ln_name' => 3045,
  'ln_type' => 3046,
  'name' => 'Get currently deﬁned datum',
  'type' => 'Get'
}
, ### UBX-CFG-DGNSS DGNSS conﬁguration ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Speciﬁes diﬀerential mode:
•   2 = RTK ﬂoat: No attempts are made to ﬁx ambiguities.
•   3 = RTK ﬁxed: Ambiguities are ﬁxed whenever possible.',
                'group' => '',
                'ln_arg' => 3116,
                'name' => 'dgnssMode',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 3121,
                'name' => 'reserved0',
                'offset' => '1',
                'repeat' => '3',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x06',
  'code' => 'UBX-CFG-DGNSS',
  'comment' => 'This message is deprecated in protocol versions greater than 23.01. Use UBX-CFG-VALSET, UBX-CFG-VALGET, UBX-CFG-VALDEL instead. See the Legacy UBX Message Fields Reference for the corresponding conﬁguration item. This message allows the user to conﬁgure the DGNSS conﬁguration of the receiver.',
  'id' => '0x70',
  'length' => '4',
  'ln_classid' => 3103,
  'ln_comment' => 3097,
  'ln_msg' => 3094,
  'ln_name' => 3095,
  'ln_type' => 3096,
  'name' => 'DGNSS conﬁguration',
  'type' => 'Get/set'
}
, ### UBX-CFG-GEOFENCE Geofencing conﬁguration ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Message version (0x00 for this version)',
                'group' => '',
                'ln_arg' => 3145,
                'name' => 'version',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Number of geofences contained in this message. Note that the receiver can only store a limited number of geofences (currently 4).',
                'group' => '',
                'ln_arg' => 3146,
                'name' => 'numFences',
                'offset' => '1',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Required conﬁdence level for state evaluation. This value times the position\'s standard deviation (sigma) deﬁnes the conﬁdence band.
•   0 = no conﬁdence required
•   1 = 68%
•   2 = 95%
•   3 = 99.7%
•   4 = 99.99%',
                'group' => '',
                'ln_arg' => 3149,
                'name' => 'confLvl',
                'offset' => '2',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 3157,
                'name' => 'reserved0',
                'offset' => '3',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => '1 = Enable PIO combined fence state output, 0 = disable',
                'group' => '',
                'ln_arg' => 3158,
                'name' => 'pioEnabled',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'PIO pin polarity. 0 = Low means inside, 1 = Low means outside. Unknown state is always high.',
                'group' => '',
                'ln_arg' => 3160,
                'name' => 'pinPolarity',
                'offset' => '5',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'PIO pin number',
                'group' => '',
                'ln_arg' => 3162,
                'name' => 'pin',
                'offset' => '6',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 3163,
                'name' => 'reserved1',
                'offset' => '7',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Latitude of the geofence circle center',
                'group' => 'repeated numFences',
                'ln_arg' => 3166,
                'name' => 'lat',
                'offset' => '8 + n·12',
                'repeat' => undef,
                'scale' => '1e-7',
                'type' => 'I4',
                'unit' => 'deg'
              },
              {
                'bitfield' => [],
                'descr' => 'Longitude of the geofence circle center',
                'group' => 'repeated numFences',
                'ln_arg' => 3167,
                'name' => 'lon',
                'offset' => '12 + n·12',
                'repeat' => undef,
                'scale' => '1e-7',
                'type' => 'I4',
                'unit' => 'deg'
              },
              {
                'bitfield' => [],
                'descr' => 'Radius of the geofence circle',
                'group' => 'repeated numFences',
                'ln_arg' => 3168,
                'name' => 'radius',
                'offset' => '16 + n·12',
                'repeat' => undef,
                'scale' => '1e-2',
                'type' => 'U4',
                'unit' => 'm'
              }
            ],
  'class' => '0x06',
  'code' => 'UBX-CFG-GEOFENCE',
  'comment' => 'This message is deprecated in protocol versions greater than 23.01. Use UBX-CFG-VALSET, UBX-CFG-VALGET, UBX-CFG-VALDEL instead. See the Legacy UBX Message Fields Reference for the corresponding conﬁguration item. Gets or sets the geofencing conﬁguration. If the receiver is sent a valid new conﬁguration, it will respond with a UBX-ACK-ACK message and immediately change to the new conﬁguration. Otherwise the receiver will reject the request, by issuing a UBX-ACK-NAK and continuing operation with the previous conﬁguration. Note that the acknowledge message does not indicate whether the PIO conﬁguration has been successfully applied (pin assigned), it only indicates the successful conﬁguration of the feature. The conﬁgured PIO must be previously unoccupied for successful assignment.',
  'hasgroup' => 'repeated numFences',
  'id' => '0x69',
  'length' => '8 + numFences·12',
  'ln_classid' => 3142,
  'ln_comment' => 3130,
  'ln_msg' => 3127,
  'ln_name' => 3128,
  'ln_type' => 3129,
  'name' => 'Geofencing conﬁguration',
  'type' => 'Get/set'
}
, ### UBX-CFG-GNSS GNSS system conﬁguration ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Message version (0x00 for this version)',
                'group' => '',
                'ln_arg' => 3216,
                'name' => 'msgVer',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Number of tracking channels available in hardware (read only)',
                'group' => '',
                'ln_arg' => 3217,
                'name' => 'numTrkChHw',
                'offset' => '1',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => '(Read only for protocol versions greater than 23.00) Number of tracking channels to use. Must be > 0, <= numTrkChHw. If 0xFF, then number of tracking channels to use will be set to numTrkChHw.',
                'group' => '',
                'ln_arg' => 3219,
                'name' => 'numTrkChUse',
                'offset' => '2',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Number of conﬁguration blocks following',
                'group' => '',
                'ln_arg' => 3223,
                'name' => 'numConfigBlocks',
                'offset' => '3',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'System identiﬁer (see Satellite Numbering)',
                'group' => 'repeated numConfigBlocks',
                'ln_arg' => 3226,
                'name' => 'gnssId',
                'offset' => '4 + n·8',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => '(Read only for protocol versions greater than 23.00) Number of reserved (minimum) tracking channels for this system.',
                'group' => 'repeated numConfigBlocks',
                'ln_arg' => 3227,
                'name' => 'resTrkCh',
                'offset' => '5 + n·8',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => '(Read only for protocol versions greater than 23.00) Maximum number of tracking channels used for this system. Must be > 0, >= resTrkChn, <= numTrkChUse and <= maximum number of tracking channels supported for this system.',
                'group' => 'repeated numConfigBlocks',
                'ln_arg' => 3240,
                'name' => 'maxTrkCh',
                'offset' => '6 + n·8',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => 'repeated numConfigBlocks',
                'ln_arg' => 3245,
                'name' => 'reserved0',
                'offset' => '7 + n·8',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '0',
                                  'bitfrom' => undef,
                                  'descr' => 'Enable this system',
                                  'name' => 'enable',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '23',
                                  'bitfrom' => '16',
                                  'descr' => 'Signal conﬁguration mask When gnssId is 0 (GPS)
•   0x01 = GPS L1C/A
•   0x10 = GPS L2C When gnssId is 1 (SBAS)
•   0x01 = SBAS L1C/A When gnssId is 2 (Galileo)
•   0x01 = Galileo E1 (not supported for protocol versions less than 18.00)
•   0x20 = Galileo E5b When gnssId is 3 (BeiDou)
•   0x01 = BeiDou B1I
•   0x10 = BeiDou B2I When gnssId is 4 (IMES)
•   0x01 = IMES L1 When gnssId is 5 (QZSS)
•   0x01 = QZSS L1C/A
•   0x04 = QZSS L1S
•   0x10 = QZSS L2C When gnssId is 6 (GLONASS)
•   0x01 = GLONASS L1
•   0x10 = GLONASS L2',
                                  'name' => 'sigCfgMask',
                                  'numbits' => '8'
                                }
                              ],
                'descr' => 'Bitﬁeld of ﬂags. At least one signal must be conﬁgured in every enabled system.',
                'group' => 'repeated numConfigBlocks',
                'ln_arg' => 3246,
                'name' => 'flags',
                'offset' => '8 + n·8',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X4',
                'unit' => '-'
              }
            ],
  'class' => '0x06',
  'code' => 'UBX-CFG-GNSS',
  'comment' => 'This message is deprecated in protocol versions greater than 23.01. Use UBX-CFG-VALSET, UBX-CFG-VALGET, UBX-CFG-VALDEL instead. See the Legacy UBX Message Fields Reference for the corresponding conﬁguration item. Gets or sets the GNSS system channel sharing conﬁguration. If the receiver is sent a valid new conﬁguration, it will respond with a UBX-ACK-ACK message and immediately change to the new conﬁguration. Otherwise the receiver will reject the request, by issuing a UBX-ACK-NAK and continuing operation with the previous conﬁguration. Conﬁguration requirements:
•    It is necessary for at least one major GNSS to be enabled, after applying the new conﬁguration to the current one.
•    It is also required that at least 4 tracking channels are available to each enabled major GNSS, i.e. maxTrkCh must have a minimum value of 4 for each enabled major GNSS.
•    The number of tracking channels in use must not exceed the number of tracking channels available in hardware, and the sum of all reserved tracking channels needs to be less than or equal to the number of tracking channels in use. Notes:
•    To avoid cross-correlation issues, it is recommended that GPS and QZSS are always both enabled or both disabled.
•    Polling this message returns the conﬁguration of all supported GNSS, whether enabled or not; it may also include GNSS unsupported by the particular product, but in such cases the enable ﬂag will always be unset.
•    See section Satellite Numbering for a description of the GNSS IDs available.
•    Conﬁguration speciﬁc to the GNSS system can be done via other messages (e.g. UBX-CFG-SBAS).',
  'hasgroup' => 'repeated numConfigBlocks',
  'id' => '0x3e',
  'length' => '4 + numConﬁgBlocks·8',
  'ln_bitfield' => 3251,
  'ln_classid' => 3213,
  'ln_comment' => 3188,
  'ln_msg' => 3185,
  'ln_name' => 3186,
  'ln_type' => 3187,
  'name' => 'GNSS system conﬁguration',
  'type' => 'Get/set'
}
, ### UBX-CFG-INF Poll conﬁguration for one protocol ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Protocol identiﬁer, identifying the output protocol for this poll request. The following are valid protocol identiﬁers:
•   0: UBX protocol
•   1: NMEA protocol
•   2-255: Reserved',
                'group' => '',
                'ln_arg' => 3300,
                'name' => 'protocolID',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x06',
  'code' => 'UBX-CFG-INF',
  'comment' => 'This message is deprecated in protocol versions greater than 23.01. Use UBX-CFG-VALSET, UBX-CFG-VALGET, UBX-CFG-VALDEL instead. See the Legacy UBX Message Fields Reference for the corresponding conﬁguration item.',
  'id' => '0x02',
  'length' => '1',
  'ln_classid' => 3287,
  'ln_comment' => 3282,
  'ln_msg' => 3279,
  'ln_name' => 3280,
  'ln_type' => 3281,
  'name' => 'Poll conﬁguration for one protocol',
  'type' => 'Poll request'
}
, ### UBX-CFG-INF Information message conﬁguration ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Protocol identiﬁer, identifying for which protocol the conﬁguration is set/get. The following are valid protocol identiﬁers:
•   0: UBX protocol
•   1: NMEA protocol
•   2-255: Reserved',
                'group' => 'repeated N',
                'ln_arg' => 3329,
                'name' => 'protocolID',
                'offset' => '0 + n·10',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => 'repeated N',
                'ln_arg' => 3335,
                'name' => 'reserved0',
                'offset' => '1 + n·10',
                'repeat' => '3',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '0',
                                  'bitfrom' => undef,
                                  'descr' => 'enable ERROR',
                                  'name' => 'ERROR',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '1',
                                  'bitfrom' => undef,
                                  'descr' => 'enable WARNING',
                                  'name' => 'WARNING',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '2',
                                  'bitfrom' => undef,
                                  'descr' => 'enable NOTICE',
                                  'name' => 'NOTICE',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '3',
                                  'bitfrom' => undef,
                                  'descr' => 'enable TEST',
                                  'name' => 'TEST',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '4',
                                  'bitfrom' => undef,
                                  'descr' => 'enable DEBUG',
                                  'name' => 'DEBUG',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'A bit mask, saying which information messages are enabled on each I/O port',
                'group' => 'repeated N',
                'ln_arg' => 3336,
                'name' => 'infMsgMask',
                'offset' => '4 + n·10',
                'repeat' => '6',
                'scale' => '-',
                'type' => 'X1',
                'unit' => '-'
              }
            ],
  'class' => '0x06',
  'code' => 'UBX-CFG-INF',
  'comment' => 'This message is deprecated in protocol versions greater than 23.01. Use UBX-CFG-VALSET, UBX-CFG-VALGET, UBX-CFG-VALDEL instead. The value of infMsgMask[x] below is formed so that each bit represents one of the INF class messages (bit 0 for ERROR, bit 1 for WARNING and so on). For a complete list, see the Message class INF. Several conﬁgurations can be concatenated to one input message. In this case the payload length can be a multiple of the normal length. Output messages from the module contain only one conﬁguration unit. Note that:
•     I/O ports 1 and 2 correspond to serial ports 1 and 2.
•     I/O port 0 is I2C (DDC).
•     I/O port 3 is USB.
•     I/O port 4 is SPI.
•     I/O port 5 is reserved for future use.',
  'hasgroup' => 'repeated N',
  'id' => '0x02',
  'length' => '[0..n]·10',
  'ln_bitfield' => 3347,
  'ln_classid' => 3325,
  'ln_comment' => 3311,
  'ln_msg' => 3308,
  'ln_name' => 3309,
  'ln_type' => 3310,
  'name' => 'Information message conﬁguration',
  'type' => 'Get/set'
}
, ### UBX-CFG-ITFM Jamming/interference monitor conﬁguration ###
{
  'args' => [
              {
                'bitfield' => [
                                {
                                  'bit' => '3',
                                  'bitfrom' => '0',
                                  'descr' => 'Broadband jamming detection threshold',
                                  'name' => 'bbThreshold',
                                  'numbits' => '4'
                                },
                                {
                                  'bit' => '8',
                                  'bitfrom' => '4',
                                  'descr' => 'CW jamming detection threshold',
                                  'name' => 'cwThreshold',
                                  'numbits' => '5'
                                },
                                {
                                  'bit' => '30',
                                  'bitfrom' => '9',
                                  'descr' => 'Reserved algorithm settings - should be set to 0x16B156 in hex for correct settings',
                                  'name' => 'algorithmBits',
                                  'numbits' => '22'
                                },
                                {
                                  'bit' => '31',
                                  'bitfrom' => undef,
                                  'descr' => 'Enable interference detection',
                                  'name' => 'enable',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'Interference conﬁg word',
                'group' => '',
                'ln_arg' => 3375,
                'name' => 'config',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X4',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '11',
                                  'bitfrom' => '0',
                                  'descr' => 'General settings - should be set to 0x31E in hex for correct setting',
                                  'name' => 'generalBits',
                                  'numbits' => '12'
                                },
                                {
                                  'bit' => '13',
                                  'bitfrom' => '12',
                                  'descr' => 'Antenna setting, 0=unknown, 1=passive, 2=active',
                                  'name' => 'antSetting',
                                  'numbits' => '2'
                                },
                                {
                                  'bit' => '14',
                                  'bitfrom' => undef,
                                  'descr' => 'Set to 1 to scan auxiliary bands (u-blox 8 / u-blox M8 only, otherwise ignored)',
                                  'name' => 'enable2',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'Extra settings for jamming/interference monitor',
                'group' => '',
                'ln_arg' => 3384,
                'name' => 'config2',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X4',
                'unit' => '-'
              }
            ],
  'class' => '0x06',
  'code' => 'UBX-CFG-ITFM',
  'comment' => 'This message is deprecated in protocol versions greater than 23.01. Use UBX-CFG-VALSET, UBX-CFG-VALGET, UBX-CFG-VALDEL instead. See the Legacy UBX Message Fields Reference for the corresponding conﬁguration item.',
  'id' => '0x39',
  'length' => '8',
  'ln_bitfield' => 3390,
  'ln_classid' => 3372,
  'ln_comment' => 3367,
  'ln_msg' => 3354,
  'ln_name' => 3355,
  'ln_type' => 3356,
  'name' => 'Jamming/interference monitor conﬁguration',
  'type' => 'Get/set'
}
, ### UBX-CFG-LOGFILTER Data logger conﬁguration ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Message version (0x01 for this version)',
                'group' => '',
                'ln_arg' => 3418,
                'name' => 'version',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '0',
                                  'bitfrom' => undef,
                                  'descr' => '1 = enable recording, 0 = disable recording',
                                  'name' => 'recordEnabled',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '1',
                                  'bitfrom' => undef,
                                  'descr' => '1 = enable recording only one single position per PSM mode wake-up period, 0 = disable once per wake-up',
                                  'name' => 'psmOncePerWakupEnabled',
                                  'numbits' => '1',
                                  'unit' => 'on/oﬀ'
                                },
                                {
                                  'bit' => '2',
                                  'bitfrom' => undef,
                                  'descr' => '1 = apply all ﬁlter settings, 0 = only apply',
                                  'name' => 'applyAllFilterSettings',
                                  'numbits' => '1',
                                  'unit' => 'recordEnabled'
                                }
                              ],
                'descr' => 'Flags',
                'group' => '',
                'ln_arg' => 3419,
                'name' => 'flags',
                'offset' => '1',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Minimum time interval between logged positions (0 = not set). This is only applied in combination with the speed and/or position thresholds. If both minInterval and timeThreshold are set, minInterval must be less than or equal to timeThreshold.',
                'group' => '',
                'ln_arg' => 3437,
                'name' => 'minInterval',
                'offset' => '2',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'If the time diﬀerence is greater than the threshold, then the position is logged (0 = not set).',
                'group' => '',
                'ln_arg' => 3442,
                'name' => 'timeThreshold',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'If the current speed is greater than the threshold, then the position is logged (0 = not set). minInterval also applies.',
                'group' => '',
                'ln_arg' => 3444,
                'name' => 'speedThreshold',
                'offset' => '6',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => 'm/s'
              },
              {
                'bitfield' => [],
                'descr' => 'If the 3D position diﬀerence is greater than the then the position is logged (0 = not set). minInterval also applies.',
                'group' => '',
                'ln_arg' => 3447,
                'name' => 'positionThreshold',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'mthreshold,'
              }
            ],
  'class' => '0x06',
  'code' => 'UBX-CFG-LOGFILTER',
  'comment' => 'This message is deprecated in protocol versions greater than 23.01. Use UBX-CFG-VALSET, UBX-CFG-VALGET, UBX-CFG-VALDEL instead. See the Legacy UBX Message Fields Reference for the corresponding conﬁguration item. This message can be used to conﬁgure the data logger, i.e. to enable/disable the log recording and to get/set the position entry ﬁlter settings. Position entries can be ﬁltered based on time diﬀerence, position diﬀerence or current speed thresholds. Position and speed ﬁltering also have a minimum time interval. A position is logged if any of the thresholds are exceeded. If a threshold is set to zero it is ignored. The maximum rate of position logging is 1 Hz. The ﬁlter settings will be conﬁgured to the provided values only if the \'applyAllFilterSettings\' ﬂag is set. This allows the recording to be enabled/disabled independently of conﬁguring the ﬁlter settings. Conﬁguring the data logger in the absence of a logging ﬁle is supported. By doing so, once the logging ﬁle is created, the data logger conﬁguration will take eﬀect immediately and logging recording and ﬁltering will activate according to the conﬁguration.',
  'id' => '0x47',
  'length' => '12',
  'ln_bitfield' => 3435,
  'ln_classid' => 3415,
  'ln_comment' => 3400,
  'ln_msg' => 3397,
  'ln_name' => 3398,
  'ln_type' => 3399,
  'name' => 'Data logger conﬁguration',
  'type' => 'Get/set'
}
, ### UBX-CFG-MSG Poll a message conﬁguration ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Message class',
                'group' => '',
                'ln_arg' => 3466,
                'name' => 'msgClass',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Message identiﬁer',
                'group' => '',
                'ln_arg' => 3467,
                'name' => 'msgID',
                'offset' => '1',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x06',
  'code' => 'UBX-CFG-MSG',
  'comment' => 'This message is deprecated in protocol versions greater than 23.01. Use UBX-CFG-VALSET, UBX-CFG-VALGET, UBX-CFG-VALDEL instead. See the Legacy UBX Message Fields Reference for the corresponding conﬁguration item.',
  'id' => '0x01',
  'length' => '2',
  'ln_classid' => 3463,
  'ln_comment' => 3458,
  'ln_msg' => 3455,
  'ln_name' => 3456,
  'ln_type' => 3457,
  'name' => 'Poll a message conﬁguration',
  'type' => 'Poll request'
}
, ### UBX-CFG-MSG Set message rate(s) ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Message class',
                'group' => '',
                'ln_arg' => 3486,
                'name' => 'msgClass',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Message identiﬁer',
                'group' => '',
                'ln_arg' => 3487,
                'name' => 'msgID',
                'offset' => '1',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Send rate on I/O port (6 ports)',
                'group' => '',
                'ln_arg' => 3498,
                'name' => 'rate',
                'offset' => '2',
                'repeat' => '6',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x06',
  'code' => 'UBX-CFG-MSG',
  'comment' => 'This message is deprecated in protocol versions greater than 23.01. Use UBX-CFG-VALSET, UBX-CFG-VALGET, UBX-CFG-VALDEL instead. See the Legacy UBX Message Fields Reference for the corresponding conﬁguration item. Get/set message rate conﬁguration (s) to/from the receiver.
•     Send rate is relative to the event a message is registered on. For example, if the rate of a navigation message is set to 2, the message is sent every second navigation solution. For conﬁguring NMEA messages, the section NMEA Messages Overview describes class and identiﬁer numbers used.',
  'id' => '0x01',
  'length' => '8',
  'ln_classid' => 3483,
  'ln_comment' => 3474,
  'ln_msg' => 3471,
  'ln_name' => 3472,
  'ln_type' => 3473,
  'name' => 'Set message rate(s)',
  'type' => 'Get/set'
}
, ### UBX-CFG-MSG Set message rate ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Message class',
                'group' => '',
                'ln_arg' => 3514,
                'name' => 'msgClass',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Message identiﬁer',
                'group' => '',
                'ln_arg' => 3515,
                'name' => 'msgID',
                'offset' => '1',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Send rate on current port',
                'group' => '',
                'ln_arg' => 3516,
                'name' => 'rate',
                'offset' => '2',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x06',
  'code' => 'UBX-CFG-MSG',
  'comment' => 'This message is deprecated in protocol versions greater than 23.01. Use UBX-CFG-VALSET, UBX-CFG-VALGET, UBX-CFG-VALDEL instead. See the Legacy UBX Message Fields Reference for the corresponding conﬁguration item. Set message rate conﬁguration for the current port.',
  'id' => '0x01',
  'length' => '3',
  'ln_classid' => 3511,
  'ln_comment' => 3505,
  'ln_msg' => 3502,
  'ln_name' => 3503,
  'ln_type' => 3504,
  'name' => 'Set message rate',
  'type' => 'Get/set'
}
, ### UBX-CFG-NAV5 Navigation engine settings ###
{
  'args' => [
              {
                'bitfield' => [
                                {
                                  'bit' => '0',
                                  'bitfrom' => undef,
                                  'descr' => 'Apply dynamic model settings',
                                  'name' => 'dyn',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '1',
                                  'bitfrom' => undef,
                                  'descr' => 'Apply minimum elevation settings',
                                  'name' => 'minEl',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '2',
                                  'bitfrom' => undef,
                                  'descr' => 'Apply ﬁx mode settings',
                                  'name' => 'posFixMode',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '3',
                                  'bitfrom' => undef,
                                  'descr' => 'Reserved (apply DR limit settings, only applicable for protocol versions less than 14.00)',
                                  'name' => 'drLim',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '4',
                                  'bitfrom' => undef,
                                  'descr' => 'Apply position mask settings',
                                  'name' => 'posMask',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '5',
                                  'bitfrom' => undef,
                                  'descr' => 'Apply time mask settings',
                                  'name' => 'timeMask',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '6',
                                  'bitfrom' => undef,
                                  'descr' => 'Apply static hold settings',
                                  'name' => 'staticHoldMask',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '7',
                                  'bitfrom' => undef,
                                  'descr' => 'Apply DGPS settings (not supported for protocol versions less than 13.00)',
                                  'name' => 'dgpsMask',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '8',
                                  'bitfrom' => undef,
                                  'descr' => 'Apply   CNO  threshold            settings     (cnoThresh, cnoThreshNumSVs) (not supported for protocol versions less than 14.00)',
                                  'name' => 'cnoThreshold',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '10',
                                  'bitfrom' => undef,
                                  'descr' => 'Apply UTC settings supported for protocol versions less than 16.00)',
                                  'name' => 'utc',
                                  'numbits' => '1',
                                  'unit' => '(not'
                                }
                              ],
                'descr' => 'Parameters bitmask. Only the masked parameters will be applied.',
                'group' => '',
                'ln_arg' => 3533,
                'name' => 'mask',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Dynamic platform model:
•   0 = portable
•   2 = stationary
•   3 = pedestrian
•   4 = automotive
•   5 = sea
•   6 = airborne with <1g acceleration
•   7 = airborne with <2g acceleration
•   8 = airborne with <4g acceleration
•   9 = wrist-worn watch (not supported for protocol versions less than 18.00)
•   10 = bike (supported for protocol versions 19.20)',
                'group' => '',
                'ln_arg' => 3565,
                'name' => 'dynModel',
                'offset' => '2',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Position ﬁxing mode:
•   1 = 2D only
•   2 = 3D only
•   3 = auto 2D/3D',
                'group' => '',
                'ln_arg' => 3577,
                'name' => 'fixMode',
                'offset' => '3',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Fixed altitude (mean sea level) for 2D ﬁx mode',
                'group' => '',
                'ln_arg' => 3581,
                'name' => 'fixedAlt',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '0.01',
                'type' => 'I4',
                'unit' => 'm'
              },
              {
                'bitfield' => [],
                'descr' => 'Fixed altitude variance for 2D mode',
                'group' => '',
                'ln_arg' => 3582,
                'name' => 'fixedAltVar',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '0.0001',
                'type' => 'U4',
                'unit' => 'm^2'
              },
              {
                'bitfield' => [],
                'descr' => 'Minimum elevation for a GNSS satellite to be used in NAV',
                'group' => '',
                'ln_arg' => 3583,
                'name' => 'minElev',
                'offset' => '12',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I1',
                'unit' => 'deg'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved (maximum time to perform dead reckoning (linear extrapolation) in case of GPS signal loss, only applicable for protocol versions less than 14.00)',
                'group' => '',
                'ln_arg' => 3585,
                'name' => 'drLimit',
                'offset' => '13',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'Position DOP mask to use',
                'group' => '',
                'ln_arg' => 3588,
                'name' => 'pDop',
                'offset' => '14',
                'repeat' => undef,
                'scale' => '0.1',
                'type' => 'U2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Time DOP mask to use',
                'group' => '',
                'ln_arg' => 3589,
                'name' => 'tDop',
                'offset' => '16',
                'repeat' => undef,
                'scale' => '0.1',
                'type' => 'U2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Position accuracy mask',
                'group' => '',
                'ln_arg' => 3590,
                'name' => 'pAcc',
                'offset' => '18',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => 'm'
              },
              {
                'bitfield' => [],
                'descr' => 'Time accuracy mask',
                'group' => '',
                'ln_arg' => 3591,
                'name' => 'tAcc',
                'offset' => '20',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => 'm'
              },
              {
                'bitfield' => [],
                'descr' => 'Static hold threshold',
                'group' => '',
                'ln_arg' => 3592,
                'name' => 'staticHoldThresh',
                'offset' => '22',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => 'cm/s'
              },
              {
                'bitfield' => [],
                'descr' => 'DGNSS timeout (not supported for protocol versions less than 13.00)',
                'group' => '',
                'ln_arg' => 3594,
                'name' => 'dgnssTimeout',
                'offset' => '23',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'Number of satellites required to have C/N0 above for a ﬁx to be attempted (not supported for protocol versions less than 14.00)',
                'group' => '',
                'ln_arg' => 3596,
                'name' => 'cnoThreshNumSVs',
                'offset' => '24',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-cnoThresh'
              },
              {
                'bitfield' => [],
                'descr' => 'C/N0 threshold for deciding whether to attempt a ﬁx (not supported for protocol versions less than 14.00)',
                'group' => '',
                'ln_arg' => 3599,
                'name' => 'cnoThresh',
                'offset' => '25',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => 'dBHz'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 3601,
                'name' => 'reserved0',
                'offset' => '26',
                'repeat' => '2',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Static hold distance threshold (before quitting static (not supported for protocol versions less than 15.00)',
                'group' => '',
                'ln_arg' => 3602,
                'name' => 'staticHoldMaxDist',
                'offset' => '28',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => 'mhold)'
              },
              {
                'bitfield' => [],
                'descr' => 'UTC standard to be used:
•  0 = Automatic; receiver selects based on GNSS conﬁguration (see GNSS time bases)
• 3 = UTC as operated by the U.S. Naval Observatory (USNO); derived from GPS time
• 5 = UTC as combined from multiple European laboratories; derived from Galileo time
• 6 = UTC as operated by the former Soviet Union (SU); derived from GLONASS time
• 7 = UTC as operated by the National Time Service Center (NTSC), China; derived from BeiDou time (not supported for protocol versions less than 16.00)',
                'group' => '',
                'ln_arg' => 3615,
                'name' => 'utcStandard',
                'offset' => '30',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 3627,
                'name' => 'reserved1',
                'offset' => '31',
                'repeat' => '5',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x06',
  'code' => 'UBX-CFG-NAV5',
  'comment' => 'This message is deprecated in protocol versions greater than 23.01. Use UBX-CFG-VALSET, UBX-CFG-VALGET, UBX-CFG-VALDEL instead. See the Legacy UBX Message Fields Reference for the corresponding conﬁguration item.',
  'id' => '0x24',
  'length' => '36',
  'ln_bitfield' => 3555,
  'ln_classid' => 3530,
  'ln_comment' => 3525,
  'ln_msg' => 3522,
  'ln_name' => 3523,
  'ln_type' => 3524,
  'name' => 'Navigation engine settings',
  'type' => 'Get/set'
}
, ### UBX-CFG-NAVX5 Navigation engine expert settings ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Message version (0x0002 for this version)',
                'group' => '',
                'ln_arg' => 3644,
                'name' => 'version',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '2',
                                  'bitfrom' => undef,
                                  'descr' => '1 = apply min/max SVs settings',
                                  'name' => 'minMax',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '3',
                                  'bitfrom' => undef,
                                  'descr' => '1 = apply minimum C/N0 setting',
                                  'name' => 'minCno',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '6',
                                  'bitfrom' => undef,
                                  'descr' => '1 = apply initial 3D ﬁx settings',
                                  'name' => 'initial3dfix',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '9',
                                  'bitfrom' => undef,
                                  'descr' => '1 = apply GPS weeknumber rollover settings',
                                  'name' => 'wknRoll',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '10',
                                  'bitfrom' => undef,
                                  'descr' => '1 = apply assistance acknowledgement settings',
                                  'name' => 'ackAid',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '13',
                                  'bitfrom' => undef,
                                  'descr' => '1 = apply usePPP ﬂag',
                                  'name' => 'ppp',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '14',
                                  'bitfrom' => undef,
                                  'descr' => '1 = apply aopCfg (useAOP ﬂag) and aopOrbMaxErr settings (AssistNow Autonomous)',
                                  'name' => 'aop',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'First parameters bitmask. Only the ﬂagged parameters will be applied, unused bits must be set to 0.',
                'group' => '',
                'ln_arg' => 3645,
                'name' => 'mask1',
                'offset' => '2',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X2',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '6',
                                  'bitfrom' => undef,
                                  'descr' => 'Apply ADR/UDR sensor fusion on/oﬀ setting (useAdr ﬂag)',
                                  'name' => 'adr',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '7',
                                  'bitfrom' => undef,
                                  'descr' => 'Only supported on certain products',
                                  'name' => 'sigAttenComp',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'Second parameters bitmask. Only the ﬂagged parameters will be applied, unused bits must be set to 0.',
                'group' => '',
                'ln_arg' => 3663,
                'name' => 'mask2',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X4',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 3670,
                'name' => 'reserved0',
                'offset' => '8',
                'repeat' => '2',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Minimum number of satellites for navigation',
                'group' => '',
                'ln_arg' => 3671,
                'name' => 'minSVs',
                'offset' => '10',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '#SVs'
              },
              {
                'bitfield' => [],
                'descr' => 'Maximum number of satellites for navigation',
                'group' => '',
                'ln_arg' => 3672,
                'name' => 'maxSVs',
                'offset' => '11',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '#SVs'
              },
              {
                'bitfield' => [],
                'descr' => 'Minimum satellite signal level for navigation',
                'group' => '',
                'ln_arg' => 3673,
                'name' => 'minCNO',
                'offset' => '12',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => 'dBHz'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 3684,
                'name' => 'reserved1',
                'offset' => '13',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => '1 = initial ﬁx must be 3D',
                'group' => '',
                'ln_arg' => 3685,
                'name' => 'iniFix3D',
                'offset' => '14',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 3686,
                'name' => 'reserved2',
                'offset' => '15',
                'repeat' => '2',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => '1 = issue acknowledgements for assistance message input',
                'group' => '',
                'ln_arg' => 3687,
                'name' => 'ackAiding',
                'offset' => '17',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'GPS week rollover number; GPS week numbers will be set correctly from this week up to 1024 weeks after this week. Setting this to 0 reverts to ﬁrmware default.',
                'group' => '',
                'ln_arg' => 3689,
                'name' => 'wknRollover',
                'offset' => '18',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Only supported on certain products',
                'group' => '',
                'ln_arg' => 3692,
                'name' => 'sigAttenCompMode',
                'offset' => '20',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => 'dBHz'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 3694,
                'name' => 'reserved3',
                'offset' => '21',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 3695,
                'name' => 'reserved4',
                'offset' => '22',
                'repeat' => '2',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 3696,
                'name' => 'reserved5',
                'offset' => '24',
                'repeat' => '2',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => '1 = use Precise Point Positioning (only available with the PPP product variant)',
                'group' => '',
                'ln_arg' => 3697,
                'name' => 'usePPP',
                'offset' => '26',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '0',
                                  'bitfrom' => undef,
                                  'descr' => '1 = enable AssistNow Autonomous',
                                  'name' => 'useAOP',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'AssistNow Autonomous conﬁguration',
                'group' => '',
                'ln_arg' => 3699,
                'name' => 'aopCfg',
                'offset' => '27',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 3702,
                'name' => 'reserved6',
                'offset' => '28',
                'repeat' => '2',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Maximum      acceptable     (modeled)     AssistNow Autonomous orbit error (valid range = 5..1000, or 0 = reset to ﬁrmware default)',
                'group' => '',
                'ln_arg' => 3703,
                'name' => 'aopOrbMaxErr',
                'offset' => '30',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => 'm'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 3706,
                'name' => 'reserved7',
                'offset' => '32',
                'repeat' => '4',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 3707,
                'name' => 'reserved8',
                'offset' => '36',
                'repeat' => '3',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Only supported on certain products',
                'group' => '',
                'ln_arg' => 3708,
                'name' => 'useAdr',
                'offset' => '39',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x06',
  'code' => 'UBX-CFG-NAVX5',
  'comment' => 'This message is deprecated in protocol versions greater than 23.01. Use UBX-CFG-VALSET, UBX-CFG-VALGET, UBX-CFG-VALDEL instead. See the Legacy UBX Message Fields Reference for the corresponding conﬁguration item.',
  'id' => '0x23',
  'length' => '40',
  'ln_bitfield' => 3701,
  'ln_classid' => 3641,
  'ln_comment' => 3636,
  'ln_msg' => 3633,
  'ln_name' => 3634,
  'ln_type' => 3635,
  'name' => 'Navigation engine expert settings',
  'type' => 'Get/set'
}
, ### UBX-CFG-NMEA Extended NMEA protocol conﬁguration V1 ###
{
  'args' => [
              {
                'bitfield' => [
                                {
                                  'bit' => '0',
                                  'bitfrom' => undef,
                                  'descr' => 'Enable position output for failed or invalid ﬁxes',
                                  'name' => 'posFilt',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '1',
                                  'bitfrom' => undef,
                                  'descr' => 'Enable position output for invalid ﬁxes',
                                  'name' => 'mskPosFilt',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '2',
                                  'bitfrom' => undef,
                                  'descr' => 'Enable time output for invalid times',
                                  'name' => 'timeFilt',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '3',
                                  'bitfrom' => undef,
                                  'descr' => 'Enable date output for invalid dates',
                                  'name' => 'dateFilt',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '4',
                                  'bitfrom' => undef,
                                  'descr' => 'Restrict output to GPS satellites only',
                                  'name' => 'gpsOnlyFilter',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '5',
                                  'bitfrom' => undef,
                                  'descr' => 'Enable COG output even if COG is frozen',
                                  'name' => 'trackFilt',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'ﬁlter ﬂags',
                'group' => '',
                'ln_arg' => 3727,
                'name' => 'filter',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => '•   0x4b = NMEA version 4.11 (not available in all products)
•   0x41 = NMEA version 4.10 (not available in all products)
•   0x40 = NMEA version 4.0 (not available in all products)
•   0x23 = NMEA version 2.3
•   0x21 = NMEA version 2.1',
                'group' => '',
                'ln_arg' => 3749,
                'name' => 'nmeaVersion',
                'offset' => '1',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Maximum number of SVs to report per TalkerId.
•   0 = unlimited
•   8 = 8 SVs
•   12 = 12 SVs
•   16 = 16 SVs',
                'group' => '',
                'ln_arg' => 3757,
                'name' => 'numSV',
                'offset' => '2',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '0',
                                  'bitfrom' => undef,
                                  'descr' => 'enable compatibility mode. This might be needed for certain applications when customer\'s NMEA parser expects a ﬁxed number of digits in position coordinates.',
                                  'name' => 'compat',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '1',
                                  'bitfrom' => undef,
                                  'descr' => 'enable considering mode.',
                                  'name' => 'consider',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '2',
                                  'bitfrom' => undef,
                                  'descr' => 'enable strict limit to 82 characters maximum.',
                                  'name' => 'limit82',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '3',
                                  'bitfrom' => undef,
                                  'descr' => 'enable high precision mode. This ﬂag cannot be set in conjunction with either compatibility mode or Limit82 mode (not supported for protocol versions less than 20.01).',
                                  'name' => 'highPrec',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'ﬂags',
                'group' => '',
                'ln_arg' => 3762,
                'name' => 'flags',
                'offset' => '3',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X1',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '0',
                                  'bitfrom' => undef,
                                  'descr' => 'Disable reporting of GPS satellites',
                                  'name' => 'gps',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '1',
                                  'bitfrom' => undef,
                                  'descr' => 'Disable reporting of SBAS satellites',
                                  'name' => 'sbas',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '2',
                                  'bitfrom' => undef,
                                  'descr' => 'Disable reporting of Galileo satellites',
                                  'name' => 'galileo',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '4',
                                  'bitfrom' => undef,
                                  'descr' => 'Disable reporting of QZSS satellites',
                                  'name' => 'qzss',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '5',
                                  'bitfrom' => undef,
                                  'descr' => 'Disable reporting of GLONASS satellites',
                                  'name' => 'glonass',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '6',
                                  'bitfrom' => undef,
                                  'descr' => 'Disable reporting of BeiDou satellites',
                                  'name' => 'beidou',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'Filters out satellites based on their GNSS. If a bitﬁeld is enabled, the corresponding satellites will be not output.',
                'group' => '',
                'ln_arg' => 3777,
                'name' => 'gnssToFilter',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X4',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Conﬁgures the display of satellites that do not have an NMEA-deﬁned value. Note: this does not apply to satellites with an unknown ID.
•   0 = Strict - Satellites are not output
•   1 = Extended - Use proprietary numbering (see Satellite Numbering)',
                'group' => '',
                'ln_arg' => 3792,
                'name' => 'svNumbering',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'By default the main Talker ID (i.e. the Talker ID used for all messages other than GSV) is determined by the GNSS assignment of the receiver\'s channels (see UBX- CFG-GNSS). This ﬁeld enables the main Talker ID to be overridden.
•   0 = Main Talker ID is not overridden
•   1 = Set main Talker ID to \'GP\'
•   2 = Set main Talker ID to \'GL\'
•   3 = Set main Talker ID to \'GN\'
•   4 = Set main Talker ID to \'GA\' (not supported for protocol versions less than 15.00)
•   5 = Set main Talker ID to \'GB\' (not supported for protocol versions less than 15.00)
•   6 = Set main Talker ID to \'GQ\' (available in NMEA 4.11 or later)',
                'group' => '',
                'ln_arg' => 3809,
                'name' => 'mainTalkerId',
                'offset' => '9',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'By default the Talker ID for GSV messages is GNSS- speciﬁc (as deﬁned by NMEA). This ﬁeld enables the GSV Talker ID to be overridden.
•   0 = Use GNSS-speciﬁc Talker ID (as deﬁned by NMEA)
•   1 = Use the main Talker ID',
                'group' => '',
                'ln_arg' => 3824,
                'name' => 'gsvTalkerId',
                'offset' => '10',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Message version (0x01 for this version)',
                'group' => '',
                'ln_arg' => 3830,
                'name' => 'version',
                'offset' => '11',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Sets the two characters that should be used for the BeiDou Talker ID. If these are set to zero, then the default BeiDou Talker ID will be used.',
                'group' => '',
                'ln_arg' => 3831,
                'name' => 'bdsTalkerId',
                'offset' => '12',
                'repeat' => '2',
                'scale' => '-',
                'type' => 'CH',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 3834,
                'name' => 'reserved0',
                'offset' => '14',
                'repeat' => '6',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x06',
  'code' => 'UBX-CFG-NMEA',
  'comment' => 'This message is deprecated in protocol versions greater than 23.01. Use UBX-CFG-VALSET, UBX-CFG-VALGET, UBX-CFG-VALDEL instead. Get/set the NMEA protocol conﬁguration. See section NMEA Protocol Conﬁguration for a detailed description of the conﬁguration eﬀects on NMEA output. See the Legacy UBX Message Fields Reference for the corresponding conﬁguration item.',
  'id' => '0x17',
  'length' => '20',
  'ln_bitfield' => 3791,
  'ln_classid' => 3724,
  'ln_comment' => 3717,
  'ln_msg' => 3714,
  'ln_name' => 3715,
  'ln_type' => 3716,
  'name' => 'Extended NMEA protocol conﬁguration V1',
  'type' => 'Get/set'
}
, ### UBX-CFG-ODO Odometer, low-speed COG engine settings ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Message version (0x00 for this version)',
                'group' => '',
                'ln_arg' => 3852,
                'name' => 'version',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 3853,
                'name' => 'reserved0',
                'offset' => '1',
                'repeat' => '3',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '0',
                                  'bitfrom' => undef,
                                  'descr' => 'Odometer-enabled ﬂag',
                                  'name' => 'useODO',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '1',
                                  'bitfrom' => undef,
                                  'descr' => 'Low-speed COG ﬁlter enabled ﬂag',
                                  'name' => 'useCOG',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '2',
                                  'bitfrom' => undef,
                                  'descr' => 'Output low-pass ﬁltered velocity ﬂag',
                                  'name' => 'outLPVel',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '3',
                                  'bitfrom' => undef,
                                  'descr' => 'Output low-pass ﬁltered heading (COG) ﬂag',
                                  'name' => 'outLPCog',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'Odometer/Low-speed COG ﬁlter ﬂags',
                'group' => '',
                'ln_arg' => 3854,
                'name' => 'flags',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '2',
                                  'bitfrom' => '0',
                                  'descr' => 'Proﬁle type (0=running, 1=cycling, 2=swimming, 3=car, 4=custom)',
                                  'name' => 'profile',
                                  'numbits' => '3'
                                }
                              ],
                'descr' => 'Odometer ﬁlter settings',
                'group' => '',
                'ln_arg' => 3863,
                'name' => 'odoCfg',
                'offset' => '5',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 3876,
                'name' => 'reserved1',
                'offset' => '6',
                'repeat' => '6',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Speed below which course-over-ground (COG) is computed with the low-speed COG ﬁlter',
                'group' => '',
                'ln_arg' => 3877,
                'name' => 'cogMaxSpeed',
                'offset' => '12',
                'repeat' => undef,
                'scale' => '1e-1',
                'type' => 'U1',
                'unit' => 'm/s'
              },
              {
                'bitfield' => [],
                'descr' => 'Maximum acceptable position accuracy for computing COG with the low-speed COG ﬁlter',
                'group' => '',
                'ln_arg' => 3879,
                'name' => 'cogMaxPosAcc',
                'offset' => '13',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => 'm'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 3881,
                'name' => 'reserved2',
                'offset' => '14',
                'repeat' => '2',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Velocity low-pass ﬁlter level, range 0..255',
                'group' => '',
                'ln_arg' => 3882,
                'name' => 'velLpGain',
                'offset' => '16',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'COG low-pass ﬁlter level (at speed < 8 m/s), range 0..255',
                'group' => '',
                'ln_arg' => 3883,
                'name' => 'cogLpGain',
                'offset' => '17',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 3885,
                'name' => 'reserved3',
                'offset' => '18',
                'repeat' => '2',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x06',
  'code' => 'UBX-CFG-ODO',
  'comment' => 'This message is deprecated in protocol versions greater than 23.01. Use UBX-CFG-VALSET, UBX-CFG-VALGET, UBX-CFG-VALDEL instead. See the Legacy UBX Message Fields Reference for the corresponding conﬁguration item. ☞ This feature is not supported for the FTS product variant.',
  'id' => '0x1e',
  'length' => '20',
  'ln_bitfield' => 3874,
  'ln_classid' => 3849,
  'ln_comment' => 3843,
  'ln_msg' => 3840,
  'ln_name' => 3841,
  'ln_type' => 3842,
  'name' => 'Odometer, low-speed COG engine settings',
  'type' => 'Get/set'
}
, ### UBX-CFG-PRT Polls the conﬁguration for one I/O port ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Port identiﬁer number (see the other versions of CFG- PRT for valid values)',
                'group' => '',
                'ln_arg' => 3904,
                'name' => 'PortID',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x06',
  'code' => 'UBX-CFG-PRT',
  'comment' => 'This message is deprecated in protocol versions greater than 23.01. Use UBX-CFG-VALSET, UBX-CFG-VALGET, UBX-CFG-VALDEL instead. See the Legacy UBX Message Fields Reference for the corresponding conﬁguration item. Sending this message with a port ID as payload results in having the receiver return the conﬁguration for the speciﬁed port.',
  'id' => '0x00',
  'length' => '1',
  'ln_classid' => 3901,
  'ln_comment' => 3894,
  'ln_msg' => 3891,
  'ln_name' => 3892,
  'ln_type' => 3893,
  'name' => 'Polls the conﬁguration for one I/O port',
  'type' => 'Poll request'
}
, ### UBX-CFG-PRT Port conﬁguration for UART ports ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Port identiﬁer number (see Integration manual for valid UART port IDs)',
                'group' => '',
                'ln_arg' => 3938,
                'name' => 'portID',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 3940,
                'name' => 'reserved0',
                'offset' => '1',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '0',
                                  'bitfrom' => undef,
                                  'descr' => 'Enable TX ready feature for this port',
                                  'name' => 'en',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '1',
                                  'bitfrom' => undef,
                                  'descr' => 'Polarity
•   0 High-active
•   1 Low-active',
                                  'name' => 'pol',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '6',
                                  'bitfrom' => '2',
                                  'descr' => 'PIO to be used (must not be in use by another function)',
                                  'name' => 'pin',
                                  'numbits' => '5'
                                },
                                {
                                  'bit' => '15',
                                  'bitfrom' => '7',
                                  'descr' => 'Threshold The given threshold is multiplied by 8 bytes. The TX ready PIN goes active after >= thres*8 bytes are pending for the port and going inactive after the last pending bytes have been written to hardware (0-4 bytes before end of stream).
•   0x000 no threshold
•   0x001 8byte
•   0x002 16byte
•   ...
•   0x1FE 4080byte
•   0x1FF 4088byte',
                                  'name' => 'thres',
                                  'numbits' => '9'
                                }
                              ],
                'descr' => 'TX ready PIN conﬁguration (not supported for protocol versions less than 13.01)',
                'group' => '',
                'ln_arg' => 3941,
                'name' => 'txReady',
                'offset' => '2',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X2',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '7',
                                  'bitfrom' => '6',
                                  'descr' => 'Character length
•   00 5bit (not supported)
•   01 6bit (not supported)
•   10 7bit (supported only with parity)
•   11 8bit',
                                  'name' => 'charLen',
                                  'numbits' => '2'
                                },
                                {
                                  'bit' => '11',
                                  'bitfrom' => '9',
                                  'descr' => '•   000 Even parity
•   001 Odd parity
•   10X No parity
•   X1X Reserved',
                                  'name' => 'parity',
                                  'numbits' => '3'
                                },
                                {
                                  'bit' => '13',
                                  'bitfrom' => '12',
                                  'descr' => 'Number of Stop bits
•   00 1 Stop bit
•   01 1.5 Stop bit
•   10 2 Stop bit
•   11 0.5 Stop bit',
                                  'name' => 'nStopBits',
                                  'numbits' => '2'
                                }
                              ],
                'descr' => 'A bit mask describing the UART mode',
                'group' => '',
                'ln_arg' => 3963,
                'name' => 'mode',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X4',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Baud rate in bits/second',
                'group' => '',
                'ln_arg' => 3979,
                'name' => 'baudRate',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'Bits/s'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '0',
                                  'bitfrom' => undef,
                                  'descr' => 'UBX protocol',
                                  'name' => 'inUbx',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '1',
                                  'bitfrom' => undef,
                                  'descr' => 'NMEA protocol',
                                  'name' => 'inNmea',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '2',
                                  'bitfrom' => undef,
                                  'descr' => 'RTCM2 protocol',
                                  'name' => 'inRtcm',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '5',
                                  'bitfrom' => undef,
                                  'descr' => 'RTCM3 protocol (not supported for protocol versions less than 20.00)',
                                  'name' => 'inRtcm3',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'A mask describing which input protocols are active. Each bit of this mask is used for a protocol. Through that, multiple protocols can be deﬁned on a single port.',
                'group' => '',
                'ln_arg' => 3980,
                'name' => 'inProtoMask',
                'offset' => '12',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X2',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '0',
                                  'bitfrom' => undef,
                                  'descr' => 'UBX protocol',
                                  'name' => 'outUbx',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '1',
                                  'bitfrom' => undef,
                                  'descr' => 'NMEA protocol',
                                  'name' => 'outNmea',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '5',
                                  'bitfrom' => undef,
                                  'descr' => 'RTCM3 protocol (not supported for protocol versions less than 20.00)',
                                  'name' => 'outRtcm3',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'A mask describing which output protocols are active. Each bit of this mask is used for a protocol. Through that, multiple protocols can be deﬁned on a single port.',
                'group' => '',
                'ln_arg' => 3992,
                'name' => 'outProtoMask',
                'offset' => '14',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X2',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '1',
                                  'bitfrom' => undef,
                                  'descr' => 'Extended TX timeout: if set, the port will time out if TX memory >=4 kB and no activity for 1.5 s. If not set the port will time out if no activity for 1.5 s regardless on the amount of allocated TX memory (not supported for protocol versions less than 13.01).',
                                  'name' => 'extendedTxTimeout',
                                  'numbits' => '1',
                                  'unit' => 'allocated'
                                }
                              ],
                'descr' => 'Flags bit mask',
                'group' => '',
                'ln_arg' => 4010,
                'name' => 'flags',
                'offset' => '16',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 4017,
                'name' => 'reserved1',
                'offset' => '18',
                'repeat' => '2',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x06',
  'code' => 'UBX-CFG-PRT',
  'comment' => 'This message is deprecated in protocol versions greater than 23.01. Use UBX-CFG-VALSET, UBX-CFG-VALGET, UBX-CFG-VALDEL instead. See the Legacy UBX Message Fields Reference for the corresponding conﬁguration item. Several conﬁgurations can be concatenated to one input message. In this case the payload length can be a multiple of the normal length (see the other versions of CFG-PRT). Output messages from the module contain only one conﬁguration unit. Note that this message can aﬀect baud rate and other transmission parameters. Because there may be messages queued for transmission there may be uncertainty about which protocol applies to such messages. In addition a message currently in transmission may be corrupted by a protocol change. Host data reception parameters may have to be changed to be able to receive future messages, including the acknowledge message resulting from the CFG-PRT message.',
  'id' => '0x00',
  'length' => '20',
  'ln_bitfield' => 4012,
  'ln_classid' => 3925,
  'ln_comment' => 3912,
  'ln_msg' => 3909,
  'ln_name' => 3910,
  'ln_type' => 3911,
  'name' => 'Port conﬁguration for UART ports',
  'type' => 'Get/set'
}
, ### UBX-CFG-PRT Port conﬁguration for USB port ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Port identiﬁer number (= 3 for USB port)',
                'group' => '',
                'ln_arg' => 4035,
                'name' => 'portID',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 4036,
                'name' => 'reserved0',
                'offset' => '1',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '0',
                                  'bitfrom' => undef,
                                  'descr' => 'Enable TX ready feature for this port',
                                  'name' => 'en',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '1',
                                  'bitfrom' => undef,
                                  'descr' => 'Polarity
•   0 High-active
•   1 Low-active',
                                  'name' => 'pol',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '6',
                                  'bitfrom' => '2',
                                  'descr' => 'PIO to be used (must not be in use by another function)',
                                  'name' => 'pin',
                                  'numbits' => '5'
                                },
                                {
                                  'bit' => '15',
                                  'bitfrom' => '7',
                                  'descr' => 'Threshold The given threshold is multiplied by 8 bytes. The TX ready PIN goes active after >= thres*8 bytes are pending for the port and going inactive after the last pending bytes have been written to hardware (0-4 bytes before end of stream).
•   0x000 no threshold
•   0x001 8byte
•   0x002 16byte
•   ...
•   0x1FE 4080byte
•   0x1FF 4088byte',
                                  'name' => 'thres',
                                  'numbits' => '9'
                                }
                              ],
                'descr' => 'TX ready PIN conﬁguration (not supported for protocol versions less than 13.01)',
                'group' => '',
                'ln_arg' => 4037,
                'name' => 'txReady',
                'offset' => '2',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 4059,
                'name' => 'reserved1',
                'offset' => '4',
                'repeat' => '8',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '0',
                                  'bitfrom' => undef,
                                  'descr' => 'UBX protocol',
                                  'name' => 'inUbx',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '1',
                                  'bitfrom' => undef,
                                  'descr' => 'NMEA protocol',
                                  'name' => 'inNmea',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '2',
                                  'bitfrom' => undef,
                                  'descr' => 'RTCM2 protocol',
                                  'name' => 'inRtcm',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '5',
                                  'bitfrom' => undef,
                                  'descr' => 'RTCM3 protocol (not supported for protocol versions less than 20.00)',
                                  'name' => 'inRtcm3',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'A mask describing which input protocols are active. Each bit of this mask is used for a protocol. Through that, multiple protocols can be deﬁned on a single port.',
                'group' => '',
                'ln_arg' => 4060,
                'name' => 'inProtoMask',
                'offset' => '12',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X2',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '0',
                                  'bitfrom' => undef,
                                  'descr' => 'UBX protocol',
                                  'name' => 'outUbx',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '1',
                                  'bitfrom' => undef,
                                  'descr' => 'NMEA protocol',
                                  'name' => 'outNmea',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '5',
                                  'bitfrom' => undef,
                                  'descr' => 'RTCM3 protocol (not supported for protocol versions less than 20.00)',
                                  'name' => 'outRtcm3',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'A mask describing which output protocols are active. Each bit of this mask is used for a protocol. Through that, multiple protocols can be deﬁned on a single port.',
                'group' => '',
                'ln_arg' => 4081,
                'name' => 'outProtoMask',
                'offset' => '14',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 4091,
                'name' => 'reserved2',
                'offset' => '16',
                'repeat' => '2',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 4092,
                'name' => 'reserved3',
                'offset' => '18',
                'repeat' => '2',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x06',
  'code' => 'UBX-CFG-PRT',
  'comment' => 'This message is deprecated in protocol versions greater than 23.01. Use UBX-CFG-VALSET, UBX-CFG-VALGET, UBX-CFG-VALDEL instead. See the Legacy UBX Message Fields Reference for the corresponding conﬁguration item. Several conﬁgurations can be concatenated to one input message. In this case the payload length can be a multiple of the normal length (see the other versions of CFG-PRT). Output messages from the module contain only one conﬁguration unit.',
  'id' => '0x00',
  'length' => '20',
  'ln_bitfield' => 4089,
  'ln_classid' => 4032,
  'ln_comment' => 4024,
  'ln_msg' => 4021,
  'ln_name' => 4022,
  'ln_type' => 4023,
  'name' => 'Port conﬁguration for USB port',
  'type' => 'Get/set'
}
, ### UBX-CFG-PRT Port conﬁguration for SPI port ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Port identiﬁer number (= 4 for SPI port)',
                'group' => '',
                'ln_arg' => 4109,
                'name' => 'portID',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 4110,
                'name' => 'reserved0',
                'offset' => '1',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '0',
                                  'bitfrom' => undef,
                                  'descr' => 'Enable TX ready feature for this port',
                                  'name' => 'en',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '1',
                                  'bitfrom' => undef,
                                  'descr' => 'Polarity
•   0 High-active
•   1 Low-active',
                                  'name' => 'pol',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '6',
                                  'bitfrom' => '2',
                                  'descr' => 'PIO to be used (must not be in use by another function)',
                                  'name' => 'pin',
                                  'numbits' => '5'
                                },
                                {
                                  'bit' => '15',
                                  'bitfrom' => '7',
                                  'descr' => 'Threshold The given threshold is multiplied by 8 bytes. The TX ready PIN goes active after >= thres*8 bytes are pending for the port and going inactive after the last pending bytes have been written to hardware (0-4 bytes before end of stream).
•   0x000 no threshold
•   0x001 8byte
•   0x002 16byte
•   ...
•   0x1FE 4080byte
•   0x1FF 4088byte',
                                  'name' => 'thres',
                                  'numbits' => '9'
                                }
                              ],
                'descr' => 'TX ready PIN conﬁguration (not supported for protocol versions less than 13.01)',
                'group' => '',
                'ln_arg' => 4111,
                'name' => 'txReady',
                'offset' => '2',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X2',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '2',
                                  'bitfrom' => '1',
                                  'descr' => '•   00 SPI Mode 0: CPOL = 0, CPHA = 0
•   01 SPI Mode 1: CPOL = 0, CPHA = 1
•   10 SPI Mode 2: CPOL = 1, CPHA = 0
•   11 SPI Mode 3: CPOL = 1, CPHA = 1',
                                  'name' => 'spiMode',
                                  'numbits' => '2'
                                },
                                {
                                  'bit' => '13',
                                  'bitfrom' => '8',
                                  'descr' => 'Number of bytes containing 0xFF to receive before switching oﬀ reception. Range: 0 (mechanism oﬀ) - 63',
                                  'name' => 'ffCnt',
                                  'numbits' => '6'
                                }
                              ],
                'descr' => 'SPI Mode Flags',
                'group' => '',
                'ln_arg' => 4143,
                'name' => 'mode',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X4',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 4151,
                'name' => 'reserved1',
                'offset' => '8',
                'repeat' => '4',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '0',
                                  'bitfrom' => undef,
                                  'descr' => '',
                                  'name' => 'inUbx',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '1',
                                  'bitfrom' => undef,
                                  'descr' => '',
                                  'name' => 'inNmea',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '2',
                                  'bitfrom' => undef,
                                  'descr' => '',
                                  'name' => 'inRtcm',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '5',
                                  'bitfrom' => undef,
                                  'descr' => '',
                                  'name' => 'inRtcm3',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'A mask describing which input protocols are active. Each bit of this mask is used for a protocol. Through that, multiple protocols can be deﬁned on a single port. (The bitﬁeld inRtcm3 is not supported for protocol versions less than 20.00)',
                'group' => '',
                'ln_arg' => 4152,
                'name' => 'inProtoMask',
                'offset' => '12',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X2',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '0',
                                  'bitfrom' => undef,
                                  'descr' => '',
                                  'name' => 'outUbx',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '1',
                                  'bitfrom' => undef,
                                  'descr' => '',
                                  'name' => 'outNmea',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '5',
                                  'bitfrom' => undef,
                                  'descr' => '',
                                  'name' => 'outRtcm3',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'A mask describing which output protocols are active. Each bit of this mask is used for a protocol. Through that, multiple protocols can be deﬁned on a single port. (The bitﬁeld outRtcm3 is not supported for protocol versions less than 20.00)',
                'group' => '',
                'ln_arg' => 4165,
                'name' => 'outProtoMask',
                'offset' => '14',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X2',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '1',
                                  'bitfrom' => undef,
                                  'descr' => 'Extended TX timeout: if set, the port will time out if TX memory >=4 kB and no activity for 1.5 s. (not supported for protocol versions less than 13.01)',
                                  'name' => 'extendedTxTimeout',
                                  'numbits' => '1',
                                  'unit' => 'allocated'
                                }
                              ],
                'descr' => 'Flags bit mask',
                'group' => '',
                'ln_arg' => 4176,
                'name' => 'flags',
                'offset' => '16',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 4181,
                'name' => 'reserved2',
                'offset' => '18',
                'repeat' => '2',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x06',
  'code' => 'UBX-CFG-PRT',
  'comment' => 'This message is deprecated in protocol versions greater than 23.01. Use UBX-CFG-VALSET, UBX-CFG-VALGET, UBX-CFG-VALDEL instead. See the Legacy UBX Message Fields Reference for the corresponding conﬁguration item. Several conﬁgurations can be concatenated to one input message. In this case the payload length can be a multiple of the normal length. Output messages from the module contain only one conﬁguration unit.',
  'id' => '0x00',
  'length' => '20',
  'ln_bitfield' => 4178,
  'ln_classid' => 4106,
  'ln_comment' => 4099,
  'ln_msg' => 4096,
  'ln_name' => 4097,
  'ln_type' => 4098,
  'name' => 'Port conﬁguration for SPI port',
  'type' => 'Get/set'
}
, ### UBX-CFG-PRT Port conﬁguration for I2C (DDC) port ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Port identiﬁer number (= 0 for I2C (DDC) port)',
                'group' => '',
                'ln_arg' => 4199,
                'name' => 'portID',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 4200,
                'name' => 'reserved0',
                'offset' => '1',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '0',
                                  'bitfrom' => undef,
                                  'descr' => 'Enable TX ready feature for this port',
                                  'name' => 'en',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '1',
                                  'bitfrom' => undef,
                                  'descr' => 'Polarity
•   0 High-active
•   1 Low-active',
                                  'name' => 'pol',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '6',
                                  'bitfrom' => '2',
                                  'descr' => 'PIO to be used (must not be in use by another function)',
                                  'name' => 'pin',
                                  'numbits' => '5'
                                },
                                {
                                  'bit' => '15',
                                  'bitfrom' => '7',
                                  'descr' => 'Threshold The given threshold is multiplied by 8 bytes. The TX ready PIN goes active after >= thres*8 bytes are pending for the port and going inactive after the last pending bytes have been written to hardware (0-4 bytes before end of stream).
•   0x000 no threshold
•   0x001 8byte
•   0x002 16byte
•   ...
•   0x1FE 4080byte
•   0x1FF 4088byte',
                                  'name' => 'thres',
                                  'numbits' => '9'
                                }
                              ],
                'descr' => 'TX ready PIN conﬁguration (not supported for protocol versions less than 13.01)',
                'group' => '',
                'ln_arg' => 4211,
                'name' => 'txReady',
                'offset' => '2',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X2',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '7',
                                  'bitfrom' => '1',
                                  'descr' => 'Slave address Range: 0x07 < slaveAddr < 0x78. Bit 0 must be 0',
                                  'name' => 'slaveAddr',
                                  'numbits' => '7'
                                }
                              ],
                'descr' => 'I2C (DDC) Mode Flags',
                'group' => '',
                'ln_arg' => 4233,
                'name' => 'mode',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X4',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 4237,
                'name' => 'reserved1',
                'offset' => '8',
                'repeat' => '4',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '0',
                                  'bitfrom' => undef,
                                  'descr' => '',
                                  'name' => 'inUbx',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '1',
                                  'bitfrom' => undef,
                                  'descr' => '',
                                  'name' => 'inNmea',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '2',
                                  'bitfrom' => undef,
                                  'descr' => '',
                                  'name' => 'inRtcm',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '5',
                                  'bitfrom' => undef,
                                  'descr' => '',
                                  'name' => 'inRtcm3',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'A mask describing which input protocols are active. Each bit of this mask is used for a protocol. Through that, multiple protocols can be deﬁned on a single port. (The bitﬁeld inRtcm3 is not supported for protocol versions less than 20.00)',
                'group' => '',
                'ln_arg' => 4238,
                'name' => 'inProtoMask',
                'offset' => '12',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X2',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '0',
                                  'bitfrom' => undef,
                                  'descr' => '',
                                  'name' => 'outUbx',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '1',
                                  'bitfrom' => undef,
                                  'descr' => '',
                                  'name' => 'outNmea',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '5',
                                  'bitfrom' => undef,
                                  'descr' => '',
                                  'name' => 'outRtcm3',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'A mask describing which output protocols are active. Each bit of this mask is used for a protocol. Through that, multiple protocols can be deﬁned on a single port. (The bitﬁeld outRtcm3 is not supported for protocol versions less than 20.00)',
                'group' => '',
                'ln_arg' => 4251,
                'name' => 'outProtoMask',
                'offset' => '14',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X2',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '1',
                                  'bitfrom' => undef,
                                  'descr' => 'Extended TX timeout: if set, the port will time out if TX memory >=4 kB and no activity for 1.5 s (not supported for protocol versions less than 13.01).',
                                  'name' => 'extendedTxTimeout',
                                  'numbits' => '1',
                                  'unit' => 'allocated'
                                }
                              ],
                'descr' => 'Flags bit mask',
                'group' => '',
                'ln_arg' => 4262,
                'name' => 'flags',
                'offset' => '16',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 4267,
                'name' => 'reserved2',
                'offset' => '18',
                'repeat' => '2',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x06',
  'code' => 'UBX-CFG-PRT',
  'comment' => 'This message is deprecated in protocol versions greater than 23.01. Use UBX-CFG-VALSET, UBX-CFG-VALGET, UBX-CFG-VALDEL instead. See the Legacy UBX Message Fields Reference for the corresponding conﬁguration item. Several conﬁgurations can be concatenated to one input message. In this case the payload length can be a multiple of the normal length (see the other versions of CFG-PRT). Output messages from the module contain only one conﬁguration unit.',
  'id' => '0x00',
  'length' => '20',
  'ln_bitfield' => 4264,
  'ln_classid' => 4196,
  'ln_comment' => 4188,
  'ln_msg' => 4185,
  'ln_name' => 4186,
  'ln_type' => 4187,
  'name' => 'Port conﬁguration for I2C (DDC) port',
  'type' => 'Get/set'
}
, ### UBX-CFG-PWR Put receiver in a deﬁned power state ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Message version (0x01 for this version)',
                'group' => '',
                'ln_arg' => 4292,
                'name' => 'version',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 4293,
                'name' => 'reserved0',
                'offset' => '1',
                'repeat' => '3',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Enter system state
•   0x52554E20 = GNSS running
•   0x53544F50 = GNSS stopped
•   0x42434B50 = Software backup. USB interface will be disabled, other wakeup source is needed.',
                'group' => '',
                'ln_arg' => 4294,
                'name' => 'state',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => '-'
              }
            ],
  'class' => '0x06',
  'code' => 'UBX-CFG-PWR',
  'comment' => '☞ This message is deprecated in protocol versions greater than 17. Use UBX-CFG-RST for GNSS start/stop and UBX-RXM-PMREQ for software backup.',
  'id' => '0x57',
  'length' => '8',
  'ln_classid' => 4289,
  'ln_comment' => 4285,
  'ln_msg' => 4282,
  'ln_name' => 4283,
  'ln_type' => 4284,
  'name' => 'Put receiver in a deﬁned power state',
  'type' => 'Set'
}
, ### UBX-CFG-RATE Navigation/measurement rate settings ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'The elapsed time between GNSS measurements, which deﬁnes the rate, e.g. 100 ms => 10 Hz, 1000 ms => 1 Hz, 10000 ms => 0.1 Hz. Measurement rate should be greater than or equal to 25 ms. (Measurement rate should be greater than or equal to 50 ms for protocol versions less than 24.00).',
                'group' => '',
                'ln_arg' => 4326,
                'name' => 'measRate',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => 'ms'
              },
              {
                'bitfield' => [],
                'descr' => 'The ratio between the number of measurements and the number of navigation solutions, e.g. 5 means ﬁve measurements for every navigation solution. Maximum value is 127. (This parameter is ignored and the navRate is ﬁxed to 1 for protocol versions less than 18.00).',
                'group' => '',
                'ln_arg' => 4342,
                'name' => 'navRate',
                'offset' => '2',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => 'cycles'
              },
              {
                'bitfield' => [],
                'descr' => 'The time system to which measurements are aligned:
•   0 = UTC time
•   1 = GPS time
•   2 = GLONASS time (not supported for protocol versions less than 18.00)
•   3 = BeiDou time (not supported for protocol versions less than 18.00)
•   4 = Galileo time (not supported for protocol versions less than 18.00)',
                'group' => '',
                'ln_arg' => 4348,
                'name' => 'timeRef',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => '-'
              }
            ],
  'class' => '0x06',
  'code' => 'UBX-CFG-RATE',
  'comment' => 'This message is deprecated in protocol versions greater than 23.01. Use UBX-CFG-VALSET, UBX-CFG-VALGET, UBX-CFG-VALDEL instead. See the Legacy UBX Message Fields Reference for the corresponding conﬁguration item. This message allows the user to alter the rate at which navigation solutions (and the measurements that they depend on) are generated by the receiver. The calculation of the navigation solution will always be aligned to the top of a second zero (ﬁrst second of the week) of the conﬁgured reference time system. (Navigation period is an integer multiple of the measurement period for protocol versions greater than 17.00).
•     Each measurement triggers the measurements generation and, if available, raw data output.
•     The navRate value deﬁnes that every nth measurement triggers a navigation epoch.
•     The update rate has a direct inﬂuence on the power consumption. The more ﬁxes that are required, the more CPU power and communication resources are required.
•     For most applications a 1 Hz update rate would be suﬃcient.
•     When using power save mode, measurement and navigation rate can diﬀer from the values conﬁgured here.',
  'id' => '0x08',
  'length' => '6',
  'ln_classid' => 4323,
  'ln_comment' => 4307,
  'ln_msg' => 4304,
  'ln_name' => 4305,
  'ln_type' => 4306,
  'name' => 'Navigation/measurement rate settings',
  'type' => 'Get/set'
}
, ### UBX-CFG-RINV Contents of remote inventory ###
{
  'args' => [
              {
                'bitfield' => [
                                {
                                  'bit' => '0',
                                  'bitfrom' => undef,
                                  'descr' => 'Dump data at startup. Does not work if ﬂag binary is set.',
                                  'name' => 'dump',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '1',
                                  'bitfrom' => undef,
                                  'descr' => 'Data is binary.',
                                  'name' => 'binary',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'Flags',
                'group' => '',
                'ln_arg' => 4374,
                'name' => 'flags',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Data to store/stored in remote inventory.',
                'group' => 'repeated N',
                'ln_arg' => 4380,
                'name' => 'data',
                'offset' => '1+n',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x06',
  'code' => 'UBX-CFG-RINV',
  'comment' => 'This message is deprecated in protocol versions greater than 23.01. Use UBX-CFG-VALSET, UBX-CFG-VALGET, UBX-CFG-VALDEL instead. If N is greater than 30, the excess bytes are discarded. See the Legacy UBX Message Fields Reference for the corresponding conﬁguration item.',
  'hasgroup' => 'repeated N',
  'id' => '0x34',
  'length' => '1 + [0..n]',
  'ln_bitfield' => 4378,
  'ln_classid' => 4371,
  'ln_comment' => 4365,
  'ln_msg' => 4362,
  'ln_name' => 4363,
  'ln_type' => 4364,
  'name' => 'Contents of remote inventory',
  'type' => 'Get/set'
}
, ### UBX-CFG-RST Reset receiver / Clear backup data structures ###
{
  'args' => [
              {
                'bitfield' => [
                                {
                                  'bit' => '0',
                                  'bitfrom' => undef,
                                  'descr' => 'Ephemeris',
                                  'name' => 'eph',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '1',
                                  'bitfrom' => undef,
                                  'descr' => 'Almanac',
                                  'name' => 'alm',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '2',
                                  'bitfrom' => undef,
                                  'descr' => 'Health',
                                  'name' => 'health',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '3',
                                  'bitfrom' => undef,
                                  'descr' => 'Klobuchar parameters',
                                  'name' => 'klob',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '4',
                                  'bitfrom' => undef,
                                  'descr' => 'Position',
                                  'name' => 'pos',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '5',
                                  'bitfrom' => undef,
                                  'descr' => 'Clock drift',
                                  'name' => 'clkd',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '6',
                                  'bitfrom' => undef,
                                  'descr' => 'Oscillator parameter',
                                  'name' => 'osc',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '7',
                                  'bitfrom' => undef,
                                  'descr' => 'UTC correction + GPS leap seconds parameters',
                                  'name' => 'utc',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '8',
                                  'bitfrom' => undef,
                                  'descr' => 'RTC',
                                  'name' => 'rtc',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '15',
                                  'bitfrom' => undef,
                                  'descr' => 'Autonomous orbit parameters',
                                  'name' => 'aop',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'BBR sections to clear. The following special sets apply:
•   0x0000 Hot start
•   0x0001 Warm start
•   0xFFFF Cold start',
                'group' => '',
                'ln_arg' => 4409,
                'name' => 'navBbrMask',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reset Type
•   0x00 = Hardware reset (watchdog) immediately
•   0x01 = Controlled software reset
•   0x02 = Controlled software reset (GNSS only)
•   0x04 = Hardware reset (watchdog) after shutdown
•   0x08 = Controlled GNSS stop
•   0x09 = Controlled GNSS start',
                'group' => '',
                'ln_arg' => 4433,
                'name' => 'resetMode',
                'offset' => '2',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 4441,
                'name' => 'reserved0',
                'offset' => '3',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x06',
  'code' => 'UBX-CFG-RST',
  'comment' => 'Do not expect this message to be acknowledged by the receiver.
•     Newer FW version will not acknowledge this message at all.
•     Older FW version will acknowledge this message but the acknowledge may not be sent completely before the receiver is reset.',
  'id' => '0x04',
  'length' => '4',
  'ln_bitfield' => 4432,
  'ln_classid' => 4396,
  'ln_comment' => 4390,
  'ln_msg' => 4387,
  'ln_name' => 4388,
  'ln_type' => 4389,
  'name' => 'Reset receiver / Clear backup data structures',
  'type' => 'Command'
}
, ### UBX-CFG-SBAS SBAS conﬁguration ###
{
  'args' => [
              {
                'bitfield' => [
                                {
                                  'bit' => '0',
                                  'bitfrom' => undef,
                                  'descr' => 'SBAS enabled (1) / disabled (0) - This ﬁeld is deprecated; use UBX-CFG-GNSS to enable/disable SBAS operation',
                                  'name' => 'enabled',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '1',
                                  'bitfrom' => undef,
                                  'descr' => 'SBAS testbed: Use data anyhow (1) / Ignore data when in test mode (SBAS msg 0)',
                                  'name' => 'test',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'SBAS mode',
                'group' => '',
                'ln_arg' => 4460,
                'name' => 'mode',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X1',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '0',
                                  'bitfrom' => undef,
                                  'descr' => 'Use SBAS GEOs as a ranging source (for navigation)',
                                  'name' => 'range',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '1',
                                  'bitfrom' => undef,
                                  'descr' => 'Use SBAS diﬀerential corrections',
                                  'name' => 'diffCorr',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '2',
                                  'bitfrom' => undef,
                                  'descr' => 'Use SBAS integrity information. If enabled, the receiver will only use GPS satellites for which integrity information is available.',
                                  'name' => 'integrity',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'SBAS usage',
                'group' => '',
                'ln_arg' => 4467,
                'name' => 'usage',
                'offset' => '1',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Maximum number of SBAS prioritized tracking channels (valid range: 0 - 3) to use (obsolete and superseded by UBX-CFG-GNSS for protocol versions 14.00+).',
                'group' => '',
                'ln_arg' => 4485,
                'name' => 'maxSBAS',
                'offset' => '2',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '0',
                                  'bitfrom' => undef,
                                  'descr' => '',
                                  'name' => 'PRN152',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '1',
                                  'bitfrom' => undef,
                                  'descr' => '',
                                  'name' => 'PRN153',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '2',
                                  'bitfrom' => undef,
                                  'descr' => '',
                                  'name' => 'PRN154',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '3',
                                  'bitfrom' => undef,
                                  'descr' => '',
                                  'name' => 'PRN155',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '4',
                                  'bitfrom' => undef,
                                  'descr' => '',
                                  'name' => 'PRN156',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '5',
                                  'bitfrom' => undef,
                                  'descr' => '',
                                  'name' => 'PRN157',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '6',
                                  'bitfrom' => undef,
                                  'descr' => '',
                                  'name' => 'PRN158',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'Continuation of scanmode bitmask below',
                'group' => '',
                'ln_arg' => 4489,
                'name' => 'scanmode2',
                'offset' => '3',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X1',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '0',
                                  'bitfrom' => undef,
                                  'descr' => '',
                                  'name' => 'PRN120',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '1',
                                  'bitfrom' => undef,
                                  'descr' => '',
                                  'name' => 'PRN121',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '2',
                                  'bitfrom' => undef,
                                  'descr' => '',
                                  'name' => 'PRN122',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '3',
                                  'bitfrom' => undef,
                                  'descr' => '',
                                  'name' => 'PRN123',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '4',
                                  'bitfrom' => undef,
                                  'descr' => '',
                                  'name' => 'PRN124',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '5',
                                  'bitfrom' => undef,
                                  'descr' => '',
                                  'name' => 'PRN125',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '6',
                                  'bitfrom' => undef,
                                  'descr' => '',
                                  'name' => 'PRN126',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '7',
                                  'bitfrom' => undef,
                                  'descr' => '',
                                  'name' => 'PRN127',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '8',
                                  'bitfrom' => undef,
                                  'descr' => '',
                                  'name' => 'PRN128',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '9',
                                  'bitfrom' => undef,
                                  'descr' => '',
                                  'name' => 'PRN129',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '10',
                                  'bitfrom' => undef,
                                  'descr' => '',
                                  'name' => 'PRN130',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '11',
                                  'bitfrom' => undef,
                                  'descr' => '',
                                  'name' => 'PRN131',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '12',
                                  'bitfrom' => undef,
                                  'descr' => '',
                                  'name' => 'PRN132',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '13',
                                  'bitfrom' => undef,
                                  'descr' => '',
                                  'name' => 'PRN133',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '14',
                                  'bitfrom' => undef,
                                  'descr' => '',
                                  'name' => 'PRN134',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '15',
                                  'bitfrom' => undef,
                                  'descr' => '',
                                  'name' => 'PRN135',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '16',
                                  'bitfrom' => undef,
                                  'descr' => '',
                                  'name' => 'PRN136',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '17',
                                  'bitfrom' => undef,
                                  'descr' => '',
                                  'name' => 'PRN137',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '18',
                                  'bitfrom' => undef,
                                  'descr' => '',
                                  'name' => 'PRN138',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '19',
                                  'bitfrom' => undef,
                                  'descr' => '',
                                  'name' => 'PRN139',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '20',
                                  'bitfrom' => undef,
                                  'descr' => '',
                                  'name' => 'PRN140',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '21',
                                  'bitfrom' => undef,
                                  'descr' => '',
                                  'name' => 'PRN141',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '22',
                                  'bitfrom' => undef,
                                  'descr' => '',
                                  'name' => 'PRN142',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '23',
                                  'bitfrom' => undef,
                                  'descr' => '',
                                  'name' => 'PRN143',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '24',
                                  'bitfrom' => undef,
                                  'descr' => '',
                                  'name' => 'PRN144',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '25',
                                  'bitfrom' => undef,
                                  'descr' => '',
                                  'name' => 'PRN145',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '26',
                                  'bitfrom' => undef,
                                  'descr' => '',
                                  'name' => 'PRN146',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '27',
                                  'bitfrom' => undef,
                                  'descr' => '',
                                  'name' => 'PRN147',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '28',
                                  'bitfrom' => undef,
                                  'descr' => '',
                                  'name' => 'PRN148',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '29',
                                  'bitfrom' => undef,
                                  'descr' => '',
                                  'name' => 'PRN149',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '30',
                                  'bitfrom' => undef,
                                  'descr' => '',
                                  'name' => 'PRN150',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '31',
                                  'bitfrom' => undef,
                                  'descr' => '',
                                  'name' => 'PRN151',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'Which SBAS PRN numbers to search for (bitmask). If all bits are set to zero, auto-scan (i.e. all valid PRNs) are searched. Every bit corresponds to a PRN number.',
                'group' => '',
                'ln_arg' => 4504,
                'name' => 'scanmode1',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X4',
                'unit' => '-'
              }
            ],
  'class' => '0x06',
  'code' => 'UBX-CFG-SBAS',
  'comment' => 'This message is deprecated in protocol versions greater than 23.01. Use UBX-CFG-VALSET, UBX-CFG-VALGET, UBX-CFG-VALDEL instead. This message conﬁgures the SBAS receiver subsystem (i.e. WAAS, EGNOS, MSAS). See the SBAS conﬁguration settings description in the Integration manual for a detailed description of how these settings aﬀect receiver operation.',
  'id' => '0x16',
  'length' => '8',
  'ln_bitfield' => 4580,
  'ln_classid' => 4457,
  'ln_comment' => 4450,
  'ln_msg' => 4447,
  'ln_name' => 4448,
  'ln_type' => 4449,
  'name' => 'SBAS conﬁguration',
  'type' => 'Get/set'
}
, ### UBX-CFG-TMODE3 Time mode settings 3 ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Message version (0x00 for this version)',
                'group' => '',
                'ln_arg' => 4603,
                'name' => 'version',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 4604,
                'name' => 'reserved0',
                'offset' => '1',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '7',
                                  'bitfrom' => '0',
                                  'descr' => 'Receiver Mode:
•   0 Disabled
•   1 Survey In
•   2 Fixed Mode (true ARP position information required)
•   3-255 Reserved',
                                  'name' => 'mode',
                                  'numbits' => '8'
                                },
                                {
                                  'bit' => '8',
                                  'bitfrom' => undef,
                                  'descr' => 'Position is given in LAT/LON/ALT (default is ECEF)',
                                  'name' => 'lla',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'Receiver mode ﬂags',
                'group' => '',
                'ln_arg' => 4605,
                'name' => 'flags',
                'offset' => '2',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'WGS84 ECEF X coordinate (or latitude) of the ARP position, depending on ﬂags above',
                'group' => '',
                'ln_arg' => 4614,
                'name' => 'ecefXOrLat',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I4',
                'unit' => 'cm_or_deg*1e-7'
              },
              {
                'bitfield' => [],
                'descr' => 'WGS84 ECEF Y coordinate (or longitude) of the ARP position, depending on ﬂags above',
                'group' => '',
                'ln_arg' => 4617,
                'name' => 'ecefYOrLon',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I4',
                'unit' => 'cm_or_deg*1e-7'
              },
              {
                'bitfield' => [],
                'descr' => 'WGS84 ECEF Z coordinate (or altitude) of the ARP position, depending on ﬂags above',
                'group' => '',
                'ln_arg' => 4620,
                'name' => 'ecefZOrAlt',
                'offset' => '12',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I4',
                'unit' => 'cm'
              },
              {
                'bitfield' => [],
                'descr' => 'High-precision WGS84 ECEF X coordinate (or latitude) of the ARP position, depending on ﬂags above. Must be in the range -99..+99. The precise WGS84 ECEF X coordinate in units of cm, or the precise WGS84 ECEF latitude in units of 1e-7 degrees, is given by ecefXOrLat + (ecefXOrLatHP * 1e-2)',
                'group' => '',
                'ln_arg' => 4632,
                'name' => 'ecefXOrLatHP',
                'offset' => '16',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I1',
                'unit' => '0.1_mm_or_deg*1e-9'
              },
              {
                'bitfield' => [],
                'descr' => 'High-precision WGS84 ECEF Y coordinate (or longitude) of the ARP position, depending on ﬂags above. Must be in the range -99..+99. The precise WGS84 ECEF Y coordinate in units of cm, or the precise WGS84 ECEF longitude in units of 1e-7 degrees, is given by ecefYOrLon + (ecefYOrLonHP * 1e-2)',
                'group' => '',
                'ln_arg' => 4639,
                'name' => 'ecefYOrLonHP',
                'offset' => '17',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I1',
                'unit' => '0.1_mm_or_deg*1e-9'
              },
              {
                'bitfield' => [],
                'descr' => 'High-precision WGS84 ECEF Z coordinate (or altitude) the ARP position, depending on ﬂags above. Must be in the range -99..+99. The precise WGS84 ECEF Z coordinate, or altitude coordinate, in units of cm is given by ecefZOrAlt + (ecefZOrAltHP * 1e-2)',
                'group' => '',
                'ln_arg' => 4646,
                'name' => 'ecefZOrAltHP',
                'offset' => '18',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I1',
                'unit' => '0.1_mmof'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 4652,
                'name' => 'reserved1',
                'offset' => '19',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Fixed position 3D accuracy',
                'group' => '',
                'ln_arg' => 4653,
                'name' => 'fixedPosAcc',
                'offset' => '20',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => '0.1_mm'
              },
              {
                'bitfield' => [],
                'descr' => 'Survey-in minimum duration',
                'group' => '',
                'ln_arg' => 4654,
                'name' => 'svinMinDur',
                'offset' => '24',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'Survey-in position accuracy limit',
                'group' => '',
                'ln_arg' => 4655,
                'name' => 'svinAccLimit',
                'offset' => '28',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => '0.1_mm'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 4656,
                'name' => 'reserved2',
                'offset' => '32',
                'repeat' => '8',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x06',
  'code' => 'UBX-CFG-TMODE3',
  'comment' => 'This message is deprecated in protocol versions greater than 23.01. Use UBX-CFG-VALSET, UBX-CFG-VALGET, UBX-CFG-VALDEL instead. See the Legacy UBX Message Fields Reference for the corresponding conﬁguration item. Conﬁgures the receiver to be in Time Mode. The position referred to in this message is that of the Antenna Reference Point (ARP). Note that using UBX-CFG-TMODE3 to set the receiver mode to Survey In or to Fixed Mode, will set automatically the dynamic platform model (CFG-NAVSPG-DYNMODEL) to Stationary. Note that using UBX-CFG-TMODE3 to set the receiver mode to Disabled, will set automatically the dynamic platform model (CFG-NAVSPG-DYNMODEL) to Portable.',
  'id' => '0x71',
  'length' => '40',
  'ln_bitfield' => 4613,
  'ln_classid' => 4600,
  'ln_comment' => 4589,
  'ln_msg' => 4586,
  'ln_name' => 4587,
  'ln_type' => 4588,
  'name' => 'Time mode settings 3',
  'type' => 'Get/set'
}
, ### UBX-CFG-TP5 Time pulse parameters ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Time pulse selection      (0   =    TIMEPULSE,   1   = TIMEPULSE2)',
                'group' => '',
                'ln_arg' => 4673,
                'name' => 'tpIdx',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Message version (0x01 for this version)',
                'group' => '',
                'ln_arg' => 4675,
                'name' => 'version',
                'offset' => '1',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 4676,
                'name' => 'reserved0',
                'offset' => '2',
                'repeat' => '2',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Antenna cable delay',
                'group' => '',
                'ln_arg' => 4677,
                'name' => 'antCableDelay',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I2',
                'unit' => 'ns'
              },
              {
                'bitfield' => [],
                'descr' => 'RF group delay',
                'group' => '',
                'ln_arg' => 4678,
                'name' => 'rfGroupDelay',
                'offset' => '6',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I2',
                'unit' => 'ns'
              },
              {
                'bitfield' => [],
                'descr' => 'Frequency or period time, depending on setting of bit \'isFreq\'',
                'group' => '',
                'ln_arg' => 4679,
                'name' => 'freqPeriod',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'Hz_or_us'
              },
              {
                'bitfield' => [],
                'descr' => 'Frequency or period time when locked to GNSS time, only used if \'lockedOtherSet\' is set',
                'group' => '',
                'ln_arg' => 4681,
                'name' => 'freqPeriodLock',
                'offset' => '12',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'Hz_or_us'
              },
              {
                'bitfield' => [],
                'descr' => 'Pulse length or duty cycle, depending on \'isLength\' ',
                'group' => '',
                'ln_arg' => 4693,
                'name' => 'pulseLenRatio',
                'offset' => '16',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'us_or_2^-32'
              },
              {
                'bitfield' => [],
                'descr' => 'Pulse length or duty cycle when locked to GNSS time, only used if \'lockedOtherSet\' is set',
                'group' => '',
                'ln_arg' => 4695,
                'name' => 'pulseLenRatioLock',
                'offset' => '20',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'us_or_2^-32'
              },
              {
                'bitfield' => [],
                'descr' => 'User-conﬁgurable time pulse delay',
                'group' => '',
                'ln_arg' => 4697,
                'name' => 'userConfigDelay',
                'offset' => '24',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I4',
                'unit' => 'ns'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '0',
                                  'bitfrom' => undef,
                                  'descr' => 'If set enable time pulse; if pin assigned to another function, other function takes precedence. Must be set for FTS variant.',
                                  'name' => 'active',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '1',
                                  'bitfrom' => undef,
                                  'descr' => 'If set, synchronize time pulse to GNSS as soon as GNSS time is valid. If not set, or before GNSS time is valid, use local clock. This ﬂag is ignored by the FTS product variant; in this case the receiver always locks to the best available time/frequency reference (which is not necessarily GNSS). This ﬂag can be unset only in Timing product variants.',
                                  'name' => 'lockGnssFreq',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '2',
                                  'bitfrom' => undef,
                                  'descr' => 'If set the receiver switches between the timepulse settings given by \'freqPeriodLocked\' & \'pulseLenLocked\' and those given by \'freqPeriod\' & \'pulseLen\'. The \'Locked\' settings are used where the receiver has an accurate sense of time. For non-FTS products, this occurs when GNSS solution with a reliable time is available, but for FTS products the setting syncMode ﬁeld governs behavior. In all cases, the receiver only uses \'freqPeriod\' & \'pulseLen\' when the ﬂag is unset.',
                                  'name' => 'lockedOtherSet',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '3',
                                  'bitfrom' => undef,
                                  'descr' => 'If set \'freqPeriodLock\' and \'freqPeriod\' are interpreted as frequency, otherwise interpreted as period.',
                                  'name' => 'isFreq',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '4',
                                  'bitfrom' => undef,
                                  'descr' => 'If set \'pulseLenRatioLock\' and \'pulseLenRatio\' interpreted as pulse length, otherwise interpreted as duty cycle.',
                                  'name' => 'isLength',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '5',
                                  'bitfrom' => undef,
                                  'descr' => 'Align pulse to top of second (period time must be integer fraction of 1s). Also set \'lockGnssFreq\' to use this feature. This ﬂag is ignored by the FTS product variant; it is assumed to be always set (as is lockGnssFreq). Set maxSlewRate and maxPhaseCorrRate ﬁelds of UBX- CFG-SMGR to 0 to disable alignment.',
                                  'name' => 'alignToTow',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '6',
                                  'bitfrom' => undef,
                                  'descr' => 'Pulse polarity:
•   0 = falling edge at top of second
•   1 = rising edge at top of second',
                                  'name' => 'polarity',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '10',
                                  'bitfrom' => '7',
                                  'descr' => 'Timegrid to use:
•   0 = UTC
•   1 = GPS
•   2 = GLONASS
•   3 = BeiDou
•   4 = Galileo (not supported for protocol versions less than 18.00) This ﬂag is only relevant if \'lockGnssFreq\' and \'alignToTow\' are set. Note that conﬁgured GNSS time is estimated by the receiver if locked to any GNSS system. If the receiver has a valid GNSS ﬁx it will attempt to steer the TP to the speciﬁed time grid even if the speciﬁed time is not based on information from the constellation\'s satellites. To ensure timing based purely on a given GNSS, restrict the supported constellations in UBX- CFG-GNSS.',
                                  'name' => 'gridUtcGnss',
                                  'numbits' => '4'
                                },
                                {
                                  'bit' => '13',
                                  'bitfrom' => '11',
                                  'descr' => 'Sync Manager lock mode to use:
•   0 = switch to \'freqPeriodLock\' and \'pulseLenRatioLock\' as soon as Sync Manager has an accurate time, never switch back to \'freqPeriod\' and \'pulseLenRatio\'
•   1 = switch to \'freqPeriodLock\' and \'pulseLenRatioLock\' as soon as Sync Manager has an accurate time, and switch back to \'freqPeriod\' and \'pulseLenRatio\' as soon as time gets inaccurate This ﬁeld is only relevant for the FTS product variant. This ﬁeld is only relevant if the ﬂag \'lockedOtherSet\' is set.',
                                  'name' => 'syncMode',
                                  'numbits' => '3'
                                }
                              ],
                'descr' => 'Conﬁguration ﬂags',
                'group' => '',
                'ln_arg' => 4699,
                'name' => 'flags',
                'offset' => '28',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X4',
                'unit' => '-'
              }
            ],
  'class' => '0x06',
  'code' => 'UBX-CFG-TP5',
  'comment' => 'This message is deprecated in protocol versions greater than 27. Use UBX-CFG-VALSET, UBX-CFG-VALGET, UBX-CFG-VALDEL instead. See the Legacy UBX Message Fields Reference for the corresponding conﬁguration item.',
  'id' => '0x31',
  'length' => '32',
  'ln_bitfield' => 4763,
  'ln_classid' => 4670,
  'ln_comment' => 4665,
  'ln_msg' => 4662,
  'ln_name' => 4663,
  'ln_type' => 4664,
  'name' => 'Time pulse parameters',
  'type' => 'Get/set'
}
, ### UBX-CFG-USB USB conﬁguration ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Vendor ID. This ﬁeld shall only be set to registered Vendor IDs. Changing this ﬁeld requires special Host drivers.',
                'group' => '',
                'ln_arg' => 4792,
                'name' => 'vendorID',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Product ID. Changing this ﬁeld requires special Host drivers.',
                'group' => '',
                'ln_arg' => 4795,
                'name' => 'productID',
                'offset' => '2',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 4797,
                'name' => 'reserved0',
                'offset' => '4',
                'repeat' => '2',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 4798,
                'name' => 'reserved1',
                'offset' => '6',
                'repeat' => '2',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Power consumed by the device',
                'group' => '',
                'ln_arg' => 4799,
                'name' => 'powerConsumption',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => 'mA'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '0',
                                  'bitfrom' => undef,
                                  'descr' => 'force re-enumeration',
                                  'name' => 'reEnum',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '1',
                                  'bitfrom' => undef,
                                  'descr' => 'self-powered (1), bus-powered (0)',
                                  'name' => 'powerMode',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'various conﬁguration ﬂags',
                'group' => '',
                'ln_arg' => 4801,
                'name' => 'flags',
                'offset' => '10',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'String containing the vendor name. 32 ASCII bytes including 0-termination.',
                'group' => '',
                'ln_arg' => 4806,
                'name' => 'vendorString',
                'offset' => '12',
                'repeat' => '32',
                'scale' => '-',
                'type' => 'CH',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'String containing the product name. 32 ASCII bytes including 0-termination.',
                'group' => '',
                'ln_arg' => 4808,
                'name' => 'productString',
                'offset' => '44',
                'repeat' => '32',
                'scale' => '-',
                'type' => 'CH',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'String containing the serial number. 32 ASCII bytes including 0-termination. Changing the String ﬁelds requires special Host drivers.',
                'group' => '',
                'ln_arg' => 4820,
                'name' => 'serialNumber',
                'offset' => '76',
                'repeat' => '32',
                'scale' => '-',
                'type' => 'CH',
                'unit' => '-'
              }
            ],
  'class' => '0x06',
  'code' => 'UBX-CFG-USB',
  'comment' => 'This message is deprecated in protocol versions greater than 23.01. Use UBX-CFG-VALSET, UBX-CFG-VALGET, UBX-CFG-VALDEL instead. See the Legacy UBX Message Fields Reference for the corresponding conﬁguration item.',
  'id' => '0x1b',
  'length' => '108',
  'ln_bitfield' => 4805,
  'ln_classid' => 4789,
  'ln_comment' => 4784,
  'ln_msg' => 4781,
  'ln_name' => 4782,
  'ln_type' => 4783,
  'name' => 'USB conﬁguration',
  'type' => 'Get/set'
}
, ### UBX-CFG-VALDEL Delete conﬁguration item values ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Message version (0x00 for this version)',
                'group' => '',
                'ln_arg' => 4854,
                'name' => 'version',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '1',
                                  'bitfrom' => undef,
                                  'descr' => 'Delete conﬁguration from the BBR layer',
                                  'name' => 'bbr',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '2',
                                  'bitfrom' => undef,
                                  'descr' => 'Delete conﬁguration from the Flash layer',
                                  'name' => 'flash',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'The layers where the conﬁguration should be deleted from',
                'group' => '',
                'ln_arg' => 4855,
                'name' => 'layers',
                'offset' => '1',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 4861,
                'name' => 'reserved0',
                'offset' => '2',
                'repeat' => '2',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Conﬁguration key IDs of the conﬁguration items to be deleted',
                'group' => 'repeated N',
                'ln_arg' => 4863,
                'name' => 'keys',
                'offset' => '4 + n·4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => '-'
              }
            ],
  'class' => '0x06',
  'code' => 'UBX-CFG-VALDEL',
  'comment' => 'Overview:
•     This message can be used to delete saved conﬁguration to eﬀectively revert the item values to defaults.
•     This message can delete saved conﬁguration from the ﬂash conﬁguration layer and the BBR conﬁguration layer. The changes will not be eﬀective until these layers are loaded into the RAM layer.
•     This message is limited to containing a maximum of 64 keys up for deletion; i.e. N is a maximum of 64.
•     This message can be used multiple times and every time the result will be applied immediately. To send this message multiple times with the result being applied at the end, see version 1 of UBX-CFG-VALDEL that supports transactions.
•     This message does not check if the resulting conﬁguration is valid.
•     See Receiver conﬁguration for details. This message returns a UBX-ACK-NAK and no conﬁguration is applied:
•     if any key is unknown to the receiver FW
•     if the layer\'s bitﬁeld does not specify a layer to delete a value from. Notes:
•     If a key is sent multiple times within the same message, then the value is eﬀectively deleted only once.
•     Attempting to delete items that have not been set before, or that have already been deleted, is considered a valid request.',
  'hasgroup' => 'repeated N',
  'id' => '0x8c',
  'length' => '4 + [0..n]·4',
  'ln_bitfield' => 4860,
  'ln_classid' => 4851,
  'ln_comment' => 4832,
  'ln_msg' => 4829,
  'ln_name' => 4830,
  'ln_type' => 4831,
  'name' => 'Delete conﬁguration item values',
  'type' => 'Set'
}
, ### UBX-CFG-VALDEL Delete conﬁguration item values (with transaction) ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Message version (0x01 for this version)',
                'group' => '',
                'ln_arg' => 4909,
                'name' => 'version',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '1',
                                  'bitfrom' => undef,
                                  'descr' => 'Delete conﬁguration from the BBR layer',
                                  'name' => 'bbr',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '2',
                                  'bitfrom' => undef,
                                  'descr' => 'Delete conﬁguration from the Flash layer',
                                  'name' => 'flash',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'The layers where the conﬁguration should be deleted from',
                'group' => '',
                'ln_arg' => 4910,
                'name' => 'layers',
                'offset' => '1',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X1',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '1',
                                  'bitfrom' => '0',
                                  'descr' => 'Transaction action to be applied:
•   0 = Transactionless UBX-CFG-VALDEL: In the next UBX-CFG-VALDEL, it can be either 0 or 1. If a transaction has not yet been started, the incoming conﬁguration is applied. If a transaction has already been started, cancels any started transaction and the incoming conﬁguration is applied.
•   1 = (Re)Start deletion transaction: In the next UBX-CFG-VALDEL, it can be either 0, 1, 2 or 3. If a transaction has not yet been started, a transaction will be started. If a transaction has already been started, restarts the transaction, eﬀectively removing all previous non-applied UBX- CFG-VALDEL messages.
•   2 = Deletion transaction ongoing: In the next UBX- CFG-VALDEL, it can be either 0, 1, 2 or 3.
•   3 = Apply and end a deletion transaction: In the next UBX-CFG-VALDEL, it can be either 0 or 1.',
                                  'name' => 'action',
                                  'numbits' => '2'
                                }
                              ],
                'descr' => 'Transaction action to be applied:',
                'group' => '',
                'ln_arg' => 4916,
                'name' => 'transaction',
                'offset' => '2',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 4937,
                'name' => 'reserved0',
                'offset' => '3',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Conﬁguration key IDs of the conﬁguration items to be deleted',
                'group' => 'repeated N',
                'ln_arg' => 4939,
                'name' => 'keys',
                'offset' => '4 + n·4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => '-'
              }
            ],
  'class' => '0x06',
  'code' => 'UBX-CFG-VALDEL',
  'comment' => 'Overview:
•     This message can be used to delete saved conﬁguration to eﬀectively revert them to defaults.
•     This message can delete saved conﬁguration from the ﬂash conﬁguration layer and the BBR conﬁguration layer. The changes will not be eﬀective until these layers are loaded into the RAM layer.
•     This message is limited to containing a maximum of 64 keys up for deletion; i.e. N is a maximum of 64.
•     This message can be used multiple times with the result being managed within a transaction.
•     This message does not check if the resulting conﬁguration is valid.
•     See Receiver conﬁguration for details.
•     See version 0 of UBX-CFG-VALDEL for simpliﬁed version of this message. This message returns a UBX-ACK-NAK, cancels any started transaction, and no conﬁguration is applied:
•     if any key within a transaction is unknown to the receiver FW
•     if an invalid transaction state transition is requested
•     if the layer\'s bitﬁeld changes within a transaction
•     if the layer\'s bitﬁeld does not specify a layer to delete a value from. Notes:
•     Any request for another UBX-CFG- message type (including UBX-CFG-VALSET and UBX-CFG-VALGET) will cancel any started transaction, and no conﬁguration is applied.
•     This message can be sent with no keys to delete for the purposes of managing the transaction state transition.
•     If a key is sent multiple times within the same message or within the same transaction, then the value is eﬀectively deleted only once.
•     Attempting to delete items that have not been set before, or that have already been deleted, is considered a valid request.',
  'hasgroup' => 'repeated N',
  'id' => '0x8c',
  'length' => '4 + [0..n]·4',
  'ln_bitfield' => 4918,
  'ln_classid' => 4906,
  'ln_comment' => 4872,
  'ln_msg' => 4869,
  'ln_name' => 4870,
  'ln_type' => 4871,
  'name' => 'Delete conﬁguration item values (with transaction)',
  'type' => 'Set'
}
, ### UBX-CFG-VALGET Get conﬁguration items ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Message version (0x00 for this version)',
                'group' => '',
                'ln_arg' => 4989,
                'name' => 'version',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'The layer from which the conﬁguration items should be retrieved:
•   0 - RAM layer
•   1 - BBR layer
•   2 - Flash layer
•   7 - Default layer',
                'group' => '',
                'ln_arg' => 4990,
                'name' => 'layer',
                'offset' => '1',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Skip this many key values before constructing output message',
                'group' => '',
                'ln_arg' => 4996,
                'name' => 'position',
                'offset' => '2',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Conﬁguration key IDs of the conﬁguration items to be retrieved',
                'group' => 'repeated N',
                'ln_arg' => 4999,
                'name' => 'keys',
                'offset' => '4 + n·4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => '-'
              }
            ],
  'class' => '0x06',
  'code' => 'UBX-CFG-VALGET',
  'comment' => 'Overview:
•    This message is used to get conﬁguration values by providing a list of conﬁguration key IDs, which identify the conﬁguration items to retrieve.
•    This message can specify the conﬁguration layer where the values of the speciﬁed conﬁguration items are retrieved from.
•    This message is limited to containing a maximum of 64 key IDs.
•    See Receiver conﬁguration for details. This message returns a UBX-ACK-NAK:
•    if any key is unknown to the receiver FW
•    if the layer ﬁeld speciﬁes an invalid layer to get the value from
•    if the keys array speciﬁes more than 64 key IDs. Notes:
•    If a value is requested multiple times within the same poll request, then the reply will contain it multiple times.
•    The provided keys can be complete key values (group and item speciﬁers) or wild-card speciﬁcations. A complete key value will constitute a request for one key-value pair. A key value that has a valid group speciﬁer and 0xﬀﬀ in the item part of the key value (bits 0-15) constitutes a request for all items in the speciﬁed group. A key with a value of 0xﬀf in the group part of the key value (bits 16-27) is a request for all items known to the receiver in all groups.
•    The response message is limited to containing a maximum of 64 key-value pairs. If there are wild-card speciﬁcations then there may be more than 64 possible responses. In order to handle this, the \'position\' ﬁeld can specify that the response message should skip this number of key-value pairs before it starts constructing the message. This allows a large set of values to be retrieved 64 at a time. If the response contains less than 64 key-value pairs then all values have been reported, otherwise there may be more to read.
•    It is not possible to retrieve conﬁguration values for the same conﬁguration item from multiple conﬁguration layers. Separate poll requests must be made for each desired layer.',
  'hasgroup' => 'repeated N',
  'id' => '0x8b',
  'length' => '4 + [0..n]·4',
  'ln_classid' => 4986,
  'ln_comment' => 4957,
  'ln_msg' => 4954,
  'ln_name' => 4955,
  'ln_type' => 4956,
  'name' => 'Get conﬁguration items',
  'type' => 'Poll request'
}
, ### UBX-CFG-VALGET Conﬁguration items ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Message version (0x01 for this version)',
                'group' => '',
                'ln_arg' => 5023,
                'name' => 'version',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'The layer from which the conﬁguration item was retrieved:
•   0 - RAM layer
•   1 - BBR
•   2 - Flash
•   7 - Default',
                'group' => '',
                'ln_arg' => 5024,
                'name' => 'layer',
                'offset' => '1',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Number of conﬁguration items skipped in the result set before constructing this message (mirrors the equivalent ﬁeld in the request message)',
                'group' => '',
                'ln_arg' => 5030,
                'name' => 'position',
                'offset' => '2',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Conﬁguration data (key and value pairs)',
                'group' => 'repeated N',
                'ln_arg' => 5034,
                'name' => 'cfgData',
                'offset' => '4+n',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x06',
  'code' => 'UBX-CFG-VALGET',
  'comment' => 'This message is output by the receiver to return requested conﬁguration data (key and value pairs). See Receiver conﬁguration for details.',
  'hasgroup' => 'repeated N',
  'id' => '0x8b',
  'length' => '4 + [0..n]',
  'ln_classid' => 5020,
  'ln_comment' => 5008,
  'ln_msg' => 5005,
  'ln_name' => 5006,
  'ln_type' => 5007,
  'name' => 'Conﬁguration items',
  'type' => 'Polled'
}
, ### UBX-CFG-VALSET Set conﬁguration item values ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Message version (0x00 for this version)',
                'group' => '',
                'ln_arg' => 5065,
                'name' => 'version',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '0',
                                  'bitfrom' => undef,
                                  'descr' => 'Update conﬁguration in the RAM layer',
                                  'name' => 'ram',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '1',
                                  'bitfrom' => undef,
                                  'descr' => 'Update conﬁguration in the BBR layer',
                                  'name' => 'bbr',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '2',
                                  'bitfrom' => undef,
                                  'descr' => 'Update conﬁguration in the Flash layer',
                                  'name' => 'flash',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'The layers where the conﬁguration should be applied',
                'group' => '',
                'ln_arg' => 5066,
                'name' => 'layers',
                'offset' => '1',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 5083,
                'name' => 'reserved0',
                'offset' => '2',
                'repeat' => '2',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Conﬁguration data (key and value pairs)',
                'group' => 'repeated N',
                'ln_arg' => 5085,
                'name' => 'cfgData',
                'offset' => '4+n',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x06',
  'code' => 'UBX-CFG-VALSET',
  'comment' => 'Overview:
•     This message is used to set a conﬁguration by providing conﬁguration data (a list of key and value pairs), which identify the conﬁguration items to change, and their new values.
•     This message is limited to containing a maximum of 64 key-value pairs.
•     This message can be used multiple times and every time the result will be applied immediately. To send this message multiple times with the result being applied at the end, see version 1 of UBX-CFG-VALSET that supports transactions.
•     See Receiver conﬁguration for details. This message returns a UBX-ACK-NAK and no conﬁguration is applied:
•     if any key is unknown to the receiver FW
•     if the layer\'s bitﬁeld does not specify a layer to save a value to
•     if the requested conﬁguration is not valid. The validity of a conﬁguration is checked only if the message requests to apply the conﬁguration to the RAM conﬁguration layer. Notes:
•     If a key is sent multiple times within the same message, then the value eventually being applied is the last sent.',
  'hasgroup' => 'repeated N',
  'id' => '0x8a',
  'length' => '4 + [0..n]',
  'ln_bitfield' => 5072,
  'ln_classid' => 5062,
  'ln_comment' => 5044,
  'ln_msg' => 5041,
  'ln_name' => 5042,
  'ln_type' => 5043,
  'name' => 'Set conﬁguration item values',
  'type' => 'Set'
}
, ### UBX-CFG-VALSET Set conﬁguration item values (with transaction) ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Message version (0x01 for this version)',
                'group' => '',
                'ln_arg' => 5124,
                'name' => 'version',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '0',
                                  'bitfrom' => undef,
                                  'descr' => 'Update conﬁguration in the RAM layer',
                                  'name' => 'ram',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '1',
                                  'bitfrom' => undef,
                                  'descr' => 'Update conﬁguration in the BBR layer',
                                  'name' => 'bbr',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '2',
                                  'bitfrom' => undef,
                                  'descr' => 'Update conﬁguration in the Flash layer',
                                  'name' => 'flash',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'The layers where the conﬁguration should be applied',
                'group' => '',
                'ln_arg' => 5125,
                'name' => 'layers',
                'offset' => '1',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X1',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '1',
                                  'bitfrom' => '0',
                                  'descr' => 'Transaction action to be applied:
•   0 = Transactionless UBX-CFG-VALSET: In the next UBX-CFG-VALSET, it can be either 0 or 1. If a transaction has not yet been started, the incoming conﬁguration is applied (if valid). If a transaction has already been started, cancels any started transaction and the incoming conﬁguration is applied (if valid). 1 = (Re)Start set transaction: In the next it can be either 0, 1, 2 or If a transaction has not yet been started, a will be started. If a transaction has been started, restarts the transaction, removing all previous non-applied UBX- messages. 2 = Set transaction ongoing: In the next UBX- it can be either 0, 1, 2 or 3. 3 = Apply and end a set transaction: In the next it can be either 0 or 1.',
                                  'name' => 'action',
                                  'numbits' => '2',
                                  'unit' => '•UBX-CFG-VALSET,3.transactionalreadyeﬀectivelyCFG-VALSET•CFG-VALSET,•UBX-CFG-VALSET,'
                                }
                              ],
                'descr' => 'Transaction action to be applied',
                'group' => '',
                'ln_arg' => 5132,
                'name' => 'transaction',
                'offset' => '2',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 5162,
                'name' => 'reserved0',
                'offset' => '3',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Conﬁguration data (key and value pairs)',
                'group' => 'repeated N',
                'ln_arg' => 5164,
                'name' => 'cfgData',
                'offset' => '4+n',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x06',
  'code' => 'UBX-CFG-VALSET',
  'comment' => 'Overview:
•     This message is used to set a conﬁguration by providing conﬁguration data (a list of key and value pairs), which identify the conﬁguration items to change, and their new values.
•     This message is limited to containing a maximum of 64 key-value pairs.
•     This message can be used multiple times with the result being managed within a transaction. Within a transaction there is no limit on the number key-value pairs; a transaction is eﬀectively limited to the number of known keys.
•     See Receiver conﬁguration for details.
•     See version 0 of UBX-CFG-VALSET for simpliﬁed version of this message. This message returns a UBX-ACK-NAK, cancels any started transaction, and no conﬁguration is applied:
•     if any key within a transaction is unknown to the receiver FW
•     if an invalid transaction state transition is requested
•     if the layer\'s bitﬁeld changes within a transaction
•     if the layer\'s bitﬁeld does not specify a layer to save a value to This message returns a UBX-ACK-NAK, and no conﬁguration is applied:
•     if the requested conﬁguration is not valid. While in a transaction context, only the last message that requests to apply the transaction returns a UBX-ACK-NAK. The validity of a conﬁguration is checked only if the message requests to apply the conﬁguration to the RAM conﬁguration layer. This also applies to a transactionless request. Notes:
•     Any request for another UBX-CFG-message type (including UBX-CFG-VALDEL and UBX-CFG-VALGET) will cancel any started transaction, and no conﬁguration is applied.
•     This message can be sent with no key/values to set for the purposes of managing the transaction state transition.
•     If a key is sent multiple times within the same message or within the same transaction, then the value eventually being applied is the last sent.',
  'hasgroup' => 'repeated N',
  'id' => '0x8a',
  'length' => '4 + [0..n]',
  'ln_bitfield' => 5134,
  'ln_classid' => 5121,
  'ln_comment' => 5093,
  'ln_msg' => 5090,
  'ln_name' => 5091,
  'ln_type' => 5092,
  'name' => 'Set conﬁguration item values (with transaction)',
  'type' => 'Set'
}
, ### UBX-INF-DEBUG ASCII output with debug contents ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'ASCII Character',
                'group' => 'repeated N',
                'ln_arg' => 5185,
                'name' => 'str',
                'offset' => '0+n',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'CH',
                'unit' => '-'
              }
            ],
  'class' => '0x04',
  'code' => 'UBX-INF-DEBUG',
  'comment' => 'This message has a variable length payload, representing an ASCII string.',
  'hasgroup' => 'repeated N',
  'id' => '0x04',
  'length' => '[0..n]',
  'ln_classid' => 5181,
  'ln_comment' => 5178,
  'ln_msg' => 5175,
  'ln_name' => 5176,
  'ln_type' => 5177,
  'name' => 'ASCII output with debug contents',
  'type' => 'Output'
}
, ### UBX-INF-ERROR ASCII output with error contents ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'ASCII Character',
                'group' => 'repeated N',
                'ln_arg' => 5202,
                'name' => 'str',
                'offset' => '0+n',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'CH',
                'unit' => '-'
              }
            ],
  'class' => '0x04',
  'code' => 'UBX-INF-ERROR',
  'comment' => 'This message has a variable length payload, representing an ASCII string.',
  'hasgroup' => 'repeated N',
  'id' => '0x00',
  'length' => '[0..n]',
  'ln_classid' => 5198,
  'ln_comment' => 5195,
  'ln_msg' => 5192,
  'ln_name' => 5193,
  'ln_type' => 5194,
  'name' => 'ASCII output with error contents',
  'type' => 'Output'
}
, ### UBX-INF-NOTICE ASCII output with informational contents ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'ASCII Character',
                'group' => 'repeated N',
                'ln_arg' => 5229,
                'name' => 'str',
                'offset' => '0+n',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'CH',
                'unit' => '-'
              }
            ],
  'class' => '0x04',
  'code' => 'UBX-INF-NOTICE',
  'comment' => 'This message has a variable length payload, representing an ASCII string.',
  'hasgroup' => 'repeated N',
  'id' => '0x02',
  'length' => '[0..n]',
  'ln_classid' => 5225,
  'ln_comment' => 5222,
  'ln_msg' => 5219,
  'ln_name' => 5220,
  'ln_type' => 5221,
  'name' => 'ASCII output with informational contents',
  'type' => 'Output'
}
, ### UBX-INF-TEST ASCII output with test contents ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'ASCII Character',
                'group' => 'repeated N',
                'ln_arg' => 5246,
                'name' => 'str',
                'offset' => '0+n',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'CH',
                'unit' => '-'
              }
            ],
  'class' => '0x04',
  'code' => 'UBX-INF-TEST',
  'comment' => 'This message has a variable length payload, representing an ASCII string.',
  'hasgroup' => 'repeated N',
  'id' => '0x03',
  'length' => '[0..n]',
  'ln_classid' => 5242,
  'ln_comment' => 5239,
  'ln_msg' => 5236,
  'ln_name' => 5237,
  'ln_type' => 5238,
  'name' => 'ASCII output with test contents',
  'type' => 'Output'
}
, ### UBX-INF-WARNING ASCII output with warning contents ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'ASCII Character',
                'group' => 'repeated N',
                'ln_arg' => 5263,
                'name' => 'str',
                'offset' => '0+n',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'CH',
                'unit' => '-'
              }
            ],
  'class' => '0x04',
  'code' => 'UBX-INF-WARNING',
  'comment' => 'This message has a variable length payload, representing an ASCII string.',
  'hasgroup' => 'repeated N',
  'id' => '0x01',
  'length' => '[0..n]',
  'ln_classid' => 5259,
  'ln_comment' => 5256,
  'ln_msg' => 5253,
  'ln_name' => 5254,
  'ln_type' => 5255,
  'name' => 'ASCII output with warning contents',
  'type' => 'Output'
}
, ### UBX-LOG-CREATE Create log ﬁle ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Message version (0x00 for this version)',
                'group' => '',
                'ln_arg' => 5295,
                'name' => 'version',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '0',
                                  'bitfrom' => undef,
                                  'descr' => 'Log is circular (new entries overwrite old ones in a full log) if this bit set',
                                  'name' => 'circular',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'Conﬁg ﬂags',
                'group' => '',
                'ln_arg' => 5296,
                'name' => 'logCfg',
                'offset' => '1',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 5300,
                'name' => 'reserved0',
                'offset' => '2',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Indicates the size of the log:
•   0 (maximum safe size) = Ensures that logging will not be interrupted and enough space will be left available for all other uses of the ﬁlestore
•   1 (minimum size) =
•   2 (user-deﬁned) = See \'userDeﬁnedSize\' below',
                'group' => '',
                'ln_arg' => 5301,
                'name' => 'logSize',
                'offset' => '3',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Sets the maximum amount of space in the ﬁlestore can be used by the logging task. This ﬁeld is only applicable if logSize is set to user- deﬁned.',
                'group' => '',
                'ln_arg' => 5307,
                'name' => 'userDefinedSize',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'bytesthat'
              }
            ],
  'class' => '0x21',
  'code' => 'UBX-LOG-CREATE',
  'comment' => 'This message is used to create an initial logging ﬁle and activate the logging subsystem. UBX-ACK-ACK or UBX-ACK-NAK are returned to indicate success or failure. This message does not handle activation of recording or ﬁltering of log entries (see UBX-CFG-LOGFILTER).',
  'id' => '0x07',
  'length' => '8',
  'ln_bitfield' => 5298,
  'ln_classid' => 5292,
  'ln_comment' => 5287,
  'ln_msg' => 5284,
  'ln_name' => 5285,
  'ln_type' => 5286,
  'name' => 'Create log ﬁle',
  'type' => 'Command'
}
, ### UBX-LOG-ERASE Erase logged data ###
{
  'args' => [],
  'class' => '0x21',
  'code' => 'UBX-LOG-ERASE',
  'comment' => 'This message deactivates the logging system and erases all logged data. UBX-ACK-ACK or UBX-ACK-NAK are returned to indicate success or failure.',
  'id' => '0x03',
  'length' => '0',
  'ln_classid' => 5323,
  'ln_comment' => 5319,
  'ln_msg' => 5316,
  'ln_name' => 5317,
  'ln_type' => 5318,
  'name' => 'Erase logged data',
  'type' => 'Command'
}
, ### UBX-LOG-FINDTIME Find index of a log entry based on a given time ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Message version (0x00 for this version)',
                'group' => '',
                'ln_arg' => 5354,
                'name' => 'version',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Message type, 0 for request',
                'group' => '',
                'ln_arg' => 5355,
                'name' => 'type',
                'offset' => '1',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 5356,
                'name' => 'reserved0',
                'offset' => '2',
                'repeat' => '2',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Year (1-65635) of UTC time',
                'group' => '',
                'ln_arg' => 5357,
                'name' => 'year',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Month (1-12) of UTC time',
                'group' => '',
                'ln_arg' => 5358,
                'name' => 'month',
                'offset' => '6',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Day (1-31) of UTC time',
                'group' => '',
                'ln_arg' => 5359,
                'name' => 'day',
                'offset' => '7',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Hour (0-23) of UTC time',
                'group' => '',
                'ln_arg' => 5360,
                'name' => 'hour',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Minute (0-59) of UTC time',
                'group' => '',
                'ln_arg' => 5361,
                'name' => 'minute',
                'offset' => '9',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Second (0-60) of UTC time',
                'group' => '',
                'ln_arg' => 5362,
                'name' => 'second',
                'offset' => '10',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 5363,
                'name' => 'reserved1',
                'offset' => '11',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x21',
  'code' => 'UBX-LOG-FINDTIME',
  'comment' => 'This message can be used for a time-based search of a log. It can ﬁnd the index of the ﬁrst log entry with time equal to the given time, otherwise the index of the most recent entry with time less than the given time. This index can then be used with the UBX-LOG-RETRIEVE message to provide time-based retrieval of log entries. Searching a log is eﬀective for a given time later than the base date (January 1st, 2004). Searching a log for a given time earlier than the base date will result in an \'entry not found\' response. (Searching a log for a given time earlier than the base date will result in a UBX-ACK-NAK message for protocol versions less than 18.00). Searching a log for a given time greater than the last recorded entry\'s time will return the index of the last recorded entry. (If the logging has stopped due to lack of ﬁle space, such a search will result in a UBX-ACK-NAK message for protocol versions less than 18.00).',
  'id' => '0x0e',
  'length' => '12',
  'ln_classid' => 5351,
  'ln_comment' => 5340,
  'ln_msg' => 5337,
  'ln_name' => 5338,
  'ln_type' => 5339,
  'name' => 'Find index of a log entry based on a given time',
  'type' => 'Input'
}
, ### UBX-LOG-FINDTIME Response to FINDTIME request ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Message version (0x01 for this version)',
                'group' => '',
                'ln_arg' => 5376,
                'name' => 'version',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Message type, 1 for response',
                'group' => '',
                'ln_arg' => 5377,
                'name' => 'type',
                'offset' => '1',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 5378,
                'name' => 'reserved0',
                'offset' => '2',
                'repeat' => '2',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Index of the ﬁrst log entry with time = given time, otherwise index of the most recent entry with time < given time. If 0xFFFFFFFF, no log entry found with time <= given time. The indexing of log entries is zero- based.',
                'group' => '',
                'ln_arg' => 5379,
                'name' => 'entryNumber',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => '-'
              }
            ],
  'class' => '0x21',
  'code' => 'UBX-LOG-FINDTIME',
  'comment' => '',
  'id' => '0x0e',
  'length' => '8',
  'ln_classid' => 5373,
  'ln_comment' => 5370,
  'ln_msg' => 5367,
  'ln_name' => 5368,
  'ln_type' => 5369,
  'name' => 'Response to FINDTIME request',
  'type' => 'Output'
}
, ### UBX-LOG-INFO Poll for log information ###
{
  'args' => [],
  'class' => '0x21',
  'code' => 'UBX-LOG-INFO',
  'comment' => 'Upon sending of this message, the receiver returns UBX-LOG-INFO as deﬁned below.',
  'id' => '0x08',
  'length' => '0',
  'ln_classid' => 5403,
  'ln_comment' => 5400,
  'ln_msg' => 5397,
  'ln_name' => 5398,
  'ln_type' => 5399,
  'name' => 'Poll for log information',
  'type' => 'Poll request'
}
, ### UBX-LOG-INFO Log information ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Message version (0x01 for this version)',
                'group' => '',
                'ln_arg' => 5424,
                'name' => 'version',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 5425,
                'name' => 'reserved0',
                'offset' => '1',
                'repeat' => '3',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'The capacity of the ﬁlestore',
                'group' => '',
                'ln_arg' => 5426,
                'name' => 'filestoreCapacity',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'bytes'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 5428,
                'name' => 'reserved1',
                'offset' => '8',
                'repeat' => '8',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'The maximum size the current log is allowed to grow to',
                'group' => '',
                'ln_arg' => 5429,
                'name' => 'currentMaxLogSize',
                'offset' => '16',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'bytes'
              },
              {
                'bitfield' => [],
                'descr' => 'Approximate amount of space in log currently occupied',
                'group' => '',
                'ln_arg' => 5431,
                'name' => 'currentLogSize',
                'offset' => '20',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'bytes'
              },
              {
                'bitfield' => [],
                'descr' => 'Number of entries in the log. Note: for circular logs this value will decrease when a group of entries is deleted to make space for new ones.',
                'group' => '',
                'ln_arg' => 5433,
                'name' => 'entryCount',
                'offset' => '24',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Oldest entry UTC year (1-65635) or zero if there are no entries with known time',
                'group' => '',
                'ln_arg' => 5436,
                'name' => 'oldestYear',
                'offset' => '28',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Oldest month (1-12)',
                'group' => '',
                'ln_arg' => 5438,
                'name' => 'oldestMonth',
                'offset' => '30',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Oldest day (1-31)',
                'group' => '',
                'ln_arg' => 5439,
                'name' => 'oldestDay',
                'offset' => '31',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Oldest hour (0-23)',
                'group' => '',
                'ln_arg' => 5440,
                'name' => 'oldestHour',
                'offset' => '32',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Oldest minute (0-59)',
                'group' => '',
                'ln_arg' => 5441,
                'name' => 'oldestMinute',
                'offset' => '33',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Oldest second (0-60)',
                'group' => '',
                'ln_arg' => 5442,
                'name' => 'oldestSecond',
                'offset' => '34',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 5443,
                'name' => 'reserved2',
                'offset' => '35',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Newest year (1-65635) or zero if there are no entries with known time',
                'group' => '',
                'ln_arg' => 5444,
                'name' => 'newestYear',
                'offset' => '36',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Newest month (1-12)',
                'group' => '',
                'ln_arg' => 5456,
                'name' => 'newestMonth',
                'offset' => '38',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Newest day (1-31)',
                'group' => '',
                'ln_arg' => 5457,
                'name' => 'newestDay',
                'offset' => '39',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Newest hour (0-23)',
                'group' => '',
                'ln_arg' => 5458,
                'name' => 'newestHour',
                'offset' => '40',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Newest minute (0-59)',
                'group' => '',
                'ln_arg' => 5459,
                'name' => 'newestMinute',
                'offset' => '41',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Newest second (0-60)',
                'group' => '',
                'ln_arg' => 5460,
                'name' => 'newestSecond',
                'offset' => '42',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 5461,
                'name' => 'reserved3',
                'offset' => '43',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '3',
                                  'bitfrom' => undef,
                                  'descr' => 'Log entry recording is currently turned on',
                                  'name' => 'recording',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '4',
                                  'bitfrom' => undef,
                                  'descr' => 'Logging system not active - no log present',
                                  'name' => 'inactive',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '5',
                                  'bitfrom' => undef,
                                  'descr' => 'The current log is circular',
                                  'name' => 'circular',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'Log status ﬂags',
                'group' => '',
                'ln_arg' => 5462,
                'name' => 'status',
                'offset' => '44',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 5469,
                'name' => 'reserved4',
                'offset' => '45',
                'repeat' => '3',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x21',
  'code' => 'UBX-LOG-INFO',
  'comment' => 'This message is used to report information about the logging subsystem. Note:
•    The reported maximum log size will be smaller than that originally speciﬁed in LOG-CREATE due to logging and ﬁlestore implementation overheads.
•    Log entries are compressed in a variable length fashion, so it may be diﬃcult to predict log space usage with any precision.
•    There may be times when the receiver does not have an accurate time (e.g. if the week number is not yet known), in which case some entries will not have a timestamp. This may result in the oldest/newest entry time values not taking account of these entries.',
  'id' => '0x08',
  'length' => '48',
  'ln_bitfield' => 5468,
  'ln_classid' => 5421,
  'ln_comment' => 5410,
  'ln_msg' => 5407,
  'ln_name' => 5408,
  'ln_type' => 5409,
  'name' => 'Log information',
  'type' => 'Output'
}
, ### UBX-LOG-RETRIEVE Request log data ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Index of ﬁrst log entry to be transferred. If it is larger than the index of the last available log entry, then the ﬁrst log entry to be transferred is the last available log entry. The indexing of log entries is zero-based.',
                'group' => '',
                'ln_arg' => 5491,
                'name' => 'startNumber',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Number of log entries to transfer in total including the ﬁrst entry to be transferred. If it is larger than the log entries available starting from the ﬁrst entry to be transferred, then only the available log entries are transferred followed by a UBX-ACK-NAK. The maximum is 256.',
                'group' => '',
                'ln_arg' => 5495,
                'name' => 'entryCount',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Message version (0x00 for this version)',
                'group' => '',
                'ln_arg' => 5501,
                'name' => 'version',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 5502,
                'name' => 'reserved0',
                'offset' => '9',
                'repeat' => '3',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x21',
  'code' => 'UBX-LOG-RETRIEVE',
  'comment' => 'This message is used to request logged data (log recording must ﬁrst be disabled, see UBX-CFG-LOGFILTER). Log entries are returned in chronological order, using the messages UBX-LOG-RETRIEVEPOS and UBX-LOG-RETRIEVESTRING. If the odometer was enabled at the time a position was logged, then message UBX-LOG-RETRIEVEPOSEXTRA will also be used. The maximum number of entries that can be returned in response to a single UBX-LOG-RETRIEVE message is 256. If more entries than this are required the message will need to be sent multiple times with diﬀerent startNumbers. The retrieve will be stopped if any UBX-LOG message is received. The speed of transfer can be maximized by using a high data rate and temporarily stopping the GPS processing (see UBX-CFG-RST).',
  'id' => '0x09',
  'length' => '12',
  'ln_classid' => 5488,
  'ln_comment' => 5478,
  'ln_msg' => 5475,
  'ln_name' => 5476,
  'ln_type' => 5477,
  'name' => 'Request log data',
  'type' => 'Command'
}
, ### UBX-LOG-RETRIEVEPOS Position ﬁx log entry ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'The index of this log entry',
                'group' => '',
                'ln_arg' => 5526,
                'name' => 'entryIndex',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Longitude',
                'group' => '',
                'ln_arg' => 5527,
                'name' => 'lon',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '1e-7',
                'type' => 'I4',
                'unit' => 'deg'
              },
              {
                'bitfield' => [],
                'descr' => 'Latitude',
                'group' => '',
                'ln_arg' => 5528,
                'name' => 'lat',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '1e-7',
                'type' => 'I4',
                'unit' => 'deg'
              },
              {
                'bitfield' => [],
                'descr' => 'Height above mean sea level',
                'group' => '',
                'ln_arg' => 5529,
                'name' => 'hMSL',
                'offset' => '12',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I4',
                'unit' => 'mm'
              },
              {
                'bitfield' => [],
                'descr' => 'Horizontal accuracy estimate',
                'group' => '',
                'ln_arg' => 5530,
                'name' => 'hAcc',
                'offset' => '16',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'mm'
              },
              {
                'bitfield' => [],
                'descr' => 'Ground speed (2-D)',
                'group' => '',
                'ln_arg' => 5531,
                'name' => 'gSpeed',
                'offset' => '20',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'mm/s'
              },
              {
                'bitfield' => [],
                'descr' => 'Heading',
                'group' => '',
                'ln_arg' => 5532,
                'name' => 'heading',
                'offset' => '24',
                'repeat' => undef,
                'scale' => '1e-5',
                'type' => 'U4',
                'unit' => 'deg'
              },
              {
                'bitfield' => [],
                'descr' => 'Message version (0x00 for this version)',
                'group' => '',
                'ln_arg' => 5533,
                'name' => 'version',
                'offset' => '28',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Fix type:
•   0x01 = Dead Reckoning only
•   0x02 = 2D-Fix
•   0x03 = 3D-Fix
•   0x04 = GNSS + Dead Reckoning combined',
                'group' => '',
                'ln_arg' => 5534,
                'name' => 'fixType',
                'offset' => '29',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Year (1-65635) of UTC time',
                'group' => '',
                'ln_arg' => 5539,
                'name' => 'year',
                'offset' => '30',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Month (1-12) of UTC time',
                'group' => '',
                'ln_arg' => 5540,
                'name' => 'month',
                'offset' => '32',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Day (1-31) of UTC time',
                'group' => '',
                'ln_arg' => 5541,
                'name' => 'day',
                'offset' => '33',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Hour (0-23) of UTC time',
                'group' => '',
                'ln_arg' => 5542,
                'name' => 'hour',
                'offset' => '34',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Minute (0-59) of UTC time',
                'group' => '',
                'ln_arg' => 5543,
                'name' => 'minute',
                'offset' => '35',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Second (0-60) of UTC time',
                'group' => '',
                'ln_arg' => 5544,
                'name' => 'second',
                'offset' => '36',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 5545,
                'name' => 'reserved0',
                'offset' => '37',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Number of satellites used in the position ﬁx',
                'group' => '',
                'ln_arg' => 5546,
                'name' => 'numSV',
                'offset' => '38',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 5547,
                'name' => 'reserved1',
                'offset' => '39',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x21',
  'code' => 'UBX-LOG-RETRIEVEPOS',
  'comment' => 'This message is used to report a position ﬁx log entry',
  'id' => '0x0b',
  'length' => '40',
  'ln_classid' => 5523,
  'ln_comment' => 5520,
  'ln_msg' => 5517,
  'ln_name' => 5518,
  'ln_type' => 5519,
  'name' => 'Position ﬁx log entry',
  'type' => 'Output'
}
, ### UBX-LOG-RETRIEVEPOSEXTRA Odometer log entry ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'The index of this log entry',
                'group' => '',
                'ln_arg' => 5562,
                'name' => 'entryIndex',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Message version (0x00 for this version)',
                'group' => '',
                'ln_arg' => 5563,
                'name' => 'version',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 5573,
                'name' => 'reserved0',
                'offset' => '5',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Year (1-65635) of UTC time. Will be zero if time not known',
                'group' => '',
                'ln_arg' => 5574,
                'name' => 'year',
                'offset' => '6',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Month (1-12) of UTC time',
                'group' => '',
                'ln_arg' => 5576,
                'name' => 'month',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Day (1-31) of UTC time',
                'group' => '',
                'ln_arg' => 5577,
                'name' => 'day',
                'offset' => '9',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Hour (0-23) of UTC time',
                'group' => '',
                'ln_arg' => 5578,
                'name' => 'hour',
                'offset' => '10',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Minute (0-59) of UTC time',
                'group' => '',
                'ln_arg' => 5579,
                'name' => 'minute',
                'offset' => '11',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Second (0-60) of UTC time',
                'group' => '',
                'ln_arg' => 5580,
                'name' => 'second',
                'offset' => '12',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 5581,
                'name' => 'reserved1',
                'offset' => '13',
                'repeat' => '3',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Odometer distance traveled since the last time the odometer was reset by a UBX-NAV-RESETODO',
                'group' => '',
                'ln_arg' => 5582,
                'name' => 'distance',
                'offset' => '16',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 5584,
                'name' => 'reserved2',
                'offset' => '20',
                'repeat' => '12',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x21',
  'code' => 'UBX-LOG-RETRIEVEPOSEXTRA',
  'comment' => 'This message is used to report an odometer log entry',
  'id' => '0x0f',
  'length' => '32',
  'ln_classid' => 5559,
  'ln_comment' => 5556,
  'ln_msg' => 5553,
  'ln_name' => 5554,
  'ln_type' => 5555,
  'name' => 'Odometer log entry',
  'type' => 'Output'
}
, ### UBX-LOG-RETRIEVESTRING Byte string log entry ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'The index of this log entry',
                'group' => '',
                'ln_arg' => 5599,
                'name' => 'entryIndex',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Message version (0x00 for this version)',
                'group' => '',
                'ln_arg' => 5600,
                'name' => 'version',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 5601,
                'name' => 'reserved0',
                'offset' => '5',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Year (1-65635) of UTC time. Will be zero if time not known',
                'group' => '',
                'ln_arg' => 5602,
                'name' => 'year',
                'offset' => '6',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Month (1-12) of UTC time',
                'group' => '',
                'ln_arg' => 5604,
                'name' => 'month',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Day (1-31) of UTC time',
                'group' => '',
                'ln_arg' => 5605,
                'name' => 'day',
                'offset' => '9',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Hour (0-23) of UTC time',
                'group' => '',
                'ln_arg' => 5606,
                'name' => 'hour',
                'offset' => '10',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Minute (0-59) of UTC time',
                'group' => '',
                'ln_arg' => 5607,
                'name' => 'minute',
                'offset' => '11',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Second (0-60) of UTC time',
                'group' => '',
                'ln_arg' => 5608,
                'name' => 'second',
                'offset' => '12',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 5609,
                'name' => 'reserved1',
                'offset' => '13',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Size of string in bytes',
                'group' => '',
                'ln_arg' => 5610,
                'name' => 'byteCount',
                'offset' => '14',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'The bytes of the string',
                'group' => 'repeated byteCount',
                'ln_arg' => 5613,
                'name' => 'bytes',
                'offset' => '16 + n',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x21',
  'code' => 'UBX-LOG-RETRIEVESTRING',
  'comment' => 'This message is used to report a byte string log entry',
  'hasgroup' => 'repeated byteCount',
  'id' => '0x0d',
  'length' => '16 + byteCount',
  'ln_classid' => 5596,
  'ln_comment' => 5593,
  'ln_msg' => 5590,
  'ln_name' => 5591,
  'ln_type' => 5592,
  'name' => 'Byte string log entry',
  'type' => 'Output'
}
, ### UBX-LOG-STRING Store arbitrary string in on-board ﬂash ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'The string of bytes to be logged (maximum 256)',
                'group' => 'repeated N',
                'ln_arg' => 5641,
                'name' => 'bytes',
                'offset' => '0+n',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x21',
  'code' => 'UBX-LOG-STRING',
  'comment' => 'This message can be used to store an arbitrary byte string in the on-board ﬂash memory. The maximum length that can be stored is 256 bytes.',
  'hasgroup' => 'repeated N',
  'id' => '0x04',
  'length' => '[0..n]',
  'ln_classid' => 5637,
  'ln_comment' => 5633,
  'ln_msg' => 5630,
  'ln_name' => 5631,
  'ln_type' => 5632,
  'name' => 'Store arbitrary string in on-board ﬂash',
  'type' => 'Command'
}
, ### UBX-MGA-ACK-DATA0 Multiple GNSS acknowledge message ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Type of acknowledgment:
•   0 = The message was not used by the receiver (see infoCode ﬁeld for an indication of why)
•   1 = The message was accepted for use by the receiver (the infoCode ﬁeld will be 0)',
                'group' => '',
                'ln_arg' => 5663,
                'name' => 'type',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Message version (0x00 for this version)',
                'group' => '',
                'ln_arg' => 5668,
                'name' => 'version',
                'offset' => '1',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Provides greater information on what the receiver chose to do with the message contents:
•   0 = The receiver accepted the data
•   1 = The receiver does not know the time so it cannot use the data (To resolve this a UBX-MGA- INI-TIME_UTC message should be supplied ﬁrst)
•   2 = The message version is not supported by the receiver
•   3 = The message size does not match the message version
•   4 = The message data could not be stored to the database
•   5 = The receiver is not ready to use the message data
•   6 = The message type is unknown',
                'group' => '',
                'ln_arg' => 5679,
                'name' => 'infoCode',
                'offset' => '2',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'UBX message ID of the acknowledged message',
                'group' => '',
                'ln_arg' => 5694,
                'name' => 'msgId',
                'offset' => '3',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'The ﬁrst 4 bytes of the acknowledged message\'s',
                'group' => '',
                'ln_arg' => 5695,
                'name' => 'msgPayloadStart',
                'offset' => '4',
                'repeat' => '4',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-payload'
              }
            ],
  'class' => '0x13',
  'code' => 'UBX-MGA-ACK-DATA0',
  'comment' => 'This message is sent by a u-blox receiver to acknowledge the receipt of an assistance message. Acknowledgments are enabled by setting the CFG-NAVSPG-ACKAIDING item. See the section Flow control in Integration manual for details.',
  'id' => '0x60',
  'length' => '8',
  'ln_classid' => 5660,
  'ln_comment' => 5655,
  'ln_msg' => 5652,
  'ln_name' => 5653,
  'ln_type' => 5654,
  'name' => 'Multiple GNSS acknowledge message',
  'type' => 'Output'
}
, ### UBX-MGA-BDS-EPH BeiDou ephemeris assistance ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Message type (0x01 for this type)',
                'group' => '',
                'ln_arg' => 5712,
                'name' => 'type',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Message version (0x00 for this version)',
                'group' => '',
                'ln_arg' => 5713,
                'name' => 'version',
                'offset' => '1',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'BeiDou satellite identiﬁer (see Satellite Numbering)',
                'group' => '',
                'ln_arg' => 5714,
                'name' => 'svId',
                'offset' => '2',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 5715,
                'name' => 'reserved0',
                'offset' => '3',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Autonomous satellite Health ﬂag',
                'group' => '',
                'ln_arg' => 5716,
                'name' => 'SatH1',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Issue of Data, Clock',
                'group' => '',
                'ln_arg' => 5717,
                'name' => 'IODC',
                'offset' => '5',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Time polynomial coeﬃcient 2',
                'group' => '',
                'ln_arg' => 5718,
                'name' => 'a2',
                'offset' => '6',
                'repeat' => undef,
                'scale' => '2^-66',
                'type' => 'I2',
                'unit' => 's/s^2'
              },
              {
                'bitfield' => [],
                'descr' => 'Time polynomial coeﬃcient 1',
                'group' => '',
                'ln_arg' => 5719,
                'name' => 'a1',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '2^-50',
                'type' => 'I4',
                'unit' => 's/s'
              },
              {
                'bitfield' => [],
                'descr' => 'Time polynomial coeﬃcient 0',
                'group' => '',
                'ln_arg' => 5720,
                'name' => 'a0',
                'offset' => '12',
                'repeat' => undef,
                'scale' => '2^-33',
                'type' => 'I4',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'Clock data reference time',
                'group' => '',
                'ln_arg' => 5721,
                'name' => 'toc',
                'offset' => '16',
                'repeat' => undef,
                'scale' => '2^3',
                'type' => 'U4',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'Equipment Group Delay Diﬀerential',
                'group' => '',
                'ln_arg' => 5722,
                'name' => 'TGD1',
                'offset' => '20',
                'repeat' => undef,
                'scale' => '0.1',
                'type' => 'I2',
                'unit' => 'ns'
              },
              {
                'bitfield' => [],
                'descr' => 'User Range Accuracy Index',
                'group' => '',
                'ln_arg' => 5723,
                'name' => 'URAI',
                'offset' => '22',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Issue of Data, Ephemeris',
                'group' => '',
                'ln_arg' => 5724,
                'name' => 'IODE',
                'offset' => '23',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Ephemeris reference time',
                'group' => '',
                'ln_arg' => 5725,
                'name' => 'toe',
                'offset' => '24',
                'repeat' => undef,
                'scale' => '2^3',
                'type' => 'U4',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'Square root of semi-major axis',
                'group' => '',
                'ln_arg' => 5726,
                'name' => 'sqrtA',
                'offset' => '28',
                'repeat' => undef,
                'scale' => '2^-19',
                'type' => 'U4',
                'unit' => 'm^0.5'
              },
              {
                'bitfield' => [],
                'descr' => 'Eccentricity',
                'group' => '',
                'ln_arg' => 5727,
                'name' => 'e',
                'offset' => '32',
                'repeat' => undef,
                'scale' => '2^-33',
                'type' => 'U4',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Argument of perigee ',
                'group' => '',
                'ln_arg' => 5738,
                'name' => 'omega',
                'offset' => '36',
                'repeat' => undef,
                'scale' => '2^-31',
                'type' => 'I4',
                'unit' => 'semi-circles'
              },
              {
                'bitfield' => [],
                'descr' => 'Mean motion diﬀerence from computed value ',
                'group' => '',
                'ln_arg' => 5740,
                'name' => 'Deltan',
                'offset' => '40',
                'repeat' => undef,
                'scale' => '2^-43',
                'type' => 'I2',
                'unit' => 'semi-circles/s'
              },
              {
                'bitfield' => [],
                'descr' => 'Rate of inclination angle ',
                'group' => '',
                'ln_arg' => 5742,
                'name' => 'IDOT',
                'offset' => '42',
                'repeat' => undef,
                'scale' => '2^-43',
                'type' => 'I2',
                'unit' => 'semi-circles/s'
              },
              {
                'bitfield' => [],
                'descr' => 'Mean anomaly at reference time ',
                'group' => '',
                'ln_arg' => 5744,
                'name' => 'M0',
                'offset' => '44',
                'repeat' => undef,
                'scale' => '2^-31',
                'type' => 'I4',
                'unit' => 'semi-circles'
              },
              {
                'bitfield' => [],
                'descr' => 'Longitude of ascending node of orbital of plane computed according to reference time',
                'group' => '',
                'ln_arg' => 5746,
                'name' => 'Omega0',
                'offset' => '48',
                'repeat' => undef,
                'scale' => '2^-31',
                'type' => 'I4',
                'unit' => 'semi-circles'
              },
              {
                'bitfield' => [],
                'descr' => 'Rate of right ascension ',
                'group' => '',
                'ln_arg' => 5748,
                'name' => 'OmegaDot',
                'offset' => '52',
                'repeat' => undef,
                'scale' => '2^-43',
                'type' => 'I4',
                'unit' => 'semi-circles/s'
              },
              {
                'bitfield' => [],
                'descr' => 'Inclination angle at reference time ',
                'group' => '',
                'ln_arg' => 5750,
                'name' => 'i0',
                'offset' => '56',
                'repeat' => undef,
                'scale' => '2^-31',
                'type' => 'I4',
                'unit' => 'semi-circles'
              },
              {
                'bitfield' => [],
                'descr' => 'Amplitude of cosine harmonic correction term to the argument of latitude',
                'group' => '',
                'ln_arg' => 5752,
                'name' => 'Cuc',
                'offset' => '60',
                'repeat' => undef,
                'scale' => '2^-31',
                'type' => 'I4',
                'unit' => 'semi-circles'
              },
              {
                'bitfield' => [],
                'descr' => 'Amplitude of sine harmonic correction term to the argument of latitude',
                'group' => '',
                'ln_arg' => 5754,
                'name' => 'Cus',
                'offset' => '64',
                'repeat' => undef,
                'scale' => '2^-31',
                'type' => 'I4',
                'unit' => 'semi-circles'
              },
              {
                'bitfield' => [],
                'descr' => 'Amplitude of cosine harmonic correction term to the orbit radius',
                'group' => '',
                'ln_arg' => 5756,
                'name' => 'Crc',
                'offset' => '68',
                'repeat' => undef,
                'scale' => '2^-6',
                'type' => 'I4',
                'unit' => 'm'
              },
              {
                'bitfield' => [],
                'descr' => 'Amplitude of sine harmonic correction term to the orbit radius',
                'group' => '',
                'ln_arg' => 5758,
                'name' => 'Crs',
                'offset' => '72',
                'repeat' => undef,
                'scale' => '2^-6',
                'type' => 'I4',
                'unit' => 'm'
              },
              {
                'bitfield' => [],
                'descr' => 'Amplitude of cosine harmonic correction term to the angle of inclination',
                'group' => '',
                'ln_arg' => 5760,
                'name' => 'Cic',
                'offset' => '76',
                'repeat' => undef,
                'scale' => '2^-31',
                'type' => 'I4',
                'unit' => 'semi-circles'
              },
              {
                'bitfield' => [],
                'descr' => 'Amplitude of sine harmonic correction term to the angle of inclination',
                'group' => '',
                'ln_arg' => 5762,
                'name' => 'Cis',
                'offset' => '80',
                'repeat' => undef,
                'scale' => '2^-31',
                'type' => 'I4',
                'unit' => 'semi-circles'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 5764,
                'name' => 'reserved1',
                'offset' => '84',
                'repeat' => '4',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x13',
  'code' => 'UBX-MGA-BDS-EPH',
  'comment' => 'This message allows the delivery of BeiDou ephemeris assistance to a receiver. See the section AssistNow online in Integration manual for details.',
  'id' => '0x03',
  'length' => '88',
  'ln_classid' => 5709,
  'ln_comment' => 5705,
  'ln_msg' => 5702,
  'ln_name' => 5703,
  'ln_type' => 5704,
  'name' => 'BeiDou ephemeris assistance',
  'type' => 'Input'
}
, ### UBX-MGA-BDS-ALM BeiDou almanac assistance ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Message type (0x02 for this version)',
                'group' => '',
                'ln_arg' => 5778,
                'name' => 'type',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Message version (0x00 for this version)',
                'group' => '',
                'ln_arg' => 5779,
                'name' => 'version',
                'offset' => '1',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'BeiDou satellite identiﬁer (see Satellite Numbering)',
                'group' => '',
                'ln_arg' => 5780,
                'name' => 'svId',
                'offset' => '2',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 5781,
                'name' => 'reserved0',
                'offset' => '3',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Almanac Week Number',
                'group' => '',
                'ln_arg' => 5782,
                'name' => 'Wna',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => 'week'
              },
              {
                'bitfield' => [],
                'descr' => 'Almanac reference time',
                'group' => '',
                'ln_arg' => 5783,
                'name' => 'toa',
                'offset' => '5',
                'repeat' => undef,
                'scale' => '2^12',
                'type' => 'U1',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'Almanac correction of orbit reference inclination at reference time',
                'group' => '',
                'ln_arg' => 5784,
                'name' => 'deltaI',
                'offset' => '6',
                'repeat' => undef,
                'scale' => '2^-19',
                'type' => 'I2',
                'unit' => 'semi-circles'
              },
              {
                'bitfield' => [],
                'descr' => 'Almanac square root of semi-major axis',
                'group' => '',
                'ln_arg' => 5786,
                'name' => 'sqrtA',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '2^-11',
                'type' => 'U4',
                'unit' => 'm^0.5'
              },
              {
                'bitfield' => [],
                'descr' => 'Almanac eccentricity',
                'group' => '',
                'ln_arg' => 5787,
                'name' => 'e',
                'offset' => '12',
                'repeat' => undef,
                'scale' => '2^-21',
                'type' => 'U4',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Almanac argument of perigee ',
                'group' => '',
                'ln_arg' => 5798,
                'name' => 'omega',
                'offset' => '16',
                'repeat' => undef,
                'scale' => '2^-23',
                'type' => 'I4',
                'unit' => 'semi-circles'
              },
              {
                'bitfield' => [],
                'descr' => 'Almanac mean anomaly at reference time ',
                'group' => '',
                'ln_arg' => 5800,
                'name' => 'M0',
                'offset' => '20',
                'repeat' => undef,
                'scale' => '2^-23',
                'type' => 'I4',
                'unit' => 'semi-circles'
              },
              {
                'bitfield' => [],
                'descr' => 'Almanac longitude of ascending node of orbit plane at computed according to reference time',
                'group' => '',
                'ln_arg' => 5802,
                'name' => 'Omega0',
                'offset' => '24',
                'repeat' => undef,
                'scale' => '2^-23',
                'type' => 'I4',
                'unit' => 'semi-circles'
              },
              {
                'bitfield' => [],
                'descr' => 'Almanac rate of right ascension ',
                'group' => '',
                'ln_arg' => 5804,
                'name' => 'omegaDot',
                'offset' => '28',
                'repeat' => undef,
                'scale' => '2^-38',
                'type' => 'I4',
                'unit' => 'semi-circles/s'
              },
              {
                'bitfield' => [],
                'descr' => 'Almanac satellite clock bias',
                'group' => '',
                'ln_arg' => 5806,
                'name' => 'a0',
                'offset' => '32',
                'repeat' => undef,
                'scale' => '2^-20',
                'type' => 'I2',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'Almanac satellite clock rate',
                'group' => '',
                'ln_arg' => 5807,
                'name' => 'a1',
                'offset' => '34',
                'repeat' => undef,
                'scale' => '2^-38',
                'type' => 'I2',
                'unit' => 's/s'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 5808,
                'name' => 'reserved1',
                'offset' => '36',
                'repeat' => '4',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x13',
  'code' => 'UBX-MGA-BDS-ALM',
  'comment' => 'This message allows the delivery of BeiDou almanac assistance to a receiver. See the section AssistNow online in Integration manual for details.',
  'id' => '0x03',
  'length' => '40',
  'ln_classid' => 5775,
  'ln_comment' => 5771,
  'ln_msg' => 5768,
  'ln_name' => 5769,
  'ln_type' => 5770,
  'name' => 'BeiDou almanac assistance',
  'type' => 'Input'
}
, ### UBX-MGA-BDS-HEALTH BeiDou health assistance ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Message type (0x04 for this type)',
                'group' => '',
                'ln_arg' => 5822,
                'name' => 'type',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Message version (0x00 for this version)',
                'group' => '',
                'ln_arg' => 5823,
                'name' => 'version',
                'offset' => '1',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 5824,
                'name' => 'reserved0',
                'offset' => '2',
                'repeat' => '2',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Each two-byte value represents a BeiDou SV (1-30). The 9 LSBs of each byte contain the 9 bit health code from subframe 5 pages 7,8 of the D1 message, and from subframe 5 pages 35,36 of the D1 message.',
                'group' => '',
                'ln_arg' => 5825,
                'name' => 'healthCode',
                'offset' => '4',
                'repeat' => '30',
                'scale' => '-',
                'type' => 'U2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 5829,
                'name' => 'reserved1',
                'offset' => '64',
                'repeat' => '4',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x13',
  'code' => 'UBX-MGA-BDS-HEALTH',
  'comment' => 'This message allows the delivery of BeiDou health assistance to a receiver. See the section AssistNow online in Integration manual for details.',
  'id' => '0x03',
  'length' => '68',
  'ln_classid' => 5819,
  'ln_comment' => 5815,
  'ln_msg' => 5812,
  'ln_name' => 5813,
  'ln_type' => 5814,
  'name' => 'BeiDou health assistance',
  'type' => 'Input'
}
, ### UBX-MGA-BDS-UTC BeiDou UTC assistance ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Message type (0x05 for this type)',
                'group' => '',
                'ln_arg' => 5843,
                'name' => 'type',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Message version (0x00 for this version)',
                'group' => '',
                'ln_arg' => 5844,
                'name' => 'version',
                'offset' => '1',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 5845,
                'name' => 'reserved0',
                'offset' => '2',
                'repeat' => '2',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'BDT clock bias relative to UTC',
                'group' => '',
                'ln_arg' => 5846,
                'name' => 'a0UTC',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '2^-30',
                'type' => 'I4',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'BDT clock rate relative to UTC',
                'group' => '',
                'ln_arg' => 5847,
                'name' => 'a1UTC',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '2^-50',
                'type' => 'I4',
                'unit' => 's/s'
              },
              {
                'bitfield' => [],
                'descr' => 'Delta time due to leap seconds before the new leap second eﬀective',
                'group' => '',
                'ln_arg' => 5858,
                'name' => 'dtLS',
                'offset' => '12',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I1',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 5860,
                'name' => 'reserved1',
                'offset' => '13',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'BeiDou week number of reception of this UTC parameter set (8-bit truncated)',
                'group' => '',
                'ln_arg' => 5861,
                'name' => 'wnRec',
                'offset' => '14',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => 'week'
              },
              {
                'bitfield' => [],
                'descr' => 'Week number of the new leap second',
                'group' => '',
                'ln_arg' => 5863,
                'name' => 'wnLSF',
                'offset' => '15',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => 'week'
              },
              {
                'bitfield' => [],
                'descr' => 'Day number of the new leap second',
                'group' => '',
                'ln_arg' => 5864,
                'name' => 'dN',
                'offset' => '16',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => 'day'
              },
              {
                'bitfield' => [],
                'descr' => 'Delta time due to leap seconds after the new leap second eﬀective',
                'group' => '',
                'ln_arg' => 5865,
                'name' => 'dtLSF',
                'offset' => '17',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I1',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 5867,
                'name' => 'reserved2',
                'offset' => '18',
                'repeat' => '2',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x13',
  'code' => 'UBX-MGA-BDS-UTC',
  'comment' => 'This message allows the delivery of BeiDou UTC assistance to a receiver. See the section AssistNow online in Integration manual for details.',
  'id' => '0x03',
  'length' => '20',
  'ln_classid' => 5840,
  'ln_comment' => 5836,
  'ln_msg' => 5833,
  'ln_name' => 5834,
  'ln_type' => 5835,
  'name' => 'BeiDou UTC assistance',
  'type' => 'Input'
}
, ### UBX-MGA-BDS-IONO BeiDou ionosphere assistance ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Message type (0x06 for this type)',
                'group' => '',
                'ln_arg' => 5881,
                'name' => 'type',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Message version (0x00 for this version)',
                'group' => '',
                'ln_arg' => 5882,
                'name' => 'version',
                'offset' => '1',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 5883,
                'name' => 'reserved0',
                'offset' => '2',
                'repeat' => '2',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Ionospheric parameter alpha0',
                'group' => '',
                'ln_arg' => 5884,
                'name' => 'alpha0',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '2^-30',
                'type' => 'I1',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'Ionospheric parameter alpha1',
                'group' => '',
                'ln_arg' => 5885,
                'name' => 'alpha1',
                'offset' => '5',
                'repeat' => undef,
                'scale' => '2^-27',
                'type' => 'I1',
                'unit' => 's/pi'
              },
              {
                'bitfield' => [],
                'descr' => 'Ionospheric parameter alpha2',
                'group' => '',
                'ln_arg' => 5886,
                'name' => 'alpha2',
                'offset' => '6',
                'repeat' => undef,
                'scale' => '2^-24',
                'type' => 'I1',
                'unit' => 's/pi^2'
              },
              {
                'bitfield' => [],
                'descr' => 'Ionospheric parameter alpha3',
                'group' => '',
                'ln_arg' => 5887,
                'name' => 'alpha3',
                'offset' => '7',
                'repeat' => undef,
                'scale' => '2^-24',
                'type' => 'I1',
                'unit' => 's/pi^3'
              },
              {
                'bitfield' => [],
                'descr' => 'Ionospheric parameter beta0',
                'group' => '',
                'ln_arg' => 5888,
                'name' => 'beta0',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '2^11',
                'type' => 'I1',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'Ionospheric parameter beta1',
                'group' => '',
                'ln_arg' => 5889,
                'name' => 'beta1',
                'offset' => '9',
                'repeat' => undef,
                'scale' => '2^14',
                'type' => 'I1',
                'unit' => 's/pi'
              },
              {
                'bitfield' => [],
                'descr' => 'Ionospheric parameter beta2',
                'group' => '',
                'ln_arg' => 5890,
                'name' => 'beta2',
                'offset' => '10',
                'repeat' => undef,
                'scale' => '2^16',
                'type' => 'I1',
                'unit' => 's/pi^2'
              },
              {
                'bitfield' => [],
                'descr' => 'Ionospheric parameter beta3',
                'group' => '',
                'ln_arg' => 5891,
                'name' => 'beta3',
                'offset' => '11',
                'repeat' => undef,
                'scale' => '2^16',
                'type' => 'I1',
                'unit' => 's/pi^3'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 5892,
                'name' => 'reserved1',
                'offset' => '12',
                'repeat' => '4',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x13',
  'code' => 'UBX-MGA-BDS-IONO',
  'comment' => 'This message allows the delivery of BeiDou ionospheric assistance to a receiver. See the section AssistNow online in Integration manual for details.',
  'id' => '0x03',
  'length' => '16',
  'ln_classid' => 5878,
  'ln_comment' => 5874,
  'ln_msg' => 5871,
  'ln_name' => 5872,
  'ln_type' => 5873,
  'name' => 'BeiDou ionosphere assistance',
  'type' => 'Input'
}
, ### UBX-MGA-DBD Poll the navigation database ###
{
  'args' => [],
  'class' => '0x13',
  'code' => 'UBX-MGA-DBD',
  'comment' => 'Poll the whole navigation data base. The receiver will send all available data from its internal database. The receiver will indicate the ﬁnish of the transmission with a UBX-MGA-ACK. The msgPayloadStart ﬁeld of the UBX-MGA-ACK message will contain a U4 representing the number of UBX-MGA-DBD-DATA* messages sent.',
  'id' => '0x80',
  'length' => '0',
  'ln_classid' => 5906,
  'ln_comment' => 5901,
  'ln_msg' => 5898,
  'ln_name' => 5899,
  'ln_type' => 5900,
  'name' => 'Poll the navigation database',
  'type' => 'Poll request'
}
, ### UBX-MGA-DBD Navigation database dump entry ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 5932,
                'name' => 'reserved0',
                'offset' => '0',
                'repeat' => '12',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'ﬁrmware-speciﬁc data',
                'group' => 'repeated N',
                'ln_arg' => 5934,
                'name' => 'data',
                'offset' => '12 + n',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x13',
  'code' => 'UBX-MGA-DBD',
  'comment' => 'Navigation database entry. The data ﬁelds are ﬁrmware-speciﬁc. Transmission of this type of message will be acknowledged by UBX-MGA-ACK messages, if acknowledgment has been enabled. See the section AssistNow online in Integration manual for details. The maximum payload size for ﬁrmware 2.01 onwards is 164 bytes (which makes the maximum message size 172 bytes). ☞ UBX-MGA-DBD messages are only intended to be sent back to the same receiver that generated them.',
  'hasgroup' => 'repeated N',
  'id' => '0x80',
  'length' => '12 + [0..n]',
  'ln_classid' => 5929,
  'ln_comment' => 5921,
  'ln_msg' => 5918,
  'ln_name' => 5919,
  'ln_type' => 5920,
  'name' => 'Navigation database dump entry',
  'type' => 'Input/output'
}
, ### UBX-MGA-GAL-EPH Galileo ephemeris assistance ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Message type (0x01 for this type)',
                'group' => '',
                'ln_arg' => 5951,
                'name' => 'type',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Message version (0x00 for this version)',
                'group' => '',
                'ln_arg' => 5952,
                'name' => 'version',
                'offset' => '1',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Galileo Satellite identiﬁer (see Satellite Numbering)',
                'group' => '',
                'ln_arg' => 5953,
                'name' => 'svId',
                'offset' => '2',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 5954,
                'name' => 'reserved0',
                'offset' => '3',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Ephemeris and clock correction Issue of Data',
                'group' => '',
                'ln_arg' => 5955,
                'name' => 'iodNav',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Mean motion diﬀerence from computed value ',
                'group' => '',
                'ln_arg' => 5956,
                'name' => 'deltaN',
                'offset' => '6',
                'repeat' => undef,
                'scale' => '2^-43',
                'type' => 'I2',
                'unit' => 'semi-circles/s'
              },
              {
                'bitfield' => [],
                'descr' => 'Mean anomaly at reference time ',
                'group' => '',
                'ln_arg' => 5958,
                'name' => 'm0',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '2^-31',
                'type' => 'I4',
                'unit' => 'semi-circles'
              },
              {
                'bitfield' => [],
                'descr' => 'Eccentricity',
                'group' => '',
                'ln_arg' => 5960,
                'name' => 'e',
                'offset' => '12',
                'repeat' => undef,
                'scale' => '2^-33',
                'type' => 'U4',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Square root of the semi-major axis',
                'group' => '',
                'ln_arg' => 5961,
                'name' => 'sqrtA',
                'offset' => '16',
                'repeat' => undef,
                'scale' => '2^-19',
                'type' => 'U4',
                'unit' => 'm^0.5'
              },
              {
                'bitfield' => [],
                'descr' => 'Longitude of ascending node of orbital plane at weekly epoch',
                'group' => '',
                'ln_arg' => 5962,
                'name' => 'omega0',
                'offset' => '20',
                'repeat' => undef,
                'scale' => '2^-31',
                'type' => 'I4',
                'unit' => 'semi-circles'
              },
              {
                'bitfield' => [],
                'descr' => 'Inclination angle at reference time ',
                'group' => '',
                'ln_arg' => 5964,
                'name' => 'i0',
                'offset' => '24',
                'repeat' => undef,
                'scale' => '2^-31',
                'type' => 'I4',
                'unit' => 'semi-circles'
              },
              {
                'bitfield' => [],
                'descr' => 'Argument of perigee ',
                'group' => '',
                'ln_arg' => 5976,
                'name' => 'omega',
                'offset' => '28',
                'repeat' => undef,
                'scale' => '2^-31',
                'type' => 'I4',
                'unit' => 'semi-circles'
              },
              {
                'bitfield' => [],
                'descr' => 'Rate of change of right ascension ',
                'group' => '',
                'ln_arg' => 5978,
                'name' => 'omegaDot',
                'offset' => '32',
                'repeat' => undef,
                'scale' => '2^-43',
                'type' => 'I4',
                'unit' => 'semi-circles/s'
              },
              {
                'bitfield' => [],
                'descr' => 'Rate of change of inclination angle ',
                'group' => '',
                'ln_arg' => 5980,
                'name' => 'iDot',
                'offset' => '36',
                'repeat' => undef,
                'scale' => '2^-43',
                'type' => 'I2',
                'unit' => 'semi-circles/s'
              },
              {
                'bitfield' => [],
                'descr' => 'Amplitude of the cosine harmonic correction term to the argument of latitude',
                'group' => '',
                'ln_arg' => 5982,
                'name' => 'cuc',
                'offset' => '38',
                'repeat' => undef,
                'scale' => '2^-29',
                'type' => 'I2',
                'unit' => 'radians'
              },
              {
                'bitfield' => [],
                'descr' => 'Amplitude of the sine harmonic correction term to the argument of latitude',
                'group' => '',
                'ln_arg' => 5984,
                'name' => 'cus',
                'offset' => '40',
                'repeat' => undef,
                'scale' => '2^-29',
                'type' => 'I2',
                'unit' => 'radians'
              },
              {
                'bitfield' => [],
                'descr' => 'Amplitude of the cosine harmonic correction term to the orbit radius',
                'group' => '',
                'ln_arg' => 5986,
                'name' => 'crc',
                'offset' => '42',
                'repeat' => undef,
                'scale' => '2^-5',
                'type' => 'I2',
                'unit' => 'radians'
              },
              {
                'bitfield' => [],
                'descr' => 'Amplitude of the sine harmonic correction term to the orbit radius',
                'group' => '',
                'ln_arg' => 5988,
                'name' => 'crs',
                'offset' => '44',
                'repeat' => undef,
                'scale' => '2^-5',
                'type' => 'I2',
                'unit' => 'radians'
              },
              {
                'bitfield' => [],
                'descr' => 'Amplitude of the cosine harmonic correction term to the angle of inclination',
                'group' => '',
                'ln_arg' => 5990,
                'name' => 'cic',
                'offset' => '46',
                'repeat' => undef,
                'scale' => '2^-29',
                'type' => 'I2',
                'unit' => 'radians'
              },
              {
                'bitfield' => [],
                'descr' => 'Amplitude of the sine harmonic correction term to the angle of inclination',
                'group' => '',
                'ln_arg' => 5992,
                'name' => 'cis',
                'offset' => '48',
                'repeat' => undef,
                'scale' => '2^-29',
                'type' => 'I2',
                'unit' => 'radians'
              },
              {
                'bitfield' => [],
                'descr' => 'Ephemeris reference time',
                'group' => '',
                'ln_arg' => 5994,
                'name' => 'toe',
                'offset' => '50',
                'repeat' => undef,
                'scale' => '60',
                'type' => 'U2',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'SV clock bias correction coeﬃcient',
                'group' => '',
                'ln_arg' => 5995,
                'name' => 'af0',
                'offset' => '52',
                'repeat' => undef,
                'scale' => '2^-34',
                'type' => 'I4',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'SV clock drift correction coeﬃcient',
                'group' => '',
                'ln_arg' => 5996,
                'name' => 'af1',
                'offset' => '56',
                'repeat' => undef,
                'scale' => '2^-46',
                'type' => 'I4',
                'unit' => 's/s'
              },
              {
                'bitfield' => [],
                'descr' => 'SV clock drift rate correction coeﬃcient ',
                'group' => '',
                'ln_arg' => 5997,
                'name' => 'af2',
                'offset' => '60',
                'repeat' => undef,
                'scale' => '2^-59',
                'type' => 'I1',
                'unit' => 's/ssquared'
              },
              {
                'bitfield' => [],
                'descr' => 'Signal-In-Space Accuracy index for dual frequency E1-',
                'group' => '',
                'ln_arg' => 5999,
                'name' => 'sisaIndexE1E5b',
                'offset' => '61',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-E5b'
              },
              {
                'bitfield' => [],
                'descr' => 'Clock correction data reference Time of Week',
                'group' => '',
                'ln_arg' => 6001,
                'name' => 'toc',
                'offset' => '62',
                'repeat' => undef,
                'scale' => '60',
                'type' => 'U2',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'E1-E5b Broadcast Group Delay',
                'group' => '',
                'ln_arg' => 6002,
                'name' => 'bgdE1E5b',
                'offset' => '64',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 6003,
                'name' => 'reserved1',
                'offset' => '66',
                'repeat' => '2',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'E1-B Signal Health Status',
                'group' => '',
                'ln_arg' => 6004,
                'name' => 'healthE1B',
                'offset' => '68',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'E1-B Data Validity Status',
                'group' => '',
                'ln_arg' => 6005,
                'name' => 'dataValidityE1B',
                'offset' => '69',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'E5b Signal Health Status',
                'group' => '',
                'ln_arg' => 6007,
                'name' => 'healthE5b',
                'offset' => '70',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'E5b Data Validity Status',
                'group' => '',
                'ln_arg' => 6008,
                'name' => 'dataValidityE5b',
                'offset' => '71',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 6010,
                'name' => 'reserved2',
                'offset' => '72',
                'repeat' => '4',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x13',
  'code' => 'UBX-MGA-GAL-EPH',
  'comment' => 'This message allows the delivery of Galileo ephemeris assistance to a receiver. See the section AssistNow online in Integration manual for details.',
  'id' => '0x02',
  'length' => '76',
  'ln_classid' => 5948,
  'ln_comment' => 5944,
  'ln_msg' => 5941,
  'ln_name' => 5942,
  'ln_type' => 5943,
  'name' => 'Galileo ephemeris assistance',
  'type' => 'Input'
}
, ### UBX-MGA-GAL-ALM Galileo almanac assistance ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Message type (0x02 for this type)',
                'group' => '',
                'ln_arg' => 6024,
                'name' => 'type',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Message version (0x00 for this version)',
                'group' => '',
                'ln_arg' => 6025,
                'name' => 'version',
                'offset' => '1',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Galileo Satellite identiﬁer (see Satellite Numbering)',
                'group' => '',
                'ln_arg' => 6036,
                'name' => 'svId',
                'offset' => '2',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 6037,
                'name' => 'reserved0',
                'offset' => '3',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Almanac Issue of Data',
                'group' => '',
                'ln_arg' => 6038,
                'name' => 'ioda',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Almanac reference week number',
                'group' => '',
                'ln_arg' => 6039,
                'name' => 'almWNa',
                'offset' => '5',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => 'week'
              },
              {
                'bitfield' => [],
                'descr' => 'Almanac reference time',
                'group' => '',
                'ln_arg' => 6040,
                'name' => 'toa',
                'offset' => '6',
                'repeat' => undef,
                'scale' => '600',
                'type' => 'U2',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'Diﬀerence with respect to the square root of the nominal semi-major axis (29 600 km)',
                'group' => '',
                'ln_arg' => 6041,
                'name' => 'deltaSqrtA',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '2^-9',
                'type' => 'I2',
                'unit' => 'm^0.5'
              },
              {
                'bitfield' => [],
                'descr' => 'Eccentricity',
                'group' => '',
                'ln_arg' => 6043,
                'name' => 'e',
                'offset' => '10',
                'repeat' => undef,
                'scale' => '2^-16',
                'type' => 'U2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Inclination at reference time relative to i0 = 56 degree ',
                'group' => '',
                'ln_arg' => 6044,
                'name' => 'deltaI',
                'offset' => '12',
                'repeat' => undef,
                'scale' => '2^-14',
                'type' => 'I2',
                'unit' => 'semi-circles'
              },
              {
                'bitfield' => [],
                'descr' => 'Longitude of ascending node of orbital plane at weekly epoch',
                'group' => '',
                'ln_arg' => 6046,
                'name' => 'omega0',
                'offset' => '14',
                'repeat' => undef,
                'scale' => '2^-15',
                'type' => 'I2',
                'unit' => 'semi-circles'
              },
              {
                'bitfield' => [],
                'descr' => 'Rate of change of right ascension ',
                'group' => '',
                'ln_arg' => 6048,
                'name' => 'omegaDot',
                'offset' => '16',
                'repeat' => undef,
                'scale' => '2^-33',
                'type' => 'I2',
                'unit' => 'semi-circles/s'
              },
              {
                'bitfield' => [],
                'descr' => 'Argument of perigee ',
                'group' => '',
                'ln_arg' => 6050,
                'name' => 'omega',
                'offset' => '18',
                'repeat' => undef,
                'scale' => '2^-15',
                'type' => 'I2',
                'unit' => 'semi-circles'
              },
              {
                'bitfield' => [],
                'descr' => 'Satellite mean anomaly at reference time ',
                'group' => '',
                'ln_arg' => 6052,
                'name' => 'm0',
                'offset' => '20',
                'repeat' => undef,
                'scale' => '2^-15',
                'type' => 'I2',
                'unit' => 'semi-circles'
              },
              {
                'bitfield' => [],
                'descr' => 'Satellite clock correction bias \'truncated\'',
                'group' => '',
                'ln_arg' => 6054,
                'name' => 'af0',
                'offset' => '22',
                'repeat' => undef,
                'scale' => '2^-19',
                'type' => 'I2',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'Satellite clock correction linear \'truncated\'',
                'group' => '',
                'ln_arg' => 6055,
                'name' => 'af1',
                'offset' => '24',
                'repeat' => undef,
                'scale' => '2^-38',
                'type' => 'I2',
                'unit' => 's/s'
              },
              {
                'bitfield' => [],
                'descr' => 'Satellite E1-B signal health status',
                'group' => '',
                'ln_arg' => 6056,
                'name' => 'healthE1B',
                'offset' => '26',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Satellite E5b signal health status',
                'group' => '',
                'ln_arg' => 6057,
                'name' => 'healthE5b',
                'offset' => '27',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 6058,
                'name' => 'reserved1',
                'offset' => '28',
                'repeat' => '4',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x13',
  'code' => 'UBX-MGA-GAL-ALM',
  'comment' => 'This message allows the delivery of Galileo almanac assistance to a receiver. See the section AssistNow online in Integration manual for details.',
  'id' => '0x02',
  'length' => '32',
  'ln_classid' => 6021,
  'ln_comment' => 6017,
  'ln_msg' => 6014,
  'ln_name' => 6015,
  'ln_type' => 6016,
  'name' => 'Galileo almanac assistance',
  'type' => 'Input'
}
, ### UBX-MGA-GAL-TIMEOFFSET Galileo GPS time oﬀset assistance ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Message type (0x03 for this type)',
                'group' => '',
                'ln_arg' => 6072,
                'name' => 'type',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Message version (0x00 for this version)',
                'group' => '',
                'ln_arg' => 6073,
                'name' => 'version',
                'offset' => '1',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 6074,
                'name' => 'reserved0',
                'offset' => '2',
                'repeat' => '2',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Constant term of the polynomial describing the oﬀset',
                'group' => '',
                'ln_arg' => 6075,
                'name' => 'a0G',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '2^-35',
                'type' => 'I2',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'Rate of change of the oﬀset',
                'group' => '',
                'ln_arg' => 6076,
                'name' => 'a1G',
                'offset' => '6',
                'repeat' => undef,
                'scale' => '2^-51',
                'type' => 'I2',
                'unit' => 's/s'
              },
              {
                'bitfield' => [],
                'descr' => 'Reference time for GGTO data',
                'group' => '',
                'ln_arg' => 6077,
                'name' => 't0G',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '3600',
                'type' => 'U1',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'Week Number of GGTO reference',
                'group' => '',
                'ln_arg' => 6078,
                'name' => 'wn0G',
                'offset' => '9',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => 'weeks'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 6079,
                'name' => 'reserved1',
                'offset' => '10',
                'repeat' => '2',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x13',
  'code' => 'UBX-MGA-GAL-TIMEOFFSET',
  'comment' => 'This message allows the delivery of Galileo time to GPS time oﬀset. See the section AssistNow online in Integration manual for details.',
  'id' => '0x02',
  'length' => '12',
  'ln_classid' => 6069,
  'ln_comment' => 6065,
  'ln_msg' => 6062,
  'ln_name' => 6063,
  'ln_type' => 6064,
  'name' => 'Galileo GPS time oﬀset assistance',
  'type' => 'Input'
}
, ### UBX-MGA-GAL-UTC Galileo UTC assistance ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Message type (0x05 for this type)',
                'group' => '',
                'ln_arg' => 6101,
                'name' => 'type',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Message version (0x00 for this version)',
                'group' => '',
                'ln_arg' => 6102,
                'name' => 'version',
                'offset' => '1',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 6103,
                'name' => 'reserved0',
                'offset' => '2',
                'repeat' => '2',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'First parameter of UTC polynomial',
                'group' => '',
                'ln_arg' => 6104,
                'name' => 'a0',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '2^-30',
                'type' => 'I4',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'Second parameter of UTC polynomial',
                'group' => '',
                'ln_arg' => 6105,
                'name' => 'a1',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '2^-50',
                'type' => 'I4',
                'unit' => 's/s'
              },
              {
                'bitfield' => [],
                'descr' => 'Delta time due to current leap seconds',
                'group' => '',
                'ln_arg' => 6106,
                'name' => 'dtLS',
                'offset' => '12',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I1',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'UTC parameters reference time of week (Galileo time)',
                'group' => '',
                'ln_arg' => 6107,
                'name' => 'tot',
                'offset' => '13',
                'repeat' => undef,
                'scale' => '3600',
                'type' => 'U1',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'UTC parameters reference week number (the 8-bit WNt ﬁeld)',
                'group' => '',
                'ln_arg' => 6108,
                'name' => 'wnt',
                'offset' => '14',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => 'weeks'
              },
              {
                'bitfield' => [],
                'descr' => 'Week number at the end of which the future leap second becomes eﬀective (the 8-bit WNLSF ﬁeld)',
                'group' => '',
                'ln_arg' => 6110,
                'name' => 'wnLSF',
                'offset' => '15',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => 'weeks'
              },
              {
                'bitfield' => [],
                'descr' => 'Day number at the end of which the future leap second becomes eﬀective',
                'group' => '',
                'ln_arg' => 6112,
                'name' => 'dN',
                'offset' => '16',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => 'days'
              },
              {
                'bitfield' => [],
                'descr' => 'Delta time due to future leap seconds',
                'group' => '',
                'ln_arg' => 6114,
                'name' => 'dTLSF',
                'offset' => '17',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I1',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 6115,
                'name' => 'reserved1',
                'offset' => '18',
                'repeat' => '2',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x13',
  'code' => 'UBX-MGA-GAL-UTC',
  'comment' => 'This message allows the delivery of Galileo UTC assistance to a receiver. See the section AssistNow online in Integration manual for details.',
  'id' => '0x02',
  'length' => '20',
  'ln_classid' => 6098,
  'ln_comment' => 6094,
  'ln_msg' => 6091,
  'ln_name' => 6092,
  'ln_type' => 6093,
  'name' => 'Galileo UTC assistance',
  'type' => 'Input'
}
, ### UBX-MGA-GLO-EPH GLONASS ephemeris assistance ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Message type (0x01 for this type)',
                'group' => '',
                'ln_arg' => 6131,
                'name' => 'type',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Message version (0x00 for this version)',
                'group' => '',
                'ln_arg' => 6132,
                'name' => 'version',
                'offset' => '1',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'GLONASS    Satellite       identiﬁer    (see   Satellite Numbering)',
                'group' => '',
                'ln_arg' => 6133,
                'name' => 'svId',
                'offset' => '2',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 6135,
                'name' => 'reserved0',
                'offset' => '3',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'User range accuracy',
                'group' => '',
                'ln_arg' => 6136,
                'name' => 'FT',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Health ﬂag from string 2',
                'group' => '',
                'ln_arg' => 6137,
                'name' => 'B',
                'offset' => '5',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Type of GLONASS satellite (1 indicates GLONASS-M)',
                'group' => '',
                'ln_arg' => 6148,
                'name' => 'M',
                'offset' => '6',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Carrier frequency number of navigation RF signal, Range=(-7 .. 6), -128 for unknown',
                'group' => '',
                'ln_arg' => 6149,
                'name' => 'H',
                'offset' => '7',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'X component of the SV position in PZ-90.02 coordinate System',
                'group' => '',
                'ln_arg' => 6151,
                'name' => 'x',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '2^-11',
                'type' => 'I4',
                'unit' => 'km'
              },
              {
                'bitfield' => [],
                'descr' => 'Y component of the SV position in PZ-90.02 coordinate System',
                'group' => '',
                'ln_arg' => 6153,
                'name' => 'y',
                'offset' => '12',
                'repeat' => undef,
                'scale' => '2^-11',
                'type' => 'I4',
                'unit' => 'km'
              },
              {
                'bitfield' => [],
                'descr' => 'Z component of the SV position in PZ-90.02 coordinate System',
                'group' => '',
                'ln_arg' => 6155,
                'name' => 'z',
                'offset' => '16',
                'repeat' => undef,
                'scale' => '2^-11',
                'type' => 'I4',
                'unit' => 'km'
              },
              {
                'bitfield' => [],
                'descr' => 'X component of the SV velocity in PZ-90.02 coordinate System',
                'group' => '',
                'ln_arg' => 6157,
                'name' => 'dx',
                'offset' => '20',
                'repeat' => undef,
                'scale' => '2^-20',
                'type' => 'I4',
                'unit' => 'km/s'
              },
              {
                'bitfield' => [],
                'descr' => 'Y component of the SV velocity in PZ-90.02 coordinate System',
                'group' => '',
                'ln_arg' => 6159,
                'name' => 'dy',
                'offset' => '24',
                'repeat' => undef,
                'scale' => '2^-20',
                'type' => 'I4',
                'unit' => 'km/s'
              },
              {
                'bitfield' => [],
                'descr' => 'Z component of the SV velocity in PZ-90.02 coordinate System',
                'group' => '',
                'ln_arg' => 6161,
                'name' => 'dz',
                'offset' => '28',
                'repeat' => undef,
                'scale' => '2^-20',
                'type' => 'I4',
                'unit' => 'km/s'
              },
              {
                'bitfield' => [],
                'descr' => 'X component of the SV acceleration in PZ-90.02 coordinate System',
                'group' => '',
                'ln_arg' => 6163,
                'name' => 'ddx',
                'offset' => '32',
                'repeat' => undef,
                'scale' => '2^-30',
                'type' => 'I1',
                'unit' => 'km/s^2'
              },
              {
                'bitfield' => [],
                'descr' => 'Y component of the SV acceleration in PZ-90.02 coordinate System',
                'group' => '',
                'ln_arg' => 6165,
                'name' => 'ddy',
                'offset' => '33',
                'repeat' => undef,
                'scale' => '2^-30',
                'type' => 'I1',
                'unit' => 'km/s^2'
              },
              {
                'bitfield' => [],
                'descr' => 'Z component of the SV acceleration in PZ-90.02 coordinate System',
                'group' => '',
                'ln_arg' => 6167,
                'name' => 'ddz',
                'offset' => '34',
                'repeat' => undef,
                'scale' => '2^-30',
                'type' => 'I1',
                'unit' => 'km/s^2'
              },
              {
                'bitfield' => [],
                'descr' => 'Index of a time interval within current day according to UTC(SU)',
                'group' => '',
                'ln_arg' => 6169,
                'name' => 'tb',
                'offset' => '35',
                'repeat' => undef,
                'scale' => '15',
                'type' => 'U1',
                'unit' => 'minutes'
              },
              {
                'bitfield' => [],
                'descr' => 'Relative carrier frequency deviation',
                'group' => '',
                'ln_arg' => 6171,
                'name' => 'gamma',
                'offset' => '36',
                'repeat' => undef,
                'scale' => '2^-40',
                'type' => 'I2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Ephemeris data age indicator',
                'group' => '',
                'ln_arg' => 6172,
                'name' => 'E',
                'offset' => '38',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => 'days'
              },
              {
                'bitfield' => [],
                'descr' => 'Time diﬀerence between L2 and L1 band',
                'group' => '',
                'ln_arg' => 6173,
                'name' => 'deltaTau',
                'offset' => '39',
                'repeat' => undef,
                'scale' => '2^-30',
                'type' => 'I1',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'SV clock bias',
                'group' => '',
                'ln_arg' => 6174,
                'name' => 'tau',
                'offset' => '40',
                'repeat' => undef,
                'scale' => '2^-30',
                'type' => 'I4',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 6175,
                'name' => 'reserved1',
                'offset' => '44',
                'repeat' => '4',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x13',
  'code' => 'UBX-MGA-GLO-EPH',
  'comment' => 'This message allows the delivery of GLONASS ephemeris assistance to a receiver. See the section AssistNow online in Integration manual for details.',
  'id' => '0x06',
  'length' => '48',
  'ln_classid' => 6128,
  'ln_comment' => 6124,
  'ln_msg' => 6121,
  'ln_name' => 6122,
  'ln_type' => 6123,
  'name' => 'GLONASS ephemeris assistance',
  'type' => 'Input'
}
, ### UBX-MGA-GLO-ALM GLONASS almanac assistance ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Message type (0x02 for this type)',
                'group' => '',
                'ln_arg' => 6189,
                'name' => 'type',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Message version (0x00 for this version)',
                'group' => '',
                'ln_arg' => 6190,
                'name' => 'version',
                'offset' => '1',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'GLONASS    Satellite        identiﬁer   (see   Satellite Numbering)',
                'group' => '',
                'ln_arg' => 6191,
                'name' => 'svId',
                'offset' => '2',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 6193,
                'name' => 'reserved0',
                'offset' => '3',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reference calender day number of almanac within the four-year period (from string 5)',
                'group' => '',
                'ln_arg' => 6194,
                'name' => 'N',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => 'days'
              },
              {
                'bitfield' => [],
                'descr' => 'Type of GLONASS satellite (1 indicates GLONASS-M)',
                'group' => '',
                'ln_arg' => 6196,
                'name' => 'M',
                'offset' => '6',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Unhealthy ﬂag at instant of almanac upload (1 indicates operability of satellite)',
                'group' => '',
                'ln_arg' => 6207,
                'name' => 'C',
                'offset' => '7',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Coarse time correction to GLONASS time',
                'group' => '',
                'ln_arg' => 6209,
                'name' => 'tau',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '2^-18',
                'type' => 'I2',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'Eccentricity',
                'group' => '',
                'ln_arg' => 6210,
                'name' => 'epsilon',
                'offset' => '10',
                'repeat' => undef,
                'scale' => '2^-20',
                'type' => 'U2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Longitude of the ﬁrst (within the N-day) ascending node of satellite orbit in PC-90.02 coordinate system',
                'group' => '',
                'ln_arg' => 6211,
                'name' => 'lambda',
                'offset' => '12',
                'repeat' => undef,
                'scale' => '2^-20',
                'type' => 'I4',
                'unit' => 'semi-circles'
              },
              {
                'bitfield' => [],
                'descr' => 'Correction to the mean value of inclination ',
                'group' => '',
                'ln_arg' => 6213,
                'name' => 'deltaI',
                'offset' => '16',
                'repeat' => undef,
                'scale' => '2^-20',
                'type' => 'I4',
                'unit' => 'semi-circles'
              },
              {
                'bitfield' => [],
                'descr' => 'Time of the ﬁrst ascending node passage',
                'group' => '',
                'ln_arg' => 6215,
                'name' => 'tLambda',
                'offset' => '20',
                'repeat' => undef,
                'scale' => '2^-5',
                'type' => 'U4',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'Correction to the mean value of Draconian period ',
                'group' => '',
                'ln_arg' => 6216,
                'name' => 'deltaT',
                'offset' => '24',
                'repeat' => undef,
                'scale' => '2^-9',
                'type' => 'I4',
                'unit' => 's/orbital-period'
              },
              {
                'bitfield' => [],
                'descr' => 'Rate of change of Draconian period ',
                'group' => '',
                'ln_arg' => 6218,
                'name' => 'deltaDT',
                'offset' => '28',
                'repeat' => undef,
                'scale' => '2^-14',
                'type' => 'I1',
                'unit' => 's/orbital-period^2'
              },
              {
                'bitfield' => [],
                'descr' => 'Carrier frequency number of navigation RF signal, Range=(-7 .. 6)',
                'group' => '',
                'ln_arg' => 6220,
                'name' => 'H',
                'offset' => '29',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Argument of perigee',
                'group' => '',
                'ln_arg' => 6222,
                'name' => 'omega',
                'offset' => '30',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 6223,
                'name' => 'reserved1',
                'offset' => '32',
                'repeat' => '4',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x13',
  'code' => 'UBX-MGA-GLO-ALM',
  'comment' => 'This message allows the delivery of GLONASS almanac assistance to a receiver. See the section AssistNow online in Integration manual for details.',
  'id' => '0x06',
  'length' => '36',
  'ln_classid' => 6186,
  'ln_comment' => 6182,
  'ln_msg' => 6179,
  'ln_name' => 6180,
  'ln_type' => 6181,
  'name' => 'GLONASS almanac assistance',
  'type' => 'Input'
}
, ### UBX-MGA-GLO-TIMEOFFSET GLONASS auxiliary time oﬀset assistance ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Message type (0x03 for this type)',
                'group' => '',
                'ln_arg' => 6238,
                'name' => 'type',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Message version (0x00 for this version)',
                'group' => '',
                'ln_arg' => 6239,
                'name' => 'version',
                'offset' => '1',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reference calendar day number within the four-year period of almanac (from string 5)',
                'group' => '',
                'ln_arg' => 6240,
                'name' => 'N',
                'offset' => '2',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => 'days'
              },
              {
                'bitfield' => [],
                'descr' => 'Time scale correction to UTC(SU) time',
                'group' => '',
                'ln_arg' => 6242,
                'name' => 'tauC',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '2^-27',
                'type' => 'I4',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'Correction to GPS time relative to GLONASS time',
                'group' => '',
                'ln_arg' => 6243,
                'name' => 'tauGps',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '2^-31',
                'type' => 'I4',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'Coeﬃcient to determine delta UT1',
                'group' => '',
                'ln_arg' => 6244,
                'name' => 'B1',
                'offset' => '12',
                'repeat' => undef,
                'scale' => '2^-10',
                'type' => 'I2',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'Rate of change of delta UT1',
                'group' => '',
                'ln_arg' => 6245,
                'name' => 'B2',
                'offset' => '14',
                'repeat' => undef,
                'scale' => '2^-16',
                'type' => 'I2',
                'unit' => 's/msd'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 6246,
                'name' => 'reserved0',
                'offset' => '16',
                'repeat' => '4',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x13',
  'code' => 'UBX-MGA-GLO-TIMEOFFSET',
  'comment' => 'This message allows the delivery of auxiliary GLONASS assistance (including the GLONASS time oﬀsets to other GNSS systems) to a receiver. See the section AssistNow online in Integration manual for details.',
  'id' => '0x06',
  'length' => '20',
  'ln_classid' => 6235,
  'ln_comment' => 6230,
  'ln_msg' => 6227,
  'ln_name' => 6228,
  'ln_type' => 6229,
  'name' => 'GLONASS auxiliary time oﬀset assistance',
  'type' => 'Input'
}
, ### UBX-MGA-GPS-EPH GPS ephemeris assistance ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Message type (0x01 for this type)',
                'group' => '',
                'ln_arg' => 6272,
                'name' => 'type',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Message version (0x00 for this version)',
                'group' => '',
                'ln_arg' => 6273,
                'name' => 'version',
                'offset' => '1',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'GPS Satellite identiﬁer (see Satellite Numbering)',
                'group' => '',
                'ln_arg' => 6274,
                'name' => 'svId',
                'offset' => '2',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 6275,
                'name' => 'reserved0',
                'offset' => '3',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Fit interval ﬂag',
                'group' => '',
                'ln_arg' => 6276,
                'name' => 'fitInterval',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'URA index',
                'group' => '',
                'ln_arg' => 6277,
                'name' => 'uraIndex',
                'offset' => '5',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'SV health',
                'group' => '',
                'ln_arg' => 6278,
                'name' => 'svHealth',
                'offset' => '6',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Group delay diﬀerential',
                'group' => '',
                'ln_arg' => 6279,
                'name' => 'tgd',
                'offset' => '7',
                'repeat' => undef,
                'scale' => '2^-31',
                'type' => 'I1',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'IODC',
                'group' => '',
                'ln_arg' => 6280,
                'name' => 'iodc',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Clock data reference time',
                'group' => '',
                'ln_arg' => 6281,
                'name' => 'toc',
                'offset' => '10',
                'repeat' => undef,
                'scale' => '2^4',
                'type' => 'U2',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 6282,
                'name' => 'reserved1',
                'offset' => '12',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Time polynomial coeﬃcient 2 ',
                'group' => '',
                'ln_arg' => 6283,
                'name' => 'af2',
                'offset' => '13',
                'repeat' => undef,
                'scale' => '2^-55',
                'type' => 'I1',
                'unit' => 's/ssquared'
              },
              {
                'bitfield' => [],
                'descr' => 'Time polynomial coeﬃcient 1',
                'group' => '',
                'ln_arg' => 6285,
                'name' => 'af1',
                'offset' => '14',
                'repeat' => undef,
                'scale' => '2^-43',
                'type' => 'I2',
                'unit' => 's/s'
              },
              {
                'bitfield' => [],
                'descr' => 'Time polynomial coeﬃcient 0',
                'group' => '',
                'ln_arg' => 6286,
                'name' => 'af0',
                'offset' => '16',
                'repeat' => undef,
                'scale' => '2^-31',
                'type' => 'I4',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'Crs',
                'group' => '',
                'ln_arg' => 6287,
                'name' => 'crs',
                'offset' => '20',
                'repeat' => undef,
                'scale' => '2^-5',
                'type' => 'I2',
                'unit' => 'm'
              },
              {
                'bitfield' => [],
                'descr' => 'Mean motion diﬀerence from computed value ',
                'group' => '',
                'ln_arg' => 6288,
                'name' => 'deltaN',
                'offset' => '22',
                'repeat' => undef,
                'scale' => '2^-43',
                'type' => 'I2',
                'unit' => 'semi-circles/s'
              },
              {
                'bitfield' => [],
                'descr' => 'Mean anomaly at reference time ',
                'group' => '',
                'ln_arg' => 6290,
                'name' => 'm0',
                'offset' => '24',
                'repeat' => undef,
                'scale' => '2^-31',
                'type' => 'I4',
                'unit' => 'semi-circles'
              },
              {
                'bitfield' => [],
                'descr' => 'Amplitude of cosine harmonic correction term to argument of latitude',
                'group' => '',
                'ln_arg' => 6292,
                'name' => 'cuc',
                'offset' => '28',
                'repeat' => undef,
                'scale' => '2^-29',
                'type' => 'I2',
                'unit' => 'radians'
              },
              {
                'bitfield' => [],
                'descr' => 'Amplitude of sine harmonic correction term to argument of latitude',
                'group' => '',
                'ln_arg' => 6294,
                'name' => 'cus',
                'offset' => '30',
                'repeat' => undef,
                'scale' => '2^-29',
                'type' => 'I2',
                'unit' => 'radians'
              },
              {
                'bitfield' => [],
                'descr' => 'Eccentricity',
                'group' => '',
                'ln_arg' => 6296,
                'name' => 'e',
                'offset' => '32',
                'repeat' => undef,
                'scale' => '2^-33',
                'type' => 'U4',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Square root of the semi-major axis',
                'group' => '',
                'ln_arg' => 6297,
                'name' => 'sqrtA',
                'offset' => '36',
                'repeat' => undef,
                'scale' => '2^-19',
                'type' => 'U4',
                'unit' => 'm^0.5'
              },
              {
                'bitfield' => [],
                'descr' => 'Reference time of ephemeris',
                'group' => '',
                'ln_arg' => 6298,
                'name' => 'toe',
                'offset' => '40',
                'repeat' => undef,
                'scale' => '2^4',
                'type' => 'U2',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'Amplitude of cos harmonic correction term to angle of inclination',
                'group' => '',
                'ln_arg' => 6299,
                'name' => 'cic',
                'offset' => '42',
                'repeat' => undef,
                'scale' => '2^-29',
                'type' => 'I2',
                'unit' => 'radians'
              },
              {
                'bitfield' => [],
                'descr' => 'Longitude of ascending node of orbit plane at weekly epoch',
                'group' => '',
                'ln_arg' => 6301,
                'name' => 'omega0',
                'offset' => '44',
                'repeat' => undef,
                'scale' => '2^-31',
                'type' => 'I4',
                'unit' => 'semi-circles'
              },
              {
                'bitfield' => [],
                'descr' => 'Amplitude of sine harmonic correction term to angle of inclination',
                'group' => '',
                'ln_arg' => 6303,
                'name' => 'cis',
                'offset' => '48',
                'repeat' => undef,
                'scale' => '2^-29',
                'type' => 'I2',
                'unit' => 'radians'
              },
              {
                'bitfield' => [],
                'descr' => 'Amplitude of cosine harmonic correction term to orbit radius',
                'group' => '',
                'ln_arg' => 6305,
                'name' => 'crc',
                'offset' => '50',
                'repeat' => undef,
                'scale' => '2^-5',
                'type' => 'I2',
                'unit' => 'm'
              },
              {
                'bitfield' => [],
                'descr' => 'Inclination angle at reference time ',
                'group' => '',
                'ln_arg' => 6307,
                'name' => 'i0',
                'offset' => '52',
                'repeat' => undef,
                'scale' => '2^-31',
                'type' => 'I4',
                'unit' => 'semi-circles'
              },
              {
                'bitfield' => [],
                'descr' => 'Argument of perigee ',
                'group' => '',
                'ln_arg' => 6309,
                'name' => 'omega',
                'offset' => '56',
                'repeat' => undef,
                'scale' => '2^-31',
                'type' => 'I4',
                'unit' => 'semi-circles'
              },
              {
                'bitfield' => [],
                'descr' => 'Rate of right ascension ',
                'group' => '',
                'ln_arg' => 6311,
                'name' => 'omegaDot',
                'offset' => '60',
                'repeat' => undef,
                'scale' => '2^-43',
                'type' => 'I4',
                'unit' => 'semi-circles/s'
              },
              {
                'bitfield' => [],
                'descr' => 'Rate of inclination angle ',
                'group' => '',
                'ln_arg' => 6313,
                'name' => 'idot',
                'offset' => '64',
                'repeat' => undef,
                'scale' => '2^-43',
                'type' => 'I2',
                'unit' => 'semi-circles/s'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 6325,
                'name' => 'reserved2',
                'offset' => '66',
                'repeat' => '2',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x13',
  'code' => 'UBX-MGA-GPS-EPH',
  'comment' => 'This message allows the delivery of GPS ephemeris assistance to a receiver. See the section AssistNow online in Integration manual for details.',
  'id' => '0x00',
  'length' => '68',
  'ln_classid' => 6269,
  'ln_comment' => 6255,
  'ln_msg' => 6252,
  'ln_name' => 6253,
  'ln_type' => 6254,
  'name' => 'GPS ephemeris assistance',
  'type' => 'Input'
}
, ### UBX-MGA-GPS-ALM GPS almanac assistance ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Message type (0x02 for this type)',
                'group' => '',
                'ln_arg' => 6339,
                'name' => 'type',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Message version (0x00 for this version)',
                'group' => '',
                'ln_arg' => 6340,
                'name' => 'version',
                'offset' => '1',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'GPS Satellite identiﬁer (see Satellite Numbering)',
                'group' => '',
                'ln_arg' => 6341,
                'name' => 'svId',
                'offset' => '2',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'SV health information',
                'group' => '',
                'ln_arg' => 6342,
                'name' => 'svHealth',
                'offset' => '3',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Eccentricity',
                'group' => '',
                'ln_arg' => 6343,
                'name' => 'e',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '2^-21',
                'type' => 'U2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reference week number of almanac (the 8-bit WNa ﬁeld)',
                'group' => '',
                'ln_arg' => 6344,
                'name' => 'almWNa',
                'offset' => '6',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => 'week'
              },
              {
                'bitfield' => [],
                'descr' => 'Reference time of almanac',
                'group' => '',
                'ln_arg' => 6346,
                'name' => 'toa',
                'offset' => '7',
                'repeat' => undef,
                'scale' => '2^12',
                'type' => 'U1',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'Delta inclination angle at reference time ',
                'group' => '',
                'ln_arg' => 6347,
                'name' => 'deltaI',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '2^-19',
                'type' => 'I2',
                'unit' => 'semi-circles'
              },
              {
                'bitfield' => [],
                'descr' => 'Rate of right ascension ',
                'group' => '',
                'ln_arg' => 6349,
                'name' => 'omegaDot',
                'offset' => '10',
                'repeat' => undef,
                'scale' => '2^-38',
                'type' => 'I2',
                'unit' => 'semi-circles/s'
              },
              {
                'bitfield' => [],
                'descr' => 'Square root of the semi-major axis',
                'group' => '',
                'ln_arg' => 6351,
                'name' => 'sqrtA',
                'offset' => '12',
                'repeat' => undef,
                'scale' => '2^-11',
                'type' => 'U4',
                'unit' => 'm^0.5'
              },
              {
                'bitfield' => [],
                'descr' => 'Longitude of ascending node of orbit plane ',
                'group' => '',
                'ln_arg' => 6352,
                'name' => 'omega0',
                'offset' => '16',
                'repeat' => undef,
                'scale' => '2^-23',
                'type' => 'I4',
                'unit' => 'semi-circles'
              },
              {
                'bitfield' => [],
                'descr' => 'Argument of perigee ',
                'group' => '',
                'ln_arg' => 6354,
                'name' => 'omega',
                'offset' => '20',
                'repeat' => undef,
                'scale' => '2^-23',
                'type' => 'I4',
                'unit' => 'semi-circles'
              },
              {
                'bitfield' => [],
                'descr' => 'Mean anomaly at reference time ',
                'group' => '',
                'ln_arg' => 6356,
                'name' => 'm0',
                'offset' => '24',
                'repeat' => undef,
                'scale' => '2^-23',
                'type' => 'I4',
                'unit' => 'semi-circles'
              },
              {
                'bitfield' => [],
                'descr' => 'Time polynomial coeﬃcient 0 (8 MSBs)',
                'group' => '',
                'ln_arg' => 6358,
                'name' => 'af0',
                'offset' => '28',
                'repeat' => undef,
                'scale' => '2^-20',
                'type' => 'I2',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'Time polynomial coeﬃcient 1',
                'group' => '',
                'ln_arg' => 6359,
                'name' => 'af1',
                'offset' => '30',
                'repeat' => undef,
                'scale' => '2^-38',
                'type' => 'I2',
                'unit' => 's/s'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 6360,
                'name' => 'reserved0',
                'offset' => '32',
                'repeat' => '4',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x13',
  'code' => 'UBX-MGA-GPS-ALM',
  'comment' => 'This message allows the delivery of GPS almanac assistance to a receiver. See the section AssistNow online in Integration manual for details.',
  'id' => '0x00',
  'length' => '36',
  'ln_classid' => 6336,
  'ln_comment' => 6332,
  'ln_msg' => 6329,
  'ln_name' => 6330,
  'ln_type' => 6331,
  'name' => 'GPS almanac assistance',
  'type' => 'Input'
}
, ### UBX-MGA-GPS-HEALTH GPS health assistance ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Message type (0x04 for this type)',
                'group' => '',
                'ln_arg' => 6374,
                'name' => 'type',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Message version (0x00 for this version)',
                'group' => '',
                'ln_arg' => 6375,
                'name' => 'version',
                'offset' => '1',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 6385,
                'name' => 'reserved0',
                'offset' => '2',
                'repeat' => '2',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Each byte represents a GPS SV (1-32). The 6 LSBs of each byte contains the 6 bit health code from subframes 4/5 page 25.',
                'group' => '',
                'ln_arg' => 6386,
                'name' => 'healthCode',
                'offset' => '4',
                'repeat' => '32',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 6389,
                'name' => 'reserved1',
                'offset' => '36',
                'repeat' => '4',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x13',
  'code' => 'UBX-MGA-GPS-HEALTH',
  'comment' => 'This message allows the delivery of GPS health assistance to a receiver. See the section AssistNow online in Integration manual for details.',
  'id' => '0x00',
  'length' => '40',
  'ln_classid' => 6371,
  'ln_comment' => 6367,
  'ln_msg' => 6364,
  'ln_name' => 6365,
  'ln_type' => 6366,
  'name' => 'GPS health assistance',
  'type' => 'Input'
}
, ### UBX-MGA-GPS-UTC GPS UTC assistance ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Message type (0x05 for this type)',
                'group' => '',
                'ln_arg' => 6403,
                'name' => 'type',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Message version (0x00 for this version)',
                'group' => '',
                'ln_arg' => 6404,
                'name' => 'version',
                'offset' => '1',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 6405,
                'name' => 'reserved0',
                'offset' => '2',
                'repeat' => '2',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'First parameter of UTC polynomial',
                'group' => '',
                'ln_arg' => 6406,
                'name' => 'utcA0',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '2^-30',
                'type' => 'I4',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'Second parameter of UTC polynomial',
                'group' => '',
                'ln_arg' => 6407,
                'name' => 'utcA1',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '2^-50',
                'type' => 'I4',
                'unit' => 's/s'
              },
              {
                'bitfield' => [],
                'descr' => 'Delta time due to current leap seconds',
                'group' => '',
                'ln_arg' => 6408,
                'name' => 'utcDtLS',
                'offset' => '12',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I1',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'UTC parameters reference time of week (GPS time)',
                'group' => '',
                'ln_arg' => 6409,
                'name' => 'utcTot',
                'offset' => '13',
                'repeat' => undef,
                'scale' => '2^12',
                'type' => 'U1',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'UTC parameters reference week number (the 8-bit WNt ﬁeld)',
                'group' => '',
                'ln_arg' => 6410,
                'name' => 'utcWNt',
                'offset' => '14',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => 'weeks'
              },
              {
                'bitfield' => [],
                'descr' => 'Week number at the end of which the future leap second becomes eﬀective (the 8-bit WNLSF ﬁeld)',
                'group' => '',
                'ln_arg' => 6412,
                'name' => 'utcWNlsf',
                'offset' => '15',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => 'weeks'
              },
              {
                'bitfield' => [],
                'descr' => 'Day number at the end of which the future leap second becomes eﬀective',
                'group' => '',
                'ln_arg' => 6414,
                'name' => 'utcDn',
                'offset' => '16',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => 'days'
              },
              {
                'bitfield' => [],
                'descr' => 'Delta time due to future leap seconds',
                'group' => '',
                'ln_arg' => 6416,
                'name' => 'utcDtLSF',
                'offset' => '17',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I1',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 6417,
                'name' => 'reserved1',
                'offset' => '18',
                'repeat' => '2',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x13',
  'code' => 'UBX-MGA-GPS-UTC',
  'comment' => 'This message allows the delivery of GPS UTC assistance to a receiver. See the section AssistNow online in Integration manual for details.',
  'id' => '0x00',
  'length' => '20',
  'ln_classid' => 6400,
  'ln_comment' => 6396,
  'ln_msg' => 6393,
  'ln_name' => 6394,
  'ln_type' => 6395,
  'name' => 'GPS UTC assistance',
  'type' => 'Input'
}
, ### UBX-MGA-GPS-IONO GPS ionosphere assistance ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Message type (0x06 for this type)',
                'group' => '',
                'ln_arg' => 6431,
                'name' => 'type',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Message version (0x00 for this version)',
                'group' => '',
                'ln_arg' => 6432,
                'name' => 'version',
                'offset' => '1',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 6433,
                'name' => 'reserved0',
                'offset' => '2',
                'repeat' => '2',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Ionospheric parameter alpha0 [s]',
                'group' => '',
                'ln_arg' => 6434,
                'name' => 'ionoAlpha0',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '2^-30',
                'type' => 'I1',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'Ionospheric parameter alpha1 [s/semi-circle] ',
                'group' => '',
                'ln_arg' => 6445,
                'name' => 'ionoAlpha1',
                'offset' => '5',
                'repeat' => undef,
                'scale' => '2^-27',
                'type' => 'I1',
                'unit' => 's/semi-circle'
              },
              {
                'bitfield' => [],
                'descr' => 'Ionospheric parameter alpha2 [s/semi-circle^2] ',
                'group' => '',
                'ln_arg' => 6447,
                'name' => 'ionoAlpha2',
                'offset' => '6',
                'repeat' => undef,
                'scale' => '2^-24',
                'type' => 'I1',
                'unit' => 's/(semi-circle^2)'
              },
              {
                'bitfield' => [],
                'descr' => 'Ionospheric parameter alpha3 [s/semi-circle^3] ',
                'group' => '',
                'ln_arg' => 6449,
                'name' => 'ionoAlpha3',
                'offset' => '7',
                'repeat' => undef,
                'scale' => '2^-24',
                'type' => 'I1',
                'unit' => 's/(semi-circle^3)'
              },
              {
                'bitfield' => [],
                'descr' => 'Ionospheric parameter beta0 [s]',
                'group' => '',
                'ln_arg' => 6451,
                'name' => 'ionoBeta0',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '2^11',
                'type' => 'I1',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'Ionospheric parameter beta1 [s/semi-circle] ',
                'group' => '',
                'ln_arg' => 6452,
                'name' => 'ionoBeta1',
                'offset' => '9',
                'repeat' => undef,
                'scale' => '2^14',
                'type' => 'I1',
                'unit' => 's/semi-circle'
              },
              {
                'bitfield' => [],
                'descr' => 'Ionospheric parameter beta2 [s/semi-circle^2] ',
                'group' => '',
                'ln_arg' => 6454,
                'name' => 'ionoBeta2',
                'offset' => '10',
                'repeat' => undef,
                'scale' => '2^16',
                'type' => 'I1',
                'unit' => 's/(semi-circle^2)'
              },
              {
                'bitfield' => [],
                'descr' => 'Ionospheric parameter beta3 [s/semi-circle^3] ',
                'group' => '',
                'ln_arg' => 6456,
                'name' => 'ionoBeta3',
                'offset' => '11',
                'repeat' => undef,
                'scale' => '2^16',
                'type' => 'I1',
                'unit' => 's/(semi-circle^3)'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 6458,
                'name' => 'reserved1',
                'offset' => '12',
                'repeat' => '4',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x13',
  'code' => 'UBX-MGA-GPS-IONO',
  'comment' => 'This message allows the delivery of GPS ionospheric assistance to a receiver. See the section AssistNow online in Integration manual for details.',
  'id' => '0x00',
  'length' => '16',
  'ln_classid' => 6428,
  'ln_comment' => 6424,
  'ln_msg' => 6421,
  'ln_name' => 6422,
  'ln_type' => 6423,
  'name' => 'GPS ionosphere assistance',
  'type' => 'Input'
}
, ### UBX-MGA-INI-POS_XYZ Initial position assistance ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Message type (0x00 for this type)',
                'group' => '',
                'ln_arg' => 6477,
                'name' => 'type',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Message version (0x00 for this version)',
                'group' => '',
                'ln_arg' => 6478,
                'name' => 'version',
                'offset' => '1',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 6479,
                'name' => 'reserved0',
                'offset' => '2',
                'repeat' => '2',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'WGS84 ECEF X coordinate',
                'group' => '',
                'ln_arg' => 6480,
                'name' => 'ecefX',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I4',
                'unit' => 'cm'
              },
              {
                'bitfield' => [],
                'descr' => 'WGS84 ECEF Y coordinate',
                'group' => '',
                'ln_arg' => 6481,
                'name' => 'ecefY',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I4',
                'unit' => 'cm'
              },
              {
                'bitfield' => [],
                'descr' => 'WGS84 ECEF Z coordinate',
                'group' => '',
                'ln_arg' => 6482,
                'name' => 'ecefZ',
                'offset' => '12',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I4',
                'unit' => 'cm'
              },
              {
                'bitfield' => [],
                'descr' => 'Position accuracy (stddev)',
                'group' => '',
                'ln_arg' => 6483,
                'name' => 'posAcc',
                'offset' => '16',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'cm'
              }
            ],
  'class' => '0x13',
  'code' => 'UBX-MGA-INI-POS_XYZ',
  'comment' => 'This message allows the delivery of initial position assistance to a receiver in cartesian ECEF coordinates. This message is equivalent to the UBX-MGA-INI-POS_LLH message, except for the coordinate system. See the section AssistNow online in Integration manual for details. ☞ Supplying position assistance that is inaccurate by more than the speciﬁed position accuracy, may lead to substantially degraded receiver performance.',
  'id' => '0x40',
  'length' => '20',
  'ln_classid' => 6474,
  'ln_comment' => 6467,
  'ln_msg' => 6464,
  'ln_name' => 6465,
  'ln_type' => 6466,
  'name' => 'Initial position assistance',
  'type' => 'Input'
}
, ### UBX-MGA-INI-POS_LLH Initial position assistance ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Message type (0x01 for this type)',
                'group' => '',
                'ln_arg' => 6510,
                'name' => 'type',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Message version (0x00 for this version)',
                'group' => '',
                'ln_arg' => 6511,
                'name' => 'version',
                'offset' => '1',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 6512,
                'name' => 'reserved0',
                'offset' => '2',
                'repeat' => '2',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'WGS84 Latitude',
                'group' => '',
                'ln_arg' => 6513,
                'name' => 'lat',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '1e-7',
                'type' => 'I4',
                'unit' => 'deg'
              },
              {
                'bitfield' => [],
                'descr' => 'WGS84 Longitude',
                'group' => '',
                'ln_arg' => 6514,
                'name' => 'lon',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '1e-7',
                'type' => 'I4',
                'unit' => 'deg'
              },
              {
                'bitfield' => [],
                'descr' => 'WGS84 Altitude',
                'group' => '',
                'ln_arg' => 6515,
                'name' => 'alt',
                'offset' => '12',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I4',
                'unit' => 'cm'
              },
              {
                'bitfield' => [],
                'descr' => 'Position accuracy (stddev)',
                'group' => '',
                'ln_arg' => 6516,
                'name' => 'posAcc',
                'offset' => '16',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'cm'
              }
            ],
  'class' => '0x13',
  'code' => 'UBX-MGA-INI-POS_LLH',
  'comment' => 'This message allows the delivery of initial position assistance to a receiver in WGS84 lat/long/alt coordinates. This message is equivalent to the UBX-MGA-INI-POS_XYZ message, except for the coordinate system. See the section AssistNow online in Integration manual for details. ☞ Supplying position assistance that is inaccurate by more than the speciﬁed position accuracy, may lead to substantially degraded receiver performance.',
  'id' => '0x40',
  'length' => '20',
  'ln_classid' => 6507,
  'ln_comment' => 6490,
  'ln_msg' => 6487,
  'ln_name' => 6488,
  'ln_type' => 6489,
  'name' => 'Initial position assistance',
  'type' => 'Input'
}
, ### UBX-MGA-INI-TIME_UTC Initial time assistance ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Message type (0x10 for this type)',
                'group' => '',
                'ln_arg' => 6533,
                'name' => 'type',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Message version (0x00 for this version)',
                'group' => '',
                'ln_arg' => 6534,
                'name' => 'version',
                'offset' => '1',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '3',
                                  'bitfrom' => '0',
                                  'descr' => '•   0 = none, i.e. on receipt of message (will be inaccurate!)
•   1 = relative to pulse sent to EXTINT0
•   2 = relative to pulse sent to EXTINT1
•   3-15 = reserved',
                                  'name' => 'source',
                                  'numbits' => '4'
                                },
                                {
                                  'bit' => '4',
                                  'bitfrom' => undef,
                                  'descr' => 'use falling edge of EXTINT pulse (default rising) - only if source is EXTINT',
                                  'name' => 'fall',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '5',
                                  'bitfrom' => undef,
                                  'descr' => 'use last EXTINT pulse (default next pulse) - only if source is EXTINT',
                                  'name' => 'last',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'Reference to be used to set time',
                'group' => '',
                'ln_arg' => 6535,
                'name' => 'ref',
                'offset' => '2',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Number of leap seconds since 1980 (or 0x80 = -128 if unknown)',
                'group' => '',
                'ln_arg' => 6546,
                'name' => 'leapSecs',
                'offset' => '3',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I1',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'Year',
                'group' => '',
                'ln_arg' => 6548,
                'name' => 'year',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Month, starting at 1',
                'group' => '',
                'ln_arg' => 6549,
                'name' => 'month',
                'offset' => '6',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Day, starting at 1',
                'group' => '',
                'ln_arg' => 6550,
                'name' => 'day',
                'offset' => '7',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Hour, from 0 to 23',
                'group' => '',
                'ln_arg' => 6551,
                'name' => 'hour',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Minute, from 0 to 59',
                'group' => '',
                'ln_arg' => 6552,
                'name' => 'minute',
                'offset' => '9',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Seconds, from 0 to 59',
                'group' => '',
                'ln_arg' => 6553,
                'name' => 'second',
                'offset' => '10',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 6554,
                'name' => 'reserved0',
                'offset' => '11',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Nanoseconds, from 0 to 999,999,999',
                'group' => '',
                'ln_arg' => 6565,
                'name' => 'ns',
                'offset' => '12',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'ns'
              },
              {
                'bitfield' => [],
                'descr' => 'Seconds part of time accuracy',
                'group' => '',
                'ln_arg' => 6566,
                'name' => 'tAccS',
                'offset' => '16',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 6567,
                'name' => 'reserved1',
                'offset' => '18',
                'repeat' => '2',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Nanoseconds part of time accuracy, from 0 to 999,999,999',
                'group' => '',
                'ln_arg' => 6568,
                'name' => 'tAccNs',
                'offset' => '20',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'ns'
              }
            ],
  'class' => '0x13',
  'code' => 'UBX-MGA-INI-TIME_UTC',
  'comment' => 'This message allows the delivery of UTC time assistance to a receiver. This message is equivalent to the UBX-MGA-INI-TIME_GNSS message, except for the time base. See the section AssistNow online in Integration manual for details. ☞ Supplying time assistance that is inaccurate by more than the speciﬁed time accuracy, may lead to substantially degraded receiver performance.',
  'id' => '0x40',
  'length' => '24',
  'ln_bitfield' => 6544,
  'ln_classid' => 6530,
  'ln_comment' => 6523,
  'ln_msg' => 6520,
  'ln_name' => 6521,
  'ln_type' => 6522,
  'name' => 'Initial time assistance',
  'type' => 'Input'
}
, ### UBX-MGA-INI-TIME_GNSS Initial time assistance ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Message type (0x11 for this type)',
                'group' => '',
                'ln_arg' => 6586,
                'name' => 'type',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Message version (0x00 for this version)',
                'group' => '',
                'ln_arg' => 6587,
                'name' => 'version',
                'offset' => '1',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '3',
                                  'bitfrom' => '0',
                                  'descr' => '•   0 = none, i.e. on receipt of message (will be inaccurate!)
•   1 = relative to pulse sent to EXTINT0
•   2 = relative to pulse sent to EXTINT1
•   3-15 = reserved',
                                  'name' => 'source',
                                  'numbits' => '4'
                                },
                                {
                                  'bit' => '4',
                                  'bitfrom' => undef,
                                  'descr' => 'use falling edge of EXTINT pulse (default rising) - only if source is EXTINT',
                                  'name' => 'fall',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '5',
                                  'bitfrom' => undef,
                                  'descr' => 'use last EXTINT pulse (default next pulse) - only if source is EXTINT',
                                  'name' => 'last',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'Reference to be used to set time',
                'group' => '',
                'ln_arg' => 6588,
                'name' => 'ref',
                'offset' => '2',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Source of time information. Currently supported:
•   0 = GPS time
•   2 = Galileo time
•   3 = BeiDou time
•   6 = GLONASS time: week = 834 + ((N4-1)*1461 + Nt)/7, tow = (((N4-1)*1461 + Nt) % 7) * 86400 + tod',
                'group' => '',
                'ln_arg' => 6599,
                'name' => 'gnssId',
                'offset' => '3',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 6606,
                'name' => 'reserved0',
                'offset' => '4',
                'repeat' => '2',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'GNSS week number',
                'group' => '',
                'ln_arg' => 6607,
                'name' => 'week',
                'offset' => '6',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'GNSS time of week',
                'group' => '',
                'ln_arg' => 6608,
                'name' => 'tow',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'GNSS time of week, nanosecond part from 0 to 999,999,999',
                'group' => '',
                'ln_arg' => 6609,
                'name' => 'ns',
                'offset' => '12',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'ns'
              },
              {
                'bitfield' => [],
                'descr' => 'Seconds part of time accuracy',
                'group' => '',
                'ln_arg' => 6611,
                'name' => 'tAccS',
                'offset' => '16',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 6612,
                'name' => 'reserved1',
                'offset' => '18',
                'repeat' => '2',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Nanoseconds part of time accuracy, from 0 to 999,999,999',
                'group' => '',
                'ln_arg' => 6613,
                'name' => 'tAccNs',
                'offset' => '20',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'ns'
              }
            ],
  'class' => '0x13',
  'code' => 'UBX-MGA-INI-TIME_GNSS',
  'comment' => 'This message allows the delivery of time assistance to a receiver in a chosen GNSS timebase. This message is equivalent to the UBX-MGA-INI-TIME_UTC message, except for the time base. See the section AssistNow online in Integration manual for details. ☞ Supplying time assistance that is inaccurate by more than the speciﬁed time accuracy, may lead to substantially degraded receiver performance.',
  'id' => '0x40',
  'length' => '24',
  'ln_bitfield' => 6597,
  'ln_classid' => 6583,
  'ln_comment' => 6576,
  'ln_msg' => 6573,
  'ln_name' => 6574,
  'ln_type' => 6575,
  'name' => 'Initial time assistance',
  'type' => 'Input'
}
, ### UBX-MGA-INI-CLKD Initial clock drift assistance ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Message type (0x20 for this type)',
                'group' => '',
                'ln_arg' => 6638,
                'name' => 'type',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Message version (0x00 for this version)',
                'group' => '',
                'ln_arg' => 6639,
                'name' => 'version',
                'offset' => '1',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 6640,
                'name' => 'reserved0',
                'offset' => '2',
                'repeat' => '2',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Clock drift',
                'group' => '',
                'ln_arg' => 6641,
                'name' => 'clkD',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I4',
                'unit' => 'ns/s'
              },
              {
                'bitfield' => [],
                'descr' => 'Clock drift accuracy',
                'group' => '',
                'ln_arg' => 6642,
                'name' => 'clkDAcc',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'ns/s'
              }
            ],
  'class' => '0x13',
  'code' => 'UBX-MGA-INI-CLKD',
  'comment' => 'This message allows the delivery of clock drift assistance to a receiver. See the section AssistNow online in Integration manual for details. ☞ Supplying clock drift assistance that is inaccurate by more than the speciﬁed accuracy, may lead to substantially degraded receiver performance.',
  'id' => '0x40',
  'length' => '12',
  'ln_classid' => 6635,
  'ln_comment' => 6629,
  'ln_msg' => 6626,
  'ln_name' => 6627,
  'ln_type' => 6628,
  'name' => 'Initial clock drift assistance',
  'type' => 'Input'
}
, ### UBX-MGA-INI-FREQ Initial frequency assistance ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Message type (0x21 for this type)',
                'group' => '',
                'ln_arg' => 6658,
                'name' => 'type',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Message version (0x00 for this version)',
                'group' => '',
                'ln_arg' => 6659,
                'name' => 'version',
                'offset' => '1',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 6660,
                'name' => 'reserved0',
                'offset' => '2',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '3',
                                  'bitfrom' => '0',
                                  'descr' => '•   0 = frequency available on EXTINT0
•   1 = frequency available on EXTINT1
•   2-15 = reserved',
                                  'name' => 'source',
                                  'numbits' => '4'
                                },
                                {
                                  'bit' => '4',
                                  'bitfrom' => undef,
                                  'descr' => 'use falling edge of EXTINT pulse (default rising)',
                                  'name' => 'fall',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'Frequency reference',
                'group' => '',
                'ln_arg' => 6661,
                'name' => 'flags',
                'offset' => '3',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Frequency',
                'group' => '',
                'ln_arg' => 6667,
                'name' => 'freq',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '1e-2',
                'type' => 'I4',
                'unit' => 'Hz'
              },
              {
                'bitfield' => [],
                'descr' => 'Frequency accuracy',
                'group' => '',
                'ln_arg' => 6668,
                'name' => 'freqAcc',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'ppb'
              }
            ],
  'class' => '0x13',
  'code' => 'UBX-MGA-INI-FREQ',
  'comment' => 'This message allows the delivery of external frequency assistance to a receiver. See the section AssistNow online in Integration manual for details. ☞ Supplying external frequency assistance that is inaccurate by more than the speciﬁed accuracy, may lead to substantially degraded receiver performance.',
  'id' => '0x40',
  'length' => '12',
  'ln_bitfield' => 6666,
  'ln_classid' => 6655,
  'ln_comment' => 6649,
  'ln_msg' => 6646,
  'ln_name' => 6647,
  'ln_type' => 6648,
  'name' => 'Initial frequency assistance',
  'type' => 'Input'
}
, ### UBX-MGA-QZSS-EPH QZSS ephemeris assistance ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Message type (0x01 for this type)',
                'group' => '',
                'ln_arg' => 6693,
                'name' => 'type',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Message version (0x00 for this version)',
                'group' => '',
                'ln_arg' => 6694,
                'name' => 'version',
                'offset' => '1',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'QZSS Satellite identiﬁer (see Satellite Numbering), Range 1-5',
                'group' => '',
                'ln_arg' => 6695,
                'name' => 'svId',
                'offset' => '2',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 6697,
                'name' => 'reserved0',
                'offset' => '3',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Fit interval ﬂag',
                'group' => '',
                'ln_arg' => 6698,
                'name' => 'fitInterval',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'URA index',
                'group' => '',
                'ln_arg' => 6699,
                'name' => 'uraIndex',
                'offset' => '5',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'SV health',
                'group' => '',
                'ln_arg' => 6700,
                'name' => 'svHealth',
                'offset' => '6',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Group delay diﬀerential',
                'group' => '',
                'ln_arg' => 6701,
                'name' => 'tgd',
                'offset' => '7',
                'repeat' => undef,
                'scale' => '2^-31',
                'type' => 'I1',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'IODC',
                'group' => '',
                'ln_arg' => 6702,
                'name' => 'iodc',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Clock data reference time',
                'group' => '',
                'ln_arg' => 6703,
                'name' => 'toc',
                'offset' => '10',
                'repeat' => undef,
                'scale' => '2^4',
                'type' => 'U2',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 6704,
                'name' => 'reserved1',
                'offset' => '12',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Time polynomial coeﬃcient 2 ',
                'group' => '',
                'ln_arg' => 6705,
                'name' => 'af2',
                'offset' => '13',
                'repeat' => undef,
                'scale' => '2^-55',
                'type' => 'I1',
                'unit' => 's/ssquared'
              },
              {
                'bitfield' => [],
                'descr' => 'Time polynomial coeﬃcient 1',
                'group' => '',
                'ln_arg' => 6707,
                'name' => 'af1',
                'offset' => '14',
                'repeat' => undef,
                'scale' => '2^-43',
                'type' => 'I2',
                'unit' => 's/s'
              },
              {
                'bitfield' => [],
                'descr' => 'Time polynomial coeﬃcient 0',
                'group' => '',
                'ln_arg' => 6708,
                'name' => 'af0',
                'offset' => '16',
                'repeat' => undef,
                'scale' => '2^-31',
                'type' => 'I4',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'Crs',
                'group' => '',
                'ln_arg' => 6709,
                'name' => 'crs',
                'offset' => '20',
                'repeat' => undef,
                'scale' => '2^-5',
                'type' => 'I2',
                'unit' => 'm'
              },
              {
                'bitfield' => [],
                'descr' => 'Mean motion diﬀerence from computed value ',
                'group' => '',
                'ln_arg' => 6710,
                'name' => 'deltaN',
                'offset' => '22',
                'repeat' => undef,
                'scale' => '2^-43',
                'type' => 'I2',
                'unit' => 'semi-circles/s'
              },
              {
                'bitfield' => [],
                'descr' => 'Mean anomaly at reference time ',
                'group' => '',
                'ln_arg' => 6712,
                'name' => 'm0',
                'offset' => '24',
                'repeat' => undef,
                'scale' => '2^-31',
                'type' => 'I4',
                'unit' => 'semi-circles'
              },
              {
                'bitfield' => [],
                'descr' => 'Amp of cosine harmonic corr term to arg of lat',
                'group' => '',
                'ln_arg' => 6714,
                'name' => 'cuc',
                'offset' => '28',
                'repeat' => undef,
                'scale' => '2^-29',
                'type' => 'I2',
                'unit' => 'radians'
              },
              {
                'bitfield' => [],
                'descr' => 'Amp of sine harmonic corr term to arg of lat',
                'group' => '',
                'ln_arg' => 6715,
                'name' => 'cus',
                'offset' => '30',
                'repeat' => undef,
                'scale' => '2^-29',
                'type' => 'I2',
                'unit' => 'radians'
              },
              {
                'bitfield' => [],
                'descr' => 'eccentricity',
                'group' => '',
                'ln_arg' => 6716,
                'name' => 'e',
                'offset' => '32',
                'repeat' => undef,
                'scale' => '2^-33',
                'type' => 'U4',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Square root of the semi-major axis A',
                'group' => '',
                'ln_arg' => 6717,
                'name' => 'sqrtA',
                'offset' => '36',
                'repeat' => undef,
                'scale' => '2^-19',
                'type' => 'U4',
                'unit' => 'm^0.5'
              },
              {
                'bitfield' => [],
                'descr' => 'Reference time of ephemeris',
                'group' => '',
                'ln_arg' => 6718,
                'name' => 'toe',
                'offset' => '40',
                'repeat' => undef,
                'scale' => '2^4',
                'type' => 'U2',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'Amp of cos harmonic corr term to angle of inclination',
                'group' => '',
                'ln_arg' => 6719,
                'name' => 'cic',
                'offset' => '42',
                'repeat' => undef,
                'scale' => '2^-29',
                'type' => 'I2',
                'unit' => 'radians'
              },
              {
                'bitfield' => [],
                'descr' => 'Long of asc node of orbit plane at weekly epoch ',
                'group' => '',
                'ln_arg' => 6720,
                'name' => 'omega0',
                'offset' => '44',
                'repeat' => undef,
                'scale' => '2^-31',
                'type' => 'I4',
                'unit' => 'semi-circles'
              },
              {
                'bitfield' => [],
                'descr' => 'Amp of sine harmonic corr term to angle of inclination',
                'group' => '',
                'ln_arg' => 6722,
                'name' => 'cis',
                'offset' => '48',
                'repeat' => undef,
                'scale' => '2^-29',
                'type' => 'I2',
                'unit' => 'radians'
              },
              {
                'bitfield' => [],
                'descr' => 'Amp of cosine harmonic corr term to orbit radius',
                'group' => '',
                'ln_arg' => 6723,
                'name' => 'crc',
                'offset' => '50',
                'repeat' => undef,
                'scale' => '2^-5',
                'type' => 'I2',
                'unit' => 'm'
              },
              {
                'bitfield' => [],
                'descr' => 'Inclination angle at reference time ',
                'group' => '',
                'ln_arg' => 6724,
                'name' => 'i0',
                'offset' => '52',
                'repeat' => undef,
                'scale' => '2^-31',
                'type' => 'I4',
                'unit' => 'semi-circles'
              },
              {
                'bitfield' => [],
                'descr' => 'Argument of perigee ',
                'group' => '',
                'ln_arg' => 6726,
                'name' => 'omega',
                'offset' => '56',
                'repeat' => undef,
                'scale' => '2^-31',
                'type' => 'I4',
                'unit' => 'semi-circles'
              },
              {
                'bitfield' => [],
                'descr' => 'Rate of right ascension ',
                'group' => '',
                'ln_arg' => 6738,
                'name' => 'omegaDot',
                'offset' => '60',
                'repeat' => undef,
                'scale' => '2^-43',
                'type' => 'I4',
                'unit' => 'semi-circles/s'
              },
              {
                'bitfield' => [],
                'descr' => 'Rate of inclination angle ',
                'group' => '',
                'ln_arg' => 6740,
                'name' => 'idot',
                'offset' => '64',
                'repeat' => undef,
                'scale' => '2^-43',
                'type' => 'I2',
                'unit' => 'semi-circles/s'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 6742,
                'name' => 'reserved2',
                'offset' => '66',
                'repeat' => '2',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x13',
  'code' => 'UBX-MGA-QZSS-EPH',
  'comment' => 'This message allows the delivery of QZSS ephemeris assistance to a receiver. See the section AssistNow online in Integration manual for details.',
  'id' => '0x05',
  'length' => '68',
  'ln_classid' => 6690,
  'ln_comment' => 6686,
  'ln_msg' => 6683,
  'ln_name' => 6684,
  'ln_type' => 6685,
  'name' => 'QZSS ephemeris assistance',
  'type' => 'Input'
}
, ### UBX-MGA-QZSS-ALM QZSS almanac assistance ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Message type (0x02 for this type)',
                'group' => '',
                'ln_arg' => 6756,
                'name' => 'type',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Message version (0x00 for this version)',
                'group' => '',
                'ln_arg' => 6757,
                'name' => 'version',
                'offset' => '1',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'QZSS Satellite identiﬁer (see Satellite Numbering), Range 1-5',
                'group' => '',
                'ln_arg' => 6758,
                'name' => 'svId',
                'offset' => '2',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Almanac SV health information',
                'group' => '',
                'ln_arg' => 6760,
                'name' => 'svHealth',
                'offset' => '3',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Almanac eccentricity',
                'group' => '',
                'ln_arg' => 6761,
                'name' => 'e',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '2^-21',
                'type' => 'U2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reference week number of almanac (the 8-bit WNa ﬁeld)',
                'group' => '',
                'ln_arg' => 6762,
                'name' => 'almWNa',
                'offset' => '6',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => 'week'
              },
              {
                'bitfield' => [],
                'descr' => 'Reference time of almanac',
                'group' => '',
                'ln_arg' => 6764,
                'name' => 'toa',
                'offset' => '7',
                'repeat' => undef,
                'scale' => '2^12',
                'type' => 'U1',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'Delta inclination angle at reference time ',
                'group' => '',
                'ln_arg' => 6765,
                'name' => 'deltaI',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '2^-19',
                'type' => 'I2',
                'unit' => 'semi-circles'
              },
              {
                'bitfield' => [],
                'descr' => 'Almanac rate of right ascension ',
                'group' => '',
                'ln_arg' => 6767,
                'name' => 'omegaDot',
                'offset' => '10',
                'repeat' => undef,
                'scale' => '2^-38',
                'type' => 'I2',
                'unit' => 'semi-circles/s'
              },
              {
                'bitfield' => [],
                'descr' => 'Almanac square root of the semi-major axis A',
                'group' => '',
                'ln_arg' => 6769,
                'name' => 'sqrtA',
                'offset' => '12',
                'repeat' => undef,
                'scale' => '2^-11',
                'type' => 'U4',
                'unit' => 'm^0.5'
              },
              {
                'bitfield' => [],
                'descr' => 'Almanac long of asc node of orbit plane at weekly ',
                'group' => '',
                'ln_arg' => 6770,
                'name' => 'omega0',
                'offset' => '16',
                'repeat' => undef,
                'scale' => '2^-23',
                'type' => 'I4',
                'unit' => 'semi-circles'
              },
              {
                'bitfield' => [],
                'descr' => 'Almanac argument of perigee ',
                'group' => '',
                'ln_arg' => 6772,
                'name' => 'omega',
                'offset' => '20',
                'repeat' => undef,
                'scale' => '2^-23',
                'type' => 'I4',
                'unit' => 'semi-circles'
              },
              {
                'bitfield' => [],
                'descr' => 'Almanac mean anomaly at reference time ',
                'group' => '',
                'ln_arg' => 6774,
                'name' => 'm0',
                'offset' => '24',
                'repeat' => undef,
                'scale' => '2^-23',
                'type' => 'I4',
                'unit' => 'semi-circles'
              },
              {
                'bitfield' => [],
                'descr' => 'Almanac time polynomial coeﬃcient 0 (8 MSBs)',
                'group' => '',
                'ln_arg' => 6776,
                'name' => 'af0',
                'offset' => '28',
                'repeat' => undef,
                'scale' => '2^-20',
                'type' => 'I2',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'Almanac time polynomial coeﬃcient 1',
                'group' => '',
                'ln_arg' => 6777,
                'name' => 'af1',
                'offset' => '30',
                'repeat' => undef,
                'scale' => '2^-38',
                'type' => 'I2',
                'unit' => 's/s'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 6778,
                'name' => 'reserved0',
                'offset' => '32',
                'repeat' => '4',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x13',
  'code' => 'UBX-MGA-QZSS-ALM',
  'comment' => 'This message allows the delivery of QZSS almanac assistance to a receiver. See the section AssistNow online in Integration manual for details.',
  'id' => '0x05',
  'length' => '36',
  'ln_classid' => 6753,
  'ln_comment' => 6749,
  'ln_msg' => 6746,
  'ln_name' => 6747,
  'ln_type' => 6748,
  'name' => 'QZSS almanac assistance',
  'type' => 'Input'
}
, ### UBX-MGA-QZSS-HEALTH QZSS health assistance ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Message type (0x04 for this type)',
                'group' => '',
                'ln_arg' => 6802,
                'name' => 'type',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Message version (0x00 for this version)',
                'group' => '',
                'ln_arg' => 6803,
                'name' => 'version',
                'offset' => '1',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 6804,
                'name' => 'reserved0',
                'offset' => '2',
                'repeat' => '2',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Each byte represents a QZSS SV (1-5). The 6 LSBs of each byte contains the 6 bit health code from subframes 4/5, data ID = 3, SV ID = 51',
                'group' => '',
                'ln_arg' => 6805,
                'name' => 'healthCode',
                'offset' => '4',
                'repeat' => '5',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 6808,
                'name' => 'reserved1',
                'offset' => '9',
                'repeat' => '3',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x13',
  'code' => 'UBX-MGA-QZSS-HEALTH',
  'comment' => 'This message allows the delivery of QZSS health assistance to a receiver. See the section AssistNow online in Integration manual for details.',
  'id' => '0x05',
  'length' => '12',
  'ln_classid' => 6789,
  'ln_comment' => 6785,
  'ln_msg' => 6782,
  'ln_name' => 6783,
  'ln_type' => 6784,
  'name' => 'QZSS health assistance',
  'type' => 'Input'
}
, ### UBX-MON-COMMS Communication port information ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Message version (0x00 for this version)',
                'group' => '',
                'ln_arg' => 6829,
                'name' => 'version',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Number of ports included',
                'group' => '',
                'ln_arg' => 6830,
                'name' => 'nPorts',
                'offset' => '1',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '0',
                                  'bitfrom' => undef,
                                  'descr' => 'Memory Allocation error',
                                  'name' => 'mem',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '1',
                                  'bitfrom' => undef,
                                  'descr' => 'Allocation error (TX buﬀer full)',
                                  'name' => 'alloc',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'TX error bitmask',
                'group' => '',
                'ln_arg' => 6831,
                'name' => 'txErrors',
                'offset' => '2',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 6836,
                'name' => 'reserved0',
                'offset' => '3',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'identiﬁers of the protocols reported in the msgs 0: UBX, 1: NMEA, 2: RTCM2, 5: RTCM3, 0xFF: No reported.',
                'group' => '',
                'ln_arg' => 6837,
                'name' => 'protIds',
                'offset' => '4',
                'repeat' => '4',
                'scale' => '-',
                'type' => 'U1',
                'unit' => 'Thearray.protocol'
              },
              {
                'bitfield' => [],
                'descr' => 'Unique identiﬁer for the port. See section Communications ports in Integration manual for details.',
                'group' => 'repeated nPorts',
                'ln_arg' => 6842,
                'name' => 'portId',
                'offset' => '8 + n·40',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Number of bytes pending in transmitter buﬀer',
                'group' => 'repeated nPorts',
                'ln_arg' => 6845,
                'name' => 'txPending',
                'offset' => '10 + n·40',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => 'bytes'
              },
              {
                'bitfield' => [],
                'descr' => 'Number of bytes ever sent',
                'group' => 'repeated nPorts',
                'ln_arg' => 6846,
                'name' => 'txBytes',
                'offset' => '12 + n·40',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'bytes'
              },
              {
                'bitfield' => [],
                'descr' => 'Maximum usage transmitter buﬀer during the last sysmon period',
                'group' => 'repeated nPorts',
                'ln_arg' => 6847,
                'name' => 'txUsage',
                'offset' => '16 + n·40',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '%'
              },
              {
                'bitfield' => [],
                'descr' => 'Maximum usage transmitter buﬀer',
                'group' => 'repeated nPorts',
                'ln_arg' => 6849,
                'name' => 'txPeakUsage',
                'offset' => '17 + n·40',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '%'
              },
              {
                'bitfield' => [],
                'descr' => 'Number of bytes in receiver buﬀer',
                'group' => 'repeated nPorts',
                'ln_arg' => 6850,
                'name' => 'rxPending',
                'offset' => '18 + n·40',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => 'bytes'
              },
              {
                'bitfield' => [],
                'descr' => 'Number of bytes ever received',
                'group' => 'repeated nPorts',
                'ln_arg' => 6861,
                'name' => 'rxBytes',
                'offset' => '20 + n·40',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'bytes'
              },
              {
                'bitfield' => [],
                'descr' => 'Maximum usage receiver buﬀer during the last sysmon period',
                'group' => 'repeated nPorts',
                'ln_arg' => 6862,
                'name' => 'rxUsage',
                'offset' => '24 + n·40',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '%'
              },
              {
                'bitfield' => [],
                'descr' => 'Maximum usage receiver buﬀer',
                'group' => 'repeated nPorts',
                'ln_arg' => 6864,
                'name' => 'rxPeakUsage',
                'offset' => '25 + n·40',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '%'
              },
              {
                'bitfield' => [],
                'descr' => 'Number of 100 ms timeslots with overrun errors',
                'group' => 'repeated nPorts',
                'ln_arg' => 6865,
                'name' => 'overrunErrs',
                'offset' => '26 + n·40',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Number of successfully parsed messages for each protocol. The reported protocols are identiﬁed through the protIds ﬁeld.',
                'group' => 'repeated nPorts',
                'ln_arg' => 6866,
                'name' => 'msgs',
                'offset' => '28 + n·40',
                'repeat' => '4',
                'scale' => '-',
                'type' => 'U2',
                'unit' => 'msg'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => 'repeated nPorts',
                'ln_arg' => 6869,
                'name' => 'reserved1',
                'offset' => '36 + n·40',
                'repeat' => '8',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Number of skipped bytes',
                'group' => 'repeated nPorts',
                'ln_arg' => 6870,
                'name' => 'skipped',
                'offset' => '44 + n·40',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'bytes'
              }
            ],
  'class' => '0x0a',
  'code' => 'UBX-MON-COMMS',
  'comment' => 'Consolidated communications information for all ports. The size of the message is determined by the number of ports that are in use on the receiver. A port is only included if communication, either send or receive, has been initiated on that port.',
  'hasgroup' => 'repeated nPorts',
  'id' => '0x36',
  'length' => '8 + nPorts·40',
  'ln_bitfield' => 6835,
  'ln_classid' => 6826,
  'ln_comment' => 6821,
  'ln_msg' => 6818,
  'ln_name' => 6819,
  'ln_type' => 6820,
  'name' => 'Communication port information',
  'type' => 'Periodic/polled'
}
, ### UBX-MON-GNSS Information message major GNSS selection ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Message version (0x01for this version)',
                'group' => '',
                'ln_arg' => 6888,
                'name' => 'version',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '0',
                                  'bitfrom' => undef,
                                  'descr' => 'GPS is supported',
                                  'name' => 'GPSSup',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '1',
                                  'bitfrom' => undef,
                                  'descr' => 'GLONASS is supported',
                                  'name' => 'GlonassSup',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '2',
                                  'bitfrom' => undef,
                                  'descr' => 'BeiDou is supported',
                                  'name' => 'BeidouSup',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '3',
                                  'bitfrom' => undef,
                                  'descr' => 'Galileo is supported',
                                  'name' => 'GalileoSup',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'A bit mask showing the major GNSS that can be supported by this receiver',
                'group' => '',
                'ln_arg' => 6889,
                'name' => 'supported',
                'offset' => '1',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X1',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '0',
                                  'bitfrom' => undef,
                                  'descr' => 'GPS is default-enabled',
                                  'name' => 'GPSDef',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '1',
                                  'bitfrom' => undef,
                                  'descr' => 'GLONASS is default-enabled',
                                  'name' => 'GlonassDef',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '2',
                                  'bitfrom' => undef,
                                  'descr' => 'BeiDou is default-enabled',
                                  'name' => 'BeidouDef',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '3',
                                  'bitfrom' => undef,
                                  'descr' => 'Galileo is default-enabled',
                                  'name' => 'GalileoDef',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'A bit mask showing the default major GNSS selection. If the default major GNSS selection is currently conﬁgured in the efuse for this receiver, it takes precedence over the default major GNSS selection conﬁgured in the executing ﬁrmware of this receiver.',
                'group' => '',
                'ln_arg' => 6899,
                'name' => 'defaultGnss',
                'offset' => '2',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X1',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '0',
                                  'bitfrom' => undef,
                                  'descr' => 'GPS is enabled',
                                  'name' => 'GPSEna',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '1',
                                  'bitfrom' => undef,
                                  'descr' => 'GLONASS is enabled',
                                  'name' => 'GlonassEna',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '2',
                                  'bitfrom' => undef,
                                  'descr' => 'BeiDou is enabled',
                                  'name' => 'BeidouEna',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '3',
                                  'bitfrom' => undef,
                                  'descr' => 'Galileo is enabled',
                                  'name' => 'GalileoEna',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'A bit mask showing the current major GNSS selection enabled for this receiver',
                'group' => '',
                'ln_arg' => 6912,
                'name' => 'enabled',
                'offset' => '3',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Maximum number of concurrent major GNSS that can be supported by this receiver',
                'group' => '',
                'ln_arg' => 6932,
                'name' => 'simultaneous',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 6934,
                'name' => 'reserved0',
                'offset' => '5',
                'repeat' => '3',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x0a',
  'code' => 'UBX-MON-GNSS',
  'comment' => 'This message reports major GNSS selection. It does this by means of bit masks in U1 ﬁelds. Each bit in a bit mask corresponds to one major GNSS. Augmentation systems are not reported.',
  'id' => '0x28',
  'length' => '8',
  'ln_bitfield' => 6921,
  'ln_classid' => 6885,
  'ln_comment' => 6881,
  'ln_msg' => 6878,
  'ln_name' => 6879,
  'ln_type' => 6880,
  'name' => 'Information message major GNSS selection',
  'type' => 'Polled'
}
, ### UBX-MON-HW Hardware status ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Mask of pins set as peripheral/PIO',
                'group' => '',
                'ln_arg' => 6951,
                'name' => 'pinSel',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X4',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Mask of pins set as bank A/B',
                'group' => '',
                'ln_arg' => 6952,
                'name' => 'pinBank',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X4',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Mask of pins set as input/output',
                'group' => '',
                'ln_arg' => 6953,
                'name' => 'pinDir',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X4',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Mask of pins value low/high',
                'group' => '',
                'ln_arg' => 6954,
                'name' => 'pinVal',
                'offset' => '12',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X4',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Noise level as measured by the GPS core',
                'group' => '',
                'ln_arg' => 6955,
                'name' => 'noisePerMS',
                'offset' => '16',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'AGC monitor (counts SIGHI xor SIGLO, range 0 to 8191)',
                'group' => '',
                'ln_arg' => 6956,
                'name' => 'agcCnt',
                'offset' => '18',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Status of the antenna supervisor state machine (0=INIT, 1=DONTKNOW, 2=OK, 3=SHORT, 4=OPEN)',
                'group' => '',
                'ln_arg' => 6958,
                'name' => 'aStatus',
                'offset' => '20',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Current power status of antenna (0=OFF, 1=ON, 2=DONTKNOW)',
                'group' => '',
                'ln_arg' => 6960,
                'name' => 'aPower',
                'offset' => '21',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '0',
                                  'bitfrom' => undef,
                                  'descr' => 'RTC is calibrated',
                                  'name' => 'rtcCalib',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '1',
                                  'bitfrom' => undef,
                                  'descr' => 'Safeboot mode (0 = inactive, 1 = active)',
                                  'name' => 'safeBoot',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '3',
                                  'bitfrom' => '2',
                                  'descr' => 'Output from jamming/interference monitor (0 = unknown or feature disabled, 1 = ok - no signiﬁcant jamming, 2 = warning - interference visible but ﬁx OK, 3 = critical - interference visible and no ﬁx)',
                                  'name' => 'jammingState',
                                  'numbits' => '2'
                                },
                                {
                                  'bit' => '4',
                                  'bitfrom' => undef,
                                  'descr' => 'RTC xtal has been determined to be absent (not supported for protocol versions less than 18.00)',
                                  'name' => 'xtalAbsent',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'Flags',
                'group' => '',
                'ln_arg' => 6962,
                'name' => 'flags',
                'offset' => '22',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 6974,
                'name' => 'reserved0',
                'offset' => '23',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Mask of pins that are used by the virtual pin manager',
                'group' => '',
                'ln_arg' => 6975,
                'name' => 'usedMask',
                'offset' => '24',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X4',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Array of pin mappings for each of the 17 physical pins',
                'group' => '',
                'ln_arg' => 6976,
                'name' => 'VP',
                'offset' => '28',
                'repeat' => '17',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'CW jamming indicator, scaled (0 = no CW jamming, 255 = strong CW jamming)',
                'group' => '',
                'ln_arg' => 6977,
                'name' => 'jamInd',
                'offset' => '45',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 6979,
                'name' => 'reserved1',
                'offset' => '46',
                'repeat' => '2',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Mask of pins value using the PIO Irq',
                'group' => '',
                'ln_arg' => 6980,
                'name' => 'pinIrq',
                'offset' => '48',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X4',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Mask of pins value using the PIO pull high resistor',
                'group' => '',
                'ln_arg' => 6981,
                'name' => 'pullH',
                'offset' => '52',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X4',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Mask of pins value using the PIO pull low resistor',
                'group' => '',
                'ln_arg' => 6992,
                'name' => 'pullL',
                'offset' => '56',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X4',
                'unit' => '-'
              }
            ],
  'class' => '0x0a',
  'code' => 'UBX-MON-HW',
  'comment' => 'This message is deprecated in this protocol version. Use UBX-MON-HW3 and UBX-MON-RF instead. Status of diﬀerent aspect of the hardware, such as antenna, PIO/peripheral pins, noise level, automatic gain control (AGC)',
  'id' => '0x09',
  'length' => '60',
  'ln_bitfield' => 6972,
  'ln_classid' => 6948,
  'ln_comment' => 6943,
  'ln_msg' => 6940,
  'ln_name' => 6941,
  'ln_type' => 6942,
  'name' => 'Hardware status',
  'type' => 'Periodic/polled'
}
, ### UBX-MON-HW2 Extended hardware status ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Imbalance of I-part of complex signal, scaled (-128 = max. negative imbalance, 127 = max. positive imbalance)',
                'group' => '',
                'ln_arg' => 7013,
                'name' => 'ofsI',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Magnitude of I-part of complex signal, scaled (0 = no signal, 255 = max. magnitude)',
                'group' => '',
                'ln_arg' => 7016,
                'name' => 'magI',
                'offset' => '1',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Imbalance of Q-part of complex signal, scaled (-128 = max. negative imbalance, 127 = max. positive imbalance)',
                'group' => '',
                'ln_arg' => 7018,
                'name' => 'ofsQ',
                'offset' => '2',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Magnitude of Q-part of complex signal, scaled (0 = no signal, 255 = max. magnitude)',
                'group' => '',
                'ln_arg' => 7021,
                'name' => 'magQ',
                'offset' => '3',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Source of low-level conﬁguration (114 = ROM, 111 = OTP, 112 = conﬁg pins, 102 = ﬂash image)',
                'group' => '',
                'ln_arg' => 7023,
                'name' => 'cfgSource',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 7026,
                'name' => 'reserved0',
                'offset' => '5',
                'repeat' => '3',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Low-level conﬁguration (obsolete for protocol versions greater than 15.00)',
                'group' => '',
                'ln_arg' => 7027,
                'name' => 'lowLevCfg',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 7029,
                'name' => 'reserved1',
                'offset' => '12',
                'repeat' => '8',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'POST status word',
                'group' => '',
                'ln_arg' => 7030,
                'name' => 'postStatus',
                'offset' => '20',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 7031,
                'name' => 'reserved2',
                'offset' => '24',
                'repeat' => '4',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x0a',
  'code' => 'UBX-MON-HW2',
  'comment' => 'This message is deprecated in this protocol version. Use UBX-MON-HW3 and UBX-MON-RF instead. Status of diﬀerent aspects of the hardware such as Imbalance, Low-Level Conﬁguration and POST Results. The ﬁrst four parameters of this message represent the complex signal from the RF front end. The following rules of thumb apply:
•    The smaller the absolute value of the variable ofsI and ofsQ, the better.
•    Ideally, the magnitude of the I-part (magI) and the Q-part (magQ) of the complex signal should be the same.',
  'id' => '0x0b',
  'length' => '28',
  'ln_classid' => 7010,
  'ln_comment' => 7001,
  'ln_msg' => 6998,
  'ln_name' => 6999,
  'ln_type' => 7000,
  'name' => 'Extended hardware status',
  'type' => 'Periodic/polled'
}
, ### UBX-MON-HW3 I/O pin status ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Message version (0x00 for this version)',
                'group' => '',
                'ln_arg' => 7058,
                'name' => 'version',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'The number of I/O pins included',
                'group' => '',
                'ln_arg' => 7059,
                'name' => 'nPins',
                'offset' => '1',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '0',
                                  'bitfrom' => undef,
                                  'descr' => 'RTC is calibrated',
                                  'name' => 'rtcCalib',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '1',
                                  'bitfrom' => undef,
                                  'descr' => 'Safeboot mode (0 = inactive, 1 = active)',
                                  'name' => 'safeBoot',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '2',
                                  'bitfrom' => undef,
                                  'descr' => 'RTC xtal has been determined to be absent',
                                  'name' => 'xtalAbsent',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'Flags',
                'group' => '',
                'ln_arg' => 7060,
                'name' => 'flags',
                'offset' => '2',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Zero-terminated hardware version string (same as that returned in the UBX-MON-VER message)',
                'group' => '',
                'ln_arg' => 7067,
                'name' => 'hwVersion',
                'offset' => '3',
                'repeat' => '10',
                'scale' => '-',
                'type' => 'CH',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 7069,
                'name' => 'reserved0',
                'offset' => '13',
                'repeat' => '9',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Identiﬁer for the pin, including both external and internal pins.',
                'group' => 'repeated nPins',
                'ln_arg' => 7072,
                'name' => 'pinId',
                'offset' => '22 + n·6',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '0',
                                  'bitfrom' => undef,
                                  'descr' => 'Pin is set to peripheral or PIO? 0=Peripheral 1=PIO',
                                  'name' => 'periphPIO',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '3',
                                  'bitfrom' => '1',
                                  'descr' => 'Bank the pin belongs to, where 0=A 1=B 2=C 3=D 4=E 5=F 6=G 7=H',
                                  'name' => 'pinBank',
                                  'numbits' => '3'
                                },
                                {
                                  'bit' => '4',
                                  'bitfrom' => undef,
                                  'descr' => 'Pin direction? 0=Input 1=Output',
                                  'name' => 'direction',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '5',
                                  'bitfrom' => undef,
                                  'descr' => 'Pin value? 0=Low 1=High',
                                  'name' => 'value',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '6',
                                  'bitfrom' => undef,
                                  'descr' => 'Used by virtual pin manager? 0=No 1=Yes',
                                  'name' => 'vpManager',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '7',
                                  'bitfrom' => undef,
                                  'descr' => 'Interrupt enabled? 0=No 1=Yes',
                                  'name' => 'pioIrq',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '8',
                                  'bitfrom' => undef,
                                  'descr' => 'Using pull high resistor? 0=No 1=Yes',
                                  'name' => 'pioPullHigh',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '9',
                                  'bitfrom' => undef,
                                  'descr' => 'Using pull low resistor 0=No 1=Yes',
                                  'name' => 'pioPullLow',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'Pin mask',
                'group' => 'repeated nPins',
                'ln_arg' => 7074,
                'name' => 'pinMask',
                'offset' => '24 + n·6',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Virtual pin mapping',
                'group' => 'repeated nPins',
                'ln_arg' => 7091,
                'name' => 'VP',
                'offset' => '26 + n·6',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => 'repeated nPins',
                'ln_arg' => 7092,
                'name' => 'reserved1',
                'offset' => '27 + n·6',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x0a',
  'code' => 'UBX-MON-HW3',
  'comment' => 'This message contains information speciﬁc to each HW I/O pin, for example whether the pin is set as Input or Output. For the antenna supervisor status and other RF status information, see the UBX-MON-RF message.',
  'hasgroup' => 'repeated nPins',
  'id' => '0x37',
  'length' => '22 + nPins·6',
  'ln_bitfield' => 7090,
  'ln_classid' => 7055,
  'ln_comment' => 7040,
  'ln_msg' => 7037,
  'ln_name' => 7038,
  'ln_type' => 7039,
  'name' => 'I/O pin status',
  'type' => 'Periodic/polled'
}
, ### UBX-MON-IO I/O system status ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Number of bytes ever received',
                'group' => 'repeated N',
                'ln_arg' => 7112,
                'name' => 'rxBytes',
                'offset' => '0 + n·20',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'bytes'
              },
              {
                'bitfield' => [],
                'descr' => 'Number of bytes ever sent',
                'group' => 'repeated N',
                'ln_arg' => 7123,
                'name' => 'txBytes',
                'offset' => '4 + n·20',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'bytes'
              },
              {
                'bitfield' => [],
                'descr' => 'Number of 100 ms timeslots with parity errors',
                'group' => 'repeated N',
                'ln_arg' => 7124,
                'name' => 'parityErrs',
                'offset' => '8 + n·20',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Number of 100 ms timeslots with framing errors',
                'group' => 'repeated N',
                'ln_arg' => 7125,
                'name' => 'framingErrs',
                'offset' => '10 + n·20',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Number of 100 ms timeslots with overrun errors',
                'group' => 'repeated N',
                'ln_arg' => 7126,
                'name' => 'overrunErrs',
                'offset' => '12 + n·20',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Number of 100 ms timeslots with break conditions',
                'group' => 'repeated N',
                'ln_arg' => 7127,
                'name' => 'breakCond',
                'offset' => '14 + n·20',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => 'repeated N',
                'ln_arg' => 7128,
                'name' => 'reserved0',
                'offset' => '16 + n·20',
                'repeat' => '4',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x0a',
  'code' => 'UBX-MON-IO',
  'comment' => 'This message is deprecated in this protocol version. Use UBX-MON-COMMS instead. The size of the message is determined by the number of ports \'N\' the receiver supports, i.e. on u-blox 5 the number of ports is 6.',
  'hasgroup' => 'repeated N',
  'id' => '0x02',
  'length' => '[0..n]·20',
  'ln_classid' => 7108,
  'ln_comment' => 7103,
  'ln_msg' => 7100,
  'ln_name' => 7101,
  'ln_type' => 7102,
  'name' => 'I/O system status',
  'type' => 'Periodic/polled'
}
, ### UBX-MON-MSGPP Message parse and process status ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Number of successfully parsed messages for each protocol on port0',
                'group' => '',
                'ln_arg' => 7144,
                'name' => 'msg1',
                'offset' => '0',
                'repeat' => '8',
                'scale' => '-',
                'type' => 'U2',
                'unit' => 'msgs'
              },
              {
                'bitfield' => [],
                'descr' => 'Number of successfully parsed messages for each protocol on port1',
                'group' => '',
                'ln_arg' => 7146,
                'name' => 'msg2',
                'offset' => '16',
                'repeat' => '8',
                'scale' => '-',
                'type' => 'U2',
                'unit' => 'msgs'
              },
              {
                'bitfield' => [],
                'descr' => 'Number of successfully parsed messages for each protocol on port2',
                'group' => '',
                'ln_arg' => 7148,
                'name' => 'msg3',
                'offset' => '32',
                'repeat' => '8',
                'scale' => '-',
                'type' => 'U2',
                'unit' => 'msgs'
              },
              {
                'bitfield' => [],
                'descr' => 'Number of successfully parsed messages for each protocol on port3',
                'group' => '',
                'ln_arg' => 7150,
                'name' => 'msg4',
                'offset' => '48',
                'repeat' => '8',
                'scale' => '-',
                'type' => 'U2',
                'unit' => 'msgs'
              },
              {
                'bitfield' => [],
                'descr' => 'Number of successfully parsed messages for each protocol on port4',
                'group' => '',
                'ln_arg' => 7152,
                'name' => 'msg5',
                'offset' => '64',
                'repeat' => '8',
                'scale' => '-',
                'type' => 'U2',
                'unit' => 'msgs'
              },
              {
                'bitfield' => [],
                'descr' => 'Number of successfully parsed messages for each protocol on port5',
                'group' => '',
                'ln_arg' => 7154,
                'name' => 'msg6',
                'offset' => '80',
                'repeat' => '8',
                'scale' => '-',
                'type' => 'U2',
                'unit' => 'msgs'
              },
              {
                'bitfield' => [],
                'descr' => 'Number skipped bytes for each port',
                'group' => '',
                'ln_arg' => 7156,
                'name' => 'skipped',
                'offset' => '96',
                'repeat' => '6',
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'bytes'
              }
            ],
  'class' => '0x0a',
  'code' => 'UBX-MON-MSGPP',
  'comment' => 'This message is deprecated in this protocol version. Use UBX-MON-COMMS instead.',
  'id' => '0x06',
  'length' => '120',
  'ln_classid' => 7141,
  'ln_comment' => 7138,
  'ln_msg' => 7135,
  'ln_name' => 7136,
  'ln_type' => 7137,
  'name' => 'Message parse and process status',
  'type' => 'Periodic/polled'
}
, ### UBX-MON-PATCH Installed patches ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Message version (0x0001 for this version)',
                'group' => '',
                'ln_arg' => 7184,
                'name' => 'version',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Total number of reported patches',
                'group' => '',
                'ln_arg' => 7185,
                'name' => 'nEntries',
                'offset' => '2',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '0',
                                  'bitfrom' => undef,
                                  'descr' => '1: the patch is active, 0: otherwise',
                                  'name' => 'activated',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '2',
                                  'bitfrom' => '1',
                                  'descr' => 'Indicates where the patch is stored. 0: eFuse, 1: ROM, 2: BBR, 3: ﬁle system',
                                  'name' => 'location',
                                  'numbits' => '2'
                                }
                              ],
                'descr' => 'Status information about the reported patch',
                'group' => 'repeated nEntries',
                'ln_arg' => 7188,
                'name' => 'patchInfo',
                'offset' => '4 + n·16',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X4',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'The number of the comparator',
                'group' => 'repeated nEntries',
                'ln_arg' => 7194,
                'name' => 'comparatorNumber',
                'offset' => '8 + n·16',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'The address that is targeted by the patch',
                'group' => 'repeated nEntries',
                'ln_arg' => 7196,
                'name' => 'patchAddress',
                'offset' => '12 + n·16',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'The data that is inserted at the patchAddress',
                'group' => 'repeated nEntries',
                'ln_arg' => 7197,
                'name' => 'patchData',
                'offset' => '16 + n·16',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => '-'
              }
            ],
  'class' => '0x0a',
  'code' => 'UBX-MON-PATCH',
  'comment' => 'This message reports information about patches installed and currently enabled on the receiver. It does not report on patches installed and then disabled. An enabled patch is considered active when the receiver executes from the code space where the patch resides on. For example, a ROM patch is reported active only when the system runs from ROM.',
  'hasgroup' => 'repeated nEntries',
  'id' => '0x27',
  'length' => '4 + nEntries·16',
  'ln_bitfield' => 7192,
  'ln_classid' => 7171,
  'ln_comment' => 7165,
  'ln_msg' => 7162,
  'ln_name' => 7163,
  'ln_type' => 7164,
  'name' => 'Installed patches',
  'type' => 'Polled'
}
, ### UBX-MON-RF RF information ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Message version (0x00 for this version)',
                'group' => '',
                'ln_arg' => 7214,
                'name' => 'version',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'The number of RF blocks included',
                'group' => '',
                'ln_arg' => 7215,
                'name' => 'nBlocks',
                'offset' => '1',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 7216,
                'name' => 'reserved0',
                'offset' => '2',
                'repeat' => '2',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'RF block ID',
                'group' => 'repeated nBlocks',
                'ln_arg' => 7219,
                'name' => 'blockId',
                'offset' => '4 + n·24',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '1',
                                  'bitfrom' => '0',
                                  'descr' => 'output from Jamming/Interference Monitor (0 = unknown or feature disabled, 1 = ok - no signiﬁcant jamming, 2 = warning - interference visible but ﬁx OK, 3 = critical - interference visible and no ﬁx)',
                                  'name' => 'jammingState',
                                  'numbits' => '2'
                                }
                              ],
                'descr' => 'Flags',
                'group' => 'repeated nBlocks',
                'ln_arg' => 7220,
                'name' => 'flags',
                'offset' => '5 + n·24',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Status   of  the    antenna supervisor state machine (0x00=INIT, 0x01=DONTKNOW, 0x02=OK, 0x03=SHORT, 0x04=OPEN)',
                'group' => 'repeated nBlocks',
                'ln_arg' => 7226,
                'name' => 'antStatus',
                'offset' => '6 + n·24',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Current power status of antenna             (0x00=OFF, 0x01=ON, 0x02=DONTKNOW)',
                'group' => 'repeated nBlocks',
                'ln_arg' => 7229,
                'name' => 'antPower',
                'offset' => '7 + n·24',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'POST status word',
                'group' => 'repeated nBlocks',
                'ln_arg' => 7231,
                'name' => 'postStatus',
                'offset' => '8 + n·24',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => 'repeated nBlocks',
                'ln_arg' => 7232,
                'name' => 'reserved1',
                'offset' => '12 + n·24',
                'repeat' => '4',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Noise level as measured by the GPS core',
                'group' => 'repeated nBlocks',
                'ln_arg' => 7233,
                'name' => 'noisePerMS',
                'offset' => '16 + n·24',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'AGC Monitor (counts SIGHI xor SIGLO, range 0 to 8191)',
                'group' => 'repeated nBlocks',
                'ln_arg' => 7234,
                'name' => 'agcCnt',
                'offset' => '18 + n·24',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'CW jamming indicator, scaled (0=no CW jamming, 255 = strong CW jamming)',
                'group' => 'repeated nBlocks',
                'ln_arg' => 7236,
                'name' => 'jamInd',
                'offset' => '20 + n·24',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Imbalance of I-part of complex signal, scaled (-128 = max. negative imbalance, 127 = max. positive imbalance)',
                'group' => 'repeated nBlocks',
                'ln_arg' => 7248,
                'name' => 'ofsI',
                'offset' => '21 + n·24',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Magnitude of I-part of complex signal, scaled (0 = no signal, 255 = max.magnitude)',
                'group' => 'repeated nBlocks',
                'ln_arg' => 7251,
                'name' => 'magI',
                'offset' => '22 + n·24',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Imbalance of Q-part of complex signal, scaled (-128 = max. negative imbalance, 127 = max. positive imbalance)',
                'group' => 'repeated nBlocks',
                'ln_arg' => 7253,
                'name' => 'ofsQ',
                'offset' => '23 + n·24',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Magnitude of Q-part of complex signal, scaled (0 = no signal, 255 = max.magnitude)',
                'group' => 'repeated nBlocks',
                'ln_arg' => 7256,
                'name' => 'magQ',
                'offset' => '24 + n·24',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => 'repeated nBlocks',
                'ln_arg' => 7258,
                'name' => 'reserved2',
                'offset' => '25 + n·24',
                'repeat' => '3',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x0a',
  'code' => 'UBX-MON-RF',
  'comment' => 'Information for each RF block.',
  'hasgroup' => 'repeated nBlocks',
  'id' => '0x38',
  'length' => '4 + nBlocks·24',
  'ln_bitfield' => 7222,
  'ln_classid' => 7211,
  'ln_comment' => 7208,
  'ln_msg' => 7205,
  'ln_name' => 7206,
  'ln_type' => 7207,
  'name' => 'RF information',
  'type' => 'Periodic/polled'
}
, ### UBX-MON-RXBUF Receiver buﬀer status ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Number of bytes pending in receiver buﬀer for each target',
                'group' => '',
                'ln_arg' => 7275,
                'name' => 'pending',
                'offset' => '0',
                'repeat' => '6',
                'scale' => '-',
                'type' => 'U2',
                'unit' => 'bytes'
              },
              {
                'bitfield' => [],
                'descr' => 'Maximum usage receiver buﬀer during the last sysmon period for each target',
                'group' => '',
                'ln_arg' => 7277,
                'name' => 'usage',
                'offset' => '12',
                'repeat' => '6',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '%'
              },
              {
                'bitfield' => [],
                'descr' => 'Maximum usage receiver buﬀer for each target',
                'group' => '',
                'ln_arg' => 7279,
                'name' => 'peakUsage',
                'offset' => '18',
                'repeat' => '6',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '%'
              }
            ],
  'class' => '0x0a',
  'code' => 'UBX-MON-RXBUF',
  'comment' => 'This message is deprecated in this protocol version. Use UBX-MON-COMMS instead.',
  'id' => '0x07',
  'length' => '24',
  'ln_classid' => 7272,
  'ln_comment' => 7269,
  'ln_msg' => 7266,
  'ln_name' => 7267,
  'ln_type' => 7268,
  'name' => 'Receiver buﬀer status',
  'type' => 'Periodic/polled'
}
, ### UBX-MON-RXR Receiver status information ###
{
  'args' => [
              {
                'bitfield' => [
                                {
                                  'bit' => '0',
                                  'bitfrom' => undef,
                                  'descr' => 'not in backup mode',
                                  'name' => 'awake',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'Receiver status ﬂags',
                'group' => '',
                'ln_arg' => 7294,
                'name' => 'flags',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X1',
                'unit' => '-'
              }
            ],
  'class' => '0x0a',
  'code' => 'UBX-MON-RXR',
  'comment' => 'The receiver ready message is sent when the receiver changes from or to backup mode.',
  'id' => '0x21',
  'length' => '1',
  'ln_bitfield' => 7296,
  'ln_classid' => 7291,
  'ln_comment' => 7288,
  'ln_msg' => 7285,
  'ln_name' => 7286,
  'ln_type' => 7287,
  'name' => 'Receiver status information',
  'type' => 'Output'
}
, ### UBX-MON-SPAN Signal characteristics ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Message version (0x00 for this version)',
                'group' => '',
                'ln_arg' => 7330,
                'name' => 'version',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Number of RF blocks included',
                'group' => '',
                'ln_arg' => 7331,
                'name' => 'numRfBlocks',
                'offset' => '1',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 7332,
                'name' => 'reserved0',
                'offset' => '2',
                'repeat' => '2',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Spectrum data (number of points = span/res)',
                'group' => 'repeated numRfBlocks',
                'ln_arg' => 7335,
                'name' => 'spectrum',
                'offset' => '4 + n·272',
                'repeat' => '256',
                'scale' => '-',
                'type' => 'U1',
                'unit' => 'dB'
              }
            ],
  'class' => '0x0a',
  'code' => 'UBX-MON-SPAN',
  'comment' => 'This message is to be used as a basic spectrum analyzer, where it displays one spectrum for each of the receiver\'s existing RF paths. The spectrum is conveyed with the following parameters: The frequency span in MHz, the frequency bin resolution in MHz, the center frequency in MHz, and 256 bins with amplitude data. Additionally, in order to give further insight on the signal captured by the receiver, the current gain of the internal programmable gain ampliﬁer (PGA) is provided. This message gives information for comparative analysis rather than absolute and precise spectrum overview. Users should not expect highly accurate spectrum amplitude. Note that the PGA gain is not included in the spectrum data but is available as a separate ﬁeld. Neither the spectrum, nor the PGA gain considers the internal ﬁxed LNA gain or an external third-party LNA. The center frequency at each bin, assuming a zero-based bin count, can be computed as f(i) = center + span * (i - 128) / 256',
  'hasgroup' => 'repeated numRfBlocks',
  'id' => '0x31',
  'length' => '4 + numRfBlocks·272',
  'ln_classid' => 7327,
  'ln_comment' => 7314,
  'ln_msg' => 7311,
  'ln_name' => 7312,
  'ln_type' => 7313,
  'name' => 'Signal characteristics',
  'type' => 'Periodic/polled'
}
, ### UBX-MON-TXBUF Transmitter buﬀer status ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Number of bytes pending in transmitter buﬀer for each target',
                'group' => '',
                'ln_arg' => 7357,
                'name' => 'pending',
                'offset' => '0',
                'repeat' => '6',
                'scale' => '-',
                'type' => 'U2',
                'unit' => 'bytes'
              },
              {
                'bitfield' => [],
                'descr' => 'Maximum usage transmitter buﬀer during the last sysmon period for each target',
                'group' => '',
                'ln_arg' => 7359,
                'name' => 'usage',
                'offset' => '12',
                'repeat' => '6',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '%'
              },
              {
                'bitfield' => [],
                'descr' => 'Maximum usage transmitter buﬀer for each target',
                'group' => '',
                'ln_arg' => 7361,
                'name' => 'peakUsage',
                'offset' => '18',
                'repeat' => '6',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '%'
              },
              {
                'bitfield' => [],
                'descr' => 'Maximum usage of transmitter buﬀer during the last sysmon period for all targets',
                'group' => '',
                'ln_arg' => 7372,
                'name' => 'tUsage',
                'offset' => '24',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '%'
              },
              {
                'bitfield' => [],
                'descr' => 'Maximum usage of transmitter buﬀer for all targets',
                'group' => '',
                'ln_arg' => 7374,
                'name' => 'tPeakusage',
                'offset' => '25',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '%'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '5',
                                  'bitfrom' => '0',
                                  'descr' => 'Buﬀer limit of corresponding target reached',
                                  'name' => 'limit',
                                  'numbits' => '6'
                                },
                                {
                                  'bit' => '6',
                                  'bitfrom' => undef,
                                  'descr' => 'Memory Allocation error',
                                  'name' => 'mem',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '7',
                                  'bitfrom' => undef,
                                  'descr' => 'Allocation error (TX buﬀer full)',
                                  'name' => 'alloc',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'Error bitmask',
                'group' => '',
                'ln_arg' => 7375,
                'name' => 'errors',
                'offset' => '26',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 7382,
                'name' => 'reserved0',
                'offset' => '27',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x0a',
  'code' => 'UBX-MON-TXBUF',
  'comment' => 'This message is deprecated in this protocol version. Use UBX-MON-COMMS instead.',
  'id' => '0x08',
  'length' => '28',
  'ln_bitfield' => 7381,
  'ln_classid' => 7354,
  'ln_comment' => 7351,
  'ln_msg' => 7348,
  'ln_name' => 7349,
  'ln_type' => 7350,
  'name' => 'Transmitter buﬀer status',
  'type' => 'Periodic/polled'
}
, ### UBX-MON-VER Receiver and software version ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Nul-terminated software version string.',
                'group' => '',
                'ln_arg' => 7397,
                'name' => 'swVersion',
                'offset' => '0',
                'repeat' => '30',
                'scale' => '-',
                'type' => 'CH',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Nul-terminated hardware version string',
                'group' => '',
                'ln_arg' => 7398,
                'name' => 'hwVersion',
                'offset' => '30',
                'repeat' => '10',
                'scale' => '-',
                'type' => 'CH',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Extended software information strings. A series of nul-terminated strings. Each extension ﬁeld is 30 characters long and contains varying software information. Not all extension ﬁelds may appear. Examples of reported information: the software version string of the underlying ROM (when the receiver\'s ﬁrmware is running from ﬂash), the ﬁrmware version, the supported protocol version, the module identiﬁer, the ﬂash information structure (FIS) ﬁle information, the supported major GNSS, the supported augmentation systems. See Firmware and protocol versions for details.',
                'group' => 'repeated N',
                'ln_arg' => 7400,
                'name' => 'extension',
                'offset' => '40 + n·30',
                'repeat' => '30',
                'scale' => '-',
                'type' => 'CH',
                'unit' => '-'
              }
            ],
  'class' => '0x0a',
  'code' => 'UBX-MON-VER',
  'comment' => '',
  'hasgroup' => 'repeated N',
  'id' => '0x04',
  'length' => '40 + [0..n]·30',
  'ln_classid' => 7394,
  'ln_comment' => 7391,
  'ln_msg' => 7388,
  'ln_name' => 7389,
  'ln_type' => 7390,
  'name' => 'Receiver and software version',
  'type' => 'Polled'
}
, ### UBX-NAV-CLOCK Clock solution ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'GPS time of week of the navigation epoch. See the section Navigation epochs in Integration manual for details. See the section iTOW timestamps in Integration manual for details.',
                'group' => '',
                'ln_arg' => 7443,
                'name' => 'iTOW',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'ms'
              },
              {
                'bitfield' => [],
                'descr' => 'Clock bias',
                'group' => '',
                'ln_arg' => 7448,
                'name' => 'clkB',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I4',
                'unit' => 'ns'
              },
              {
                'bitfield' => [],
                'descr' => 'Clock drift',
                'group' => '',
                'ln_arg' => 7449,
                'name' => 'clkD',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I4',
                'unit' => 'ns/s'
              },
              {
                'bitfield' => [],
                'descr' => 'Time accuracy estimate',
                'group' => '',
                'ln_arg' => 7450,
                'name' => 'tAcc',
                'offset' => '12',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'ns'
              },
              {
                'bitfield' => [],
                'descr' => 'Frequency accuracy estimate',
                'group' => '',
                'ln_arg' => 7451,
                'name' => 'fAcc',
                'offset' => '16',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'ps/s'
              }
            ],
  'class' => '0x01',
  'code' => 'UBX-NAV-CLOCK',
  'comment' => '',
  'id' => '0x22',
  'length' => '20',
  'ln_classid' => 7440,
  'ln_comment' => 7437,
  'ln_msg' => 7434,
  'ln_name' => 7435,
  'ln_type' => 7436,
  'name' => 'Clock solution',
  'type' => 'Periodic/polled'
}
, ### UBX-NAV-DOP Dilution of precision ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'GPS time of week of the navigation epoch. See the section iTOW timestamps in Integration manual for details.',
                'group' => '',
                'ln_arg' => 7468,
                'name' => 'iTOW',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'ms'
              },
              {
                'bitfield' => [],
                'descr' => 'Geometric DOP',
                'group' => '',
                'ln_arg' => 7471,
                'name' => 'gDOP',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '0.01',
                'type' => 'U2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Position DOP',
                'group' => '',
                'ln_arg' => 7472,
                'name' => 'pDOP',
                'offset' => '6',
                'repeat' => undef,
                'scale' => '0.01',
                'type' => 'U2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Time DOP',
                'group' => '',
                'ln_arg' => 7473,
                'name' => 'tDOP',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '0.01',
                'type' => 'U2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Vertical DOP',
                'group' => '',
                'ln_arg' => 7474,
                'name' => 'vDOP',
                'offset' => '10',
                'repeat' => undef,
                'scale' => '0.01',
                'type' => 'U2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Horizontal DOP',
                'group' => '',
                'ln_arg' => 7475,
                'name' => 'hDOP',
                'offset' => '12',
                'repeat' => undef,
                'scale' => '0.01',
                'type' => 'U2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Northing DOP',
                'group' => '',
                'ln_arg' => 7476,
                'name' => 'nDOP',
                'offset' => '14',
                'repeat' => undef,
                'scale' => '0.01',
                'type' => 'U2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Easting DOP',
                'group' => '',
                'ln_arg' => 7477,
                'name' => 'eDOP',
                'offset' => '16',
                'repeat' => undef,
                'scale' => '0.01',
                'type' => 'U2',
                'unit' => '-'
              }
            ],
  'class' => '0x01',
  'code' => 'UBX-NAV-DOP',
  'comment' => '•    DOP values are dimensionless.
•    All DOP values are scaled by a factor of 100. If the unit transmits a value of e.g. 156, the DOP value is 1.56.',
  'id' => '0x04',
  'length' => '18',
  'ln_classid' => 7465,
  'ln_comment' => 7460,
  'ln_msg' => 7457,
  'ln_name' => 7458,
  'ln_type' => 7459,
  'name' => 'Dilution of precision',
  'type' => 'Periodic/polled'
}
, ### UBX-NAV-EOE End of epoch ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'GPS time of week of the navigation epoch. See the section iTOW timestamps in Integration manual for details.',
                'group' => '',
                'ln_arg' => 7502,
                'name' => 'iTOW',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'ms'
              }
            ],
  'class' => '0x01',
  'code' => 'UBX-NAV-EOE',
  'comment' => 'This message is intended to be used as a marker to collect all navigation messages of an epoch. It is output after all enabled NAV class messages (except UBX-NAV-HNR) and after all enabled NMEA messages.',
  'id' => '0x61',
  'length' => '4',
  'ln_classid' => 7499,
  'ln_comment' => 7495,
  'ln_msg' => 7492,
  'ln_name' => 7493,
  'ln_type' => 7494,
  'name' => 'End of epoch',
  'type' => 'Periodic'
}
, ### UBX-NAV-GEOFENCE Geofencing status ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'GPS time of week of the navigation epoch. See the section iTOW timestamps in Integration manual for details.',
                'group' => '',
                'ln_arg' => 7520,
                'name' => 'iTOW',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'ms'
              },
              {
                'bitfield' => [],
                'descr' => 'Message version (0x00 for this version)',
                'group' => '',
                'ln_arg' => 7523,
                'name' => 'version',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Geofencing status
•   0 - Geofencing not available or not reliable
•   1 - Geofencing active',
                'group' => '',
                'ln_arg' => 7524,
                'name' => 'status',
                'offset' => '5',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Number of geofences',
                'group' => '',
                'ln_arg' => 7527,
                'name' => 'numFences',
                'offset' => '6',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Combined (logical OR) state of all geofences
•   0 - Unknown
•   1 - Inside
•   2 - Outside',
                'group' => '',
                'ln_arg' => 7528,
                'name' => 'combState',
                'offset' => '7',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Geofence state
•   0 - Unknown
•   1 - Inside
•   2 - Outside',
                'group' => 'repeated numFences',
                'ln_arg' => 7533,
                'name' => 'state',
                'offset' => '8 + n·2',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Geofence ID (0 = not available)',
                'group' => 'repeated numFences',
                'ln_arg' => 7537,
                'name' => 'id',
                'offset' => '9 + n·2',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x01',
  'code' => 'UBX-NAV-GEOFENCE',
  'comment' => 'This message outputs the evaluated states of all conﬁgured geofences for the current epoch\'s position. See the section Geofencing in Integration manual for feature details.',
  'hasgroup' => 'repeated numFences',
  'id' => '0x39',
  'length' => '8 + numFences·2',
  'ln_classid' => 7517,
  'ln_comment' => 7513,
  'ln_msg' => 7510,
  'ln_name' => 7511,
  'ln_type' => 7512,
  'name' => 'Geofencing status',
  'type' => 'Periodic/polled'
}
, ### UBX-NAV-HPPOSECEF High precision position solution in ECEF ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Message version (0x00 for this version)',
                'group' => '',
                'ln_arg' => 7563,
                'name' => 'version',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 7564,
                'name' => 'reserved0',
                'offset' => '1',
                'repeat' => '3',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'GPS time of week of the navigation epoch. See the section iTOW timestamps in Integration manual for details.',
                'group' => '',
                'ln_arg' => 7565,
                'name' => 'iTOW',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'ms'
              },
              {
                'bitfield' => [],
                'descr' => 'ECEF X coordinate',
                'group' => '',
                'ln_arg' => 7568,
                'name' => 'ecefX',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I4',
                'unit' => 'cm'
              },
              {
                'bitfield' => [],
                'descr' => 'ECEF Y coordinate',
                'group' => '',
                'ln_arg' => 7569,
                'name' => 'ecefY',
                'offset' => '12',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I4',
                'unit' => 'cm'
              },
              {
                'bitfield' => [],
                'descr' => 'ECEF Z coordinate',
                'group' => '',
                'ln_arg' => 7570,
                'name' => 'ecefZ',
                'offset' => '16',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I4',
                'unit' => 'cm'
              },
              {
                'bitfield' => [],
                'descr' => 'High precision component of ECEF X coordinate. Must be in the range of -99..+99. Precise coordinate in cm = ecefX + (ecefXHp * 1e-2).',
                'group' => '',
                'ln_arg' => 7571,
                'name' => 'ecefXHp',
                'offset' => '20',
                'repeat' => undef,
                'scale' => '0.1',
                'type' => 'I1',
                'unit' => 'mm'
              },
              {
                'bitfield' => [],
                'descr' => 'High precision component of ECEF Y coordinate. Must be in the range of -99..+99. Precise coordinate in cm = ecefY + (ecefYHp * 1e-2).',
                'group' => '',
                'ln_arg' => 7574,
                'name' => 'ecefYHp',
                'offset' => '21',
                'repeat' => undef,
                'scale' => '0.1',
                'type' => 'I1',
                'unit' => 'mm'
              },
              {
                'bitfield' => [],
                'descr' => 'High precision component of ECEF Z coordinate. Must be in the range of -99..+99. Precise coordinate in cm = ecefZ + (ecefZHp * 1e-2).',
                'group' => '',
                'ln_arg' => 7577,
                'name' => 'ecefZHp',
                'offset' => '22',
                'repeat' => undef,
                'scale' => '0.1',
                'type' => 'I1',
                'unit' => 'mm'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '0',
                                  'bitfrom' => undef,
                                  'descr' => '1 = Invalid ecefX, ecefY, ecefZ, ecefXHp, ecefYHp and ecefZHp',
                                  'name' => 'invalidEcef',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'Additional ﬂags',
                'group' => '',
                'ln_arg' => 7580,
                'name' => 'flags',
                'offset' => '23',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Position Accuracy Estimate',
                'group' => '',
                'ln_arg' => 7584,
                'name' => 'pAcc',
                'offset' => '24',
                'repeat' => undef,
                'scale' => '0.1',
                'type' => 'U4',
                'unit' => 'mm'
              }
            ],
  'class' => '0x01',
  'code' => 'UBX-NAV-HPPOSECEF',
  'comment' => 'See important comments concerning validity of position given in section Navigation output ﬁlters in Integration manual.',
  'id' => '0x13',
  'length' => '28',
  'ln_bitfield' => 7582,
  'ln_classid' => 7560,
  'ln_comment' => 7556,
  'ln_msg' => 7553,
  'ln_name' => 7554,
  'ln_type' => 7555,
  'name' => 'High precision position solution in ECEF',
  'type' => 'Periodic/polled'
}
, ### UBX-NAV-HPPOSLLH High precision geodetic position solution ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Message version (0x00 for this version)',
                'group' => '',
                'ln_arg' => 7602,
                'name' => 'version',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 7603,
                'name' => 'reserved0',
                'offset' => '1',
                'repeat' => '2',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '0',
                                  'bitfrom' => undef,
                                  'descr' => '1 = Invalid lon, lat, height, hMSL, lonHp, latHp, heightHp and hMSLHp',
                                  'name' => 'invalidLlh',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'Additional ﬂags',
                'group' => '',
                'ln_arg' => 7613,
                'name' => 'flags',
                'offset' => '3',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'GPS time of week of the navigation epoch. See the section iTOW timestamps in Integration manual for details.',
                'group' => '',
                'ln_arg' => 7617,
                'name' => 'iTOW',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'ms'
              },
              {
                'bitfield' => [],
                'descr' => 'Longitude',
                'group' => '',
                'ln_arg' => 7620,
                'name' => 'lon',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '1e-7',
                'type' => 'I4',
                'unit' => 'deg'
              },
              {
                'bitfield' => [],
                'descr' => 'Latitude',
                'group' => '',
                'ln_arg' => 7621,
                'name' => 'lat',
                'offset' => '12',
                'repeat' => undef,
                'scale' => '1e-7',
                'type' => 'I4',
                'unit' => 'deg'
              },
              {
                'bitfield' => [],
                'descr' => 'Height above ellipsoid.',
                'group' => '',
                'ln_arg' => 7622,
                'name' => 'height',
                'offset' => '16',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I4',
                'unit' => 'mm'
              },
              {
                'bitfield' => [],
                'descr' => 'Height above mean sea level',
                'group' => '',
                'ln_arg' => 7623,
                'name' => 'hMSL',
                'offset' => '20',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I4',
                'unit' => 'mm'
              },
              {
                'bitfield' => [],
                'descr' => 'High precision component of longitude. Must be in the range -99..+99. Precise longitude in deg * 1e-7 = lon + (lonHp * 1e-2).',
                'group' => '',
                'ln_arg' => 7624,
                'name' => 'lonHp',
                'offset' => '24',
                'repeat' => undef,
                'scale' => '1e-9',
                'type' => 'I1',
                'unit' => 'deg'
              },
              {
                'bitfield' => [],
                'descr' => 'High precision component of latitude. Must be in the range -99..+99. Precise latitude in deg * 1e-7 = lat + (latHp * 1e-2).',
                'group' => '',
                'ln_arg' => 7627,
                'name' => 'latHp',
                'offset' => '25',
                'repeat' => undef,
                'scale' => '1e-9',
                'type' => 'I1',
                'unit' => 'deg'
              },
              {
                'bitfield' => [],
                'descr' => 'High precision component of height above ellipsoid. Must be in the range -9..+9. Precise height in mm = height + (heightHp * 0.1).',
                'group' => '',
                'ln_arg' => 7630,
                'name' => 'heightHp',
                'offset' => '26',
                'repeat' => undef,
                'scale' => '0.1',
                'type' => 'I1',
                'unit' => 'mm'
              },
              {
                'bitfield' => [],
                'descr' => 'High precision component of height above mean sea level. Must be in range -9..+9. Precise height in mm = hMSL + (hMSLHp * 0.1)',
                'group' => '',
                'ln_arg' => 7633,
                'name' => 'hMSLHp',
                'offset' => '27',
                'repeat' => undef,
                'scale' => '0.1',
                'type' => 'I1',
                'unit' => 'mm'
              },
              {
                'bitfield' => [],
                'descr' => 'Horizontal accuracy estimate',
                'group' => '',
                'ln_arg' => 7636,
                'name' => 'hAcc',
                'offset' => '28',
                'repeat' => undef,
                'scale' => '0.1',
                'type' => 'U4',
                'unit' => 'mm'
              },
              {
                'bitfield' => [],
                'descr' => 'Vertical accuracy estimate',
                'group' => '',
                'ln_arg' => 7637,
                'name' => 'vAcc',
                'offset' => '32',
                'repeat' => undef,
                'scale' => '0.1',
                'type' => 'U4',
                'unit' => 'mm'
              }
            ],
  'class' => '0x01',
  'code' => 'UBX-NAV-HPPOSLLH',
  'comment' => 'See important comments concerning validity of position given in section Navigation output ﬁlters in Integration manual. This message outputs the Geodetic position in the currently selected ellipsoid. The default is the WGS84 Ellipsoid, but can be changed with the message CFG-NAVSPG-USE_USRDAT.',
  'id' => '0x14',
  'length' => '36',
  'ln_bitfield' => 7615,
  'ln_classid' => 7599,
  'ln_comment' => 7593,
  'ln_msg' => 7590,
  'ln_name' => 7591,
  'ln_type' => 7592,
  'name' => 'High precision geodetic position solution',
  'type' => 'Periodic/polled'
}
, ### UBX-NAV-ODO Odometer solution ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Message version (0x00 for this version)',
                'group' => '',
                'ln_arg' => 7654,
                'name' => 'version',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 7655,
                'name' => 'reserved0',
                'offset' => '1',
                'repeat' => '3',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'GPS time of week of the navigation epoch. See the section iTOW timestamps in Integration manual for details.',
                'group' => '',
                'ln_arg' => 7656,
                'name' => 'iTOW',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'ms'
              },
              {
                'bitfield' => [],
                'descr' => 'Ground distance since last reset',
                'group' => '',
                'ln_arg' => 7659,
                'name' => 'distance',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'm'
              },
              {
                'bitfield' => [],
                'descr' => 'Total cumulative ground distance',
                'group' => '',
                'ln_arg' => 7660,
                'name' => 'totalDistance',
                'offset' => '12',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'm'
              },
              {
                'bitfield' => [],
                'descr' => 'Ground distance accuracy (1-sigma)',
                'group' => '',
                'ln_arg' => 7661,
                'name' => 'distanceStd',
                'offset' => '16',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'm'
              }
            ],
  'class' => '0x01',
  'code' => 'UBX-NAV-ODO',
  'comment' => 'This message outputs the traveled distance since last reset (see UBX-NAV-RESETODO) together with an associated estimated accuracy and the total cumulated ground distance (can only be reset by a cold start of the receiver).',
  'id' => '0x09',
  'length' => '20',
  'ln_classid' => 7651,
  'ln_comment' => 7646,
  'ln_msg' => 7643,
  'ln_name' => 7644,
  'ln_type' => 7645,
  'name' => 'Odometer solution',
  'type' => 'Periodic/polled'
}
, ### UBX-NAV-ORB GNSS orbit database info ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'GPS time of week of the navigation epoch. See the section iTOW timestamps in Integration manual for details.',
                'group' => '',
                'ln_arg' => 7683,
                'name' => 'iTOW',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'ms'
              },
              {
                'bitfield' => [],
                'descr' => 'Message version (0x01 for this version)',
                'group' => '',
                'ln_arg' => 7686,
                'name' => 'version',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Number of SVs in the database',
                'group' => '',
                'ln_arg' => 7687,
                'name' => 'numSv',
                'offset' => '5',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 7688,
                'name' => 'reserved0',
                'offset' => '6',
                'repeat' => '2',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'GNSS ID',
                'group' => 'repeated numSv',
                'ln_arg' => 7691,
                'name' => 'gnssId',
                'offset' => '8 + n·6',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Satellite ID',
                'group' => 'repeated numSv',
                'ln_arg' => 7692,
                'name' => 'svId',
                'offset' => '9 + n·6',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '1',
                                  'bitfrom' => '0',
                                  'descr' => 'SV health:
•   0 = unknown
•   1 = healthy
•   2 = not healty',
                                  'name' => 'health',
                                  'numbits' => '2'
                                },
                                {
                                  'bit' => '3',
                                  'bitfrom' => '2',
                                  'descr' => 'SV health:
•   0 = unknown
•   1 = below horizon
•   2 = above horizon
•   3 = above elevation mask',
                                  'name' => 'visibility',
                                  'numbits' => '2'
                                }
                              ],
                'descr' => 'Information Flags',
                'group' => 'repeated numSv',
                'ln_arg' => 7693,
                'name' => 'svFlag',
                'offset' => '10 + n·6',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X1',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '4',
                                  'bitfrom' => '0',
                                  'descr' => 'How long the receiver will be able to use the stored ephemeris data from now on:
•   31 = The usability period is unknown
•   30 = The usability period is more than 450 minutes
•   30 > n > 0 = The usability period is between (n-1)*15 and n*15 minutes
•   0 = Ephemeris can no longer be used',
                                  'name' => 'ephUsability',
                                  'numbits' => '5'
                                },
                                {
                                  'bit' => '7',
                                  'bitfrom' => '5',
                                  'descr' => '•   0 = not available
•   1 = GNSS transmission
•   2 = external aiding
•   3-7 = other',
                                  'name' => 'ephSource',
                                  'numbits' => '3'
                                }
                              ],
                'descr' => 'Ephemeris data',
                'group' => 'repeated numSv',
                'ln_arg' => 7704,
                'name' => 'eph',
                'offset' => '11 + n·6',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X1',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '4',
                                  'bitfrom' => '0',
                                  'descr' => 'How long the receiver will be able to use the stored almanac data from now on:
•   31 = The usability period is unknown
•   30 = The usability period is more than 30 days
•   30 > n > 0 = The usability period is between n-1 and n days
•   0 = Almanac can no longer be used',
                                  'name' => 'almUsability',
                                  'numbits' => '5'
                                },
                                {
                                  'bit' => '7',
                                  'bitfrom' => '5',
                                  'descr' => '•   0 = not available
•   1 = GNSS transmission
•   2 = external aiding
•   3-7 = other',
                                  'name' => 'almSource',
                                  'numbits' => '3'
                                }
                              ],
                'descr' => 'Almanac data',
                'group' => 'repeated numSv',
                'ln_arg' => 7718,
                'name' => 'alm',
                'offset' => '12 + n·6',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X1',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '4',
                                  'bitfrom' => '0',
                                  'descr' => 'How long the receiver will be able to use the orbit data now on:
•   31 = The usability period is unknown
•   30 = The usability period is more than 30 days
•   30 > n > 0 = The usability period is between n-1 and n days
•   0 = Data can no longer be used',
                                  'name' => 'anoAopUsability',
                                  'numbits' => '5',
                                  'unit' => 'from'
                                },
                                {
                                  'bit' => '7',
                                  'bitfrom' => '5',
                                  'descr' => 'Type of orbit data:
•   0 = No orbit data available
•   1 = AssistNow Oﬄine data
•   2 = AssistNow Autonomous data
•   3-7 = Other orbit data',
                                  'name' => 'type',
                                  'numbits' => '3'
                                }
                              ],
                'descr' => 'Other orbit data available',
                'group' => 'repeated numSv',
                'ln_arg' => 7740,
                'name' => 'otherOrb',
                'offset' => '13 + n·6',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X1',
                'unit' => '-'
              }
            ],
  'class' => '0x01',
  'code' => 'UBX-NAV-ORB',
  'comment' => 'Status of the GNSS orbit database knowledge.',
  'hasgroup' => 'repeated numSv',
  'id' => '0x34',
  'length' => '8 + numSv·6',
  'ln_bitfield' => 7749,
  'ln_classid' => 7680,
  'ln_comment' => 7677,
  'ln_msg' => 7674,
  'ln_name' => 7675,
  'ln_type' => 7676,
  'name' => 'GNSS orbit database info',
  'type' => 'Periodic/polled'
}
, ### UBX-NAV-POSECEF Position solution in ECEF ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'GPS time of week of the navigation epoch. See the section iTOW timestamps in Integration manual for details.',
                'group' => '',
                'ln_arg' => 7770,
                'name' => 'iTOW',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'ms'
              },
              {
                'bitfield' => [],
                'descr' => 'ECEF X coordinate',
                'group' => '',
                'ln_arg' => 7773,
                'name' => 'ecefX',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I4',
                'unit' => 'cm'
              },
              {
                'bitfield' => [],
                'descr' => 'ECEF Y coordinate',
                'group' => '',
                'ln_arg' => 7774,
                'name' => 'ecefY',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I4',
                'unit' => 'cm'
              },
              {
                'bitfield' => [],
                'descr' => 'ECEF Z coordinate',
                'group' => '',
                'ln_arg' => 7775,
                'name' => 'ecefZ',
                'offset' => '12',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I4',
                'unit' => 'cm'
              },
              {
                'bitfield' => [],
                'descr' => 'Position Accuracy Estimate',
                'group' => '',
                'ln_arg' => 7776,
                'name' => 'pAcc',
                'offset' => '16',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'cm'
              }
            ],
  'class' => '0x01',
  'code' => 'UBX-NAV-POSECEF',
  'comment' => 'See important comments concerning validity of position given in section Navigation output ﬁlters in Integration manual.',
  'id' => '0x01',
  'length' => '20',
  'ln_classid' => 7767,
  'ln_comment' => 7763,
  'ln_msg' => 7760,
  'ln_name' => 7761,
  'ln_type' => 7762,
  'name' => 'Position solution in ECEF',
  'type' => 'Periodic/polled'
}
, ### UBX-NAV-POSLLH Geodetic position solution ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'GPS time of week of the navigation epoch. See the section iTOW timestamps in Integration manual for details.',
                'group' => '',
                'ln_arg' => 7804,
                'name' => 'iTOW',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'ms'
              },
              {
                'bitfield' => [],
                'descr' => 'Longitude',
                'group' => '',
                'ln_arg' => 7807,
                'name' => 'lon',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '1e-7',
                'type' => 'I4',
                'unit' => 'deg'
              },
              {
                'bitfield' => [],
                'descr' => 'Latitude',
                'group' => '',
                'ln_arg' => 7808,
                'name' => 'lat',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '1e-7',
                'type' => 'I4',
                'unit' => 'deg'
              },
              {
                'bitfield' => [],
                'descr' => 'Height above ellipsoid',
                'group' => '',
                'ln_arg' => 7809,
                'name' => 'height',
                'offset' => '12',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I4',
                'unit' => 'mm'
              },
              {
                'bitfield' => [],
                'descr' => 'Height above mean sea level',
                'group' => '',
                'ln_arg' => 7810,
                'name' => 'hMSL',
                'offset' => '16',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I4',
                'unit' => 'mm'
              },
              {
                'bitfield' => [],
                'descr' => 'Horizontal accuracy estimate',
                'group' => '',
                'ln_arg' => 7811,
                'name' => 'hAcc',
                'offset' => '20',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'mm'
              },
              {
                'bitfield' => [],
                'descr' => 'Vertical accuracy estimate',
                'group' => '',
                'ln_arg' => 7812,
                'name' => 'vAcc',
                'offset' => '24',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'mm'
              }
            ],
  'class' => '0x01',
  'code' => 'UBX-NAV-POSLLH',
  'comment' => 'See important comments concerning validity of position given in section Navigation output ﬁlters in Integration manual. This message outputs the Geodetic position in the currently selected ellipsoid. The default is the WGS84 Ellipsoid, but can be changed with the message CFG-NAVSPG-USE_USRDAT.',
  'id' => '0x02',
  'length' => '28',
  'ln_classid' => 7801,
  'ln_comment' => 7785,
  'ln_msg' => 7782,
  'ln_name' => 7783,
  'ln_type' => 7784,
  'name' => 'Geodetic position solution',
  'type' => 'Periodic/polled'
}
, ### UBX-NAV-PVT Navigation position velocity time solution ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'GPS time of week of the navigation epoch. See the section iTOW timestamps in Integration manual for details.',
                'group' => '',
                'ln_arg' => 7829,
                'name' => 'iTOW',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'ms'
              },
              {
                'bitfield' => [],
                'descr' => 'Year (UTC)',
                'group' => '',
                'ln_arg' => 7832,
                'name' => 'year',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => 'y'
              },
              {
                'bitfield' => [],
                'descr' => 'Month, range 1..12 (UTC)',
                'group' => '',
                'ln_arg' => 7833,
                'name' => 'month',
                'offset' => '6',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => 'month'
              },
              {
                'bitfield' => [],
                'descr' => 'Day of month, range 1..31 (UTC)',
                'group' => '',
                'ln_arg' => 7834,
                'name' => 'day',
                'offset' => '7',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => 'd'
              },
              {
                'bitfield' => [],
                'descr' => 'Hour of day, range 0..23 (UTC)',
                'group' => '',
                'ln_arg' => 7835,
                'name' => 'hour',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => 'h'
              },
              {
                'bitfield' => [],
                'descr' => 'Minute of hour, range 0..59 (UTC)',
                'group' => '',
                'ln_arg' => 7836,
                'name' => 'min',
                'offset' => '9',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => 'min'
              },
              {
                'bitfield' => [],
                'descr' => 'Seconds of minute, range 0..60 (UTC)',
                'group' => '',
                'ln_arg' => 7837,
                'name' => 'sec',
                'offset' => '10',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => 's'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '0',
                                  'bitfrom' => undef,
                                  'descr' => '1 = valid UTC Date (see section Time validity in Integration manual for details)',
                                  'name' => 'validDate',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '1',
                                  'bitfrom' => undef,
                                  'descr' => '1 = valid UTC time of day (see section Time validity in Integration manual for details)',
                                  'name' => 'validTime',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '2',
                                  'bitfrom' => undef,
                                  'descr' => '1 = UTC time of day has been fully resolved (no seconds uncertainty). Cannot be used to check if time is completely solved.',
                                  'name' => 'fullyResolved',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '3',
                                  'bitfrom' => undef,
                                  'descr' => '1 = valid magnetic declination',
                                  'name' => 'validMag',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'Validity ﬂags',
                'group' => '',
                'ln_arg' => 7838,
                'name' => 'valid',
                'offset' => '11',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Time accuracy estimate (UTC)',
                'group' => '',
                'ln_arg' => 7848,
                'name' => 'tAcc',
                'offset' => '12',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'ns'
              },
              {
                'bitfield' => [],
                'descr' => 'Fraction of second, range -1e9 .. 1e9 (UTC)',
                'group' => '',
                'ln_arg' => 7859,
                'name' => 'nano',
                'offset' => '16',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I4',
                'unit' => 'ns'
              },
              {
                'bitfield' => [],
                'descr' => 'GNSSﬁx Type:
•   0 = no ﬁx
•   1 = dead reckoning only
•   2 = 2D-ﬁx
•   3 = 3D-ﬁx
•   4 = GNSS + dead reckoning combined
•   5 = time only ﬁx',
                'group' => '',
                'ln_arg' => 7860,
                'name' => 'fixType',
                'offset' => '20',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '0',
                                  'bitfrom' => undef,
                                  'descr' => '1 = valid ﬁx (i.e within DOP & accuracy masks)',
                                  'name' => 'gnssFixOK',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '1',
                                  'bitfrom' => undef,
                                  'descr' => '1 = diﬀerential corrections were applied',
                                  'name' => 'diffSoln',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '4',
                                  'bitfrom' => '2',
                                  'descr' => 'Power save mode state (see Power management section in Integration Manual for details.
•   0 = PSM is not active
•   1 = Enabled (an intermediate state before Acquisition state
•   2 = Acquisition
•   3 = Tracking
•   4 = Power Optimized Tracking
•   5 = Inactive',
                                  'name' => 'psmState',
                                  'numbits' => '3'
                                },
                                {
                                  'bit' => '5',
                                  'bitfrom' => undef,
                                  'descr' => '1 = heading of vehicle is valid, only set if the receiver is in sensor fusion mode',
                                  'name' => 'headVehValid',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '7',
                                  'bitfrom' => '6',
                                  'descr' => 'Carrier phase range solution status:
•   0 = no carrier phase range solution
•   1 = carrier phase range solution with ﬂoating ambiguities
•   2 = carrier phase range solution with ﬁxed ambiguities (not supported for protocol versions less than 20.00)',
                                  'name' => 'carrSoln',
                                  'numbits' => '2'
                                }
                              ],
                'descr' => 'Fix status ﬂags',
                'group' => '',
                'ln_arg' => 7867,
                'name' => 'flags',
                'offset' => '21',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X1',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '5',
                                  'bitfrom' => undef,
                                  'descr' => '1 = information about UTC Date and Time of Day validity conﬁrmation is available (see section Time validity in Integration manual for details) This ﬂag is only supported in Protocol Versions 19.00, 19.10, 20.10, 20.20, 20.30, 22.00, 23.00, 23.01, 27 and 28.',
                                  'name' => 'confirmedAvai',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '6',
                                  'bitfrom' => undef,
                                  'descr' => '1 = UTC Date validity could be conﬁrmed (see section Time validity in Integration manual for details)',
                                  'name' => 'confirmedDate',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '7',
                                  'bitfrom' => undef,
                                  'descr' => '1 = UTC Time of Day could be conﬁrmed (see section Time validity in Integration manual for details)',
                                  'name' => 'confirmedTime',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'Additional ﬂags',
                'group' => '',
                'ln_arg' => 7891,
                'name' => 'flags2',
                'offset' => '22',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Number of satellites used in Nav Solution',
                'group' => '',
                'ln_arg' => 7904,
                'name' => 'numSV',
                'offset' => '23',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Longitude',
                'group' => '',
                'ln_arg' => 7905,
                'name' => 'lon',
                'offset' => '24',
                'repeat' => undef,
                'scale' => '1e-7',
                'type' => 'I4',
                'unit' => 'deg'
              },
              {
                'bitfield' => [],
                'descr' => 'Latitude',
                'group' => '',
                'ln_arg' => 7906,
                'name' => 'lat',
                'offset' => '28',
                'repeat' => undef,
                'scale' => '1e-7',
                'type' => 'I4',
                'unit' => 'deg'
              },
              {
                'bitfield' => [],
                'descr' => 'Height above ellipsoid',
                'group' => '',
                'ln_arg' => 7907,
                'name' => 'height',
                'offset' => '32',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I4',
                'unit' => 'mm'
              },
              {
                'bitfield' => [],
                'descr' => 'Height above mean sea level',
                'group' => '',
                'ln_arg' => 7908,
                'name' => 'hMSL',
                'offset' => '36',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I4',
                'unit' => 'mm'
              },
              {
                'bitfield' => [],
                'descr' => 'Horizontal accuracy estimate',
                'group' => '',
                'ln_arg' => 7909,
                'name' => 'hAcc',
                'offset' => '40',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'mm'
              },
              {
                'bitfield' => [],
                'descr' => 'Vertical accuracy estimate',
                'group' => '',
                'ln_arg' => 7910,
                'name' => 'vAcc',
                'offset' => '44',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'mm'
              },
              {
                'bitfield' => [],
                'descr' => 'NED north velocity',
                'group' => '',
                'ln_arg' => 7911,
                'name' => 'velN',
                'offset' => '48',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I4',
                'unit' => 'mm/s'
              },
              {
                'bitfield' => [],
                'descr' => 'NED east velocity',
                'group' => '',
                'ln_arg' => 7912,
                'name' => 'velE',
                'offset' => '52',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I4',
                'unit' => 'mm/s'
              },
              {
                'bitfield' => [],
                'descr' => 'NED down velocity',
                'group' => '',
                'ln_arg' => 7913,
                'name' => 'velD',
                'offset' => '56',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I4',
                'unit' => 'mm/s'
              },
              {
                'bitfield' => [],
                'descr' => 'Ground Speed (2-D)',
                'group' => '',
                'ln_arg' => 7924,
                'name' => 'gSpeed',
                'offset' => '60',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I4',
                'unit' => 'mm/s'
              },
              {
                'bitfield' => [],
                'descr' => 'Heading of motion (2-D)',
                'group' => '',
                'ln_arg' => 7925,
                'name' => 'headMot',
                'offset' => '64',
                'repeat' => undef,
                'scale' => '1e-5',
                'type' => 'I4',
                'unit' => 'deg'
              },
              {
                'bitfield' => [],
                'descr' => 'Speed accuracy estimate',
                'group' => '',
                'ln_arg' => 7926,
                'name' => 'sAcc',
                'offset' => '68',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'mm/s'
              },
              {
                'bitfield' => [],
                'descr' => 'Heading accuracy estimate (both motion and vehicle)',
                'group' => '',
                'ln_arg' => 7927,
                'name' => 'headAcc',
                'offset' => '72',
                'repeat' => undef,
                'scale' => '1e-5',
                'type' => 'U4',
                'unit' => 'deg'
              },
              {
                'bitfield' => [],
                'descr' => 'Position DOP',
                'group' => '',
                'ln_arg' => 7928,
                'name' => 'pDOP',
                'offset' => '76',
                'repeat' => undef,
                'scale' => '0.01',
                'type' => 'U2',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '0',
                                  'bitfrom' => undef,
                                  'descr' => '1 = Invalid lon, lat, height and hMSL',
                                  'name' => 'invalidLlh',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'Additional ﬂags',
                'group' => '',
                'ln_arg' => 7929,
                'name' => 'flags3',
                'offset' => '78',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 7932,
                'name' => 'reserved0',
                'offset' => '79',
                'repeat' => '5',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Heading of vehicle (2-D), this is only valid when headVehValid is set, otherwise the output is set to the heading of motion',
                'group' => '',
                'ln_arg' => 7933,
                'name' => 'headVeh',
                'offset' => '84',
                'repeat' => undef,
                'scale' => '1e-5',
                'type' => 'I4',
                'unit' => 'deg'
              },
              {
                'bitfield' => [],
                'descr' => 'Magnetic declination. Only supported in ADR 4.10 and later.',
                'group' => '',
                'ln_arg' => 7936,
                'name' => 'magDec',
                'offset' => '88',
                'repeat' => undef,
                'scale' => '1e-2',
                'type' => 'I2',
                'unit' => 'deg'
              },
              {
                'bitfield' => [],
                'descr' => 'Magnetic declination accuracy. Only supported in ADR 4.10 and later.',
                'group' => '',
                'ln_arg' => 7938,
                'name' => 'magAcc',
                'offset' => '90',
                'repeat' => undef,
                'scale' => '1e-2',
                'type' => 'U2',
                'unit' => 'deg'
              }
            ],
  'class' => '0x01',
  'code' => 'UBX-NAV-PVT',
  'comment' => 'This message combines position, velocity and time solution, including accuracy ﬁgures. Note that during a leap second there may be more or less than 60 seconds in a minute. See the description of leap seconds in the Integration manual for details.',
  'id' => '0x07',
  'length' => '92',
  'ln_bitfield' => 7931,
  'ln_classid' => 7826,
  'ln_comment' => 7821,
  'ln_msg' => 7818,
  'ln_name' => 7819,
  'ln_type' => 7820,
  'name' => 'Navigation position velocity time solution',
  'type' => 'Periodic/polled'
}
, ### UBX-NAV-RELPOSNED Relative positioning information in NED frame ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Message version (0x01 for this version)',
                'group' => '',
                'ln_arg' => 7958,
                'name' => 'version',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 7959,
                'name' => 'reserved0',
                'offset' => '1',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reference station ID. Must be in the range 0..4095.',
                'group' => '',
                'ln_arg' => 7960,
                'name' => 'refStationId',
                'offset' => '2',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'GPS time of week of the navigation epoch. See the section iTOW timestamps in Integration manual for details.',
                'group' => '',
                'ln_arg' => 7961,
                'name' => 'iTOW',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'ms'
              },
              {
                'bitfield' => [],
                'descr' => 'North component of relative position vector',
                'group' => '',
                'ln_arg' => 7964,
                'name' => 'relPosN',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I4',
                'unit' => 'cm'
              },
              {
                'bitfield' => [],
                'descr' => 'East component of relative position vector',
                'group' => '',
                'ln_arg' => 7965,
                'name' => 'relPosE',
                'offset' => '12',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I4',
                'unit' => 'cm'
              },
              {
                'bitfield' => [],
                'descr' => 'Down component of relative position vector',
                'group' => '',
                'ln_arg' => 7966,
                'name' => 'relPosD',
                'offset' => '16',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I4',
                'unit' => 'cm'
              },
              {
                'bitfield' => [],
                'descr' => 'Length of the relative position vector',
                'group' => '',
                'ln_arg' => 7967,
                'name' => 'relPosLength',
                'offset' => '20',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I4',
                'unit' => 'cm'
              },
              {
                'bitfield' => [],
                'descr' => 'Heading of the relative position vector',
                'group' => '',
                'ln_arg' => 7968,
                'name' => 'relPosHeading',
                'offset' => '24',
                'repeat' => undef,
                'scale' => '1e-5',
                'type' => 'I4',
                'unit' => 'deg'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 7969,
                'name' => 'reserved1',
                'offset' => '28',
                'repeat' => '4',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'High-precision North component of relative position vector. Must be in the range -99 to +99. The full North component of the relative position vector, in units of cm, is given by relPosN + (relPosHPN * 1e-2)',
                'group' => '',
                'ln_arg' => 7980,
                'name' => 'relPosHPN',
                'offset' => '32',
                'repeat' => undef,
                'scale' => '0.1',
                'type' => 'I1',
                'unit' => 'mm'
              },
              {
                'bitfield' => [],
                'descr' => 'High-precision East component of relative position vector. Must be in the range -99 to +99. The full East component of the relative position vector, in units of cm, is given by relPosE + (relPosHPE * 1e-2)',
                'group' => '',
                'ln_arg' => 7986,
                'name' => 'relPosHPE',
                'offset' => '33',
                'repeat' => undef,
                'scale' => '0.1',
                'type' => 'I1',
                'unit' => 'mm'
              },
              {
                'bitfield' => [],
                'descr' => 'High-precision Down component of relative position vector. Must be in the range -99 to +99. The full Down component of the relative position vector, in units of cm, is given by relPosD + (relPosHPD * 1e-2)',
                'group' => '',
                'ln_arg' => 7992,
                'name' => 'relPosHPD',
                'offset' => '34',
                'repeat' => undef,
                'scale' => '0.1',
                'type' => 'I1',
                'unit' => 'mm'
              },
              {
                'bitfield' => [],
                'descr' => 'High-precision component of the length of the relative vector. Must be in the range -99 to +99. The full length of the relative position vector, in units of cm, is given by relPosLength + (relPosHPLength * 1e-2)',
                'group' => '',
                'ln_arg' => 7998,
                'name' => 'relPosHPLength',
                'offset' => '35',
                'repeat' => undef,
                'scale' => '0.1',
                'type' => 'I1',
                'unit' => 'mmposition'
              },
              {
                'bitfield' => [],
                'descr' => 'Accuracy of relative position North component',
                'group' => '',
                'ln_arg' => 8004,
                'name' => 'accN',
                'offset' => '36',
                'repeat' => undef,
                'scale' => '0.1',
                'type' => 'U4',
                'unit' => 'mm'
              },
              {
                'bitfield' => [],
                'descr' => 'Accuracy of relative position East component',
                'group' => '',
                'ln_arg' => 8005,
                'name' => 'accE',
                'offset' => '40',
                'repeat' => undef,
                'scale' => '0.1',
                'type' => 'U4',
                'unit' => 'mm'
              },
              {
                'bitfield' => [],
                'descr' => 'Accuracy of relative position Down component',
                'group' => '',
                'ln_arg' => 8006,
                'name' => 'accD',
                'offset' => '44',
                'repeat' => undef,
                'scale' => '0.1',
                'type' => 'U4',
                'unit' => 'mm'
              },
              {
                'bitfield' => [],
                'descr' => 'Accuracy of length of the relative position vector',
                'group' => '',
                'ln_arg' => 8007,
                'name' => 'accLength',
                'offset' => '48',
                'repeat' => undef,
                'scale' => '0.1',
                'type' => 'U4',
                'unit' => 'mm'
              },
              {
                'bitfield' => [],
                'descr' => 'Accuracy of heading of the relative position vector',
                'group' => '',
                'ln_arg' => 8008,
                'name' => 'accHeading',
                'offset' => '52',
                'repeat' => undef,
                'scale' => '1e-5',
                'type' => 'U4',
                'unit' => 'deg'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 8009,
                'name' => 'reserved2',
                'offset' => '56',
                'repeat' => '4',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '0',
                                  'bitfrom' => undef,
                                  'descr' => 'A valid ﬁx (i.e within DOP & accuracy masks)',
                                  'name' => 'gnssFixOK',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '1',
                                  'bitfrom' => undef,
                                  'descr' => '1 if diﬀerential corrections were applied',
                                  'name' => 'diffSoln',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '2',
                                  'bitfrom' => undef,
                                  'descr' => '1 if relative position components and accuracies are valid and, in moving base mode only, if baseline is valid',
                                  'name' => 'relPosValid',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '4',
                                  'bitfrom' => '3',
                                  'descr' => 'Carrier phase range solution status:
•   0 = no carrier phase range solution
•   1 = carrier phase range solution with ﬂoating ambiguities
•   2 = carrier phase range solution with ﬁxed ambiguities',
                                  'name' => 'carrSoln',
                                  'numbits' => '2'
                                },
                                {
                                  'bit' => '5',
                                  'bitfrom' => undef,
                                  'descr' => '1 if the receiver is operating in moving base mode',
                                  'name' => 'isMoving',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '6',
                                  'bitfrom' => undef,
                                  'descr' => '1 if extrapolated reference position was used to compute moving base solution this epoch. (Flag set for protocol versions 27.10, and 27.11, and 31.11)',
                                  'name' => 'refPosMiss',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '7',
                                  'bitfrom' => undef,
                                  'descr' => '1 if extrapolated reference observations were used to compute moving base solution this epoch. (Flag set for protocol versions 27.10, and 27.11, and 31.11)',
                                  'name' => 'refObsMiss',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '8',
                                  'bitfrom' => undef,
                                  'descr' => '1 if relPosHeading is valid',
                                  'name' => 'relPosHeadingValid',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '9',
                                  'bitfrom' => undef,
                                  'descr' => '1 if the components of the relative position vector the high-precision parts) are normalized',
                                  'name' => 'relPosNormalized',
                                  'numbits' => '1',
                                  'unit' => '(including'
                                }
                              ],
                'descr' => 'Flags',
                'group' => '',
                'ln_arg' => 8010,
                'name' => 'flags',
                'offset' => '60',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X4',
                'unit' => '-'
              }
            ],
  'class' => '0x01',
  'code' => 'UBX-NAV-RELPOSNED',
  'comment' => 'This message contains the relative position vector from the reference station to the rover, including accuracy ﬁgures, in the local topological system deﬁned at the reference station. ☞ The NED frame is deﬁned as the local topological system at the reference station. The relative position vector components in this message, along with their associated accuracies, are given in that local topological system.',
  'id' => '0x3c',
  'length' => '64',
  'ln_bitfield' => 8044,
  'ln_classid' => 7955,
  'ln_comment' => 7948,
  'ln_msg' => 7945,
  'ln_name' => 7946,
  'ln_type' => 7947,
  'name' => 'Relative positioning information in NED frame',
  'type' => 'Periodic/polled'
}
, ### UBX-NAV-RESETODO Reset odometer ###
{
  'args' => [],
  'class' => '0x01',
  'code' => 'UBX-NAV-RESETODO',
  'comment' => 'This message resets the traveled distance computed by the odometer (see UBX-NAV-ODO). UBX-ACK-ACK or UBX-ACK-NAK are returned to indicate success or failure.',
  'id' => '0x10',
  'length' => '0',
  'ln_classid' => 8058,
  'ln_comment' => 8054,
  'ln_msg' => 8051,
  'ln_name' => 8052,
  'ln_type' => 8053,
  'name' => 'Reset odometer',
  'type' => 'Command'
}
, ### UBX-NAV-SAT Satellite information ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'GPS time of week of the navigation epoch. See the section iTOW timestamps in Integration manual for details.',
                'group' => '',
                'ln_arg' => 8075,
                'name' => 'iTOW',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'ms'
              },
              {
                'bitfield' => [],
                'descr' => 'Message version (0x01 for this version)',
                'group' => '',
                'ln_arg' => 8078,
                'name' => 'version',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Number of satellites',
                'group' => '',
                'ln_arg' => 8079,
                'name' => 'numSvs',
                'offset' => '5',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 8080,
                'name' => 'reserved0',
                'offset' => '6',
                'repeat' => '2',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'GNSS identiﬁer      (see    Satellite   Numbering)   for assignment',
                'group' => 'repeated numSvs',
                'ln_arg' => 8083,
                'name' => 'gnssId',
                'offset' => '8 + n·12',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Satellite identiﬁer (see Satellite Numbering) for assignment',
                'group' => 'repeated numSvs',
                'ln_arg' => 8085,
                'name' => 'svId',
                'offset' => '9 + n·12',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Carrier to noise ratio (signal strength)',
                'group' => 'repeated numSvs',
                'ln_arg' => 8087,
                'name' => 'cno',
                'offset' => '10 + n·12',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => 'dBHz'
              },
              {
                'bitfield' => [],
                'descr' => 'Elevation (range: +/-90), unknown if out of range',
                'group' => 'repeated numSvs',
                'ln_arg' => 8088,
                'name' => 'elev',
                'offset' => '11 + n·12',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I1',
                'unit' => 'deg'
              },
              {
                'bitfield' => [],
                'descr' => 'Azimuth (range 0-360), unknown if elevation is out of range',
                'group' => 'repeated numSvs',
                'ln_arg' => 8089,
                'name' => 'azim',
                'offset' => '12 + n·12',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I2',
                'unit' => 'deg'
              },
              {
                'bitfield' => [],
                'descr' => 'Pseudorange residual',
                'group' => 'repeated numSvs',
                'ln_arg' => 8091,
                'name' => 'prRes',
                'offset' => '14 + n·12',
                'repeat' => undef,
                'scale' => '0.1',
                'type' => 'I2',
                'unit' => 'm'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '2',
                                  'bitfrom' => '0',
                                  'descr' => 'Signal quality indicator:
•   0 = no signal
•   1 = searching signal
•   2 = signal acquired
•   3 = signal detected but unusable
•   4 = code locked and time synchronized
•   5, 6, 7 = code and carrier locked and time synchronized',
                                  'name' => 'qualityInd',
                                  'numbits' => '3'
                                },
                                {
                                  'bit' => '3',
                                  'bitfrom' => undef,
                                  'descr' => '1 = Signal in the subset speciﬁed in Signal Identiﬁers is currently being used for navigation',
                                  'name' => 'svUsed',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '5',
                                  'bitfrom' => '4',
                                  'descr' => 'Signal health ﬂag:
•   0 = unknown
•   1 = healthy
•   2 = unhealthy',
                                  'name' => 'health',
                                  'numbits' => '2'
                                },
                                {
                                  'bit' => '6',
                                  'bitfrom' => undef,
                                  'descr' => '1 = diﬀerential correction data is available for this SV',
                                  'name' => 'diffCorr',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '7',
                                  'bitfrom' => undef,
                                  'descr' => '1 = carrier smoothed pseudorange used',
                                  'name' => 'smoothed',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '10',
                                  'bitfrom' => '8',
                                  'descr' => 'Orbit source:
•   0 = no orbit information is available for this SV
•   1 = ephemeris is used
•   2 = almanac is used
•   3 = AssistNow Oﬄine orbit is used
•   4 = AssistNow Autonomous orbit is used
•   5, 6, 7 = other orbit information is used',
                                  'name' => 'orbitSource',
                                  'numbits' => '3'
                                },
                                {
                                  'bit' => '11',
                                  'bitfrom' => undef,
                                  'descr' => '1 = ephemeris is available for this SV',
                                  'name' => 'ephAvail',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '12',
                                  'bitfrom' => undef,
                                  'descr' => '1 = almanac is available for this SV',
                                  'name' => 'almAvail',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '13',
                                  'bitfrom' => undef,
                                  'descr' => '1 = AssistNow Oﬄine data is available for this SV',
                                  'name' => 'anoAvail',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '14',
                                  'bitfrom' => undef,
                                  'descr' => '1 = AssistNow Autonomous data is available for this SV',
                                  'name' => 'aopAvail',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '16',
                                  'bitfrom' => undef,
                                  'descr' => '1 = SBAS corrections have been used for a signal in the subset speciﬁed in Signal Identiﬁers',
                                  'name' => 'sbasCorrUsed',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '17',
                                  'bitfrom' => undef,
                                  'descr' => '1 = RTCM corrections have been used for a signal in the subset speciﬁed in Signal Identiﬁers',
                                  'name' => 'rtcmCorrUsed',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '18',
                                  'bitfrom' => undef,
                                  'descr' => '1 = QZSS SLAS corrections have been used for a signal in the subset speciﬁed in Signal Identiﬁers',
                                  'name' => 'slasCorrUsed',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '20',
                                  'bitfrom' => undef,
                                  'descr' => '1 = Pseudorange corrections have been used for a signal in the subset speciﬁed in Signal Identiﬁers',
                                  'name' => 'prCorrUsed',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '21',
                                  'bitfrom' => undef,
                                  'descr' => '1 = Carrier range corrections have been used for a signal in the subset speciﬁed in Signal Identiﬁers',
                                  'name' => 'crCorrUsed',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '22',
                                  'bitfrom' => undef,
                                  'descr' => '1 = Range rate (Doppler) corrections have been used for a signal in the subset speciﬁed in Signal Identiﬁers',
                                  'name' => 'doCorrUsed',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'Bitmask',
                'group' => 'repeated numSvs',
                'ln_arg' => 8092,
                'name' => 'flags',
                'offset' => '16 + n·12',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X4',
                'unit' => '-'
              }
            ],
  'class' => '0x01',
  'code' => 'UBX-NAV-SAT',
  'comment' => 'This message displays information about SVs that are either known to be visible or currently tracked by the receiver. All signal related information corresponds to the subset of signals speciﬁed in Signal Identiﬁers.',
  'hasgroup' => 'repeated numSvs',
  'id' => '0x35',
  'length' => '8 + numSvs·12',
  'ln_bitfield' => 8146,
  'ln_classid' => 8072,
  'ln_comment' => 8068,
  'ln_msg' => 8065,
  'ln_name' => 8066,
  'ln_type' => 8067,
  'name' => 'Satellite information',
  'type' => 'Periodic/polled'
}
, ### UBX-NAV-SBAS SBAS status data ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'GPS time of week of the navigation epoch. See the description of iTOW for details.',
                'group' => '',
                'ln_arg' => 8173,
                'name' => 'iTOW',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'ms'
              },
              {
                'bitfield' => [],
                'descr' => 'PRN Number of the GEO where correction and integrity data is used from',
                'group' => '',
                'ln_arg' => 8175,
                'name' => 'geo',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'SBAS Mode
•   0 Disabled
•   1 Enabled integrity
•   3 Enabled test mode',
                'group' => '',
                'ln_arg' => 8177,
                'name' => 'mode',
                'offset' => '5',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'SBAS System (WAAS/EGNOS/...)
•   -1 Unknown
•   0 WAAS
•   1 EGNOS
•   2 MSAS
•   3 GAGAN
•   16 GPS',
                'group' => '',
                'ln_arg' => 8181,
                'name' => 'sys',
                'offset' => '6',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I1',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '0',
                                  'bitfrom' => undef,
                                  'descr' => 'GEO may be used as ranging source',
                                  'name' => 'Ranging',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '1',
                                  'bitfrom' => undef,
                                  'descr' => 'GEO is providing correction data',
                                  'name' => 'Corrections',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '2',
                                  'bitfrom' => undef,
                                  'descr' => 'GEO is providing integrity',
                                  'name' => 'Integrity',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '3',
                                  'bitfrom' => undef,
                                  'descr' => 'GEO is in test mode',
                                  'name' => 'Testmode',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '4',
                                  'bitfrom' => undef,
                                  'descr' => 'Problem with signal or broadcast data indicated',
                                  'name' => 'Bad',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'SBAS Services available',
                'group' => '',
                'ln_arg' => 8188,
                'name' => 'service',
                'offset' => '7',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Number of SV data following',
                'group' => '',
                'ln_arg' => 8199,
                'name' => 'cnt',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 8200,
                'name' => 'reserved0',
                'offset' => '9',
                'repeat' => '3',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'SV ID',
                'group' => 'repeated cnt',
                'ln_arg' => 8203,
                'name' => 'svid',
                'offset' => '12 + n·12',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Flags for this SV',
                'group' => 'repeated cnt',
                'ln_arg' => 8204,
                'name' => 'flags',
                'offset' => '13 + n·12',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Monitoring status',
                'group' => 'repeated cnt',
                'ln_arg' => 8205,
                'name' => 'udre',
                'offset' => '14 + n·12',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'System (WAAS/EGNOS/...) same as SYS',
                'group' => 'repeated cnt',
                'ln_arg' => 8206,
                'name' => 'svSys',
                'offset' => '15 + n·12',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Services available same as SERVICE',
                'group' => 'repeated cnt',
                'ln_arg' => 8208,
                'name' => 'svService',
                'offset' => '16 + n·12',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => 'repeated cnt',
                'ln_arg' => 8210,
                'name' => 'reserved1',
                'offset' => '17 + n·12',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Pseudo Range correction in [cm]',
                'group' => 'repeated cnt',
                'ln_arg' => 8211,
                'name' => 'prc',
                'offset' => '18 + n·12',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I2',
                'unit' => 'cm'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => 'repeated cnt',
                'ln_arg' => 8212,
                'name' => 'reserved2',
                'offset' => '20 + n·12',
                'repeat' => '2',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Ionosphere correction in [cm]',
                'group' => 'repeated cnt',
                'ln_arg' => 8213,
                'name' => 'ic',
                'offset' => '22 + n·12',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I2',
                'unit' => 'cm'
              }
            ],
  'class' => '0x01',
  'code' => 'UBX-NAV-SBAS',
  'comment' => 'This message outputs the status of the SBAS sub system',
  'hasgroup' => 'repeated cnt',
  'id' => '0x32',
  'length' => '12 + cnt·12',
  'ln_bitfield' => 8198,
  'ln_classid' => 8161,
  'ln_comment' => 8158,
  'ln_msg' => 8155,
  'ln_name' => 8156,
  'ln_type' => 8157,
  'name' => 'SBAS status data',
  'type' => 'Periodic/polled'
}
, ### UBX-NAV-SIG Signal information ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'GPS time of week of the navigation epoch. See the section iTOW timestamps in Integration manual for details.',
                'group' => '',
                'ln_arg' => 8241,
                'name' => 'iTOW',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'ms'
              },
              {
                'bitfield' => [],
                'descr' => 'Message version (0x00 for this version)',
                'group' => '',
                'ln_arg' => 8244,
                'name' => 'version',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Number of signals',
                'group' => '',
                'ln_arg' => 8245,
                'name' => 'numSigs',
                'offset' => '5',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 8246,
                'name' => 'reserved0',
                'offset' => '6',
                'repeat' => '2',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'GNSS identiﬁer        (see   Satellite   Numbering)   for assignment',
                'group' => 'repeated numSigs',
                'ln_arg' => 8249,
                'name' => 'gnssId',
                'offset' => '8 + n·16',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Satellite identiﬁer (see Satellite Numbering) for assignment',
                'group' => 'repeated numSigs',
                'ln_arg' => 8251,
                'name' => 'svId',
                'offset' => '9 + n·16',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'New style signal identiﬁer (see Signal Identiﬁers)',
                'group' => 'repeated numSigs',
                'ln_arg' => 8253,
                'name' => 'sigId',
                'offset' => '10 + n·16',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Only used for GLONASS: This is the frequency slot + 7 (range from 0 to 13)',
                'group' => 'repeated numSigs',
                'ln_arg' => 8254,
                'name' => 'freqId',
                'offset' => '11 + n·16',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Pseudorange residual',
                'group' => 'repeated numSigs',
                'ln_arg' => 8256,
                'name' => 'prRes',
                'offset' => '12 + n·16',
                'repeat' => undef,
                'scale' => '0.1',
                'type' => 'I2',
                'unit' => 'm'
              },
              {
                'bitfield' => [],
                'descr' => 'Carrier-to-noise density ratio (signal strength)',
                'group' => 'repeated numSigs',
                'ln_arg' => 8257,
                'name' => 'cno',
                'offset' => '14 + n·16',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => 'dBHz'
              },
              {
                'bitfield' => [],
                'descr' => 'Signal quality indicator:
•   0 = no signal
•   1 = searching signal
•   2 = signal acquired
•   3 = signal detected but unusable
•   4 = code locked and time synchronized
•   5, 6, 7 = code and carrier locked and time synchronized',
                'group' => 'repeated numSigs',
                'ln_arg' => 8258,
                'name' => 'qualityInd',
                'offset' => '15 + n·16',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Correction source:
•   0 = no corrections
•   1 = SBAS corrections
•   2 = BeiDou corrections
•   3 = RTCM2 corrections
•   4 = RTCM3 OSR corrections
•   5 = RTCM3 SSR corrections
•   6 = QZSS SLAS corrections',
                'group' => 'repeated numSigs',
                'ln_arg' => 8266,
                'name' => 'corrSource',
                'offset' => '16 + n·16',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Ionospheric model used:
•   0 = no model
•   1 = Klobuchar model transmitted by GPS
•   2 = SBAS model
•   3 = Klobuchar model transmitted by BeiDou
•   8 = Iono delay derived from dual frequency observations',
                'group' => 'repeated numSigs',
                'ln_arg' => 8274,
                'name' => 'ionoModel',
                'offset' => '17 + n·16',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '1',
                                  'bitfrom' => '0',
                                  'descr' => 'Signal health ﬂag:
•   0 = unknown
•   1 = healthy
•   2 = unhealthy',
                                  'name' => 'health',
                                  'numbits' => '2'
                                },
                                {
                                  'bit' => '2',
                                  'bitfrom' => undef,
                                  'descr' => '1 = Pseudorange has been smoothed',
                                  'name' => 'prSmoothed',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '3',
                                  'bitfrom' => undef,
                                  'descr' => '1 = Pseudorange has been used for this signal',
                                  'name' => 'prUsed',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '4',
                                  'bitfrom' => undef,
                                  'descr' => '1 = Carrier range has been used for this signal',
                                  'name' => 'crUsed',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '5',
                                  'bitfrom' => undef,
                                  'descr' => '1 = Range rate (Doppler) has been used for this signal',
                                  'name' => 'doUsed',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '6',
                                  'bitfrom' => undef,
                                  'descr' => '1 = Pseudorange corrections have been used for this signal',
                                  'name' => 'prCorrUsed',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '7',
                                  'bitfrom' => undef,
                                  'descr' => '1 = Carrier range corrections have been used for this signal',
                                  'name' => 'crCorrUsed',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '8',
                                  'bitfrom' => undef,
                                  'descr' => '1 = Range rate (Doppler) corrections have been used for this signal',
                                  'name' => 'doCorrUsed',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'Signal related ﬂags',
                'group' => 'repeated numSigs',
                'ln_arg' => 8281,
                'name' => 'sigFlags',
                'offset' => '18 + n·16',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => 'repeated numSigs',
                'ln_arg' => 8310,
                'name' => 'reserved1',
                'offset' => '20 + n·16',
                'repeat' => '4',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x01',
  'code' => 'UBX-NAV-SIG',
  'comment' => 'This message displays information about signals currently tracked by the receiver. On the F9 platform the maximum number of signals is 120.',
  'hasgroup' => 'repeated numSigs',
  'id' => '0x43',
  'length' => '8 + numSigs·16',
  'ln_bitfield' => 8308,
  'ln_classid' => 8238,
  'ln_comment' => 8224,
  'ln_msg' => 8221,
  'ln_name' => 8222,
  'ln_type' => 8223,
  'name' => 'Signal information',
  'type' => 'Periodic/polled'
}
, ### UBX-NAV-SLAS QZSS L1S SLAS status data ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'GPS time of week of the navigation epoch. See the description of iTOW for details.',
                'group' => '',
                'ln_arg' => 8327,
                'name' => 'iTOW',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'ms'
              },
              {
                'bitfield' => [],
                'descr' => 'Message version (0x00 for this version)',
                'group' => '',
                'ln_arg' => 8329,
                'name' => 'version',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 8330,
                'name' => 'reserved0',
                'offset' => '5',
                'repeat' => '3',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Longitude of the used ground monitoring station',
                'group' => '',
                'ln_arg' => 8331,
                'name' => 'gmsLon',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '1e-3',
                'type' => 'I4',
                'unit' => 'deg'
              },
              {
                'bitfield' => [],
                'descr' => 'Latitude of the used ground monitoring station',
                'group' => '',
                'ln_arg' => 8332,
                'name' => 'gmsLat',
                'offset' => '12',
                'repeat' => undef,
                'scale' => '1e-3',
                'type' => 'I4',
                'unit' => 'deg'
              },
              {
                'bitfield' => [],
                'descr' => 'Code of the used ground monitoring station according to the QZSS SLAS Interface Speciﬁcation, available from qzss.go.jp/en/',
                'group' => '',
                'ln_arg' => 8333,
                'name' => 'gmsCode',
                'offset' => '16',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Satellite identiﬁer of the QZS/GEO whose correction data is used (see Satellite Numbering)',
                'group' => '',
                'ln_arg' => 8336,
                'name' => 'qzssSvId',
                'offset' => '17',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '0',
                                  'bitfrom' => undef,
                                  'descr' => '1 = Ground monitoring station available',
                                  'name' => 'gmsAvailable',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '1',
                                  'bitfrom' => undef,
                                  'descr' => '1 = Correction providing QZSS SV available',
                                  'name' => 'qzssSvAvailable',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '2',
                                  'bitfrom' => undef,
                                  'descr' => '1 = Currently used QZSS SV in test mode',
                                  'name' => 'testMode',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'Flags regarding SLAS service',
                'group' => '',
                'ln_arg' => 8338,
                'name' => 'serviceFlags',
                'offset' => '18',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Number of pseudorange corrections following',
                'group' => '',
                'ln_arg' => 8345,
                'name' => 'cnt',
                'offset' => '19',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'GNSS identiﬁer (see Satellite Numbering)',
                'group' => 'repeated cnt',
                'ln_arg' => 8348,
                'name' => 'gnssId',
                'offset' => '20 + n·8',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Satellite identiﬁer (see Satellite Numbering)',
                'group' => 'repeated cnt',
                'ln_arg' => 8349,
                'name' => 'svId',
                'offset' => '21 + n·8',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => 'repeated cnt',
                'ln_arg' => 8350,
                'name' => 'reserved1',
                'offset' => '22 + n·8',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => 'repeated cnt',
                'ln_arg' => 8351,
                'name' => 'reserved2',
                'offset' => '23 + n·8',
                'repeat' => '3',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Pseudorange correction',
                'group' => 'repeated cnt',
                'ln_arg' => 8352,
                'name' => 'prc',
                'offset' => '26 + n·8',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I2',
                'unit' => 'cm'
              }
            ],
  'class' => '0x01',
  'code' => 'UBX-NAV-SLAS',
  'comment' => 'This message outputs the status of the QZSS L1S SLAS sub system',
  'hasgroup' => 'repeated cnt',
  'id' => '0x42',
  'length' => '20 + cnt·8',
  'ln_bitfield' => 8344,
  'ln_classid' => 8324,
  'ln_comment' => 8321,
  'ln_msg' => 8318,
  'ln_name' => 8319,
  'ln_type' => 8320,
  'name' => 'QZSS L1S SLAS status data',
  'type' => 'Periodic/polled'
}
, ### UBX-NAV-STATUS Receiver navigation status ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'GPS time of week of the navigation epoch. See the section iTOW timestamps in Integration manual for details.',
                'group' => '',
                'ln_arg' => 8379,
                'name' => 'iTOW',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'ms'
              },
              {
                'bitfield' => [],
                'descr' => 'GPSﬁx Type, this value does not qualify a ﬁx as valid and within the limits. See note on ﬂag gpsFixOk below.
•   0x00 = no ﬁx
•   0x01 = dead reckoning only
•   0x02 = 2D-ﬁx
•   0x03 = 3D-ﬁx
•   0x04 = GPS + dead reckoning combined
•   0x05 = Time only ﬁx
•   0x06..0xﬀ = reserved',
                'group' => '',
                'ln_arg' => 8382,
                'name' => 'gpsFix',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '0',
                                  'bitfrom' => undef,
                                  'descr' => '1 = position and velocity valid and within DOP and ACC Masks.',
                                  'name' => 'gpsFixOk',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '1',
                                  'bitfrom' => undef,
                                  'descr' => '1 = diﬀerential corrections were applied',
                                  'name' => 'diffSoln',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '2',
                                  'bitfrom' => undef,
                                  'descr' => '1 = Week Number valid (see section Time validity in Integration manual for details)',
                                  'name' => 'wknSet',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '3',
                                  'bitfrom' => undef,
                                  'descr' => '1 = Time of Week valid (see section Time validity in Integration manual for details)',
                                  'name' => 'towSet',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'Navigation Status Flags',
                'group' => '',
                'ln_arg' => 8391,
                'name' => 'flags',
                'offset' => '5',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X1',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '0',
                                  'bitfrom' => undef,
                                  'descr' => '1 = diﬀerential corrections available',
                                  'name' => 'diffCorr',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '1',
                                  'bitfrom' => undef,
                                  'descr' => '1 = valid carrSoln',
                                  'name' => 'carrSolnValid',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '7',
                                  'bitfrom' => '6',
                                  'descr' => 'map matching status:
•   00: none
•   01: valid but not used, i.e. map matching data was received, but was too old
•   10: valid and used, map matching data was applied
•   11: valid and used, map matching data was applied. In case of sensor unavailability map matching data enables dead reckoning. This requires map matched latitude/longitude or heading data.',
                                  'name' => 'mapMatching',
                                  'numbits' => '2'
                                }
                              ],
                'descr' => 'Fix Status Information',
                'group' => '',
                'ln_arg' => 8401,
                'name' => 'fixStat',
                'offset' => '6',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X1',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '1',
                                  'bitfrom' => '0',
                                  'descr' => 'power save mode state (not supported for protocol versions less than 13.01)',
                                  'name' => 'psmState',
                                  'numbits' => '2'
                                },
                                {
                                  'bit' => '4',
                                  'bitfrom' => '3',
                                  'descr' => 'Spooﬁng detection state (not supported for protocol versions less than 18.00)
•   0: Unknown or deactivated
•   1: No spooﬁng indicated
•   2: Spooﬁng indicated
•   3: Multiple spooﬁng indications Note that the spooﬁng state value only reﬂects the dector state for the current navigation epoch. As spooﬁng can be detected most easily at the transition from real signal to spooﬁng signal, this is also where the detector is triggered the most. I.e. a value of 1 - No spoofing indicated does not mean that the receiver is not spoofed, it simply states that the detector was not triggered in this epoch.',
                                  'name' => 'spoofDetState',
                                  'numbits' => '2'
                                },
                                {
                                  'bit' => '7',
                                  'bitfrom' => '6',
                                  'descr' => 'Carrier phase range solution status:
•   0 = no carrier phase range solution
•   1 = carrier phase range solution with ﬂoating ambiguities
•   2 = carrier phase range solution with ﬁxed ambiguities',
                                  'name' => 'carrSoln',
                                  'numbits' => '2'
                                }
                              ],
                'descr' => 'further information about navigation output',
                'group' => '',
                'ln_arg' => 8418,
                'name' => 'flags2',
                'offset' => '7',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Time to ﬁrst ﬁx (millisecond time tag)',
                'group' => '',
                'ln_arg' => 8455,
                'name' => 'ttff',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'ms'
              },
              {
                'bitfield' => [],
                'descr' => 'Milliseconds since Startup / Reset',
                'group' => '',
                'ln_arg' => 8456,
                'name' => 'msss',
                'offset' => '12',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'ms'
              }
            ],
  'class' => '0x01',
  'code' => 'UBX-NAV-STATUS',
  'comment' => 'See important comments concerning validity of position given in section Navigation output ﬁlters in Integration manual.',
  'id' => '0x03',
  'length' => '16',
  'ln_bitfield' => 8449,
  'ln_classid' => 8376,
  'ln_comment' => 8372,
  'ln_msg' => 8369,
  'ln_name' => 8370,
  'ln_type' => 8371,
  'name' => 'Receiver navigation status',
  'type' => 'Periodic/polled'
}
, ### UBX-NAV-SVIN Survey-in data ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Message version (0x00 for this version)',
                'group' => '',
                'ln_arg' => 8471,
                'name' => 'version',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 8472,
                'name' => 'reserved0',
                'offset' => '1',
                'repeat' => '3',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'GPS time of week of the navigation epoch. See the description of iTOW for details.',
                'group' => '',
                'ln_arg' => 8473,
                'name' => 'iTOW',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'ms'
              },
              {
                'bitfield' => [],
                'descr' => 'Passed survey-in observation time',
                'group' => '',
                'ln_arg' => 8475,
                'name' => 'dur',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'Current survey-in mean position ECEF X coordinate',
                'group' => '',
                'ln_arg' => 8476,
                'name' => 'meanX',
                'offset' => '12',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I4',
                'unit' => 'cm'
              },
              {
                'bitfield' => [],
                'descr' => 'Current survey-in mean position ECEF Y coordinate',
                'group' => '',
                'ln_arg' => 8477,
                'name' => 'meanY',
                'offset' => '16',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I4',
                'unit' => 'cm'
              },
              {
                'bitfield' => [],
                'descr' => 'Current survey-in mean position ECEF Z coordinate',
                'group' => '',
                'ln_arg' => 8478,
                'name' => 'meanZ',
                'offset' => '20',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I4',
                'unit' => 'cm'
              },
              {
                'bitfield' => [],
                'descr' => 'Current high-precision survey-in mean position ECEF X coordinate. Must be in the range -99..+99. The current survey-in mean position             ECEF    X coordinate, in units of cm, is given by meanX + (0.01 * meanXHP)',
                'group' => '',
                'ln_arg' => 8479,
                'name' => 'meanXHP',
                'offset' => '24',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I1',
                'unit' => '0.1_mm'
              },
              {
                'bitfield' => [],
                'descr' => 'Current high-precision survey-in mean position ECEF Y coordinate. Must be in the range -99..+99. The current survey-in mean position ECEF Y coordinate, in units of cm, is given by meanY + (0.01 * meanYHP)',
                'group' => '',
                'ln_arg' => 8493,
                'name' => 'meanYHP',
                'offset' => '25',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I1',
                'unit' => '0.1_mm'
              },
              {
                'bitfield' => [],
                'descr' => 'Current high-precision survey-in mean position ECEF Z coordinate. Must be in the range -99..+99. The current survey-in mean position ECEF Z coordinate, in units of cm, is given by meanZ + (0.01 * meanZHP)',
                'group' => '',
                'ln_arg' => 8498,
                'name' => 'meanZHP',
                'offset' => '26',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I1',
                'unit' => '0.1_mm'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 8503,
                'name' => 'reserved1',
                'offset' => '27',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Current survey-in mean position accuracy',
                'group' => '',
                'ln_arg' => 8504,
                'name' => 'meanAcc',
                'offset' => '28',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => '0.1_mm'
              },
              {
                'bitfield' => [],
                'descr' => 'Number of position observations used during survey- in',
                'group' => '',
                'ln_arg' => 8505,
                'name' => 'obs',
                'offset' => '32',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Survey-in position validity ﬂag, 1 = valid, otherwise 0',
                'group' => '',
                'ln_arg' => 8507,
                'name' => 'valid',
                'offset' => '36',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Survey-in in progress ﬂag, 1 = in-progress, otherwise 0',
                'group' => '',
                'ln_arg' => 8508,
                'name' => 'active',
                'offset' => '37',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 8509,
                'name' => 'reserved2',
                'offset' => '38',
                'repeat' => '2',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x01',
  'code' => 'UBX-NAV-SVIN',
  'comment' => 'This message contains information about survey-in parameters.',
  'id' => '0x3b',
  'length' => '40',
  'ln_classid' => 8468,
  'ln_comment' => 8465,
  'ln_msg' => 8462,
  'ln_name' => 8463,
  'ln_type' => 8464,
  'name' => 'Survey-in data',
  'type' => 'Periodic/polled'
}
, ### UBX-NAV-TIMEBDS BeiDou time solution ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'GPS time of week of the navigation epoch. See the section iTOW timestamps in Integration manual for details.',
                'group' => '',
                'ln_arg' => 8525,
                'name' => 'iTOW',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'ms'
              },
              {
                'bitfield' => [],
                'descr' => 'BDS time of week (rounded to seconds)',
                'group' => '',
                'ln_arg' => 8528,
                'name' => 'SOW',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'Fractional part of SOW (range: +/-500000000). The precise BDS time of week in seconds is: SOW + fSOW * 1e-9',
                'group' => '',
                'ln_arg' => 8529,
                'name' => 'fSOW',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I4',
                'unit' => 'ns'
              },
              {
                'bitfield' => [],
                'descr' => 'BDS week number of the navigation epoch',
                'group' => '',
                'ln_arg' => 8532,
                'name' => 'week',
                'offset' => '12',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'BDS leap seconds (BDS-UTC)',
                'group' => '',
                'ln_arg' => 8533,
                'name' => 'leapS',
                'offset' => '14',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I1',
                'unit' => 's'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '0',
                                  'bitfrom' => undef,
                                  'descr' => '1 = Valid SOW and fSOW (see section Time validity in Integration manual for details)',
                                  'name' => 'sowValid',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '1',
                                  'bitfrom' => undef,
                                  'descr' => '1 = Valid week (see section Time validity in Integration manual for details)',
                                  'name' => 'weekValid',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '2',
                                  'bitfrom' => undef,
                                  'descr' => '1 = Valid leap second',
                                  'name' => 'leapSValid',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'Validity Flags',
                'group' => '',
                'ln_arg' => 8534,
                'name' => 'valid',
                'offset' => '15',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Time Accuracy Estimate',
                'group' => '',
                'ln_arg' => 8551,
                'name' => 'tAcc',
                'offset' => '16',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'ns'
              }
            ],
  'class' => '0x01',
  'code' => 'UBX-NAV-TIMEBDS',
  'comment' => 'This message reports the precise BDS time of the most recent navigation solution including validity ﬂags and an accuracy estimate.',
  'id' => '0x24',
  'length' => '20',
  'ln_bitfield' => 8540,
  'ln_classid' => 8522,
  'ln_comment' => 8518,
  'ln_msg' => 8515,
  'ln_name' => 8516,
  'ln_type' => 8517,
  'name' => 'BeiDou time solution',
  'type' => 'Periodic/polled'
}
, ### UBX-NAV-TIMEGAL Galileo time solution ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'GPS time of week of the navigation epoch. See the section iTOW timestamps in Integration manual for details.',
                'group' => '',
                'ln_arg' => 8567,
                'name' => 'iTOW',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'ms'
              },
              {
                'bitfield' => [],
                'descr' => 'Galileo time of week (rounded to seconds)',
                'group' => '',
                'ln_arg' => 8570,
                'name' => 'galTow',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'Fractional part of the Galileo time of week (range: +/-500000000). The precise Galileo time of week in seconds is: galTow + fGalTow * 1e-9',
                'group' => '',
                'ln_arg' => 8571,
                'name' => 'fGalTow',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I4',
                'unit' => 'ns'
              },
              {
                'bitfield' => [],
                'descr' => 'Galileo week number',
                'group' => '',
                'ln_arg' => 8575,
                'name' => 'galWno',
                'offset' => '12',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Galileo leap seconds (Galileo-UTC)',
                'group' => '',
                'ln_arg' => 8576,
                'name' => 'leapS',
                'offset' => '14',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I1',
                'unit' => 's'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '0',
                                  'bitfrom' => undef,
                                  'descr' => '1 = Valid galTow and fGalTow (see the section Time validity in the Integration manual for details)',
                                  'name' => 'galTowValid',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '1',
                                  'bitfrom' => undef,
                                  'descr' => '1 = Valid galWno (see the section Time validity in the Integration manual for details)',
                                  'name' => 'galWnoValid',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '2',
                                  'bitfrom' => undef,
                                  'descr' => '1 = Valid leapS',
                                  'name' => 'leapSValid',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'Validity Flags',
                'group' => '',
                'ln_arg' => 8577,
                'name' => 'valid',
                'offset' => '15',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Time Accuracy Estimate',
                'group' => '',
                'ln_arg' => 8584,
                'name' => 'tAcc',
                'offset' => '16',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'ns'
              }
            ],
  'class' => '0x01',
  'code' => 'UBX-NAV-TIMEGAL',
  'comment' => 'This message reports the precise Galileo time of the most recent navigation solution including validity ﬂags and an accuracy estimate.',
  'id' => '0x25',
  'length' => '20',
  'ln_bitfield' => 8583,
  'ln_classid' => 8564,
  'ln_comment' => 8560,
  'ln_msg' => 8557,
  'ln_name' => 8558,
  'ln_type' => 8559,
  'name' => 'Galileo time solution',
  'type' => 'Periodic/polled'
}
, ### UBX-NAV-TIMEGLO GLONASS time solution ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'GPS time of week of the navigation epoch. See the section iTOW timestamps in Integration manual for details.',
                'group' => '',
                'ln_arg' => 8600,
                'name' => 'iTOW',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'ms'
              },
              {
                'bitfield' => [],
                'descr' => 'GLONASS time of day (rounded to integer seconds)',
                'group' => '',
                'ln_arg' => 8613,
                'name' => 'TOD',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'Fractional part of TOD (range: +/-500000000). The precise GLONASS time of day in seconds is: TOD + fTOD * 1e-9',
                'group' => '',
                'ln_arg' => 8614,
                'name' => 'fTOD',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I4',
                'unit' => 'ns'
              },
              {
                'bitfield' => [],
                'descr' => 'Current date (range: 1-1461), starting at 1 from the 1st Jan of the year indicated by N4 and ending at 1461 at the 31st Dec of the third year after that indicated by N4',
                'group' => '',
                'ln_arg' => 8617,
                'name' => 'Nt',
                'offset' => '12',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => 'days'
              },
              {
                'bitfield' => [],
                'descr' => 'Four-year interval number      starting   from   1996 (1=1996, 2=2000, 3=2004...)',
                'group' => '',
                'ln_arg' => 8621,
                'name' => 'N4',
                'offset' => '14',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '0',
                                  'bitfrom' => undef,
                                  'descr' => '1 = Valid TOD and fTOD (see section Time validity in Integration manual for details)',
                                  'name' => 'todValid',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '1',
                                  'bitfrom' => undef,
                                  'descr' => '1 = Valid N4 and Nt (see section Time validity in Integration manual for details)',
                                  'name' => 'dateValid',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'Validity ﬂags',
                'group' => '',
                'ln_arg' => 8623,
                'name' => 'valid',
                'offset' => '15',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Time Accuracy Estimate',
                'group' => '',
                'ln_arg' => 8629,
                'name' => 'tAcc',
                'offset' => '16',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'ns'
              }
            ],
  'class' => '0x01',
  'code' => 'UBX-NAV-TIMEGLO',
  'comment' => 'This message reports the precise GLO time of the most recent navigation solution including validity ﬂags and an accuracy estimate.',
  'id' => '0x23',
  'length' => '20',
  'ln_bitfield' => 8627,
  'ln_classid' => 8597,
  'ln_comment' => 8593,
  'ln_msg' => 8590,
  'ln_name' => 8591,
  'ln_type' => 8592,
  'name' => 'GLONASS time solution',
  'type' => 'Periodic/polled'
}
, ### UBX-NAV-TIMELS Leap second event information ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'GPS time of week of the navigation epoch. See the section iTOW timestamps in Integration manual for details.',
                'group' => '',
                'ln_arg' => 8644,
                'name' => 'iTOW',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'ms'
              },
              {
                'bitfield' => [],
                'descr' => 'Message version (0x00 for this version)',
                'group' => '',
                'ln_arg' => 8647,
                'name' => 'version',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 8648,
                'name' => 'reserved0',
                'offset' => '5',
                'repeat' => '3',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Information source for the current number of leap seconds.
•   0 = Default (hardcoded in the ﬁrmware, can be outdated)
•   1 = Derived from time diﬀerence between GPS and GLONASS time
•   2 = GPS
•   3 = SBAS
•   4 = BeiDou
•   5 = Galileo
•   6 = Aided data
•   7 = Conﬁgured
•   255 = Unknown',
                'group' => '',
                'ln_arg' => 8649,
                'name' => 'srcOfCurrLs',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Current number of leap seconds since start of GPS time (Jan 6, 1980). It reﬂects how much GPS time is ahead of UTC time. Galileo number of leap seconds is the same as GPS. BeiDou number of leap seconds is 14 less than GPS. GLONASS follows UTC time, so no leap seconds.',
                'group' => '',
                'ln_arg' => 8672,
                'name' => 'currLs',
                'offset' => '9',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I1',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'Information source for the future leap second event.
•   0 = No source
•   2 = GPS
•   3 = SBAS
•   4 = BeiDou
•   5 = Galileo
•   6 = GLONASS',
                'group' => '',
                'ln_arg' => 8678,
                'name' => 'srcOfLsChange',
                'offset' => '10',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Future leap second change if one is scheduled. +1 = positive leap second, -1 = negative leap second, 0 = no future leap second event scheduled or no information available.',
                'group' => '',
                'ln_arg' => 8685,
                'name' => 'lsChange',
                'offset' => '11',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I1',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'Number of seconds until the next leap second event, or from the last leap second event if no future event scheduled. If > 0 event is in the future, = 0 event is now, < 0 event is in the past. Valid only if validTimeToLsEvent = 1.',
                'group' => '',
                'ln_arg' => 8689,
                'name' => 'timeToLsEvent',
                'offset' => '12',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I4',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'GPS week number (WN) of the next leap second event the last one if no future event scheduled. Valid only if validTimeToLsEvent = 1.',
                'group' => '',
                'ln_arg' => 8694,
                'name' => 'dateOfLsGpsWn',
                'offset' => '16',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => '-or'
              },
              {
                'bitfield' => [],
                'descr' => 'GPS day of week number (DN) for the next leap second or the last one if no future event scheduled. Valid only if validTimeToLsEvent = 1. (GPS and Galileo DN: from 1 = Sun to 7 = Sat. BeiDou DN: from 0 = Sun to 6 = Sat.)',
                'group' => '',
                'ln_arg' => 8697,
                'name' => 'dateOfLsGpsDn',
                'offset' => '18',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => '-event'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 8702,
                'name' => 'reserved1',
                'offset' => '20',
                'repeat' => '3',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '0',
                                  'bitfrom' => undef,
                                  'descr' => '1 = Valid current number of leap seconds value.',
                                  'name' => 'validCurrLs',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '1',
                                  'bitfrom' => undef,
                                  'descr' => '1 = Valid time to next leap second event or from the leap second event if no future event scheduled.',
                                  'name' => 'validTimeToLsEvent',
                                  'numbits' => '1',
                                  'unit' => 'last'
                                }
                              ],
                'descr' => 'Validity ﬂags',
                'group' => '',
                'ln_arg' => 8703,
                'name' => 'valid',
                'offset' => '23',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X1',
                'unit' => '-'
              }
            ],
  'class' => '0x01',
  'code' => 'UBX-NAV-TIMELS',
  'comment' => 'Information about the upcoming leap second event if one is scheduled.',
  'id' => '0x26',
  'length' => '24',
  'ln_bitfield' => 8707,
  'ln_classid' => 8641,
  'ln_comment' => 8638,
  'ln_msg' => 8635,
  'ln_name' => 8636,
  'ln_type' => 8637,
  'name' => 'Leap second event information',
  'type' => 'Periodic/polled'
}
, ### UBX-NAV-TIMEQZSS QZSS time solution ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'GPS time of week of the navigation epoch. See the description of iTOW for details.',
                'group' => '',
                'ln_arg' => 8724,
                'name' => 'iTOW',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'ms'
              },
              {
                'bitfield' => [],
                'descr' => 'QZSS time of week (rounded to seconds)',
                'group' => '',
                'ln_arg' => 8726,
                'name' => 'qzssTow',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'Fractional part of QZSS time of week (range: +/-500000000). The precise QZSS time of week in seconds is: qzssTow + (fQzssTow * 1e-9)',
                'group' => '',
                'ln_arg' => 8737,
                'name' => 'fQzssTow',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I4',
                'unit' => 'ns'
              },
              {
                'bitfield' => [],
                'descr' => 'QZSS week number of the navigation epoch',
                'group' => '',
                'ln_arg' => 8741,
                'name' => 'qzssWno',
                'offset' => '12',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'QZSS leap seconds (QZSS-UTC)',
                'group' => '',
                'ln_arg' => 8742,
                'name' => 'leapS',
                'offset' => '14',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I1',
                'unit' => 's'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '0',
                                  'bitfrom' => undef,
                                  'descr' => '1 = Valid QZSS time of week (qzssTow & fQzssTow, see Time Validity section for details)',
                                  'name' => 'qzssTowValid',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '1',
                                  'bitfrom' => undef,
                                  'descr' => '1 = Valid QZSS week number (see Time Validity section for details)',
                                  'name' => 'qzssWnoValid',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '2',
                                  'bitfrom' => undef,
                                  'descr' => '1 = Valid QZSS leap seconds',
                                  'name' => 'leapSValid',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'Validity Flags',
                'group' => '',
                'ln_arg' => 8743,
                'name' => 'valid',
                'offset' => '15',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Time Accuracy Estimate',
                'group' => '',
                'ln_arg' => 8750,
                'name' => 'tAcc',
                'offset' => '16',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'ns'
              }
            ],
  'class' => '0x01',
  'code' => 'UBX-NAV-TIMEQZSS',
  'comment' => 'This message reports the precise QZSS time of the most recent navigation solution including validity ﬂags and an accuracy estimate.',
  'id' => '0x27',
  'length' => '20',
  'ln_bitfield' => 8749,
  'ln_classid' => 8721,
  'ln_comment' => 8717,
  'ln_msg' => 8714,
  'ln_name' => 8715,
  'ln_type' => 8716,
  'name' => 'QZSS time solution',
  'type' => 'Periodic/polled'
}
, ### UBX-NAV-TIMEUTC UTC time solution ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'GPS time of week of the navigation epoch. See the section iTOW timestamps in Integration manual for details.',
                'group' => '',
                'ln_arg' => 8766,
                'name' => 'iTOW',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'ms'
              },
              {
                'bitfield' => [],
                'descr' => 'Time accuracy estimate (UTC)',
                'group' => '',
                'ln_arg' => 8769,
                'name' => 'tAcc',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'ns'
              },
              {
                'bitfield' => [],
                'descr' => 'Fraction of second, range -1e9 .. 1e9 (UTC)',
                'group' => '',
                'ln_arg' => 8770,
                'name' => 'nano',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I4',
                'unit' => 'ns'
              },
              {
                'bitfield' => [],
                'descr' => 'Year, range 1999..2099 (UTC)',
                'group' => '',
                'ln_arg' => 8771,
                'name' => 'year',
                'offset' => '12',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => 'y'
              },
              {
                'bitfield' => [],
                'descr' => 'Month, range 1..12 (UTC)',
                'group' => '',
                'ln_arg' => 8772,
                'name' => 'month',
                'offset' => '14',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => 'month'
              },
              {
                'bitfield' => [],
                'descr' => 'Day of month, range 1..31 (UTC)',
                'group' => '',
                'ln_arg' => 8773,
                'name' => 'day',
                'offset' => '15',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => 'd'
              },
              {
                'bitfield' => [],
                'descr' => 'Hour of day, range 0..23 (UTC)',
                'group' => '',
                'ln_arg' => 8774,
                'name' => 'hour',
                'offset' => '16',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => 'h'
              },
              {
                'bitfield' => [],
                'descr' => 'Minute of hour, range 0..59 (UTC)',
                'group' => '',
                'ln_arg' => 8775,
                'name' => 'min',
                'offset' => '17',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => 'min'
              },
              {
                'bitfield' => [],
                'descr' => 'Seconds of minute, range 0..60 (UTC)',
                'group' => '',
                'ln_arg' => 8776,
                'name' => 'sec',
                'offset' => '18',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => 's'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '0',
                                  'bitfrom' => undef,
                                  'descr' => '1 = Valid Time of Week (see section Time validity in Integration manual for details)',
                                  'name' => 'validTOW',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '1',
                                  'bitfrom' => undef,
                                  'descr' => '1 = Valid Week Number (see section Time validity in Integration manual for details)',
                                  'name' => 'validWKN',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '2',
                                  'bitfrom' => undef,
                                  'descr' => '1 = Valid UTC Time',
                                  'name' => 'validUTC',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '7',
                                  'bitfrom' => '4',
                                  'descr' => 'UTC standard identiﬁer. (Not supported for protocol versions less than 15.00)
•   0 = Information not available 1 = Communications Research Labratory (CRL), 2 = National Institute of Standards and 3 = U.S. Naval Observatory (USNO) 4 = International Bureau of Weights and 5 = European laboratories 6 = Former Soviet Union (SU) 7 = National Time Service Center (NTSC), China 15 = Unknown',
                                  'name' => 'utcStandard',
                                  'numbits' => '4',
                                  'unit' => '••••••••'
                                }
                              ],
                'descr' => 'Validity Flags',
                'group' => '',
                'ln_arg' => 8777,
                'name' => 'valid',
                'offset' => '19',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X1',
                'unit' => '-'
              }
            ],
  'class' => '0x01',
  'code' => 'UBX-NAV-TIMEUTC',
  'comment' => 'Note that during a leap second there may be more or less than 60 seconds in a minute. See the description of leap seconds in the Integration manual for details.',
  'id' => '0x21',
  'length' => '20',
  'ln_bitfield' => 8785,
  'ln_classid' => 8763,
  'ln_comment' => 8759,
  'ln_msg' => 8756,
  'ln_name' => 8757,
  'ln_type' => 8758,
  'name' => 'UTC time solution',
  'type' => 'Periodic/polled'
}
, ### UBX-NAV-VELECEF Velocity solution in ECEF ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'GPS time of week of the navigation epoch. See the section iTOW timestamps in Integration manual for details.',
                'group' => '',
                'ln_arg' => 8823,
                'name' => 'iTOW',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'ms'
              },
              {
                'bitfield' => [],
                'descr' => 'ECEF X velocity',
                'group' => '',
                'ln_arg' => 8826,
                'name' => 'ecefVX',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I4',
                'unit' => 'cm/s'
              },
              {
                'bitfield' => [],
                'descr' => 'ECEF Y velocity',
                'group' => '',
                'ln_arg' => 8827,
                'name' => 'ecefVY',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I4',
                'unit' => 'cm/s'
              },
              {
                'bitfield' => [],
                'descr' => 'ECEF Z velocity',
                'group' => '',
                'ln_arg' => 8828,
                'name' => 'ecefVZ',
                'offset' => '12',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I4',
                'unit' => 'cm/s'
              },
              {
                'bitfield' => [],
                'descr' => 'Speed accuracy estimate',
                'group' => '',
                'ln_arg' => 8829,
                'name' => 'sAcc',
                'offset' => '16',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'cm/s'
              }
            ],
  'class' => '0x01',
  'code' => 'UBX-NAV-VELECEF',
  'comment' => 'See important comments concerning validity of position given in section Navigation output ﬁlters in Integration manual.',
  'id' => '0x11',
  'length' => '20',
  'ln_classid' => 8820,
  'ln_comment' => 8816,
  'ln_msg' => 8813,
  'ln_name' => 8814,
  'ln_type' => 8815,
  'name' => 'Velocity solution in ECEF',
  'type' => 'Periodic/polled'
}
, ### UBX-NAV-VELNED Velocity solution in NED frame ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'GPS time of week of the navigation epoch. See the section iTOW timestamps in Integration manual for details.',
                'group' => '',
                'ln_arg' => 8845,
                'name' => 'iTOW',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'ms'
              },
              {
                'bitfield' => [],
                'descr' => 'North velocity component',
                'group' => '',
                'ln_arg' => 8848,
                'name' => 'velN',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I4',
                'unit' => 'cm/s'
              },
              {
                'bitfield' => [],
                'descr' => 'East velocity component',
                'group' => '',
                'ln_arg' => 8849,
                'name' => 'velE',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I4',
                'unit' => 'cm/s'
              },
              {
                'bitfield' => [],
                'descr' => 'Down velocity component',
                'group' => '',
                'ln_arg' => 8860,
                'name' => 'velD',
                'offset' => '12',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I4',
                'unit' => 'cm/s'
              },
              {
                'bitfield' => [],
                'descr' => 'Speed (3-D)',
                'group' => '',
                'ln_arg' => 8861,
                'name' => 'speed',
                'offset' => '16',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'cm/s'
              },
              {
                'bitfield' => [],
                'descr' => 'Ground speed (2-D)',
                'group' => '',
                'ln_arg' => 8862,
                'name' => 'gSpeed',
                'offset' => '20',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'cm/s'
              },
              {
                'bitfield' => [],
                'descr' => 'Heading of motion 2-D',
                'group' => '',
                'ln_arg' => 8863,
                'name' => 'heading',
                'offset' => '24',
                'repeat' => undef,
                'scale' => '1e-5',
                'type' => 'I4',
                'unit' => 'deg'
              },
              {
                'bitfield' => [],
                'descr' => 'Speed accuracy Estimate',
                'group' => '',
                'ln_arg' => 8864,
                'name' => 'sAcc',
                'offset' => '28',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'cm/s'
              },
              {
                'bitfield' => [],
                'descr' => 'Course / Heading accuracy estimate',
                'group' => '',
                'ln_arg' => 8865,
                'name' => 'cAcc',
                'offset' => '32',
                'repeat' => undef,
                'scale' => '1e-5',
                'type' => 'U4',
                'unit' => 'deg'
              }
            ],
  'class' => '0x01',
  'code' => 'UBX-NAV-VELNED',
  'comment' => 'See important comments concerning validity of position given in section Navigation output ﬁlters in Integration manual.',
  'id' => '0x12',
  'length' => '36',
  'ln_classid' => 8842,
  'ln_comment' => 8838,
  'ln_msg' => 8835,
  'ln_name' => 8836,
  'ln_type' => 8837,
  'name' => 'Velocity solution in NED frame',
  'type' => 'Periodic/polled'
}
, ### UBX-RXM-MEASX Satellite measurements for RRLP ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Message version, currently 0x01',
                'group' => '',
                'ln_arg' => 8893,
                'name' => 'version',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 8894,
                'name' => 'reserved0',
                'offset' => '1',
                'repeat' => '3',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'GPS measurement reference time',
                'group' => '',
                'ln_arg' => 8895,
                'name' => 'gpsTOW',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'ms'
              },
              {
                'bitfield' => [],
                'descr' => 'GLONASS measurement reference time',
                'group' => '',
                'ln_arg' => 8896,
                'name' => 'gloTOW',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'ms'
              },
              {
                'bitfield' => [],
                'descr' => 'BeiDou measurement reference time',
                'group' => '',
                'ln_arg' => 8897,
                'name' => 'bdsTOW',
                'offset' => '12',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'ms'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 8898,
                'name' => 'reserved1',
                'offset' => '16',
                'repeat' => '4',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'QZSS measurement reference time',
                'group' => '',
                'ln_arg' => 8899,
                'name' => 'qzssTOW',
                'offset' => '20',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'ms'
              },
              {
                'bitfield' => [],
                'descr' => 'GPS measurement reference time accuracy (0xﬀﬀ = > 4s)',
                'group' => '',
                'ln_arg' => 8900,
                'name' => 'gpsTOWacc',
                'offset' => '24',
                'repeat' => undef,
                'scale' => '2^-4',
                'type' => 'U2',
                'unit' => 'ms'
              },
              {
                'bitfield' => [],
                'descr' => 'GLONASS measurement reference time accuracy (0xﬀﬀ = > 4s)',
                'group' => '',
                'ln_arg' => 8902,
                'name' => 'gloTOWacc',
                'offset' => '26',
                'repeat' => undef,
                'scale' => '2^-4',
                'type' => 'U2',
                'unit' => 'ms'
              },
              {
                'bitfield' => [],
                'descr' => 'BeiDou measurement reference time accuracy (0xﬀﬀ = > 4s)',
                'group' => '',
                'ln_arg' => 8904,
                'name' => 'bdsTOWacc',
                'offset' => '28',
                'repeat' => undef,
                'scale' => '2^-4',
                'type' => 'U2',
                'unit' => 'ms'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 8906,
                'name' => 'reserved2',
                'offset' => '30',
                'repeat' => '2',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'QZSS measurement reference time accuracy (0xﬀﬀ = > 4s)',
                'group' => '',
                'ln_arg' => 8907,
                'name' => 'qzssTOWacc',
                'offset' => '32',
                'repeat' => undef,
                'scale' => '2^-4',
                'type' => 'U2',
                'unit' => 'ms'
              },
              {
                'bitfield' => [],
                'descr' => 'Number of satellites in repeated block',
                'group' => '',
                'ln_arg' => 8919,
                'name' => 'numSV',
                'offset' => '34',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '1',
                                  'bitfrom' => '0',
                                  'descr' => 'TOW set (0 = no, 1 or 2 = yes)',
                                  'name' => 'towSet',
                                  'numbits' => '2'
                                }
                              ],
                'descr' => 'Flags',
                'group' => '',
                'ln_arg' => 8920,
                'name' => 'flags',
                'offset' => '35',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 8923,
                'name' => 'reserved3',
                'offset' => '36',
                'repeat' => '8',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'GNSS ID (see Satellite Numbering)',
                'group' => 'repeated numSV',
                'ln_arg' => 8926,
                'name' => 'gnssId',
                'offset' => '44 + n·24',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Satellite ID (see Satellite Numbering)',
                'group' => 'repeated numSV',
                'ln_arg' => 8927,
                'name' => 'svId',
                'offset' => '45 + n·24',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'carrier noise ratio (0..63)',
                'group' => 'repeated numSV',
                'ln_arg' => 8928,
                'name' => 'cNo',
                'offset' => '46 + n·24',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'multipath index (according to [1]) (0 = not measured, 1 = low, 2 = medium, 3 = high)',
                'group' => 'repeated numSV',
                'ln_arg' => 8929,
                'name' => 'mpathIndic',
                'offset' => '47 + n·24',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Doppler measurement',
                'group' => 'repeated numSV',
                'ln_arg' => 8931,
                'name' => 'dopplerMS',
                'offset' => '48 + n·24',
                'repeat' => undef,
                'scale' => '0.04',
                'type' => 'I4',
                'unit' => 'm/s'
              },
              {
                'bitfield' => [],
                'descr' => 'Doppler measurement',
                'group' => 'repeated numSV',
                'ln_arg' => 8932,
                'name' => 'dopplerHz',
                'offset' => '52 + n·24',
                'repeat' => undef,
                'scale' => '0.2',
                'type' => 'I4',
                'unit' => 'Hz'
              },
              {
                'bitfield' => [],
                'descr' => 'whole value of the code phase measurement (0..1022 for GPS)',
                'group' => 'repeated numSV',
                'ln_arg' => 8933,
                'name' => 'wholeChips',
                'offset' => '56 + n·24',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'fractional value of the code phase measurement (0..1023)',
                'group' => 'repeated numSV',
                'ln_arg' => 8935,
                'name' => 'fracChips',
                'offset' => '58 + n·24',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Code phase',
                'group' => 'repeated numSV',
                'ln_arg' => 8937,
                'name' => 'codePhase',
                'offset' => '60 + n·24',
                'repeat' => undef,
                'scale' => '2^-21',
                'type' => 'U4',
                'unit' => 'ms'
              },
              {
                'bitfield' => [],
                'descr' => 'Integer (part of the) code phase',
                'group' => 'repeated numSV',
                'ln_arg' => 8938,
                'name' => 'intCodePhase',
                'offset' => '64 + n·24',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => 'ms'
              },
              {
                'bitfield' => [],
                'descr' => 'pseudorange RMS error index (according to [1]) (0..63)',
                'group' => 'repeated numSV',
                'ln_arg' => 8939,
                'name' => 'pseuRangeRMSErr',
                'offset' => '65 + n·24',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => 'repeated numSV',
                'ln_arg' => 8941,
                'name' => 'reserved4',
                'offset' => '66 + n·24',
                'repeat' => '2',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x02',
  'code' => 'UBX-RXM-MEASX',
  'comment' => 'The message payload data is, where possible and appropriate, according to the Radio Resource LCS (Location Services) Protocol (RRLP) [1]. One exception is the satellite and GNSS IDs, which here are given according to the Satellite Numbering scheme. The correct satellites have to be selected and their satellite ID translated accordingly [1, tab. A.10.14] for use in a RRLP Measure Position Response Component. Similarly, the measurement reference time of week has to be forwarded correctly (modulo 14400000 for the 24 LSB GPS measurements variant, modulo 3600000 for the 22 LSB Galileo and Additional Navigation Satelllite Systems (GANSS) measurements variant) of the RRLP measure position response to the SMLC. Reference: [1] ETSI TS 144 031 V11.0.0 (2012-10), Digital cellular telecommunications system (Phase 2+), Location Services (LCS), Mobile Station (MS) - Serving Mobile Location Centre (SMLC), Radio Resource LCS Protocol (RRLP), (3GPP TS 44.031 version 11.0.0 Release 11).',
  'hasgroup' => 'repeated numSV',
  'id' => '0x14',
  'length' => '44 + numSV·24',
  'ln_bitfield' => 8922,
  'ln_classid' => 8890,
  'ln_comment' => 8878,
  'ln_msg' => 8875,
  'ln_name' => 8876,
  'ln_type' => 8877,
  'name' => 'Satellite measurements for RRLP',
  'type' => 'Periodic/polled'
}
, ### UBX-RXM-PMREQ Power management request ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Duration of the requested task, set to zero for inﬁnite duration. The maximum supported time is 12 days.',
                'group' => '',
                'ln_arg' => 8958,
                'name' => 'duration',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'ms'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '1',
                                  'bitfrom' => undef,
                                  'descr' => 'The receiver goes into backup mode for a time period deﬁned by duration, provided that it is not connected to USB',
                                  'name' => 'backup',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'task ﬂags',
                'group' => '',
                'ln_arg' => 8960,
                'name' => 'flags',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X4',
                'unit' => '-'
              }
            ],
  'class' => '0x02',
  'code' => 'UBX-RXM-PMREQ',
  'comment' => 'This message requests a power management related task of the receiver.',
  'id' => '0x41',
  'length' => '8',
  'ln_bitfield' => 8962,
  'ln_classid' => 8955,
  'ln_comment' => 8952,
  'ln_msg' => 8949,
  'ln_name' => 8950,
  'ln_type' => 8951,
  'name' => 'Power management request',
  'type' => 'Command'
}
, ### UBX-RXM-PMREQ Power management request ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Message version (0x00 for this version)',
                'group' => '',
                'ln_arg' => 8987,
                'name' => 'version',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 8988,
                'name' => 'reserved0',
                'offset' => '1',
                'repeat' => '3',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Duration of the requested task, set to zero for inﬁnite duration. The maximum supported time is 12 days.',
                'group' => '',
                'ln_arg' => 8989,
                'name' => 'duration',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'ms'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '1',
                                  'bitfrom' => undef,
                                  'descr' => 'The receiver goes into backup mode for a time period deﬁned by duration, provided that it is not connected to USB',
                                  'name' => 'backup',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '2',
                                  'bitfrom' => undef,
                                  'descr' => 'Force receiver backup while USB is connected. USB interface will be disabled.',
                                  'name' => 'force',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'task ﬂags',
                'group' => '',
                'ln_arg' => 8991,
                'name' => 'flags',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X4',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '3',
                                  'bitfrom' => undef,
                                  'descr' => 'Wake up the receiver if there is an edge on the UART RX pin',
                                  'name' => 'uartrx',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '5',
                                  'bitfrom' => undef,
                                  'descr' => 'Wake up the receiver if there is an edge on the EXTINT0 pin',
                                  'name' => 'extint0',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '6',
                                  'bitfrom' => undef,
                                  'descr' => 'Wake up the receiver if there is an edge on the EXTINT1 pin',
                                  'name' => 'extint1',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '7',
                                  'bitfrom' => undef,
                                  'descr' => 'Wake up the receiver if there is an edge on the SPI CS pin',
                                  'name' => 'spics',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'Conﬁgure pins to wake up the receiver. The receiver wakes up if there is either a falling or a rising edge on one of the conﬁgured pins.',
                'group' => '',
                'ln_arg' => 8998,
                'name' => 'wakeupSources',
                'offset' => '12',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X4',
                'unit' => '-'
              }
            ],
  'class' => '0x02',
  'code' => 'UBX-RXM-PMREQ',
  'comment' => 'This message requests a power management related task of the receiver.',
  'id' => '0x41',
  'length' => '16',
  'ln_bitfield' => 9008,
  'ln_classid' => 8984,
  'ln_comment' => 8971,
  'ln_msg' => 8968,
  'ln_name' => 8969,
  'ln_type' => 8970,
  'name' => 'Power management request',
  'type' => 'Command'
}
, ### UBX-RXM-RAWX Multi-GNSS raw measurements ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Measurement time of week in receiver local time approximately aligned to the GPS time system. The receiver local time of week, week number and leap second information can be used to translate the time to other time systems. More information about the diﬀerence in time systems can be found in the RINEX 3 format documentation. For a receiver operating in GLONASS only mode, UTC time can be determined by subtracting the leapS ﬁeld from GPS time regardless of whether the GPS leap seconds are valid.',
                'group' => '',
                'ln_arg' => 9039,
                'name' => 'rcvTow',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'R8',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'GPS week number in receiver local time.',
                'group' => '',
                'ln_arg' => 9049,
                'name' => 'week',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => 'weeks'
              },
              {
                'bitfield' => [],
                'descr' => 'GPS leap seconds (GPS-UTC). This ﬁeld represents the receiver\'s best knowledge of the leap seconds oﬀset. A ﬂag is given in the recStat bitﬁeld to indicate if the leap seconds are known.',
                'group' => '',
                'ln_arg' => 9050,
                'name' => 'leapS',
                'offset' => '10',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I1',
                'unit' => 's'
              },
              {
                'bitfield' => [],
                'descr' => 'Number of measurements to follow',
                'group' => '',
                'ln_arg' => 9054,
                'name' => 'numMeas',
                'offset' => '11',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '0',
                                  'bitfrom' => undef,
                                  'descr' => 'Leap seconds have been determined',
                                  'name' => 'leapSec',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '1',
                                  'bitfrom' => undef,
                                  'descr' => 'Clock reset applied. Typically the receiver clock is changed in increments of integer milliseconds.',
                                  'name' => 'clkReset',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'Receiver tracking status bitﬁeld',
                'group' => '',
                'ln_arg' => 9055,
                'name' => 'recStat',
                'offset' => '12',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Message version (0x01 for this version)',
                'group' => '',
                'ln_arg' => 9061,
                'name' => 'version',
                'offset' => '13',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 9062,
                'name' => 'reserved0',
                'offset' => '14',
                'repeat' => '2',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Pseudorange measurement [m]. GLONASS inter frequency channel delays are compensated with an internal calibration table.',
                'group' => 'repeated numMeas',
                'ln_arg' => 9065,
                'name' => 'prMes',
                'offset' => '16 + n·32',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'R8',
                'unit' => 'm'
              },
              {
                'bitfield' => [],
                'descr' => 'Carrier phase measurement [cycles]. The carrier phase initial ambiguity is initialized using an approximate value to make the magnitude of the phase close to the pseudorange measurement. Clock resets are applied to both phase and code measurements in accordance with the RINEX speciﬁcation.',
                'group' => 'repeated numMeas',
                'ln_arg' => 9068,
                'name' => 'cpMes',
                'offset' => '24 + n·32',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'R8',
                'unit' => 'cycles'
              },
              {
                'bitfield' => [],
                'descr' => 'Doppler measurement (positive sign for approaching satellites) [Hz]',
                'group' => 'repeated numMeas',
                'ln_arg' => 9075,
                'name' => 'doMes',
                'offset' => '32 + n·32',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'R4',
                'unit' => 'Hz'
              },
              {
                'bitfield' => [],
                'descr' => 'GNSS identiﬁer (see Satellite Numbering for a list of identiﬁers)',
                'group' => 'repeated numMeas',
                'ln_arg' => 9077,
                'name' => 'gnssId',
                'offset' => '36 + n·32',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Satellite identiﬁer (see Satellite Numbering)',
                'group' => 'repeated numMeas',
                'ln_arg' => 9079,
                'name' => 'svId',
                'offset' => '37 + n·32',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'New style signal identiﬁer (see Signal Identiﬁers).(not supported for protocol versions less than 27.00)',
                'group' => 'repeated numMeas',
                'ln_arg' => 9080,
                'name' => 'sigId',
                'offset' => '38 + n·32',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Only used for GLONASS: This is the frequency slot + 7 (range from 0 to 13)',
                'group' => 'repeated numMeas',
                'ln_arg' => 9082,
                'name' => 'freqId',
                'offset' => '39 + n·32',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Carrier phase locktime counter (maximum 64500ms)',
                'group' => 'repeated numMeas',
                'ln_arg' => 9084,
                'name' => 'locktime',
                'offset' => '40 + n·32',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => 'ms'
              },
              {
                'bitfield' => [],
                'descr' => 'Carrier-to-noise density ratio (signal strength) [dB-Hz]',
                'group' => 'repeated numMeas',
                'ln_arg' => 9085,
                'name' => 'cno',
                'offset' => '42 + n·32',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => 'dBHz'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '3',
                                  'bitfrom' => '0',
                                  'descr' => 'Estimated pseudorange standard deviation',
                                  'name' => 'prStd',
                                  'numbits' => '4'
                                }
                              ],
                'descr' => 'Estimated    pseudorange     measurement        standard deviation',
                'group' => 'repeated numMeas',
                'ln_arg' => 9086,
                'name' => 'prStdev',
                'offset' => '43 + n·32',
                'repeat' => undef,
                'scale' => '0.01*2^n',
                'type' => 'X1',
                'unit' => 'm'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '3',
                                  'bitfrom' => '0',
                                  'descr' => 'Estimated carrier phase standard deviation',
                                  'name' => 'cpStd',
                                  'numbits' => '4'
                                }
                              ],
                'descr' => 'Estimated carrier phase measurement standard deviation (note a raw value of 0x0F indicates the value is invalid)',
                'group' => 'repeated numMeas',
                'ln_arg' => 9090,
                'name' => 'cpStdev',
                'offset' => '44 + n·32',
                'repeat' => undef,
                'scale' => '0.004',
                'type' => 'X1',
                'unit' => 'cycles'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '3',
                                  'bitfrom' => '0',
                                  'descr' => 'Estimated Doppler standard deviation',
                                  'name' => 'doStd',
                                  'numbits' => '4'
                                }
                              ],
                'descr' => 'Estimated Doppler measurement standard deviation.',
                'group' => 'repeated numMeas',
                'ln_arg' => 9105,
                'name' => 'doStdev',
                'offset' => '45 + n·32',
                'repeat' => undef,
                'scale' => '0.002*2^n',
                'type' => 'X1',
                'unit' => 'Hz'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '0',
                                  'bitfrom' => undef,
                                  'descr' => 'Pseudorange valid',
                                  'name' => 'prValid',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '1',
                                  'bitfrom' => undef,
                                  'descr' => 'Carrier phase valid',
                                  'name' => 'cpValid',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '2',
                                  'bitfrom' => undef,
                                  'descr' => 'Half cycle valid',
                                  'name' => 'halfCyc',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '3',
                                  'bitfrom' => undef,
                                  'descr' => 'Half cycle subtracted from phase',
                                  'name' => 'subHalfCyc',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'Tracking status bitﬁeld',
                'group' => 'repeated numMeas',
                'ln_arg' => 9108,
                'name' => 'trkStat',
                'offset' => '46 + n·32',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => 'repeated numMeas',
                'ln_arg' => 9117,
                'name' => 'reserved1',
                'offset' => '47 + n·32',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x02',
  'code' => 'UBX-RXM-RAWX',
  'comment' => 'This message contains the information needed to be able to generate a RINEX 3 multi-GNSS observation ﬁle (see ftp://ftp.igs.org/pub/data/format/). This message contains pseudorange, Doppler, carrier phase, phase lock and signal quality information for GNSS satellites once signals have been synchronized. This message supports all active GNSS. The only diﬀerence between this version of the message and the previous version (UBX-RXM-RAWX-DATA0) is the addition of the version ﬁeld.',
  'hasgroup' => 'repeated numMeas',
  'id' => '0x15',
  'length' => '16 + numMeas·32',
  'ln_bitfield' => 9116,
  'ln_classid' => 9026,
  'ln_comment' => 9018,
  'ln_msg' => 9015,
  'ln_name' => 9016,
  'ln_type' => 9017,
  'name' => 'Multi-GNSS raw measurements',
  'type' => 'Periodic/polled'
}
, ### UBX-RXM-RLM Galileo SAR short-RLM report ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Message version (0x00 for this version)',
                'group' => '',
                'ln_arg' => 9135,
                'name' => 'version',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Message type (0x01 for Short-RLM)',
                'group' => '',
                'ln_arg' => 9136,
                'name' => 'type',
                'offset' => '1',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Identiﬁer of transmitting satellite (see Satellite Numbering)',
                'group' => '',
                'ln_arg' => 9137,
                'name' => 'svId',
                'offset' => '2',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 9139,
                'name' => 'reserved0',
                'offset' => '3',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Beacon identiﬁer (60 bits), with bytes ordered by earliest transmitted (most signiﬁcant) ﬁrst. Top four bits of ﬁrst byte are zero.',
                'group' => '',
                'ln_arg' => 9140,
                'name' => 'beacon',
                'offset' => '4',
                'repeat' => '8',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Message code (4 bits)',
                'group' => '',
                'ln_arg' => 9143,
                'name' => 'message',
                'offset' => '12',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Parameters (16 bits), with bytes ordered by earliest transmitted (most signiﬁcant) ﬁrst.',
                'group' => '',
                'ln_arg' => 9144,
                'name' => 'params',
                'offset' => '13',
                'repeat' => '2',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 9146,
                'name' => 'reserved1',
                'offset' => '15',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x02',
  'code' => 'UBX-RXM-RLM',
  'comment' => 'This message contains the contents of any Galileo Search and Rescue (SAR) Short Return Link Message detected by the receiver.',
  'id' => '0x59',
  'length' => '16',
  'ln_classid' => 9132,
  'ln_comment' => 9128,
  'ln_msg' => 9125,
  'ln_name' => 9126,
  'ln_type' => 9127,
  'name' => 'Galileo SAR short-RLM report',
  'type' => 'Output'
}
, ### UBX-RXM-RLM Galileo SAR long-RLM report ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Message version (0x00 for this version)',
                'group' => '',
                'ln_arg' => 9160,
                'name' => 'version',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Message type (0x02 for Long-RLM)',
                'group' => '',
                'ln_arg' => 9171,
                'name' => 'type',
                'offset' => '1',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Identiﬁer of transmitting satellite (see Satellite Numbering)',
                'group' => '',
                'ln_arg' => 9172,
                'name' => 'svId',
                'offset' => '2',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 9174,
                'name' => 'reserved0',
                'offset' => '3',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Beacon identiﬁer (60 bits), with bytes ordered by earliest transmitted (most signiﬁcant) ﬁrst. Top four bits of ﬁrst byte are zero.',
                'group' => '',
                'ln_arg' => 9175,
                'name' => 'beacon',
                'offset' => '4',
                'repeat' => '8',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Message code (4 bits)',
                'group' => '',
                'ln_arg' => 9178,
                'name' => 'message',
                'offset' => '12',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Parameters (96 bits), with bytes ordered by earliest transmitted (most signiﬁcant) ﬁrst.',
                'group' => '',
                'ln_arg' => 9179,
                'name' => 'params',
                'offset' => '13',
                'repeat' => '12',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 9181,
                'name' => 'reserved1',
                'offset' => '25',
                'repeat' => '3',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x02',
  'code' => 'UBX-RXM-RLM',
  'comment' => 'This message contains the contents of any Galileo Search and Rescue (SAR) Long Return Link Message detected by the receiver.',
  'id' => '0x59',
  'length' => '28',
  'ln_classid' => 9157,
  'ln_comment' => 9153,
  'ln_msg' => 9150,
  'ln_name' => 9151,
  'ln_type' => 9152,
  'name' => 'Galileo SAR long-RLM report',
  'type' => 'Output'
}
, ### UBX-RXM-RTCM RTCM input status ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Message version (0x02 for this version)',
                'group' => '',
                'ln_arg' => 9197,
                'name' => 'version',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '0',
                                  'bitfrom' => undef,
                                  'descr' => '0 when RTCM message received and passed CRC check, 1 when failed, in which case refStation and msgType might be corrupted and misleading',
                                  'name' => 'crcFailed',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '2',
                                  'bitfrom' => '1',
                                  'descr' => '2 = RTCM message used successfully by the receiver, 1 = not used, 0 = do not know',
                                  'name' => 'msgUsed',
                                  'numbits' => '2'
                                }
                              ],
                'descr' => 'RTCM input status ﬂags',
                'group' => '',
                'ln_arg' => 9198,
                'name' => 'flags',
                'offset' => '1',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Message subtype, only applicable to u-blox proprietary RTCM message 4072 (not available on all products)',
                'group' => '',
                'ln_arg' => 9205,
                'name' => 'subType',
                'offset' => '2',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reference station ID:
•   For RTCM 2.3: Reference station ID of the received RTCM 2 input message. Valid range 0-1023.
•   For RTCM 3.3: Reference station ID (DF003) of the received RTCM input message. Valid range 0-4095. Reported only for the standard RTCM messages that include the DF003 ﬁeld and for the u-blox proprietary RTCM messages 4072.x. For all other messages, reports 0xFFFF.',
                'group' => '',
                'ln_arg' => 9207,
                'name' => 'refStation',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Message type',
                'group' => '',
                'ln_arg' => 9217,
                'name' => 'msgType',
                'offset' => '6',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => '-'
              }
            ],
  'class' => '0x02',
  'code' => 'UBX-RXM-RTCM',
  'comment' => 'This message shows info on a received RTCM input message. It is output upon successful parsing of an RTCM input message, irrespective of whether the RTCM message is supported or not by the receiver.',
  'id' => '0x32',
  'length' => '8',
  'ln_bitfield' => 9203,
  'ln_classid' => 9194,
  'ln_comment' => 9190,
  'ln_msg' => 9187,
  'ln_name' => 9188,
  'ln_type' => 9189,
  'name' => 'RTCM input status',
  'type' => 'Output'
}
, ### UBX-RXM-SFRBX Broadcast navigation data subframe ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'GNSS identiﬁer (see Satellite Numbering)',
                'group' => '',
                'ln_arg' => 9242,
                'name' => 'gnssId',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Satellite identiﬁer (see Satellite Numbering)',
                'group' => '',
                'ln_arg' => 9243,
                'name' => 'svId',
                'offset' => '1',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 9244,
                'name' => 'reserved0',
                'offset' => '2',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Only used for GLONASS: This is the frequency slot + 7 (range from 0 to 13)',
                'group' => '',
                'ln_arg' => 9245,
                'name' => 'freqId',
                'offset' => '3',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'The number of data words contained in this message (up to 10, for currently supported signals)',
                'group' => '',
                'ln_arg' => 9247,
                'name' => 'numWords',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'The tracking channel number the message was received on',
                'group' => '',
                'ln_arg' => 9249,
                'name' => 'chn',
                'offset' => '5',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Message version, (0x02 for this version)',
                'group' => '',
                'ln_arg' => 9251,
                'name' => 'version',
                'offset' => '6',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 9252,
                'name' => 'reserved1',
                'offset' => '7',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'The data words',
                'group' => 'repeated numWords',
                'ln_arg' => 9255,
                'name' => 'dwrd',
                'offset' => '8 + n·4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => '-'
              }
            ],
  'class' => '0x02',
  'code' => 'UBX-RXM-SFRBX',
  'comment' => 'This message reports a complete subframe of broadcast navigation data decoded from a single signal. The number of data words reported in each message depends on the nature of the signal.',
  'hasgroup' => 'repeated numWords',
  'id' => '0x13',
  'length' => '8 + numWords·4',
  'ln_classid' => 9239,
  'ln_comment' => 9235,
  'ln_msg' => 9232,
  'ln_name' => 9233,
  'ln_type' => 9234,
  'name' => 'Broadcast navigation data subframe',
  'type' => 'Output'
}
, ### UBX-SEC-UNIQID Unique chip ID ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Message version (0x01 for this version)',
                'group' => '',
                'ln_arg' => 9275,
                'name' => 'version',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 9276,
                'name' => 'reserved0',
                'offset' => '1',
                'repeat' => '3',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Unique chip ID',
                'group' => '',
                'ln_arg' => 9277,
                'name' => 'uniqueId',
                'offset' => '4',
                'repeat' => '5',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x27',
  'code' => 'UBX-SEC-UNIQID',
  'comment' => 'This message is used to retrieve a unique chip identiﬁer (40 bits, 5 bytes).',
  'id' => '0x03',
  'length' => '9',
  'ln_classid' => 9272,
  'ln_comment' => 9269,
  'ln_msg' => 9266,
  'ln_name' => 9267,
  'ln_type' => 9268,
  'name' => 'Unique chip ID',
  'type' => 'Output'
}
, ### UBX-TIM-TM2 Time mark data ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Channel (i.e. EXTINT) upon which the pulse was measured',
                'group' => '',
                'ln_arg' => 9306,
                'name' => 'ch',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '0',
                                  'bitfrom' => undef,
                                  'descr' => '•   0=single
•   1=running',
                                  'name' => 'mode',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '1',
                                  'bitfrom' => undef,
                                  'descr' => '•   0=armed
•   1=stopped',
                                  'name' => 'run',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '2',
                                  'bitfrom' => undef,
                                  'descr' => 'New falling edge detected',
                                  'name' => 'newFallingEdge',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '4',
                                  'bitfrom' => '3',
                                  'descr' => '•   0=Time base is Receiver time
•   1=Time base is GNSS time (the system according to the conﬁguration in UBX-CFG-TP5 for tpIdx=0)
•   2=Time base is UTC (the variant according to the conﬁguration in UBX-CFG-NAV5)',
                                  'name' => 'timeBase',
                                  'numbits' => '2'
                                },
                                {
                                  'bit' => '5',
                                  'bitfrom' => undef,
                                  'descr' => '•   0=UTC not available
•   1=UTC available',
                                  'name' => 'utc',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '6',
                                  'bitfrom' => undef,
                                  'descr' => '•   0=Time is not valid
•   1=Time is valid (Valid GNSS ﬁx)',
                                  'name' => 'time',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '7',
                                  'bitfrom' => undef,
                                  'descr' => 'New rising edge detected',
                                  'name' => 'newRisingEdge',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'Bitmask',
                'group' => '',
                'ln_arg' => 9308,
                'name' => 'flags',
                'offset' => '1',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Rising edge counter',
                'group' => '',
                'ln_arg' => 9326,
                'name' => 'count',
                'offset' => '2',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Week number of last rising edge',
                'group' => '',
                'ln_arg' => 9327,
                'name' => 'wnR',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Week number of last falling edge',
                'group' => '',
                'ln_arg' => 9328,
                'name' => 'wnF',
                'offset' => '6',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Tow of rising edge',
                'group' => '',
                'ln_arg' => 9329,
                'name' => 'towMsR',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'ms'
              },
              {
                'bitfield' => [],
                'descr' => 'Millisecond fraction of tow of rising edge in nanoseconds',
                'group' => '',
                'ln_arg' => 9330,
                'name' => 'towSubMsR',
                'offset' => '12',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'ns'
              },
              {
                'bitfield' => [],
                'descr' => 'Tow of falling edge',
                'group' => '',
                'ln_arg' => 9332,
                'name' => 'towMsF',
                'offset' => '16',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'ms'
              },
              {
                'bitfield' => [],
                'descr' => 'Millisecond fraction of tow of falling edge in nanoseconds',
                'group' => '',
                'ln_arg' => 9333,
                'name' => 'towSubMsF',
                'offset' => '20',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'ns'
              },
              {
                'bitfield' => [],
                'descr' => 'Accuracy estimate',
                'group' => '',
                'ln_arg' => 9335,
                'name' => 'accEst',
                'offset' => '24',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'ns'
              }
            ],
  'class' => '0x0d',
  'code' => 'UBX-TIM-TM2',
  'comment' => 'This message contains information for high precision time stamping / pulse counting. The delay ﬁgures and timebase given in UBX-CFG-TP5 are also applied to the time results output in this message.',
  'id' => '0x03',
  'length' => '28',
  'ln_bitfield' => 9325,
  'ln_classid' => 9303,
  'ln_comment' => 9298,
  'ln_msg' => 9295,
  'ln_name' => 9296,
  'ln_type' => 9297,
  'name' => 'Time mark data',
  'type' => 'Periodic/polled'
}
, ### UBX-TIM-TP Time pulse time data ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Time pulse time of week according to time base',
                'group' => '',
                'ln_arg' => 9360,
                'name' => 'towMS',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U4',
                'unit' => 'ms'
              },
              {
                'bitfield' => [],
                'descr' => 'Submillisecond part of towMS',
                'group' => '',
                'ln_arg' => 9361,
                'name' => 'towSubMS',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '2^-32',
                'type' => 'U4',
                'unit' => 'ms'
              },
              {
                'bitfield' => [],
                'descr' => 'Quantization error of time pulse. Only available in timing products',
                'group' => '',
                'ln_arg' => 9362,
                'name' => 'qErr',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I4',
                'unit' => 'ps'
              },
              {
                'bitfield' => [],
                'descr' => 'Time pulse week number according to time base',
                'group' => '',
                'ln_arg' => 9364,
                'name' => 'week',
                'offset' => '12',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => 'weeks'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '0',
                                  'bitfrom' => undef,
                                  'descr' => '•   0 = Time base is GNSS
•   1 = Time base is UTC',
                                  'name' => 'timeBase',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '1',
                                  'bitfrom' => undef,
                                  'descr' => '•   0 = UTC not available
•   1 = UTC available',
                                  'name' => 'utc',
                                  'numbits' => '1'
                                },
                                {
                                  'bit' => '3',
                                  'bitfrom' => '2',
                                  'descr' => '(T)RAIM information
•   0 = Information not available
•   1 = Not active
•   2 = Active',
                                  'name' => 'raim',
                                  'numbits' => '2'
                                },
                                {
                                  'bit' => '4',
                                  'bitfrom' => undef,
                                  'descr' => '•   0 = Quantization error valid
•   1 = Quantization error invalid',
                                  'name' => 'qErrInvalid',
                                  'numbits' => '1'
                                }
                              ],
                'descr' => 'Flags',
                'group' => '',
                'ln_arg' => 9365,
                'name' => 'flags',
                'offset' => '14',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X1',
                'unit' => '-'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '3',
                                  'bitfrom' => '0',
                                  'descr' => 'GNSS reference information. Only valid if time base is GNSS (timeBase=0).
•   0 = GPS
•   1 = GLONASS
•   2 = BeiDou
•   3 = Galileo
•   15 = Unknown',
                                  'name' => 'timeRefGnss',
                                  'numbits' => '4'
                                },
                                {
                                  'bit' => '7',
                                  'bitfrom' => '4',
                                  'descr' => 'UTC standard identiﬁer. Only valid if time base is UTC (timeBase=1).
•   0 = Information not available
•   1 = Communications Research Laboratory (CRL), Tokyo, Japan
•   2 = National Institute of Standards and Technology (NIST)
•   3 = U.S. Naval Observatory (USNO)
•   4 = International Bureau of Weights and Measures (BIPM)
•   5 = European laboratories
•   6 = Former Soviet Union (SU)
•   7 = National Time Service Center (NTSC), China
•   15 = Unknown',
                                  'name' => 'utcStandard',
                                  'numbits' => '4'
                                }
                              ],
                'descr' => 'Time reference information',
                'group' => '',
                'ln_arg' => 9377,
                'name' => 'refInfo',
                'offset' => '15',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X1',
                'unit' => '-'
              }
            ],
  'class' => '0x0d',
  'code' => 'UBX-TIM-TP',
  'comment' => 'This message contains information on the timing of the next pulse at the TIMEPULSE0 output. The recommended conﬁguration when using this message is to set both the measurement rate (CFG-RATE) and the timepulse frequency (CFG-TP) to 1 Hz.',
  'id' => '0x01',
  'length' => '16',
  'ln_bitfield' => 9386,
  'ln_classid' => 9357,
  'ln_comment' => 9352,
  'ln_msg' => 9349,
  'ln_name' => 9350,
  'ln_type' => 9351,
  'name' => 'Time pulse time data',
  'type' => 'Periodic/polled'
}
, ### UBX-TIM-VRFY Sourced time veriﬁcation ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'integer millisecond tow received by source',
                'group' => '',
                'ln_arg' => 9422,
                'name' => 'itow',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I4',
                'unit' => 'ms'
              },
              {
                'bitfield' => [],
                'descr' => 'sub-millisecond part of tow',
                'group' => '',
                'ln_arg' => 9423,
                'name' => 'frac',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I4',
                'unit' => 'ns'
              },
              {
                'bitfield' => [],
                'descr' => 'integer milliseconds of delta time (current time minus sourced time)',
                'group' => '',
                'ln_arg' => 9424,
                'name' => 'deltaMs',
                'offset' => '8',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I4',
                'unit' => 'ms'
              },
              {
                'bitfield' => [],
                'descr' => 'Sub-millisecond part of delta time',
                'group' => '',
                'ln_arg' => 9426,
                'name' => 'deltaNs',
                'offset' => '12',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'I4',
                'unit' => 'ns'
              },
              {
                'bitfield' => [],
                'descr' => 'Week number',
                'group' => '',
                'ln_arg' => 9427,
                'name' => 'wno',
                'offset' => '16',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U2',
                'unit' => 'week'
              },
              {
                'bitfield' => [
                                {
                                  'bit' => '2',
                                  'bitfrom' => '0',
                                  'descr' => 'Aiding time source
•   0 = no time aiding done
•   2 = source was RTC
•   3 = source was assistance data',
                                  'name' => 'src',
                                  'numbits' => '3'
                                }
                              ],
                'descr' => 'Flags',
                'group' => '',
                'ln_arg' => 9428,
                'name' => 'flags',
                'offset' => '18',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'X1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 9434,
                'name' => 'reserved0',
                'offset' => '19',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x0d',
  'code' => 'UBX-TIM-VRFY',
  'comment' => 'This message contains veriﬁcation information about previous time received via assistance data or from RTC.',
  'id' => '0x06',
  'length' => '20',
  'ln_bitfield' => 9430,
  'ln_classid' => 9419,
  'ln_comment' => 9416,
  'ln_msg' => 9413,
  'ln_name' => 9414,
  'ln_type' => 9415,
  'name' => 'Sourced time veriﬁcation',
  'type' => 'Periodic/polled'
}
, ### UBX-UPD-SOS Poll backup restore status ###
{
  'args' => [],
  'class' => '0x09',
  'code' => 'UBX-UPD-SOS',
  'comment' => 'Sending this (empty) message to the receiver results in the receiver returning a System restored from backup message as deﬁned below.',
  'id' => '0x14',
  'length' => '0',
  'ln_classid' => 9451,
  'ln_comment' => 9447,
  'ln_msg' => 9444,
  'ln_name' => 9445,
  'ln_type' => 9446,
  'name' => 'Poll backup restore status',
  'type' => 'Poll request'
}
, ### UBX-UPD-SOS Create backup in ﬂash ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Command (must be 0)',
                'group' => '',
                'ln_arg' => 9478,
                'name' => 'cmd',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 9479,
                'name' => 'reserved0',
                'offset' => '1',
                'repeat' => '3',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x09',
  'code' => 'UBX-UPD-SOS',
  'comment' => 'The host can send this message in order to save part of the battery-backed memory (BBR) in a ﬁle in the ﬂash ﬁle system. The feature is designed in order to emulate the presence of the backup battery even if it is not present; the host can issue the save on shutdown command before switching oﬀ the device supply. It is recommended to issue a GNSS stop command using UBX-CFG-RST before in order to keep the BBR memory content consistent.',
  'id' => '0x14',
  'length' => '4',
  'ln_classid' => 9475,
  'ln_comment' => 9458,
  'ln_msg' => 9455,
  'ln_name' => 9456,
  'ln_type' => 9457,
  'name' => 'Create backup in ﬂash',
  'type' => 'Command'
}
, ### UBX-UPD-SOS Clear backup in ﬂash ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Command (must be 1)',
                'group' => '',
                'ln_arg' => 9495,
                'name' => 'cmd',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 9496,
                'name' => 'reserved0',
                'offset' => '1',
                'repeat' => '3',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x09',
  'code' => 'UBX-UPD-SOS',
  'comment' => 'The host can send this message in order to erase the backup ﬁle present in ﬂash. It is recommended that the clear operation is issued after the host has received the notiﬁcation that the memory has been restored after a reset. Alternatively the host can parse the startup string Restored data saved on shutdown or poll the UBX-UPD-SOS message for obtaining the status.',
  'id' => '0x14',
  'length' => '4',
  'ln_classid' => 9492,
  'ln_comment' => 9486,
  'ln_msg' => 9483,
  'ln_name' => 9484,
  'ln_type' => 9485,
  'name' => 'Clear backup in ﬂash',
  'type' => 'Command'
}
, ### UBX-UPD-SOS Backup creation acknowledge ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Command (must be 2)',
                'group' => '',
                'ln_arg' => 9510,
                'name' => 'cmd',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 9511,
                'name' => 'reserved0',
                'offset' => '1',
                'repeat' => '3',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => '•   0 = Not acknowledged
•   1 = Acknowledged',
                'group' => '',
                'ln_arg' => 9512,
                'name' => 'response',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 9514,
                'name' => 'reserved1',
                'offset' => '5',
                'repeat' => '3',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x09',
  'code' => 'UBX-UPD-SOS',
  'comment' => 'The message is sent from the device as conﬁrmation of creation of a backup ﬁle in ﬂash. The host can safely shut down the device after having received this message.',
  'id' => '0x14',
  'length' => '8',
  'ln_classid' => 9507,
  'ln_comment' => 9503,
  'ln_msg' => 9500,
  'ln_name' => 9501,
  'ln_type' => 9502,
  'name' => 'Backup creation acknowledge',
  'type' => 'Output'
}
, ### UBX-UPD-SOS System restored from backup ###
{
  'args' => [
              {
                'bitfield' => [],
                'descr' => 'Command (must be 3)',
                'group' => '',
                'ln_arg' => 9539,
                'name' => 'cmd',
                'offset' => '0',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 9540,
                'name' => 'reserved0',
                'offset' => '1',
                'repeat' => '3',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => '•   0 = Unknown
•   1 = Failed restoring from backup
•   2 = Restored from backup
•   3 = Not restored (no backup)',
                'group' => '',
                'ln_arg' => 9541,
                'name' => 'response',
                'offset' => '4',
                'repeat' => undef,
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              },
              {
                'bitfield' => [],
                'descr' => 'Reserved',
                'group' => '',
                'ln_arg' => 9545,
                'name' => 'reserved1',
                'offset' => '5',
                'repeat' => '3',
                'scale' => '-',
                'type' => 'U1',
                'unit' => '-'
              }
            ],
  'class' => '0x09',
  'code' => 'UBX-UPD-SOS',
  'comment' => 'The message is sent from the device to notify the host the BBR has been restored from a backup ﬁle in the ﬂash ﬁle sysetem. The host should clear the backup ﬁle after receiving this message. If the UBX-UPD-SOS message is polled, this message will be resent.',
  'id' => '0x14',
  'length' => '8',
  'ln_classid' => 9526,
  'ln_comment' => 9521,
  'ln_msg' => 9518,
  'ln_name' => 9519,
  'ln_type' => 9520,
  'name' => 'System restored from backup',
  'type' => 'Output'
}
, ]
